<?php
/**
 * This is the main dispatcher for the admin interface
 *
 * IF YOU ARE READING THIS IN YOUR WEB BROWSER, IT MEANS THAT PHP IS NOT PROPERLY
 * INSTALLED ON YOUR WEB SERVER. IF YOU DON'T KNOW WHAT THIS MEANS, CONTACT YOUR
 * SERVER ADMINISTRATOR OR YOUR HOSTING COMPANY.
 *
 * @todo (3048) EdB> this file is 1 of 2 that sets the default admin template (part of "Get the Admin template")
 * @todo (1111) the "Redirect old-style URLs" check is probably obsolete
 *
 * @copyright (c) 2009 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://www.gnu.org/licenses/gpl.txt GNU General Public License v3
 * @package admin
 */

/**
 * Load the configuration minimum
 */
require_once dirname(__FILE__).'/qp_config/_config.php';

// Is this an admin page? Use {@link is_admin_page()} to query it because it may change
$is_admin_page = true;

$login_required = true;

/**
 * Main initialization, without a specific blog identified
 */
require_once $inc_path.'_main.inc.php';

// Check global permission
if( ! $current_User->check_perm( 'admin', 'any' ) )
{
	// No permission to access admin...
	require $admintemplates_path.'_access_denied.main.php';
}

/**
 * Asynchronous processing options that may be required on any page
 */
require_once $inc_path.'_async.inc.php';

// Get the blog from param, defaulting to the last selected one for this user:
// we need it for quite a few of the menu urls
$user_selected_blog = (int)$UserSettings->get( 'selected_blog' );
$BlogCache = & get_Cache( 'BlogCache' );
if( param( 'blog', 'integer', NULL, true ) === NULL // no explicit blog choice, not even '0' for 'no blog'
	|| ( $blog > 0 && ! ( $Blog = & $BlogCache->get_by_ID( $blog, false, false ) ) ) ) // we requested a nonexistent blog
{
	// Try the memorized blog from the previous action
	$blog = $user_selected_blog;
	if( ! ( $Blog = & $BlogCache->get_by_ID( $blog, false, false ) ) )
	{
		// That one doesn't exist either...
		$blog = 0;
	}
}
elseif( $blog != $user_selected_blog )
{
	// We have selected a new & valid blog. Update UserSettings for selected blog
	set_working_blog( $blog );
}

// bookmarklet, upload (upload actually means sth like: select img for post)
param( 'mode', 'string', '', true );

// Get the Admin template
$admin_template = $UserSettings->get( 'admin_template' );
$admin_template_path = $admintemplates_path.'%s/_adminUI.class.php';

if( ! $admin_template || ! file_exists( sprintf( $admin_template_path, $admin_template ) ) )
{
	// there's no template for the user
	$admin_template = $Settings->get( 'default_admin_template' );

	if( ! $admin_template || ! file_exists( sprintf( $admin_template_path, $admin_template ) ) )
	{
		// even the default template does not exist!
		// set 'earth' as the admin template if it exists
		if( file_exists( sprintf( $admin_template_path, 'earth' ) ) )
		{
			$admin_template = 'earth';
		}
		else
		{
			// get the first one available one
			$admin_template_dirs = get_admin_templates();

			if( $admin_template_dirs === false )
			{
				// debuglog->add removed
			}
			elseif( empty( $admin_template_dirs ) )
			{
				// No admin template directories found
				// debuglog->add removed
			}
			else
			{
				$admin_template = array_shift( $admin_template_dirs );
			}
		}
	}
}

// we die without an admin template
if( ! $admin_template )
{
	$Debuglog->display( 'No admin template available!', '', true, 'template' );
	die(1);
}

/**
 * Load the AdminUI class for the template
 */
require_once $admintemplates_path.$admin_template.'/_adminUI.class.php';

// This is the Admin UI object which handles the UI for the backoffice
$AdminUI = new AdminUI();

// Pass over to controller ... get requested controller and memorize it
param( 'ctrl', '/^[a-z0-9_]+$/', 'dashboard', true );

// Redirect old-style URLs (e.g. /admin/plugins.php), if they come here because the webserver
// maps "/admin/" to "/admin.php" NOTE: this is just meant as a transformation from pre-1.8 to 1.8!
if( ! empty( $_SERVER['PATH_INFO'] ) && $_SERVER['PATH_INFO'] != $_SERVER['PHP_SELF'] ) // the "!= PHP_SELF" check seems needed by IIS..
{
	// Try to find the appropriate controller (ctrl) setting
	foreach( $ctrl_mappings as $k => $v )
	{
		if( preg_match( '~'.preg_quote( $_SERVER['PATH_INFO'], '~' ).'$~', $v ) )
		{
			$ctrl = $k;
			break;
		}
	}

	// Sanitize QUERY_STRING
	if( ! empty( $_SERVER['QUERY_STRING'] ) )
	{
		$query_string = explode( '&', $_SERVER['QUERY_STRING'] );
		foreach( $query_string as $k => $v )
		{
			$query_string[$k] = strip_tags( $v );
		}
		$query_string = '&'.implode( '&', $query_string );
	}
	else
	{
		$query_string = '';
	}

	header_redirect( url_add_param( $admin_url, 'ctrl='.$ctrl.$query_string, '&' ), true );
	exit(0);
}

// Check matching controller file
if( ! isset( $ctrl_mappings[$ctrl] ) )
{
	debug_die( 'The requested controller ['.$ctrl.'] does not exist.' );
}

/**
 * Call the requested controller
 */
require $inc_path.$ctrl_mappings[$ctrl];

?>
