<?php
/**
 * Config File
 *
 * This file just includes all the other config files. This file should not be
 * edited. You should edit the sub files instead. See {@link _main_config.php}
 * for the basic settings.
 *
 * @copyright (c) 2009 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://www.gnu.org/licenses/gpl.txt GNU General Public License v3
 * @package config
 */
if(defined('QP_CONFIG_LOADED')) return;

/**
 * This makes sure the config does not get loaded twice in Windows (when the
 * /qp_config file is in a path containing uppercase letters as in /Blog/qp_config).
 */
define( 'QP_CONFIG_LOADED', true );

// basic settings
if( file_exists( dirname(__FILE__).'/_main_config.php' ) )
{
	/**
	 * Use configured base config
	 */
	require_once dirname(__FILE__).'/_main_config.php';
}
else
{
	/**
	 * Use default template
	 */
	require_once dirname(__FILE__).'/_main_config.template.php';
}

/**
 * admin settings
 */
require_once dirname(__FILE__).'/_admin.php';

/**
 * advanced settings
 */
require_once dirname(__FILE__).'/_advanced.php';

/**
 * locale settings
 */
require_once $conf_path.'_locales.php';

/**
 * formatting settings
 */
require_once $conf_path.'_formatting.php';

/**
 * stats/hitlogging settings
 */
require_once $conf_path.'_stats.php';

/**
 * application settings
 */
require_once $inc_path.'_application.php';


// FOR TESTING / DEVELOPMENT OVERRIDES
if( file_exists( $conf_path.'_overrides_TEST.php' ) )
{
	/**
	 * Override for testing in there
	 */
	include_once $conf_path.'_overrides_TEST.php'; 
}

// Load modules:
foreach( $modules as $module )
{
	/**
	 * load a module
	 */
	require_once $inc_path.$module.'/_'.$module.'.init.php';
}

?>
