<?php
/**
 * Main Config File
 *
 * You do NOT need to edit this file! If you are doing a MANUAL install, you should
 * edit _main_config.php. If _main_config.php doesn't exist yet, open this file
 * and SAVE it AS _main_config.php (then edit as required). If you are doing an
 * automatic installation then don't worry: Quam Plures will copy this file and
 * create _main_config.php for you.
 *
 * @copyright (c) 2009 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://www.gnu.org/licenses/gpl.txt GNU General Public License v3
 * @package config
 */
if(!defined('QP_CONFIG_LOADED')) die('fail');

// Maintenance mode Set this to 1 in order to temporarily disable access to the application.
// Note: it is still possible to access the install script during maintenance mode.
$maintenance_mode = 0;

// Below is an alternative hardcore version of maintenance mode.
// This one will block the install script too.
// Remove the "#" from the next 3 lines to activate.
#header('HTTP/1.0 503 Service Unavailable');
#echo '<h1>503 Service Unavailable</h1>';
#die( 'The site is temporarily down for maintenance. Please reload this page in a few minutes.' );

// MySQL DB settings
// Fill in your database details (check carefully or nothing will work!)
$app_db_config = array(
	'host' => 'localhost', // "MySQL Host/Server" (typically 'localhost')
	'name' => '', // "MySQL Database"
	'user' => '', // "MySQL Username"
	'password' => '', // "MySQL Password"
);

// The tables prefix (gets placed before each table name),
// change for multiple installs in one database
$app_db_tableprefix = 'qp_';

// To be able to reset your existing tables and start anew you must set this to 1.
// NEVER LEAVE THIS SETTING ON ANYTHING OTHER THAN 0 (ZERO) ON A PRODUCTION SERVER!
// IF THIS IS SET TO (1) AND YOU FORGET TO DELETE THE INSTALL FOLDER, ANYONE WILL
// BE ABLE TO ERASE YOUR TABLES AND DATA BY A SINGLE CLICK!
$app_allow_dbase_reset = 0;

// $app_baseurl is where your blogs reside by default. CHECK THIS CAREFULLY or nothing
// will work. It should be set to the URL where you can find the blog templates
// and/or the blog stub files, that means index.php, blog_b.php, etc. Note: Blogs
// can be in subdirectories of the baseurl. However, no blog should be outside of
// there, or some tricky things may fail.
// IMPORTANT: If you want to test this app on your local machine, do NOT use that
// machine's name in the $app_baseurl! For example, if your machine is called HOMER,
// do not use http://homer/blogs/ ! Use http://localhost/blogs/ instead. And log
// in on localhost too, not homer! If you don't, login cookies will not hold.
$app_baseurl = 'http://localhost/quamplures/blogs/';

// Use the following if you want to use the current domain:
#if( isset( $_SERVER['HTTP_HOST'] ) )
#{
#	// This only works if HOSt provided by webserver (i-e DOES NOT WORK IN PHP CLI MODE)
#	$app_baseurl = ( ( isset( $_SERVER['HTTPS'] ) && ( $_SERVER['HTTPS'] != 'off' ) ) ? 'https://' : 'http://' ).$_SERVER['HTTP_HOST'].'/';
#}

// Once you have edited this file to your settings, set the following to 1 (one):
$app_config_is_done = 0;

?>
