<?php
/**
 * This is the application's config file
 *
 * @copyright (c) 2009 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://www.gnu.org/licenses/gpl.txt GNU General Public License v3
 * @package config
 */
if(!defined('QP_CONFIG_LOADED')) die('fail');

// The application's name
$app_name = 'Quam Plures';

$app_shortname = 'QP';

// The application's home page
$app_homepage = 'http://quamplures.net/';

// The fileset version: incremented at whatever rate feels good :)
$files_version = '1.52';

// The database version, incrememented by 1 with each change in upgrade_dbase_tables()
$app_db_version = 70;

// This way the version tells us the files and the database :)
$app_version = $files_version.'.'.$app_db_version;

// The application's release date (ISO) for major (quarterly) releases
$app_date = '2013-04-18';

// Displayed on the login screen
$app_banner = '<a href="'.$app_homepage.'"><img src="'.$rsc_url.'logo.jpg" width="337" height="76" alt="'.$app_name.'" /></a>';

// Displayed on admin pages (footer)
$app_footer_text = '<a href="'.$app_homepage.'" title="'.sprintf( T_('visit %s\' website'), $app_name ).'"><strong>'.$app_name.' v'.$app_version.'</strong></a>'
	.' released under the <a href="http://www.gnu.org/licenses/gpl-3.0.html" class="nobr">'.T_('GNU General Public License').'</a> v3.';

$copyright_text = '<span class="nobr">&copy;2001-2002 Michel V &amp; others,</span> ';
$copyright_text .= '<span class="nobr">&copy;2003-2009 <a href="http://b2evolution.net/dev/authors.html">Fran&ccedil;ois Planque &amp; others</a>,</span> ';
$copyright_text .= '<span class="nobr">&copy;2009+ <a href="http://quamplures.net/">Quam Plures</a>.</span>';

/**
 * Modules to load
 *
 * This is most useful when extending the application core with features beyond what
 * the application currently does, and when those features do not fit nicely into a
 * plugin (mostly when they are too large or too complex).
 */
$modules = array(
	'_core',
	'sessions',
);

?>
