<?php
/**
 * Function for handling Classes in PHP5
 *
 * @copyright (c) 2009 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://www.gnu.org/licenses/gpl.txt GNU General Public License v3
 * @package core
 */
if(!defined('QP_MAIN_INIT')) die('fail');

/**
 * Autoload the required .class.php file
 *
 * Autoload the required .class.php file when a class is accessed but not defined
 * yet. This gets hooked into spl_autoload_register (preferred) or called through
 * __autoload.
 */
function autoload_class( $classname )
{
	static $map_class_path;

	if( ! isset( $map_class_path ) )
	{
		global $admintemplates_path;
		global $inc_path;

		$_map_class_path = array(
			'abstractsettings' => $inc_path.'settings/model/_abstractsettings.class.php',
			'adminui' => $admintemplates_path.'/wind/_adminUI.class.php',
			'adminui_general' => $admintemplates_path.'/_adminUI_general.class.php',
			'blog' => $inc_path.'blogs/model/_blog.class.php',
			'blogcache' => $inc_path.'blogs/model/_blog_cache.class.php',
			'blogsettings' => $inc_path.'blogs/model/_blog_settings.class.php',
			'category' => $inc_path.'categories/model/_category.class.php',
			'categorycache' => $inc_path.'categories/model/_categorycache.class.php',
			'comment' => $inc_path.'comments/model/_comment.class.php',
			'commentlist' => $inc_path.'comments/model/_commentlist.class.php',
			'componentwidget' => $inc_path.'widgets/model/_widget.class.php',
			'cronjob' => $inc_path.'cron/model/_cronjob.class.php',
			'dataobject' => $inc_path.'_core/model/dataobjects/_dataobject.class.php',
			'dataobjectcache' => $inc_path.'_core/model/dataobjects/_dataobjectcache.class.php',
			'dataobjectlist' => $inc_path.'_core/model/dataobjects/_dataobjectlist.class.php',
			'dataobjectlist2' => $inc_path.'_core/model/dataobjects/_dataobjectlist2.class.php',
			'db' => $inc_path.'_core/model/db/_db.class.php',
			'file' => $inc_path.'files/model/_file.class.php',
			'filecache' => $inc_path.'files/model/_filecache.class.php',
			'filelist' => $inc_path.'files/model/_filelist.class.php',
			'fileroot' => $inc_path.'files/model/_fileroot.class.php',
			'filerootcache' => $inc_path.'files/model/_filerootcache.class.php',
			'filetype' => $inc_path.'files/model/_filetype.class.php',
			'filetypecache' => $inc_path.'files/model/_filetypecache.class.php',
			'form' => $inc_path.'_core/ui/forms/_form.class.php',
			'generalsettings' => $inc_path.'settings/model/_generalsettings.class.php',
			'genericcache' => $inc_path.'generic/model/_genericcache.class.php',
			'genericcategory' => $inc_path.'generic/model/_genericcategory.class.php',
			'genericcategorycache' => $inc_path.'generic/model/_genericcategorycache.class.php',
			'genericelement' => $inc_path.'generic/model/_genericelement.class.php',
			'genericordered' => $inc_path.'generic/model/_genericordered.class.php',
			'genericorderedcache' => $inc_path.'generic/model/_genericorderedcache.class.php',
			'goal' => $inc_path.'sessions/model/_goal.class.php',
			'group' => $inc_path.'users/model/_group.class.php',
			'hit' => $inc_path.'sessions/model/_hit.class.php',
			'hitlist' => $inc_path.'sessions/model/_hitlist.class.php',
			'iconlegend' => $inc_path.'_core/ui/_iconlegend.class.php',
			'idna_convert' => $inc_path.'_ext/idna/_idna_convert.class.php',
			'item' => $inc_path.'items/model/_item.class.php',
			'itemcache' => $inc_path.'items/model/_itemcache.class.php',
			'itemlight' => $inc_path.'items/model/_itemlight.class.php',
			'itemlist2' => $inc_path.'items/model/_itemlist.class.php',
			'itemlistlight' => $inc_path.'items/model/_itemlistlight.class.php',
			'itemquery' => $inc_path.'items/model/_itemquery.class.php',
			'itemtype' => $inc_path.'items/model/_itemtype.class.php',
			'itemtypecache' => $inc_path.'items/model/_itemtypecache.class.php',
			'link' => $inc_path.'items/model/_link.class.php',
			'linkcache' => $inc_path.'items/model/_linkcache.class.php',
			'log' => $inc_path.'_core/model/_log.class.php',
			'log_noop' => $inc_path.'_core/model/_log.class.php',
			'menu' => $inc_path.'_core/ui/_menu.class.php',
			'mime_parser_class' => $inc_path.'_ext/mime_parser/mime_parser.php',
			'pagecache' => $inc_path.'_core/model/_pagecache.class.php',
			'plugin' => $inc_path.'plugins/_plugin.class.php',
			'plugins' => $inc_path.'plugins/model/_plugins.class.php',
			'plugins_admin' => $inc_path.'plugins/model/_plugins_admin.class.php',
			'plugins_admin_no_db' => $inc_path.'plugins/model/_plugins_admin_no_db.class.php',
			'pluginsettings' => $inc_path.'plugins/model/_pluginsettings.class.php',
			'pluginusersettings' => $inc_path.'plugins/model/_pluginusersettings.class.php',
			'pofile' => $inc_path.'locales/_pofile.class.php',
			'potfile' => $inc_path.'locales/_pofile.class.php',
			'results' => $inc_path.'_core/ui/results/_results.class.php',
			'resultsel' => $inc_path.'_core/ui/results/_resultsel.class.php',
			'rfc822_addresses_class' => $inc_path.'_ext/mime_parser/rfc822_addresses.php',
			'session' => $inc_path.'sessions/model/_session.class.php',
			'sql' => $inc_path.'_core/model/db/_sql.class.php',
			'table' => $inc_path.'_core/ui/_uiwidget.class.php',
			'template' => $inc_path.'templates/model/_template.class.php',
			'templatecache' => $inc_path.'templates/model/_templatecache.class.php',
			'timer' => $inc_path.'_core/model/_timer.class.php',
			'user' => $inc_path.'users/model/_user.class.php',
			'usercache' => $inc_path.'users/model/_usercache.class.php',
			'usersettings' => $inc_path.'users/model/_usersettings.class.php',
			'widget' => $inc_path.'_core/ui/_uiwidget.class.php',
			'widgetcache' => $inc_path.'widgets/model/_widgetcache.class.php',
			'xhtml_validator' => $inc_path.'xhtml_validator/_xhtml_validator.class.php',
			'zip_file' => $inc_path.'_ext/_zip_archives.php',
		);
		$map_class_path = $_map_class_path;
	}

	$classname = strtolower( $classname );
	if( isset( $map_class_path[$classname] ) )
	{
		require_once $map_class_path[$classname];
	}
}


/**
 * Use spl_autoload_register mechanism
 *
 * This way several autoload functions can be used (PHP>=5.1.2).
 */
if( function_exists( 'spl_autoload_register' ) )
{
	spl_autoload_register( 'autoload_class' );
}
else
{
	/**
	 * PHP<5.1.2: Use the fallback method
	 *
	 * @deprecated - quam plures requires 5.2 or higher
	 */
	function __autoload( $classname )
	{
		return autoload_class( $classname );
	}
}

?>
