<?php
/**
 * This file implements the DataObjectList class
 *
 * This is typically an abstract class, useful only when derived. Holds DataObjects
 * in an array and allows walking through...
 *
 * @todo (1111) vars type 'foo' need useful/valid descriptions
 *
 * @copyright (c) 2009 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://www.gnu.org/licenses/gpl.txt GNU General Public License v3
 * @package core
 */
if(!defined('QP_MAIN_INIT')) die('fail');

/**
 * DataObjectList class
 *
 * @package core
 */
class DataObjectList extends Results
{
	/**
	 * The following should probably be obsoleted by Results::Cache
	 * @var foo
	 */
	var $dbtablename;
	/**
	 * FIX THIS
	 * @var foo
	 */
	var $dbprefix;
	/**
	 * FIX THIS
	 * @var foo
	 */
	var $dbIDname;
	/**
	 * Class name of objects handled in this list
	 * @var foo
	 */
	var $objType;
	/**
	 * Object array
	 * @var foo
	 */
	var $Obj = array();

	/**
	 * Constructor
	 *
	 * If provided, executes SQL query via parent Results object
	 *
	 * @param string Name of table in database
	 * @param string Prefix of fields in the table
	 * @param string Name of the ID field (including prefix)
	 * @param string Name of Class for objects within this list
	 * @param string SQL query
	 * @param integer number of lines displayed on one screen
	 * @param string prefix to differentiate page/order params when multiple Results appear one same page
	 * @param string default ordering of columns (special syntax)
	 */
	function DataObjectList(
		$tablename, $prefix = '',
		$dbIDname = 'ID',
		$objType = 'Item',
		$sql = NULL,
		$limit = 20,
		$param_prefix = '',
		$default_order = NULL )
	{
		$this->dbtablename = $tablename;
		$this->dbprefix = $prefix;
		$this->dbIDname = $dbIDname;
		$this->objType = $objType;

		if( !is_null( $sql ) )
		{
			// We have an SQL query to execute
			parent::Results( $sql, $param_prefix, $default_order, $limit );
		}
		else
		{
			// Temporary...
			// @todo (0000) do we want to autogenerate a query here???
			parent::Results( $sql, $param_prefix, $default_order, $limit );
		}
	}


	/**
	 * Get next object in list
	 *
	 * @return DataObject
	 */
	function & get_next()
	{
		if( $this->current_idx >= $this->result_num_rows )
		{
			// No more comment in list
			$r = false;
			return $r;
		}
		return $this->Obj[$this->current_idx++];
	}

}

?>
