<?php
/**
 * This file implements Fast Form handling functions
 *
 * @deprecated (0000): All those functions should be handled by the {@link Form Form class}.
 *
 * @copyright (c) 2009 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://www.gnu.org/licenses/gpl.txt GNU General Public License v3
 * @package core
 */
if(!defined('QP_MAIN_INIT')) die('fail');

/**
 * Builds a text (or password) input field
 *
 * @deprecated (0000): Deprecated by (@link Form::text_input()), except for this
 * is used 9 times by qp_install/index.php in v0.0.0 (EdB)
 * @param string the name of the input field
 * @param string initial value
 * @param integer size of the input field
 * @param string label displayed in front of the field
 * @param string note displayed with field
 * @param integer max length of the value (if 0 field_size will be used!)
 * @param string the CSS class to use
 * @param string input type (only 'text' or 'password' makes sense)
 * @param boolean display (default) or return
 * @return mixed true (if output) or the generated HTML if not outputting
 */
function form_text(
	$field_name,
	$field_value,
	$field_size,
	$field_label,
	$field_note = '',
	$field_maxlength = 0,
	$field_class = '',
	$inputtype = 'text',
	$output = true )
{
	if( $field_maxlength == 0 )
	{
		$field_maxlength = $field_size;
	}

	// enclose each field in a fieldset for CSS
	$r = "<fieldset>\n"
		.'<div class="label"><label for="'.$field_name.'">'.$field_label.":</label></div>\n"
		.'<div class="input"><input type="'.$inputtype.'" name="'.$field_name
		.'" id="'.$field_name.'" size="'.$field_size.'" maxlength="'.$field_maxlength
		.'" value="'.format_to_output( $field_value, 'formvalue' ).'"';
	if( ! empty( $field_class ) )
	{
		$r .= ' class="'.$field_class.'"';
	}
	$r .= " />\n";

	if( ! empty( $field_note ) )
	{
		$r .= '<span class="notes">'.$field_note.'</span>';
	}

	$r .= "</div>\n</fieldset>\n\n";

	if( $output )
	{
		echo $r;
		return true;
	}
	else
	{
		return $r;
	}
}


/**
 * form_info(-)
 *
 * @deprecated Deprecated by (@link Form::info_field())
 * Tblue> No, still used by gettext/staticfiles.php
 */
function form_info( $field_label, $field_info, $field_note = '' )
{
	echo '<fieldset>';
	echo '<div class="label">', $field_label, ':</div>';
	echo '<div class="info">', $field_info;
	if( ! empty( $field_note ) )
	{
		echo '&nbsp; <small class="notes">', $field_note, '</small>';
	}
	echo '</div>';
	echo "</fieldset>\n\n";
}


/**
 * Builds a form header and puts GET params of $action into hidden form inputs
 *
 * @deprecated Deprecated by (@link Form::begin_form())
 * waltercruz> still used by qp_inc/widgets/widgets/_search_form.widget.php
 */
function form_formstart( $action, $class = '', $name = '', $method = 'get', $id = '' )
{
	if( $method == 'get' )
	{
		$action = explode( '?', $action );
		if( isset( $action[1] ) )
		{
			// we have GET params in $action
			$getparams = preg_split( '/&amp;|&/i', $action[1], -1, PREG_SPLIT_NO_EMPTY );
		}
		$action = $action[0];
	}

	echo '<form action="'.$action.'" method="'.$method.'"';

	// this is not xhtml strict, see: http://forums.b2evolution.net//viewtopic.php?t=8475
	// if( ! empty( $name ) ) echo ' name="'.$name.'"';
	if( ! empty( $id ) ) echo ' id="'.$id.'"';
	if( ! empty( $class ) ) echo ' class="'.$class.'"';

	echo '>';

	if( isset( $getparams ) )
	{
		// These need to be wrapped in a div to validate xhtml strict
		echo '<div>';
		foreach( $getparams as $param)
		{
			$param = explode( '=', $param );
			if( isset( $param[1] ) )
			{
				echo '<input type="hidden" name="'.$param[0].'" value="'.$param[1].'" />';
			}
		}
		// close the div
		echo '</div>';
	}
}

?>
