<?php
/**
 * $ctrl_mappings: 'antispam' || Tools -> Antispam
 *
 * @todo (0000) From "switch action case ban current_User check_perm", this should
 * become different for 'edit'/'add' perm level - check for 'add' here.
 * @uses antispam_create()
 * @uses antispam_delete()
 * @copyright (c) 2009 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://www.gnu.org/licenses/gpl.txt GNU General Public License v3
 * @package antispam
 */
if(!defined('QP_MAIN_INIT')) die('fail');

$AdminUI->set_path( 'tools', 'antispam', 'kywds' );

param_action( '' );
param( 'confirm', 'string' );
param( 'keyword', 'string', '', true );
param( 'domain', 'string' );
param( 'filteron', 'string', '', true );
param( 'filter', 'array', array() );

if( isset( $filter['off'] ) )
{
	unset( $filteron );
	forget_param( 'filteron' );
}

// Check permission
$current_User->check_perm( 'spamblacklist', 'view', true );

switch( $action )
{
	// only an action if further "actions" given
	case 'ban':
	// Check permission
	$current_User->check_perm( 'spamblacklist', 'edit', true );
	$keyword = app_substr( $keyword, 0, 80 );
	param( 'delhits', 'integer', 0 );
	param( 'delcomments', 'integer', 0 );
	param( 'blacklist_locally', 'integer', 0 );
	param( 'aspm_source', 'string', 'core' );
	param( 'aspm_shortened', 'integer', 0 );

	// Check if the string is too short, it has to be >= 5 characters to avoid being too generic
	if( app_strlen( $keyword ) < 5 )
	{
		$Messages->add( sprintf( T_('The keyword &laquo;%s&raquo; is too short, it has to be a minimum of 5 characters!'), htmlspecialchars( $keyword ) ), 'error' );
		break;
	}

	// Delete all matching hit-log entries?
	$aspm_referers = 0;
	if( $delhits )
	{
		$aspm_referers = $DB->query('DELETE FROM T_hitlog WHERE hit_referer LIKE '.$DB->quote( '%'.$keyword.'%' ), 'Delete all banned hit-log entries' );
		$Messages->add( sprintf( T_('Deleted %d logged hits matching &laquo;%s&raquo;.'), $aspm_referers, htmlspecialchars( $keyword ) ), 'success' );
	}

	// Delete all matching comments?
	$aspm_comments = 0;
	if( $delcomments )
	{
		$aspm_comments = $DB->query('DELETE FROM T_comments
			WHERE comment_author LIKE '.$DB->quote( '%'.$keyword.'%' ).'
			OR comment_author_email LIKE '.$DB->quote( '%'.$keyword.'%' ).'
			OR comment_author_url LIKE '.$DB->quote( '%'.$keyword.'%' ).'
			OR comment_content LIKE '.$DB->quote( '%'.$keyword.'%' ) );
		$Messages->add( sprintf( T_('Deleted %d comments matching &laquo;%s&raquo;.'), $aspm_comments, htmlspecialchars( $keyword ) ), 'success' );
	}

	// Add keyword to antispam table?
	if( $blacklist_locally )
	{
		if( antispam_create( $keyword, $aspm_source, $aspm_shortened, $aspm_comments, $aspm_referers ) )
		{
			$Messages->add( sprintf( T_('The keyword &laquo;%s&raquo; has been blacklisted locally.'), htmlspecialchars( $keyword ) ), 'success' );
		}
		else
		{
			$Messages->add( sprintf( T_('The keyword &laquo;%s&raquo; was NOT blacklisted locally.'), htmlspecialchars( $keyword ) ), 'error' );
		}
	}
	// We'll ask the user later what to do, if no "sub-action" given.
	break;

	// Remove a domain from ban list
	case 'remove':
	// Check permission
	$current_User->check_perm( 'spamblacklist', 'edit', true );
	param( 'hit_ID', 'integer', true ); // Required!
	$Messages->add( sprintf( T_('Removing entry #%d from the ban list...'), $hit_ID ), 'note' );
	antispam_delete( $hit_ID );
	break;
}

// Display <html><head>...</head> section (should be done early if actions do not redirect)
$AdminUI->disp_html_head();
// Display title, menu, messages, etc... (messages MUST be displayed AFTER the actions)
$AdminUI->disp_body_top();
// Begin payload block
$AdminUI->disp_payload_begin();
// Display final (unbound) menu depth
echo $AdminUI->get_html_menu( array( 'tools', 'antispam' ), 'menu3' );

if( $action == 'ban' && ! $Messages->count( 'error' ) && ! ( $delhits || $delcomments || $blacklist_locally ) )
{
	$AdminUI->disp_view( 'antispam/views/_ban.form.php' ); // Nothing to do, ask user
}
else
{
	$AdminUI->disp_view( 'antispam/views/_list.view.php' ); // Display blacklist
}

// End payload block
$AdminUI->disp_payload_end();
// Display body bottom, debug info, close </html>
$AdminUI->disp_global_footer();

?>
