<?php
/**
 * This file implements the UI controller for the antispam management
 *
 * @copyright (c) 2009 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://www.gnu.org/licenses/gpl.txt GNU General Public License v3
 * @package antispam
 */
if(!defined('QP_MAIN_INIT')) die('fail');

echo '<h2>'.T_('Distributed Antispam').'</h2>';

// get out if this user is not in the admin group
if( ! $current_User->group_ID == 1 )
{
	return;
}

// get out if this user is not allowed to edit the blacklist
if( ! $current_User->check_perm( 'spamblacklist', 'edit' ) )
{
	return; 
}

// inbound params tell us if we are being invited
$cell_baseurl = param( 'cell_baseurl', 'string', '' );
$cell_user_id = param( 'cell_user_id', 'integer', '' );
$cell_email = param( 'cell_email', 'string', '' );
$cell_name = param( 'cell_name', 'string', '' );
$cell_msg = param( 'cell_msg', 'string', '' );
$cell_nonce = param( 'cell_nonce', 'string', '' );

/*
<p>This page becomes a form that gets sent to another Quam Plures installation via a file that 
doesn't exist yet. Something like /qp_srvc/cell_join.php I guess. Kinda like how message form 
works only it doesn't go to an email addy. Probably should be XMLRPC stuff but whatever. An 
invite to join a cell sends a bunch of info:
<pre>$app_baseurl
the sender's User ID#
the sender's email addy
the sender's preferred name
a personal message
a nonce
</pre></p>

<p>Ah okay this is actually a pinger! So someone sends a ping to request joining a cell with 
the above info bits.  The recipient gets notified of a request to join IF they still have room 
in their cell.  Each installation has room for 4 but the installation is always the first. So 
3 more can join the cell.  If the recipient's cell is full then it automatically sends back a 
"sorry no deal" message. If not full and the admin decides to not play with that person then 
they send the same message: "sorry no deal".</p>

<p>If the recipient wants this new domain in their cell then they send back a "yes" with the info 
they recieved as a serialized array, and a new nonce. A spot in the recipient's cell is now 
reserved for some period of time.  The initial sender must still have room is the thing. If 
the sender still has room and gets the "yes" message then automagically another yes with the 
second nonce is sent back. And yay a cell is born.</p>

<pre>SO: joiner sends info-with-nonce to target.
target is full? reject message returned.
target says no? reject message returned.
target says yes? accept message plus new nonce returned.
joiner still has room? cell established.
joiner filled up already? cancel request sent.</pre>
*/

?>
<p>This is a place-holder for a future option that will allow multiple Quam Plures installations to share information about blocked domains.</p>
