<?php
/**
 * This file implements the UI view for the antispam settings
 *
 * @copyright (c) 2009 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://www.gnu.org/licenses/gpl.txt GNU General Public License v3
 * @package antispam
 */
if(!defined('QP_MAIN_INIT')) die('fail');

global $Plugins;
global $Settings;

$Form = new Form( NULL, 'antispam_checkchanges' );
$Form->begin_form( 'fform', T_('Antispam Settings') );
$Form->hiddens_by_key( get_memorized() );
$Form->hidden( 'action', 'update' );

$Form->begin_fieldset( T_('Comments/Feedback') );
$Form->text( 'antispam_threshold_publish', $Settings->get( 'antispam_threshold_publish' ), 3, T_('Publishing threshold'), T_("(-100 to 100). Automatically publish feedbacks with a spam karma below this value.") );
$Form->text( 'antispam_threshold_delete', $Settings->get( 'antispam_threshold_delete' ), 3, T_('Deletion threshold'), T_("(-100 to 100). Automatically delete feedbacks with a spam karma over this value.") );
$Form->info( '', sprintf( /* TRANS: %s gets replaced by the translation for this setting */ T_('Feedbacks with a spam karma between these two thresholds will get the default status of the blog ("%s").'), T_('New feedback status') ) );
$Form->end_fieldset();

$Form->begin_fieldset( T_('Misc') );
$Form->checkbox( 'antispam_block_spam_referers', $Settings->get( 'antispam_block_spam_referers' ),
	T_('Block spam referers'), T_('If a referrer has been detected as spam, should we block the request with a "403 Forbidden" page?') );
$Form->end_fieldset();

$Form->begin_fieldset( T_('Spam detection relevance weight') );
echo '<p>'.T_('This defines the weight of the plugin, in relation to the others.').'</p>';
$karma_plugins = $Plugins->get_list_by_events( array('GetSpamKarmaForComment') );
if( empty( $karma_plugins ) )
{
	echo '<p>'.T_('There are no spam karma plugins enabled.').'</p>';
}
else foreach( $karma_plugins as $loop_Plugin )
{
	$Form->text( 'antispam_plugin_spam_weight['.$loop_Plugin->ID.']', $Plugins->index_ID_rows[$loop_Plugin->ID]['plug_spam_weight'], 2, $loop_Plugin->name );
}
$Form->end_fieldset();

if( $current_User->check_perm( 'options', 'edit' ) )
{
	$Form->end_form( array(
		array( 'submit', 'submit', T_('Update'), 'SaveButton' ),
		array( 'reset', '', T_('Reset'), 'ResetButton' ),
		array( 'submit', 'submit[restore_defaults]', T_('Restore defaults'), 'ResetButton' ),
	) );
}

?>
