<?php
/**
 * This file implements the Plugin settings form
 *
 * @copyright (c) 2009 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://www.gnu.org/licenses/gpl.txt GNU General Public License v3
 * @package blogs
 */
if(!defined('QP_MAIN_INIT')) die('fail');

global $Blog;
global $Plugins;

$Form = new Form( NULL, 'plugin_settings_checkchanges' );

// PluginUserSettings
load_funcs( 'plugins/_plugin.funcs.php' );

$have_plugins = false;
$Plugins->restart();
while( $loop_Plugin = & $Plugins->get_next() )
{
	$Form->begin_form( 'fform' );
	$Form->hidden_ctrl();
	$Form->hidden( 'tab', 'plugin_settings' );
	$Form->hidden( 'action', 'update' );
	$Form->hidden( 'blog', $Blog->ID );
	// We use output buffers here to display the fieldset only if there's content in there
	ob_start();

	$Form->begin_fieldset( $loop_Plugin->name );
	ob_start();

	$plugin_settings = $loop_Plugin->GetDefaultBlogSettings( $tmp_params = array('for_editing' => true) );
	if( is_array( $plugin_settings ) )
	{
		foreach( $plugin_settings as $l_name => $l_meta )
		{
			// Display form field for this setting
			autoform_display_field( $l_name, $l_meta, $Form, 'BlogSettings', $loop_Plugin, $Blog );
		}
	}

	$has_contents = strlen( ob_get_contents() );

	$Form->end_fieldset();

	if( $has_contents )
	{
		ob_end_flush();
		ob_end_flush();

		$have_plugins = true;
	}
	else
	{
		// No content, discard output buffers
		ob_end_clean();
		ob_end_clean();
	}
}

if( $have_plugins )
{
	// End form
	$Form->end_form( array(
		array( 'submit', 'submit', T_('Update'), 'SaveButton' ),
		array( 'reset', '', T_('Reset'), 'ResetButton' )
	) );
}
else
{
	// Display a message
	echo '<p>', T_( 'There are no plugins providing blog-specific settings.' ), '</p>';
	$Form->end_form();
}

?>
