<?php
/**
 * This file implements the Category form
 *
 * @copyright (c) 2009 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://www.gnu.org/licenses/gpl.txt GNU General Public License v3
 * @package categories
 */
if(!defined('QP_MAIN_INIT')) die('fail');

global $action;
global $edited_GenericCategory;
global $GenericCategoryCache;
global $Settings;
global $subset_ID;

$edited_Category = & $edited_GenericCategory;

// Determine if we are creating or updating...
$creating = is_create_action( $action );

$Form = new Form( NULL, 'form' );
$Form->global_icon( T_('Cancel editing!'), 'close', regenerate_url( 'action' ), T_('cancel') );

$Form->begin_form( 'fform', $creating ? T_('New category') : T_('Category') );
$Form->hidden( 'action', $creating ? 'create' : 'update' );
$Form->hiddens_by_key( get_memorized( 'action' ) );

$Form->begin_fieldset( T_('Properties') );

// We're essentially double checking here...
$edited_Blog = & $edited_Category->get_Blog();

$move = '';
if( $Settings->get( 'allow_moving_cats' ) )
{
	// If moving cats between blogs is allowed
	$move = ' '.action_icon( T_('Move to a different blog...'), 'move', regenerate_url( 'action,cat_ID', 'cat_ID='.$edited_Category->ID.'&amp;action=move' ), T_('Move') );
}
$Form->info( T_('Blog'), $edited_Blog->get_maxlen_name().$move );
$Form->select_input_options( 'cat_parent_ID',
	$GenericCategoryCache->recurse_select( $edited_Category->parent_ID, $subset_ID, true, NULL, 0, array( $edited_Category->ID ) ), T_('Parent category') );
$Form->text_input( 'cat_name', $edited_Category->name, 40, T_('Name'), '', array( 'required' => true, 'maxlength' => 255 ) );
$Form->text_input( 'cat_urlname', $edited_Category->urlname, 40, T_('URL "slug"'), T_('Used for clean URLs. Must be unique.'), array( 'maxlength' => 255 ) );
$Form->text_input( 'cat_description', $edited_Category->description, 40, T_('Description'), T_('May be used as a title tag and/or meta description'), array( 'maxlength' => 255 ) );
if( $Settings->get( 'category_order' ) == 'manual' )
{
	$Form->text_input( 'cat_order', $edited_Category->order, 5, T_('Order'), T_('For manual ordering of the categories'), array( 'maxlength' => 11 ) );
}
$Form->end_fieldset();

if( $creating )
{
	$Form->end_form( array(
		array( 'submit', 'submit', T_('Record'), 'SaveButton' ),
		array( 'reset', '', T_('Reset'), 'ResetButton' )
	) );
}
else
{
	$Form->end_form( array(
		array( 'submit', 'submit', T_('Update'), 'SaveButton' ),
		array( 'reset', '', T_('Reset'), 'ResetButton' )
	) );
}

?>
