<?php
/**
 * This file implements the Comment form
 *
 * @copyright (c) 2009 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://www.gnu.org/licenses/gpl.txt GNU General Public License v3
 * @package comments
 */
if(!defined('QP_MAIN_INIT')) die('fail');

global $Blog;
global $comments_use_autobr;
global $edited_Comment;
global $mode;
global $month;
global $Plugins;
global $redirect_to;
global $tab;

$Form = new Form( NULL, 'comment_checkchanges', 'post' );
$Form->global_icon( T_('Cancel editing!'), 'close', str_replace( '&', '&amp;', $redirect_to), T_('cancel') );
$Form->begin_form( 'eform' );
$Form->hidden_ctrl();
$Form->hidden( 'action', 'update' );
$Form->hidden( 'redirect_to', $redirect_to );
$Form->hidden( 'comment_ID', $edited_Comment->ID );
?>

<div class="clear"></div>
<div class="left_col">
<?php
$Form->begin_fieldset( T_('Comment contents') );
echo '<table cellspacing="0" class="compose_layout">';
echo '<tr><td width="1%"><strong>'.T_('In response to').':</strong></td>';
echo '<td class="input">';
$comment_Item = & $edited_Comment->get_Item();
// display and link item title
$comment_Item->title( array(
	'link_type' => 'admin_view',
) );
echo '</td></tr>';

if( ! $edited_Comment->get_author_User() )
{
	// This is not a member comment
	$Form->switch_layout( 'none' );

	echo '<tr><td width="1%"><strong>'.T_('Author').':</strong></td>';
	echo '<td class="input">';
	$Form->text_input( 'newcomment_author', $edited_Comment->author, 20, '', '', array('maxlength' => 100, 'style' => 'width: 100%;') );
	echo '</td></tr>';

	echo '<tr><td width="1%"><strong>'.T_('Email').':</strong></td>';
	echo '<td class="input">';
	$Form->text_input( 'newcomment_author_email', $edited_Comment->author_email, 20, '', '', array('maxlength' => 100, 'style' => 'width: 100%;') );
	echo '</td></tr>';

	echo '<tr><td width="1%"><strong>'.T_('Website URL').':</strong></td>';
	echo '<td class="input">';
	$Form->text_input( 'newcomment_author_url', $edited_Comment->author_url, 20, '', '', array('maxlength' => 100, 'style' => 'width: 100%;') );
	echo '</td></tr>';

	$Form->switch_layout( NULL );
}
else
{
	echo '<tr><td width="1%"><strong>'.T_('Author').':</strong></td>';
	echo '<td class="input">';
	// display comment author's name
	$edited_Comment->author( array() );
	echo '</td></tr>';
}

echo '</table>';
?>

<div class="edit_toolbars">
<?php
// spark the plugin manager
$Plugins->trigger_event( 'AdminDisplayToolbarAbove', array(
	'target_type' => 'Comment',
	'template_type' => $Blog->template_type,
) );
?>
</div>

<?php // TEXTAREA
$content = $edited_Comment->content;
if( $comments_use_autobr == 'always' || $comments_use_autobr == 'opt-out' )
{
	$content = unautobrize( $content );
}

$Form->fieldstart = '<div class="edit_area">';
$Form->fieldend = "</div>\n";
$Form->textarea( 'content', $content, 16, '', '', 40, '' );
$Form->fieldstart = '<div class="tile">';
$Form->fieldend = '</div>';
?>
<script type="text/javascript">
<!--
// This is for toolbar plugins
var app_Canvas = document.getElementById('content');
//-->
</script>

<div class="edit_toolbars">
<?php
// spark the plugin manager
$Plugins->trigger_event( 'AdminDisplayToolbarBelow', array(
	'target_type' => 'Comment',
	'template_type' => $Blog->template_type,
) );
?>
</div>

<div class="edit_actions">
<input type="submit" value="<?php /* TRANS: This is the value of an input submit button */ echo T_('Save !'); ?>" class="SaveButton" tabindex="10" />
<?php
if( $action == 'editcomment' )
{
	// display a link to delete a comment
	$edited_Comment->delete_link( array(
		'class' => 'DeleteButton',
	) );
}

// spark the plugin manager
$Plugins->trigger_event( 'AdminDisplayEditorButton', array(
	'target_type' => 'Comment',
) );
?>
</div>

<?php
$Form->end_fieldset();

$Form->begin_fieldset( T_('Advanced properties') );
$Form->switch_layout( 'linespan' );

if( $current_User->check_perm( 'edit_timestamp' ) )
{
	// TIME STAMP
	echo '<div id="itemform_edit_timestamp">';
	$Form->date( 'comment_issue_date', $edited_Comment->date, T_('Comment date') );
	echo ' '; // allow wrapping!
	$Form->time( 'comment_issue_time', $edited_Comment->date, '' );
	echo '</div>';
}

// AUTOBR ... fp> TODO: this should be Auto-P and handled by the Auto-P plugin
?>
<input type="checkbox" class="checkbox" name="post_autobr" value="1"
<?php if( $comments_use_autobr == 'always' || $comments_use_autobr == 'opt-out' )
{
	echo ' checked="checked"';
}
?>
 id="autobr" tabindex="6" />
<label for="autobr"><strong><?php echo T_('Auto-BR') ?></strong></label>
<?php
$Form->switch_layout( NULL );

$Form->end_fieldset();

// spark the plugin manager
$Plugins->trigger_event( 'AdminDispCommentFormField', array(
	'Form' => & $Form,
	'Comment' => & $edited_Comment,
) );
?>
</div>

<div class="right_col">
<div class="edit_toolbars">
<?php
// spark the plugin manager
$Plugins->trigger_event( 'AdminDisplayToolbarSidebar', array(
	'target_type' => 'Comment',
	'template_type' => $Blog->template_type,
) );
?>
</div>

<?php
if( $Blog->get_setting( 'allow_rating' ) != 'never' || ! empty( $edited_Comment->rating ) )
{
	// Rating is editable
	$Form->begin_fieldset( T_('Rating') );

	// display options to rate a comment
	$edited_Comment->rating_input( array(
		'before' => '<p>',
		'after' => '</p>',
	) );

	// display option to reset rating
	$edited_Comment->rating_none_input( array(
		'before' => '<p>',
		'after' => '</p>',
	) );

	$Form->end_fieldset();
}
else
{
	$Form->hidden( 'comment_rating', 0 );
}

/*
$Form->begin_fieldset( T_('Properties') );
echo '<p>';
$Form->checkbox_basic_input( 'comment_featured', $edited_Comment->featured, T_('Featured') );
echo '</p>';
$Form->end_fieldset();
*/

$Form->begin_fieldset( T_('Visibility'), array( 'id' => 'commentform_visibility' ) );
$sharing_options[] = array( 'published', T_('Published (Public)') );
$sharing_options[] = array( 'draft', T_('Draft (Not published!)') );
$sharing_options[] = array( 'deprecated', T_('Deprecated (Not published!)') );
$Form->radio( 'comment_status', $edited_Comment->status, $sharing_options, '', true );
$Form->end_fieldset();

$Form->begin_fieldset( T_('Links') );
echo '<p>';
$Form->checkbox_basic_input( 'comment_nofollow', $edited_Comment->nofollow, T_('Nofollow website URL') );
echo '</p>';
$Form->end_fieldset();
$Form->begin_fieldset( T_('Feedback info') );
?>

<p><strong><?php echo T_('Type') ?>:</strong> <?php echo $edited_Comment->type; ?></p>
<p><strong><?php echo T_('IP address') ?>:</strong> <?php
// Display IP address and allow plugins to filter it, e.g. the DNSBL plugin will add a link to check the IP
echo $Plugins->get_trigger_event( 'FilterIpAddress', array('format' => 'htmlbody', 'data' => $edited_Comment->author_IP), 'data' ); ?></p>
<p><strong><?php echo T_('Spam Karma') ?>:</strong> <?php $edited_Comment->spam_karma(); ?></p>

<?php
$Form->end_fieldset();
?>
</div>

<div class="clear"></div>

<?php
$Form->end_form();
?>
