<?php
/**
 * This file implements the comment list
 *
 * @uses get_ban_domain()
 * @copyright (c) 2009 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://www.gnu.org/licenses/gpl.txt GNU General Public License v3
 * @package comments
 */
if(!defined('QP_MAIN_INIT')) die('fail');

global $Blog;
global $Comment;
global $CommentList;
global $dispatcher;

while( $Comment = & $CommentList->get_next() )
{
	// Loop through comments
	?>
	<div id="c<?php echo $Comment->ID ?>" class="bComment bComment<?php $Comment->status('raw') ?>">
	<div class="bSmallHead">
	<div class="bSmallHeadRight">
	<?php echo T_('Visibility').': '; ?>
	<span class="bStatus">
	<?php $Comment->status(); ?>
	</span>
	</div>
	<?php
	// display the comment's date
	$Comment->date( array(
		'before' => '<span class="bDate">',
		'after' => '</span> @ ',
	) );

	// display the comment's time
	$Comment->time( array(
		'before' => '<span class="bTime">',
		'after' => '</span>',
		'format' => 'H:i',
	) );

	// display a link to comment author's URL
	if( $Comment->author_url( array( 'before' => ' &middot; Url: <span class="bUrl">', 'after' => '</span>' ) )
		&& $current_User->check_perm( 'spamblacklist', 'edit' ) )
	{
		// There is an URL and we have permission to ban...
		echo ' <a href="'.$dispatcher.'?ctrl=antispam&amp;action=ban&amp;keyword='.rawurlencode( get_ban_domain( $Comment->author_url ) )
			.'&amp;aspm_source=comment&amp;aspm_shortened=0">'.get_icon( 'ban' ).'</a> ';
	}
	// display mailto link to comment author's email
	$Comment->author_email( array(
		'before' => ' &middot; Email: <span class="bEmail">',
		'after' => '</span>',
	) );

	// display comment author's IP address
	$Comment->author_ip( array(
		'before' => ' &middot; IP: <span class="bIP">',
		'after' => '</span>',
	) );

	echo ' &middot; <span class="bKarma">';
	$Comment->spam_karma( T_('Spam Karma').': %s%', T_('No Spam Karma') );
	echo '</span>';
	?>
	</div>
	<div class="bCommentContent">
	<div class="bTitle">
	<?php
	$comment_Item = & $Comment->get_Item();
	echo T_('In response to')
		.': <a href="?ctrl=items&amp;blog='.$Blog->ID.'&amp;p='.$comment_Item->ID.'">'.$comment_Item->dget( 'title' ).'</a>';
	?>
	</div>
	<div class="bCommentTitle">
	<?php echo $Comment->get_title(); ?>
	</div>
	<div class="bCommentText">
	<?php
	// display a comment's rating
	$Comment->rating( array() );
	$Comment->content(); // display the comment's contents
	?>
	</div>
	</div>
	<div class="CommentActionsArea">
	<?php
	// display a permalink link to the comment
	$Comment->permanent_link( array(
		'class' => 'permalink_right',
	) );

	// display a link to edit a comment
	$Comment->edit_link( array(
		'class' => 'ActionButton',
	) );

	// display a link to publish a comment
	$Comment->publish_link( array(
		'class' => 'PublishButton',
	) );

	// display a link to deprecate a comment
	$Comment->deprecate_link( array(
		'class' => 'DeleteButton',
	) );

	// display a link to delete a comment
	$Comment->delete_link( array(
		'class' => 'DeleteButton',
	) );
	?>
	<div class="clear"></div>
	</div>

	</div>
	<?php //end of the loop, don't delete
}

?>
