<?php
/**
 * This file implements the UI view for the cron job form
 *
 * @copyright (c) 2009 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://www.gnu.org/licenses/gpl.txt GNU General Public License v3
 * @package cron
 */
if(!defined('QP_MAIN_INIT')) die('fail');

global $localtimenow, $cron_job_names;

$Form = new Form( NULL, 'cronjob' );
$Form->global_icon( T_('Cancel!'), 'close', regenerate_url( 'action' ), T_('cancel') );
$Form->begin_form( 'fform', T_('New scheduled job') );
$Form->hiddens_by_key( get_memorized( 'action' ) );
$Form->hidden( 'action', 'create' );

$Form->begin_fieldset( T_('Job details') );
$Form->select_input_array( 'cjob_type', NULL, $cron_job_names, T_('Job type') );
$Form->date_input( 'cjob_date', date2mysql( $localtimenow ), T_('Schedule date'), array( 'required' => true ) );
$Form->time_input( 'cjob_time', date2mysql( $localtimenow ), T_('Schedule time'), array( 'required' => true ) );
$Form->duration_input( 'cjob_repeat_after', 0, T_('Repeat every'), array( 'minutes_step' => 1 ) );
$Form->end_fieldset();

$Form->end_form( array(
	array( 'submit', 'submit', T_('Create'), 'SaveButton' ),
	array( 'reset', '', T_('Reset'), 'ResetButton' ),
) );

?>
