<?php
/**
 * This file implements the UI view for the cron log form
 *
 * @copyright (c) 2009 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://www.gnu.org/licenses/gpl.txt GNU General Public License v3
 * @package cron
 */
if(!defined('QP_MAIN_INIT')) die('fail');

global $cjob_row;

$Form = new Form( NULL, 'cronlog' );
$Form->global_icon( T_('Close sheet'), 'close', regenerate_url( 'action,cjob_ID' ), T_('cancel') );
$Form->begin_form( 'fform', T_('Scheduled job') );

$Form->begin_fieldset( T_('Job details') );
$Form->info( T_('Job #'), $cjob_row->ctsk_ID );
$Form->info( T_('Job name'), $cjob_row->ctsk_name );
$Form->info( T_('Scheduled at'), mysql2localedatetime( $cjob_row->ctsk_start_datetime ) );
$cjob_repeat_after = '';
if( $cjob_repeat_after_days = floor( $cjob_row->ctsk_repeat_after / 86400 ) )
{
	$cjob_repeat_after .= $cjob_repeat_after_days.' '.T_('days').' ';
}
if( $cjob_repeat_after_hours = floor( ( $cjob_row->ctsk_repeat_after % 86400 ) / 3600 ) )
{
	$cjob_repeat_after .= $cjob_repeat_after_hours.' '.T_('hours').' ';
}
if( $cjob_repeat_after_minutes = floor( ( $cjob_row->ctsk_repeat_after % 3600 ) / 60 ) )
{
	$cjob_repeat_after .= $cjob_repeat_after_minutes.' '.T_('minutes');
}
$Form->info( T_('Repeat every'), $cjob_repeat_after );
$Form->end_fieldset();

$Form->begin_fieldset( T_('Execution details') );
if( empty( $cjob_row->clog_status ) )
{
	$Form->info( T_('Status'), 'pending' );
}
else
{
	$Form->info( T_('Status'), '<span class="cron_'.$cjob_row->clog_status.'">'.$cjob_row->clog_status.'</span>' );
	$Form->info( T_('Real start time'), mysql2localedatetime( $cjob_row->clog_realstart_datetime ) );
	$Form->info( T_('Real stop time'), mysql2localedatetime( $cjob_row->clog_realstop_datetime ) );
	$Form->info( T_('Messages'), str_replace( "\n", "<br />\n", $cjob_row->clog_messages ) );
}
$Form->end_fieldset();

$Form->end_form();

?>
