<?php
/**
 * $ctrl_mappings: 'dashboard' || Dashboard -> all
 *
 * @uses get_ban_domain()
 *
 * @copyright (c) 2009 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://www.gnu.org/licenses/gpl.txt GNU General Public License v3
 * @package admin
 */
if(!defined('QP_MAIN_INIT')) die('fail');

global $app_allow_dbase_reset;
global $basepath;
global $current_User;
global $dash_disp_num;
global $dispatcher;
global $install_subdir;

if( $blog )
{
	if( ! $current_User->check_perm( 'blog_ismember', 1, false, $blog ) )
	{
		// We don't have permission for the requested blog (may happen if we come to
		// admin from a link on a different blog)
		set_working_blog( 0 );
		unset( $Blog );
	}
}

$AdminUI->set_blog_list_params( 'blog_ismember', 'view', array(), T_('Global'), '?blog=0' );
$AdminUI->set_path( 'dashboard' );
// Display <html><head>...</head> section (should be done early if actions do not redirect)
$AdminUI->disp_html_head();
// Display title, menu, messages, etc... (messages MUST be displayed AFTER the actions)
$AdminUI->disp_body_top();

// security notice on and disable write page
if( is_file( $basepath.$install_subdir.'index.php' ) )
{
	echo '<div class="action_messages"><div class="log_error">'.T_('Your /qp_install/index.php file is still there. That\'s not good. You need to delete that file OR delete the entire /qp_install/ folder!').'</div></div>';
	if( $app_allow_dbase_reset )
	{
		echo '<div class="action_messages"><div class="log_error">'.T_('Additionally, your /qp_config/_main_config.php file allows your database to be reset ($app_allow_dbase_reset is set to \'1\').');
		echo '<ul><li><strong>'.T_('You will not be able to use use this program until you').'</strong>';
		echo '<ul><li>'.T_('delete the file "/qp_install/index.php" OR delete the folder "/qp_install/"').'</li>';
		echo '<li>'.T_('OR change $app_allow_dbase_reset to 0 in your /qp_config/_main_config.php file.').'</li></ul>';
		echo '</ul></div></div>';
	}
}

if( $blog )
{
	// MAIN COLUMN, BLOG SELECTED
	// Begin payload block
	$AdminUI->disp_payload_begin();
	echo '<h2>'.$Blog->dget( 'name' ).'</h2>';
	echo '<table class="browse" cellspacing="0" cellpadding="0" border="0"><tr><td>';
	$block_item_Widget = new Widget( 'block_item' );
	$nb_blocks_displayed = 0;

	// "Comments awaiting moderation" section
	$CommentList = new CommentList( $Blog, "'comment','trackback'", array( 'draft' ), '', '', 'DESC', '', $dash_disp_num );
	if( $CommentList->result_num_rows )
	{
		// we have draft comments...
		$nb_blocks_displayed++;
		$block_item_Widget->title = T_('Comments awaiting moderation');
		$block_item_Widget->disp_template_replaced( 'block_start' );
		while( $Comment = & $CommentList->get_next() )
		{
			// Loop through draft comments
			echo '<div class="dashboard_post">';
			echo '<h3 class="dashboard_post_title">';
			echo $Comment->get_title( array( 'author_format' => '<strong>%s</strong>' ) );
			$comment_Item = & $Comment->get_Item();
			echo ' '.T_('in response to')
					.' <a href="?ctrl=items&amp;blog='.$comment_Item->get_blog_ID().'&amp;p='.$comment_Item->ID.'"><strong>'.$comment_Item->dget( 'title' ).'</strong></a>';
			echo '</h3>';
			echo '<div class="notes">';
			// display a comment's rating
			$Comment->rating( array(
				'before' => '',
				'after' => ' &bull; ',
				'star_class' => 'top',
			) );
			// display the comment's date
			$Comment->date( array() );
			// display a link to comment author's URL
			if( $Comment->author_url( array(
				'before' => ' &bull; Url: <span class="bUrl">',
				'after' => '</span>',
			) ) )
			{
				if( $current_User->check_perm( 'spamblacklist', 'edit' ) )
				{
					// There is an URL and we have permission to ban
					echo ' <a href="'.$dispatcher.'?ctrl=antispam&amp;action=ban&amp;keyword='.rawurlencode( get_ban_domain( $Comment->author_url ) )
						.'&amp;aspm_source=comment&amp;aspm_shortened=0">'.get_icon( 'ban' ).'</a> ';
				}
			}
			// display mailto link to comment author's email
			$Comment->author_email( array(
				'before' => ' &bull; Email: <span class="bEmail">',
				'after' => '</span> &bull; ',
			) );
			// display comment author's IP address
			$Comment->author_ip( array(
				'before' => 'IP: <span class="bIP">',
				'after' => '</span> &bull; ',
			) );
			$Comment->spam_karma( T_('Spam Karma').': %s%', T_('No Spam Karma') );
			echo '</div>';
			?>

			<div class="small">
			<?php $Comment->content(); // display the comment's contents ?>
			</div>

			<div class="dashboard_action_area">
			<?php
			// display a link to edit a comment
			$Comment->edit_link( array(
				'class' => 'ActionButton',
			) );
			// display a link to publish a comment
			$Comment->publish_link( array(
				'class' => 'PublishButton',
			) );
			// display a link to deprecate a comment
			$Comment->deprecate_link( array(
				'class' => 'DeleteButton',
			) );
			// display a link to delete a comment
			$Comment->delete_link( array(
				'class' => 'DeleteButton',
			) );
			?>
			<div class="clear"></div>
			</div>
			</div>
			<?php
		}
		$block_item_Widget->disp_template_raw( 'block_end' );
	}

	// "Recent drafts" section
	$ItemList = new ItemList2( $Blog, NULL, NULL );
	// Filter the new empty list
	$ItemList->set_filters( array(
		'visibility_array' => array( 'draft' ),
		'orderby' => 'datemodified',
		'order' => 'DESC',
		'posts' => $dash_disp_num,
	) );

	// Get ready for display (runs the query)
	$ItemList->display_init();
	if( $ItemList->result_num_rows )
	{
		// We have drafts
		$nb_blocks_displayed++;
		$block_item_Widget->title = T_('Recent drafts');
		$block_item_Widget->disp_template_replaced( 'block_start' );
		while( $Item = & $ItemList->get_item() )
		{
			echo '<div class="dashboard_post" lang="'.$Item->get( 'locale' ).'">';
			// Load item's creator user
			$Item->get_creator_User();
			echo '<div class="dashboard_float_actions">';
			// display a link to edit an item (if user has edit rights)
			$Item->edit_link( array(
				'before' => ' ',
				'class' => 'ActionButton'
			) );
			// display a link to 'publish NOW' an item (if user has edit rights)
			$Item->publish_link( array(
				'before' => ' ',
				'class' => 'PublishButton'
			) );
			echo '<img src="'.$rsc_url.'/img/blank.gif">';
			echo '</div>';
			echo '<h3 class="dashboard_post_title">';
			echo '<a href="?ctrl=items&amp;blog='.$Blog->ID.'&amp;p='.$Item->ID.'">'.$Item->dget( 'title' ).'</a>';
			echo '</h3>';
			echo '</div>';
		}
		$block_item_Widget->disp_template_raw( 'block_end' );
	}

	// "Recently edited" section
	$ItemList = new ItemList2( $Blog, NULL, NULL );
	// Filter the new empty list
	$ItemList->set_filters( array(
			'visibility_array' => array( 'published', 'protected', 'private', 'deprecated', 'redirected' ),
			'orderby' => 'datemodified',
			'order' => 'DESC',
			'posts' => $dash_disp_num,
		) );

	// Get ready for display (runs the query):
	$ItemList->display_init();
	if( $ItemList->result_num_rows )
	{
		// We have recent edits
		$nb_blocks_displayed++;
		if( $current_User->check_perm( 'blog_post_statuses', 'edit', false, $Blog->ID ) )
		{
			// We have permission to add a post with at least one status
			$block_item_Widget->global_icon( T_('Write a new post...'), 'new', '?ctrl=items&amp;action=new&amp;blog='.$Blog->ID, T_('New post').' &raquo;' );
		}
		$block_item_Widget->title = T_('Recently edited');
		$block_item_Widget->disp_template_replaced( 'block_start' );
		while( $Item = & $ItemList->get_item() )
		{
			echo '<div class="dashboard_post" lang="'.$Item->get( 'locale' ).'">';
			// Load item's creator user
			$Item->get_creator_User();
			echo '<div class="dashboard_float_actions">';
			// display a link to edit an item (if user has edit rights)
			$Item->edit_link( array(
				'class' => 'ActionButton'
			) );
			echo '</div>';
			echo '<h3 class="dashboard_post_title">';
			echo '<a href="?ctrl=items&amp;blog='.$Blog->ID.'&amp;p='.$Item->ID.'">'.$Item->dget( 'title' ).'</a>';
			echo ' <span class="dashboard_post_details">';
			// display the item's status
			$Item->status( array(
				'before' => '',
				'after' => ' &bull; ',
			) );
			// display item's view count
			$Item->views( array() );
			echo '</span></h3>';
			// display images linked to this item
			$Item->images( array(
				'before' => '<div class="dashboard_thumbnails">',
				'before_image' => '',
				'before_image_legend' => NULL, // No legend
				'after_image_legend' => NULL,
				'after_image' => '',
				'image_size' => 'fit-80x80'
			) );
			echo '<div class="small">'.$Item->get_content_excerpt( 150 ).'</div>';
			echo '<div style="clear:left;">'.get_icon('pixel').'</div>'; // IE crap
			echo '</div>';
		}
		$block_item_Widget->disp_template_raw( 'block_end' );
	}

	if( $nb_blocks_displayed == 0 )
	{
		// We haven't displayed anything yet!
		$nb_blocks_displayed++;
		$block_item_Widget->title = T_('Getting started');
		$block_item_Widget->disp_template_replaced( 'block_start' );
		echo '<p><strong>'.T_('Welcome to your new blog\'s dashboard!').'</strong></p>';
		echo '<p>'.T_('Use the links on the right to write a first post or to customize your blog.').'</p>';
		echo '<p>';
		printf( T_('You can see your blog page at any time by clicking "See" in the %s toolbar at the top of this page.'), $app_name );
		echo '</p>';
		echo '<p>'.T_('You can come back here at any time by clicking "Manage" in that same navbar.').'</p>';
		$block_item_Widget->disp_template_raw( 'block_end' );
	}

	// spark the plugin manager
	$Plugins->trigger_event( 'DashboardBlogMain', array(
		'blog' => 'blog',
		'current_User' => 'current_User'
	) );

	echo '</td><td>';

	// SIDEBAR COLUMN, BLOG SELECTED
	// "Manage your blog" section
	$side_item_Widget = new Widget( 'side_item' );
	$side_item_Widget->title = T_('Manage your blog');
	$side_item_Widget->disp_template_replaced( 'block_start' );
	echo '<div class="dashboard_sidebar">';
	echo '<ul>';
	echo '<li><a href="'.$dispatcher.'?ctrl=items&amp;action=new&amp;blog='.$Blog->ID.'">'.T_('Write a new post').' &raquo;</a></li>';
	echo '<li>'.T_('Browse').':<ul>';
	echo '<li><a href="'.$dispatcher.'?ctrl=items&tab=full&filter=restore&blog='.$Blog->ID.'">'.T_('Posts (full)').' &raquo;</a></li>';
	echo '<li><a href="'.$dispatcher.'?ctrl=items&tab=list&filter=restore&blog='.$Blog->ID.'">'.T_('Posts (list)').' &raquo;</a></li>';
	echo '<li><a href="'.$dispatcher.'?ctrl=comments&amp;blog='.$Blog->ID.'">'.T_('Comments').' &raquo;</a></li>';
	echo '</ul></li>';

	if( $current_User->check_perm( 'blog_cats', '', false, $Blog->ID ) )
	{
		echo '<li><a href="'.$dispatcher.'?ctrl=cats&blog='.$Blog->ID.'">'.T_('Edit categories').' &raquo;</a></li>';
	}

	echo '<li><a href="'.$Blog->get( 'url' ).'">'.T_('View this blog').'</a></li>';
	echo '</ul></div>';

	$side_item_Widget->disp_template_raw( 'block_end' );
	if( $current_User->check_perm( 'blog_properties', 'edit', false, $Blog->ID ) )
	{
		// "Customize your blog" section
		$side_item_Widget->title = T_('Customize your blog');
		$side_item_Widget->disp_template_replaced( 'block_start' );
		echo '<div class="dashboard_sidebar"><ul>';
		echo '<li><a href="'.$dispatcher.'?ctrl=blog_settings&amp;tab=general&amp;blog='.$Blog->ID.'">'.T_('Blog properties').' &raquo;</a></li>';
		echo '<li><a href="'.$dispatcher.'?ctrl=blog_settings&amp;tab=features&amp;blog='.$Blog->ID.'">'.T_('Blog features').' &raquo;</a></li>';
		echo '<li><a href="'.$dispatcher.'?ctrl=blog_settings&amp;tab=template&amp;blog='.$Blog->ID.'">'.T_('Blog template').' &raquo;</a></li>';
		echo '<li><a href="'.$dispatcher.'?ctrl=widgets&amp;blog='.$Blog->ID.'">'.T_('Blog widgets').' &raquo;</a></li>';
		echo '<li><a href="'.$dispatcher.'?ctrl=blog_settings&amp;tab=urls&amp;blog='.$Blog->ID.'">'.T_('Blog URLs').' &raquo;</a></li>';
		echo '</ul></div>';
		$side_item_Widget->disp_template_raw( 'block_end' );
	}

	// spark the plugin manager
	$Plugins->trigger_event( 'DashboardBlogSide', array(
		'blog' => 'blog',
		'current_User' => 'current_User'
	) );

}
else
{
	// We're on the GLOBAL tab (no blog specified)
	// Begin payload block
	$AdminUI->disp_payload_begin();
	echo '<h2>'.T_('Select a blog').'</h2>';
	echo '<table class="browse" cellspacing="0" cellpadding="0" border="0"><tr><td>';
	// Display blog list VIEW
	$AdminUI->disp_view( 'blogs/views/_blog_list.view.php' );
	// spark the plugin manager
	$Plugins->trigger_event( 'DashboardNoBlogMain', array(
		'current_User' => 'current_User'
	) );

	echo '</td><td>';

// spark the plugin manager
$Plugins->trigger_event( 'DashboardNoBlogSide', array(
	'current_User' => 'current_User'
) );

}

// SIDEBAR IF ADMIN PERMISSIONS (WHETHER BLOG IS SPECIFIED OR NOT)
if( $current_User->check_perm( 'options', 'edit' ) )
{
	// "Administrative tasks" section
	$side_item_Widget = new Widget( 'side_item' );
	$side_item_Widget->title = T_('Administrative tasks');
	$side_item_Widget->disp_template_replaced( 'block_start' );
	echo '<div class="dashboard_sidebar"><ul>';
	if( $current_User->check_perm( 'users', 'edit' ) )
	{
		echo '<li><a href="'.$dispatcher.'?ctrl=users&amp;action=new_user">'.T_('Create new user').' &raquo;</a></li>';
	}
	if( $current_User->check_perm( 'blogs', 'create' ) )
	{
		echo '<li><a href="'.$dispatcher.'?ctrl=blogs&amp;action=new">'.T_('Create new blog').' &raquo;</a></li>';
	}
	echo '<li><a href="'.$dispatcher.'?ctrl=templates">'.T_('Install a template').' &raquo;</a></li>';
	echo '<li><a href="'.$dispatcher.'?ctrl=plugins">'.T_('Install a plugin').' &raquo;</a></li>';
	echo '<li><a href="'.$dispatcher.'?ctrl=system">'.T_('Check system &amp; security').' &raquo;</a></li>';
	echo '</ul></div>';
	$side_item_Widget->disp_template_raw( 'block_end' );

	// spark the plugin manager
	$Plugins->trigger_event( 'DashboardAdminSide', array(
		'current_User' => 'current_User'
	) );

}

echo '</td></tr></table>';

// End payload block
$AdminUI->disp_payload_end();
// Display body bottom, debug info and close </html>
$AdminUI->disp_global_footer();

?>
