<?php
/**
 * This file implements the UI for file display settings
 *
 * @copyright (c) 2009 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://www.gnu.org/licenses/gpl.txt GNU General Public License v3
 * @package files
 */
if(!defined('QP_MAIN_INIT')) die('fail');

global $fm_FileRoot;
global $UserSettings;

$Form = new Form( NULL, 'file_displaysettings_checkchanges' );
$Form->global_icon( T_('Close settings!'), 'close', regenerate_url(), T_('cancel') );

$Form->begin_form( 'fform', T_('Display settings') );

if( $current_User->check_perm( 'options', 'edit', false ) )
{
	echo '<p class="note">'.T_('See also:').' ';

	if( $fm_FileRoot->type == 'blog' )
	{
		echo T_('Blog Settings').' &gt; '.T_('General').' &gt; <a href="?ctrl=blog_settings&tab=general&blog='.$fm_FileRoot->in_type_ID.'">'
			.T_('Media directory location').'</a> &bull; ';
	}

	echo T_('Global settings').' &gt; <a href="?ctrl=fileset">'.T_('Files').'</a> &amp; <a href="?ctrl=filetypes">'.T_('File types').'</a></p>';
}

$Form->hidden_ctrl();
$Form->hiddens_by_key( get_memorized() );

$Form->begin_fieldset( T_('Images') );
$Form->checkbox( 'option_imglistpreview', $UserSettings->get( 'fm_imglistpreview' ), T_('Thumbnails'), T_('Check to display thumbnails instead of icons for image files') );
$Form->checkbox( 'option_getimagesizes', $UserSettings->get( 'fm_getimagesizes' ), T_('Dimensions'), T_('Check to display the pixel dimensions of image files') );
$Form->end_fieldset();

$Form->begin_fieldset( T_('Columns') );
$Form->checkbox( 'option_showtypes', $UserSettings->get( 'fm_showtypes' ), T_('File type'), T_('Based on file extension') );
$Form->radio_input( 'option_showdate', $UserSettings->get( 'fm_showdate' ), array(
	array( 'value' => 'no', 'label' => T_('No') ),
	array( 'value' => 'compact', 'label' => T_('Compact format') ),
	array( 'value' => 'long', 'label' => T_('Long format') )
	), T_('Last change') );
$Form->checkbox( 'option_showfsperms', $UserSettings->get( 'fm_showfsperms' ), T_('File permissions'), T_('Unix file permissions') );
$Form->checkbox( 'option_permlikelsl', $UserSettings->get( 'fm_permlikelsl' ), '', T_('Check to display file permissions like "rwxr-xr-x" rather than short form') );
$Form->checkbox( 'option_showfsowner', $UserSettings->get( 'fm_showfsowner' ), T_('File Owner'), T_('Unix file owner') );
$Form->checkbox( 'option_showfsgroup', $UserSettings->get( 'fm_showfsgroup' ), T_('File Group'), T_('Unix file group') );
$Form->end_fieldset();

$Form->begin_fieldset( T_('Options') );
$Form->checkbox( 'option_showhidden', $UserSettings->get( 'fm_showhidden' ), T_('Hidden files'), T_('Check to show hidden files. Hidden files start with a dot (.)') );
$Form->checkbox( 'option_dirsattop', ! $UserSettings->get( 'fm_dirsnotattop' ), T_('Folders first'), T_('Check to always display folders before files') );
$Form->checkbox( 'option_recursivedirsize', $UserSettings->get( 'fm_recursivedirsize' ), T_('Folder sizes'), T_('Check to compute recursive size of folders') );
$Form->radio_input( 'option_allowfiltering', $UserSettings->get( 'fm_allowfiltering' ), array(
	array( 'value' => 'no', 'label' => T_('Don\'t show') ),
	array( 'value' => 'simple', 'label' => T_('Simple') ),
	array( 'value' => 'regexp', 'label' => T_('With regular expressions') )
	), T_('Filter box') );
$Form->end_fieldset();

$Form->end_form( array(
	array( 'submit', 'actionArray[update_settings]', T_('Update !'), 'ActionButton'),
	array( 'reset', '', T_('Reset'), 'ResetButton' )
) );

?>
