<?php
/**
 * This file implements the UI for file copy / move
 *
 * @copyright (c) 2009 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://www.gnu.org/licenses/gpl.txt GNU General Public License v3
 * @package files
 */
if(!defined('QP_MAIN_INIT')) die('fail');

global $fm_mode;
global $fm_source_Filelist;
global $new_names;

$Form = new Form( NULL, 'fm_copymove_checkchanges' );
$Form->global_icon( T_('Quit copy/move mode!'), 'close', regenerate_url('fm_sources,fm_mode'), T_('cancel') );
$Form->begin_form( 'fform', $fm_mode == 'file_copy' ? T_('Copy') : T_('Move') );
$Form->hidden_ctrl();
$Form->hiddens_by_key( get_memorized() );
$Form->hidden( 'confirm', 1 );

$fm_source_Filelist->restart();
while( $loop_src_File = & $fm_source_Filelist->get_next() )
{
	$Form->begin_fieldset( T_('Source').': '.$loop_src_File->get_rdfp_rel_path() );
	if( isset( $overwrite[$loop_src_File->get_md5_ID()] ) )
	{
		$Form->checkbox( 'overwrite['.$loop_src_File->get_md5_ID().']', $overwrite[$loop_src_File->get_md5_ID()], T_('Overwrite'), T_('Check to overwrite the existing file') );
	}
	$Form->text( 'new_names['.$loop_src_File->get_md5_ID().']', $new_names[$loop_src_File->get_md5_ID()],
		32, T_('New name'), $loop_src_File->dget( 'title' ), 128 );
	$Form->end_fieldset();
}

$Form->end_form( array(
	array( 'submit', 'submit', $fm_mode == 'file_copy' ? T_('Copy') : T_('Move'), 'SaveButton' ),
	array( 'reset', '', T_('Reset'), 'ResetButton' )
) );

echo '<p class="notes"><strong>'.T_('You are in copy/move mode.').'</strong> '.T_('Please navigate to the desired target location.').'</p>';

?>
