<?php
/**
 * This file implements the UI for item links in the filemanager.
 *
 * @copyright (c) 2009 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://www.gnu.org/licenses/gpl.txt GNU General Public License v3
 * @package files
 */
if(!defined('QP_MAIN_INIT')) die('fail');

global $edited_Item;
global $mode;

if( $mode != 'upload' )
{
	// If not operating in a popup opened from post edit screen
	$Form = new Form( NULL, 'fm_links', 'post', 'fieldset' );
	$Form->begin_form( 'fform' );
	$Form->hidden_ctrl();

	$Results = new Results( 'SELECT link_ID, link_ltype_ID, T_files.*
		FROM T_links
		INNER JOIN T_files ON link_file_ID = file_ID
		WHERE link_itm_ID = '.$edited_Item->ID, 'link_' );

	$Results->title = sprintf( T_('Files linked to &laquo;%s&raquo;'),
		'<a href="?ctrl=items&amp;blog='.$edited_Item->get_blog_ID().'&amp;p='.$edited_Item->ID.'" title="'
		.T_('View this post...').'">'.$edited_Item->dget( 'title' ).'</a>' );

	if( $current_User->check_perm( 'item_post!CURSTATUS', 'edit', false, $edited_Item ) )
	{
		// User has permission to edit this post
		$Results->global_icon( T_('Edit this post...'), 'edit', '?ctrl=items&amp;action=edit&amp;p='.$edited_Item->ID, T_('Edit') );
	}

	// Close link mode and continue in File Manager (remember the Item_ID though)
	$Results->global_icon( T_('Quit link mode!'), 'close', regenerate_url( 'fm_mode' ), T_('cancel') );

	$Results->cols[] = array(
		'th' => T_('File'),
		'order' => 'link_ID',
		'th_class' => 'shrinkwrap',
		'td_class' => 'shrinkwrap',
		'td' => '%file_type( {row} )%',
	);

	$Results->cols[] = array(
		'th' => T_('Path'),
		'order' => 'file_path',
		'td_class' => 'left',
		'td' => '%file_path()%',
	);

	// TITLE COLUMN
	$Results->cols[] = array(
		'th' => T_('Title'),
		'order' => 'file_title',
		'td_class' => 'left',
		'td' => '$file_title$',
	);

	$Results->cols[] = array(
		'th' => T_('Actions'),
		'th_class' => 'shrinkwrap',
		'td_class' => 'shrinkwrap',
		'td' => '%file_actions( #link_ID# )%',
	);
	$Results->display();

	$Form->end_form( );
}

// Check that we have permission to edit item:
if( $current_User->check_perm( 'item_post!CURSTATUS', 'edit', false, $edited_Item ) )
{
	echo '<div><span class="highlight">', sprintf( T_('Click on the %s icon to link/attach additional files to this item %s.'),
		get_icon( 'link', 'imgtag', array( 'class' => 'top' ) ),
		'&laquo;<strong>'.$edited_Item->dget( 'title' ).'</strong>&raquo;' ), '</span></div>';
}

/**
 * ACTIONS COLUMN
 */
function file_actions( $link_ID )
{
	global $current_File;
	global $current_User;
	global $edited_Item;

	$title = T_('Locate this file!');
	$r = $current_File->get_linkedit_link( '&amp;fm_mode=link_item&amp;item_ID='.$edited_Item->ID,
		get_icon( 'locate', 'imgtag', array( 'title' => $title ) ), $title );

	// Check that we have permission to edit item
	if( $current_User->check_perm( 'item_post!CURSTATUS', 'edit', false, $edited_Item ) )
	{
		$r .= action_icon( T_('Delete this link!'), 'unlink', regenerate_url( 'action', 'link_ID='.$link_ID.'&amp;action=unlink') );
	}
	return $r;
}

/**
 * dummy docblock
 */
function file_path()
{
	global $current_File;
	global $edited_Item;

	// File relative path & name
	return $current_File->get_linkedit_link( '&amp;fm_mode=link_item&amp;item_ID='.$edited_Item->ID );
}


/**
 * dummy docblock
 */
function file_type( & $row )
{
	global $current_File;

	// Instantiate a File object for this line
	$current_File = new File( $row->file_root_type, $row->file_root_ID, $row->file_path ); // COPY (FUNC) needed for following columns
	// Flow meta data into File object
	$current_File->load_meta( false, $row );
	return $current_File->get_preview_thumb( 'fulltype' );
}

?>
