<?php
/**
 * This file implements the UI controller for file upload.
 *
 * @copyright (c) 2009 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://www.gnu.org/licenses/gpl.txt GNU General Public License v3
 * @package files
 */
if(!defined('QP_MAIN_INIT')) die('fail');

global $edited_File;

$Form = new Form( NULL, 'fm_properties_checkchanges' );
$Form->global_icon( T_('Close properties!'), 'close', regenerate_url(), T_('cancel') );
$Form->begin_form( 'fform', T_('File properties') );
$Form->hidden_ctrl();
$Form->hidden( 'action', 'update_properties' );
$Form->hiddens_by_key( get_memorized() );

$Form->begin_fieldset( T_('Properties') );
$Form->info( T_('Filename'), $edited_File->dget( 'name' ), T_('This is the name of the file on the server hard drive.') );
$Form->info( T_('Type'), $edited_File->get_icon().' '.$edited_File->get_type() );
$Form->end_fieldset();

$Form->begin_fieldset( T_('Meta data') );
if( $current_User->check_perm( 'files', 'edit' ) )
{
	// User can edit
	$Form->text( 'title', $edited_File->title, 50, T_('Long title'), T_('This is a longer descriptive title'), 255 );
	$Form->text( 'alt', $edited_File->alt, 50, T_('Alternative text'), T_('This is useful for images'), 255 );
	$Form->textarea( 'desc', $edited_File->desc, 10, T_('Caption/Description') );
}
else
{
	// User can view only
	$Form->info( T_('Long title'), $edited_File->dget( 'title' ), T_('This is a longer descriptive title') );
	$Form->info( T_('Alternative text'), $edited_File->dget( 'alt' ), T_('This is useful for images') );
	$Form->info( T_('Caption/Description'), $edited_File->dget( 'desc' ) );
}
$Form->end_fieldset();

if( $current_User->check_perm( 'files', 'edit' ) )
{
	// User can edit
	$Form->end_form( array( array(
		'submit', '', T_('Update'), 'SaveButton' ),
		array( 'reset', '', T_('Reset'), 'ResetButton' )
	) );
}
else
{
	// User can view only
	$Form->end_form();
}

?>
