<?php
/**
 * This file implements the File types list
 *
 * @copyright (c) 2009 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://www.gnu.org/licenses/gpl.txt GNU General Public License v3
 * @package files
 */
if(!defined('QP_MAIN_INIT')) die('fail');

global $dispatcher;
global $rsc_url;

// Create result set
$Results = new Results( 'SELECT * FROM T_filetypes', 'ftyp_' );
$Results->Cache = & get_Cache( 'FiletypeCache' );
$Results->title = T_('File types list');

$Results->cols[] = array(
	'th' => T_('Icon'),
	// 'order' => 'ftyp_icon',
	'th_class' => 'shrinkwrap',
	'td_class' => 'shrinkwrap',
	'td' => '% {Obj}->get_icon() %',
);

if( $current_User->check_perm( 'options', 'edit', false ) )
{
	// We have permission to modify
	$Results->cols[] = array(
		'th' => T_('Extensions'),
		'order' => 'ftyp_extensions',
		'td' => '<strong><a href="'.$dispatcher.'?ctrl=filetypes&amp;ftyp_ID=$ftyp_ID$&amp;action=edit" title="'.
			T_('Edit this file type...').'">$ftyp_extensions$</a></strong>',
	);
}
else
{
	// View only
	$Results->cols[] = array(
		'th' => T_('Extensions'),
		'order' => 'ftyp_extensions',
		'td' => '<strong>$ftyp_extensions$</strong>',
	);
}

$Results->cols[] = array(
	'th' => T_('Name'),
	'order' => 'ftyp_name',
	'td' => '$ftyp_name$',
);

$Results->cols[] = array(
	'th' => T_('Mime type'),
	'order' => 'ftyp_mimetype',
	'td' => '$ftyp_mimetype$',
);

$Results->cols[] = array(
	'th' => T_('View type'),
	'order' => 'ftyp_viewtype',
	'td' => '$ftyp_viewtype$',
);

$Results->cols[] = array(
	'th' => T_('Upload'),
	'order' => 'ftyp_allowed',
	'th_class' => 'shrinkwrap',
	'td_class' => 'shrinkwrap',
	'td' => '%display_perm( #ftyp_allowed# )%',
);

if( $current_User->check_perm( 'options', 'edit', false ) )
{
	// We have permission to modify
	$Results->cols[] = array(
		'th' => T_('Actions'),
		'th_class' => 'shrinkwrap',
		'td_class' => 'shrinkwrap',
		'td' => action_icon( T_('Edit this file type...'), 'edit', '%regenerate_url( \'action\', \'ftyp_ID=$ftyp_ID$&amp;action=edit\')%' )
			.action_icon( T_('Duplicate this file type...'), 'copy', '%regenerate_url( \'action\', \'ftyp_ID=$ftyp_ID$&amp;action=copy\')%' )
			.action_icon( T_('Delete this file type!'), 'delete', '%regenerate_url( \'action\', \'ftyp_ID=$ftyp_ID$&amp;action=delete\')%' ),
	);

	$Results->global_icon( T_('Create a new file type...'), 'new', regenerate_url( 'action', 'action=new'), T_('New file type').' &raquo;' );
}

$Results->display();

/**
 * Display the permissions for the type file
 */
function display_perm( $perm )
{
	if( $perm )
	{
		$r = get_icon( 'allowed' );
	}
	else
	{
		$r = get_icon( 'not_allowed' );
	}
	return $r;
}

?>
