<?php
/**
 * This file implements the GenericCategory class
 *
 * @copyright (c) 2009 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://www.gnu.org/licenses/gpl.txt GNU General Public License v3
 * @package core
 */
if(!defined('QP_MAIN_INIT')) die('fail');

/**
 * GenericCategory class
 *
 * @package core
 */
class GenericCategory extends GenericElement
{
	/**
	 * Parent ID
	 * @var integer
	 */
	var $parent_ID;
	/**
	 * To display parent name in form
	 * @var string
	 */
	var $parent_name;
	/**
	 * Category children list
	 * @var array
	 */
	var $children = array();

	/**
	 * Constructor
	 *
	 * @param string Table name
	 * @param string
	 * @param string DB ID name
	 * @param array|NULL Database row
	 */
	function GenericCategory( $tablename, $prefix = '', $dbIDname = 'ID', $db_row = NULL )
	{
		// Call parent constructor
		parent::GenericElement( $tablename, $prefix, $dbIDname, $db_row );
		if( $db_row != NULL )
		{
			$parentIDfield = $prefix.'parent_ID';
			$this->parent_ID = $db_row->$parentIDfield;
		}
	}


	/**
	 * Load data from Request form fields
	 *
	 * @todo (0000) fp> check that we are not creating a loop!
	 * @return boolean true if loaded data seems valid.
	 */
	function load_from_request()
	{
		parent::load_from_Request();
		if( param( $this->dbprefix.'parent_ID', 'integer', -1 ) !== -1 )
		{
			$this->set_from_Request( 'parent_ID' );
		}
		return ! param_errors_detected();
	}


	/**
	 * Set param value
	 *
	 * By default, all values will be considered strings
	 * @param string parameter name
	 * @param mixed parameter value
	 */
	function set( $parname, $parvalue )
	{
		switch( $parname )
		{
			case 'parent_ID':
			$this->set_param( $parname, 'string', $parvalue, true );
			break;

			case 'name':
			case 'urlname':
			case 'description':
			default:
			$this->set_param( $parname, 'string', $parvalue );
		}
	}


	/**
	 * Add a child
	 *
	 * @param GenericCategory
	 */
	function add_children( & $GenericCategory )
	{
		$this->children[] = & $GenericCategory;
	}

}

?>
