<?php
/**
 * This file implements the generic category form
 *
 * @copyright (c) 2009 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://www.gnu.org/licenses/gpl.txt GNU General Public License v3
 * @package core
 */
if(!defined('QP_MAIN_INIT')) die('fail');

global $action;
global $edited_GenericCategory;
global $edited_name_maxlen;
global $GenericCategoryCache;
global $subset_ID;

// Determine if we are creating or updating...
$creating = is_create_action( $action );

$Form = new Form( NULL, 'form' );
$Form->global_icon( T_('Cancel editing!'), 'close', regenerate_url( 'action' ), T_('cancel') );
$Form->begin_form( 'fform', $creating ? T_('New category') : T_('Category') );
$Form->hidden( 'action', $creating ? 'create' : 'update' );
$Form->hidden( 'ctrl', $ctrl );
$Form->hiddens_by_key( get_memorized( 'action, ctrl' ) );

$Form->begin_fieldset( T_('Properties') );
$Form->select_input_options( $edited_GenericCategory->dbprefix.'parent_ID',
$GenericCategoryCache->recurse_select( $edited_GenericCategory->parent_ID, $subset_ID, true ), T_('Parent') );
$Form->text_input( $edited_GenericCategory->dbprefix.'name', $edited_GenericCategory->name, $edited_name_maxlen, T_('name'), '', array( 'required' => true ) );
$Form->end_fieldset();

if( $creating )
{
	$Form->end_form( array(
		array( 'submit', 'submit', T_('Record'), 'SaveButton' ),
		array( 'reset', '', T_('Reset'), 'ResetButton' )
	) );
}
else
{
	$Form->hidden( $edited_GenericCategory->dbIDname, $edited_GenericCategory->ID );
	$Form->end_form( array(
		array( 'submit', 'submit', T_('Update'), 'SaveButton' ),
		array( 'reset', '', T_('Reset'), 'ResetButton' )
	) );
}

?>
