<?php
/**
 * This file implements the ordered list editor list
 *
 * @copyright (c) 2009 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://www.gnu.org/licenses/gpl.txt GNU General Public License v3
 * @package core
 */
if(!defined('QP_MAIN_INIT')) die('fail');

global $default_col_order;
global $GenericElementCache;
global $list_title;
global $perm_level;
global $perm_name;
global $result_fadeout;

// EXPERIMENTAL
if( ! isset( $default_col_order ) )
{
	// The default order column is not set, so the default is the name column
	$default_col_order = '-A-';
}

// Create result set
$sql = "SELECT $GenericElementCache->dbIDname, {$GenericElementCache->dbprefix}name, {$GenericElementCache->dbprefix}order
	FROM $GenericElementCache->dbtablename";

$Results = new Results( $sql, $GenericElementCache->dbprefix, $default_col_order );

if( isset( $list_title ) )
{
	$Results->title = $list_title;
}

$Results->cols[] = array(
	'th' => T_('ID'),
	'order' => $GenericElementCache->dbIDname,
	'th_class' => 'shrinkwrap',
	'td_class' => 'shrinkwrap',
	'td' => "\$$GenericElementCache->dbIDname\$",
);

$Results->cols[] = array(
	'th' => T_('Name'),
	'order' => $GenericElementCache->dbprefix.'name',
	'td' => '%link_name( #'.$GenericElementCache->dbprefix.'name#, #'.$GenericElementCache->dbIDname.'# )%',
);

if( ! isset( $perm_name ) || $current_User->check_perm( $perm_name, $perm_level, false ) )
{
	// We have permission permission to edit
	$Results->cols[] = array(
		'th' => T_('Move'),
		'th_class' => 'shrinkwrap',
		'order' => $GenericElementCache->dbprefix.'order',
		'td_class' => 'shrinkwrap',
		'td' => '{move}',
	);

	$Results->cols[] = array(
		'th' => T_('Actions'),
		'td_class' => 'shrinkwrap',
		'td' => '%edit_actions( #'.$GenericElementCache->dbIDname.'# )%',
	);
}

if( ! isset( $perm_name ) || $current_User->check_perm( $perm_name, $perm_level, false ) )
{
	// We have permission permission to edit
	$Results->global_icon( T_('Create a new element...'), 'new', regenerate_url( 'action,'.$GenericElementCache->dbIDname, 'action=new' ), T_('New element').' &raquo;' );
}

// EXPERIMENTAL
// $Results->display();
$Results->display( NULL, $result_fadeout );

/**
 * dummy docblock
 */
function edit_actions( $ID )
{
	global $GenericElementCache;
	global $locked_IDs;

	$r = action_icon( T_('Duplicate...'), 'copy', regenerate_url( 'action,'.$GenericElementCache->dbIDname, $GenericElementCache->dbIDname.'='.$ID.'&amp;action=copy' ) );
	if( empty( $locked_IDs ) || !in_array( $ID, $locked_IDs ) )
	{
		// This element is NOT locked
		$r = action_icon( T_('Edit...'), 'edit', regenerate_url( 'action,'.$GenericElementCache->dbIDname, $GenericElementCache->dbIDname.'='.$ID.'&amp;action=edit' ) )
			.$r
			.action_icon( T_('Delete!'), 'delete', regenerate_url( 'action,'.$GenericElementCache->dbIDname, $GenericElementCache->dbIDname.'='.$ID.'&amp;action=delete' ) );
	}
	return $r;
}


/**
 * dummy docblock
 */
function link_name( $title, $ID )
{
	global $current_User;
	global $GenericElementCache;
	global $locked_IDs;
	global $perm_level;
	global $perm_name;

	if( !in_array( $ID, $locked_IDs )
		&& ( ! isset( $perm_name ) || $current_User->check_perm( $perm_name, $perm_level, false ) ) )
	{
		// The element is not locked and we have permission permission to edit
		return '<strong><a href="'.regenerate_url( 'action,ID', $GenericElementCache->dbIDname.'='.$ID.'&amp;action=edit' ).'">'.$title.'</a></strong>';
	}
	else
	{
		return '<strong>'.$title.'</strong>';
	}
}


?>
