<?php
/**
 * $ctrl_mappings: 'itemtypes' || Global settings -> Post types
 *
 * @copyright (c) 2009 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://www.gnu.org/licenses/gpl.txt GNU General Public License v3
 * @package items
 */
if(!defined('QP_MAIN_INIT')) die('fail');

// Check minimum permission
$current_User->check_perm( 'options', 'view', true );

$AdminUI->set_path( 'options', 'types' );

$list_title = T_('Item/Post/Page types');
$default_col_order = '-A';
$edited_name_maxlen = 40;
// Prevent editing of reserved and locked post types
$locked_IDs = array_merge( $posttypes_locked_IDs, $posttypes_reserved_IDs );
$perm_name = 'options';
$perm_level = 'edit';
$form_below_list = true;

// Delete restrictions
$delete_restrictions = array(
	array( 'table' => 'T_items', 'fk' => 'post_ptyp_ID', 'msg' => T_('%d related items') ),
);

$restrict_title = T_('Cannot delete item type');

// Used to know if the element can be deleted, so to display or not display
// confirm delete dialog (true:display, false:not display) It must be initialized
// to false before checking the delete restrictions
$checked_delete = false;

$GenericElementCache = new GenericCache( 'GenericElement', false, 'T_item_types', 'ptyp_', 'ptyp_ID' );

/**
 * require generic list editor
 */
require $inc_path.'generic/inc/_generic_listeditor.php';

?>
