<?php
/**
 * This file implements the ItemType class
 *
 * @copyright (c) 2009 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://www.gnu.org/licenses/gpl.txt GNU General Public License v3
 * @package items
 */
if(!defined('QP_MAIN_INIT')) die('fail');

/**
 * ItemType class
 *
 * @package items
 */
class ItemType extends DataObject
{
	/**
	 * Name
	 * @var string
	 */
	var $name;

	/**
	 * Constructor
	 *
	 * @param table Database row
	 */
	function ItemType( $db_row = NULL )
	{
		// Call parent constructor
		parent::DataObject( 'T_item_types', 'ptyp_', 'ptyp_ID' );

		$this->delete_restrictions = array(
			array( 'table' => 'T_ityp_col', 'fk' => 'itco_ityp_ID', 'msg' => T_('%d related blogs') ),
			array( 'table' => 'T_items', 'fk' => 'post_ptyp_ID', 'msg' => T_('%d related items') ),
		);

		if( $db_row != NULL )
		{
			$this->ID = $db_row->ptyp_ID;
			$this->name = $db_row->ptyp_name;
		}
	}


	/**
	 * Get the name of the ItemType
	 *
	 * @return string
	 */
	function get_name()
	{
		return $this->name;
	}

}

?>
