<?php
/**
 * This file implements the Post form
 *
 * @copyright (c) 2009 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://www.gnu.org/licenses/gpl.txt GNU General Public License v3
 * @package items
 */
if(!defined('QP_MAIN_INIT')) die('fail');

global $admin_url;
global $app_allow_dbase_reset;
global $basepath;
global $Blog;
global $bozo_start_modified;
global $creating;
global $current_User;
global $edited_Item;
global $install_subdir;
global $item_content;
global $item_tags;
global $item_title;
global $mode;
global $pagenow;
global $Plugins;
global $post_comment_status;
global $redirect_to;
global $Settings;
global $trackback_url;

// security notice on dashboard
if( is_file( $basepath.$install_subdir.'index.php' ) )
{
	echo '<div class="action_messages"><div class="log_error">'.T_('Your /qp_install/index.php file is still there.  That\'s not good. You need to delete that file OR delete the entire /qp_install/ folder!').'</div></div>';
	if( $app_allow_dbase_reset )
	{
		echo '<div class="action_messages"><div class="log_error">'.T_('Additionally, your /qp_config/_main_config.php file allows your database to be reset (when $app_allow_dbase_reset is set to \'1\').');
		echo '<ul><li><strong>'.T_('You will not be able to use use this program until you').'</strong>';
		echo '<ul><li>'.T_('delete the file "/qp_install/index.php" OR delete the folder "/qp_install/"').'</li>';
		echo '<li>'.T_('OR change $app_allow_dbase_reset to 0 in your /qp_config/_main_config.php file.').'</li></ul>';
		echo '</ul></div></div>';
		die();
	}
}

// Determine if we are creating or updating...
$creating = is_create_action( $action );

// ====== START OF EDIT FORM ======
$Form = new Form( NULL, 'item_checkchanges', 'post' );
$Form->labelstart = '<strong>';
$Form->labelend = "</strong>\n";

$params = array();

if( ! empty( $bozo_start_modified ) )
{
	$params['bozo_start_modified'] = false;
}

$Form->begin_form( '', '', $params );
$Form->hidden_ctrl();
$Form->hidden( 'blog', $Blog->ID );
if( isset( $mode ) )   $Form->hidden( 'mode', $mode ); // used by bookmarklet
if( isset( $edited_Item ) )   $Form->hidden( 'post_ID', $edited_Item->ID );
$Form->hidden( 'redirect_to', $redirect_to );

// In case we send this to the blog for a preview
$Form->hidden( 'preview', 1 );
$Form->hidden( 'more', 1 );
?>
<div class="left_col main_panel">
<?php
// spark the plugin manager
$Plugins->trigger_event( 'AdminDisplayFieldsetAbove', array(
	'Form' => & $Form, 'Item' => & $edited_Item,
) );

// ====== POST CONTENTS ======
$Form->begin_fieldset( T_('Post contents') );
echo '<table cellspacing="0" class="compose_layout"><tr>';

// Title input
$require_title = $Blog->get_setting( 'require_title' );
if( $require_title != 'none' )
{
	echo '<td width="1%"><strong>'.T_('Title').':</strong></td>';
	echo '<td width="97%" class="input">';
	$Form->switch_layout( 'none' );
	$Form->text_input( 'post_title', $item_title, 20, '', '', array( 'maxlength' => 255, 'style' => 'width: 100%;', 'required' => $Blog->get_setting( 'require_title' ) == 'required' ) );
	echo '</td>';
}

// -- Language chooser
$locale_options = locale_options( $edited_Item->get( 'locale' ), false, true );
if( is_array( $locale_options ) )
{
	// We've only one enabled locale. Tblue> The locale name is not really needed
	// here, but maybe we want to display the name of the only locale?
	$Form->hidden( 'post_locale', $locale_options[0] );
}
else
{
	// More than one locale => select field
	echo '<td width="1%">';
	if( $require_title != 'none' )
	{
		echo '&nbsp;&nbsp;';
	}
	echo '<strong>'.T_('Language').':</strong></td>';
	echo '<td width="1%" class="select">';
	$Form->select_options( 'post_locale', $locale_options, '' );
	echo '</td>';
}
echo '</tr></table>';

// -- item url & type selector fields
echo '<table cellspacing="0" class="compose_layout" style="width:100%"><tr>';
echo '<td width="1%"><strong>'.T_('Link to url').':</strong></td>';
echo '<td class="input">';
$Form->text_input( 'post_url', $edited_Item->get( 'url' ), 20, '', '', array('maxlength' => 255, 'style' => 'width: 100%;') );
echo '</td>';
echo '<td width="1%">&nbsp;&nbsp;<strong>'.T_('Type').':</strong></td>';
echo '<td width="1%" class="select">';
$ItemTypeCache = & get_Cache( 'ItemTypeCache' );
$Form->select_object( 'item_typ_ID', $edited_Item->ptyp_ID, $ItemTypeCache, '', '', false, '', 'get_option_list_unreserved_only' );
echo '</td></tr></table>'."\n";

$Form->switch_layout( NULL );
?>

<div class="edit_toolbars">
<?php
// spark the plugin manager
$Plugins->trigger_event( 'AdminDisplayToolbarAbove', array(
	'target_type' => 'Item',
	'template_type' => $Blog->template_type,
) );
?>
</div>

<?php
// ====== TEXTAREA ======
$Form->fieldstart = '<div class="edit_area">';
$Form->fieldend = "</div>\n";
$Form->textarea_input( 'content', $item_content, 16, '', array( 'cols' => 40, 'id' => 'itemform_post_content' ) );
$Form->switch_layout( 'linespan' );
?>
<script type="text/javascript">
	<!--
	// This is for toolbar plugins
	var app_Canvas = document.getElementById('itemform_post_content');
	//-->
</script>

<div class="edit_toolbars">
<?php
// spark the plugin manager
$Plugins->trigger_event( 'AdminDisplayToolbarBelow', array(
	'target_type' => 'Item',
	'template_type' => $Blog->template_type,
) );
?>
</div>

<?php
// ====== ACTIONS ======
echo '<div class="edit_actions">';

// spark the plugin manager
$Plugins->trigger_event( 'AdminDisplayEditorButton', array(
	'target_type' => 'Item',
) );

// from v247 so it might not be the best but it sure works :)
// ---------- UPLOAD ----------
if( $Settings->get( 'fm_enabled' ) )
{
	// Note: we try to land in the Blog media folder if possible
	// fp> TODO: check what happens if blog folders are disabled
	if( $current_User->check_perm( 'files', 'view' ) )
	{
		$fm_url_params = 'mode=upload';
		if( ! empty( $edited_Item->ID ) )
		{
			$fm_url_params .= '&amp;fm_mode=link_item&amp;item_ID='.$edited_Item->ID;
		}
		echo '<input id="itemform_button_files" type="button" value="'.format_to_output(T_('Files...'), 'formvalue')
			.'" class="ActionButton" onclick="pop_up_window( \''
			.url_add_param( $Blog->get_filemanager_link(), $fm_url_params ).'\', \'fileman_upload\', 987 )" /> ';
	}
}

// ====== PREVIEW ======
$url = url_same_protocol( $Blog->get( 'url' ) ); // was dynurl
$Form->button( array( 'button', '', T_('Preview'), 'PreviewButton', 'b2edit_open_preview(this.form, \''.$url.'\');' ) );

// ====== SAVE ======
$next_action = ( $creating ? 'create' : 'update' );
$Form->submit( array( 'actionArray['.$next_action.']', /* TRANS: This is the value of an input submit button */ T_('Save'), 'SaveButton' ) );
$Form->submit( array( 'actionArray['.$next_action.'_edit]', /* TRANS: This is the value of an input submit button */ T_('Save & edit'), 'SaveEditButton' ) );

// ====== PUBLISH NOW ======
$publishnow_displayed = false;
if( $edited_Item->status == 'draft'
	&& $current_User->check_perm( 'blog_post!published', 'edit', false, $Blog->ID )
	&& $current_User->check_perm( 'edit_timestamp', 'edit', false ) )
{
	// Only allow publishing if in draft mode. Other modes are too special to run
	// the risk of 1 click publication.
	$Form->submit( array(
		'actionArray['.$next_action.'_publish]',
		/* TRANS: This is the value of an input submit button */ T_('Publish NOW !'),
		'SaveButton',
	) );
	$publishnow_displayed = true;
}

echo '</div>';

$Form->end_fieldset();

$Form->switch_layout( 'chicago' );
// spark the plugin manager
$Plugins->trigger_event( 'AdminDisplayFieldsetBelow', array(
	'Form' => & $Form,
	'Item' => & $edited_Item,
) );

// ====== ATTACHMENTS/LINKS ======
attachment_iframe( $Form, $creating, $edited_Item, $Blog );

// ====== ADVANCED ======
$Form->switch_layout( 'linespan' );

$Form->begin_fieldset( T_('Advanced properties'), array( 'id' => 'itemform_adv_props' ) );

echo '<table cellspacing="0" class="compose_layout">';
echo '<tr><td class="label"><label for="post_urltitle" title="'.T_('&quot;slug&quot; to be used in permalinks').'"><strong>'.T_('URL title "slug"').'</strong></label></td>';
echo '<td style="padding:0 1em; text-align:center;">:</td><td class="input" >';
$Form->text_input( 'post_urltitle', $edited_Item->get( 'urltitle' ), 40, '', '', array('maxlength' => 210, 'style' => 'width: 100%;') );
echo '</td><td width="1"><!-- for IE7 --></td></tr>';

echo '<tr><td class="label"><label for="titletag"><strong>'.T_('&lt;title&gt; tag').'</strong></label></td>';
echo '<td style="padding:0 1em; text-align:center;">:</td><td class="input" >';
$Form->text_input( 'titletag', $edited_Item->get( 'titletag' ), 40, '', '', array('maxlength' => 255, 'style' => 'width: 100%;') );
echo '</td><td width="1"><!-- for IE7 --></td></tr>';

echo '<tr><td class="label"><label for="metadesc" title="&lt;meta name=&quot;description&quot;&gt;"><strong>'.T_('&lt;meta&gt; desc').'</strong></label></td>';
echo '<td style="padding:0 1em; text-align:center;">:</td><td class="input" >';
$Form->text_input( 'metadesc', $edited_Item->get( 'metadesc' ), 40, '', '', array('maxlength' => 255, 'style' => 'width: 100%;') );
echo '</td><td width="1"><!-- for IE7 --></td></tr>';

echo '<tr><td class="label"><label for="metakeywords" title="&lt;meta name=&quot;keywords&quot;&gt;"><strong>'.T_('&lt;meta&gt; keywords').'</strong></label></td>';
echo '<td style="padding:0 1em; text-align:center;">:</td><td class="input" >';
$Form->text_input( 'metakeywords', $edited_Item->get( 'metakeywords' ), 40, '', '', array('maxlength' => 255, 'style' => 'width: 100%;') );
echo '</td><td width="1"><!-- for IE7 --></td></tr>';

echo '<tr><td class="label" style="vertical-align:top"><label for="post_excerpt"><strong>'.T_('Excerpt').'</strong><span class="notes">'.T_('(for XML feeds)').'</span></label></td>';
echo '<td style="padding:0 1em; text-align:center;vertical-align:top">:</td><td class="input" ><textarea name="post_excerpt" rows="2" cols="25" style="width:100%" id="post_excerpt">';
$edited_Item->disp( 'excerpt', 'formvalue' );
echo '</textarea></td><td width="1"><!-- for IE7 --></td></tr>';
echo '</table>';

$Form->end_fieldset();

// ====== WORKFLOW ======
if( $Blog->get_setting( 'use_workflow' ) )
{
	// We want to use workflow properties for this blog:
	$Form->begin_fieldset( T_('Workflow properties'), array( 'id' => 'itemform_workflow_props' ) );
	echo '<div id="itemform_edit_timestamp" class="edit_fieldgroup">';
	$Form->select_object( 'item_priority', NULL, $edited_Item, T_('Priority'), '', true, '', 'priority_options' );
	echo ' '; // allow wrapping!
	$Form->select_object( 'item_assigned_user_ID', NULL, $edited_Item, T_('Assigned to'), '', true, '', 'get_assigned_user_options' );
	echo ' '; // allow wrapping!
	$ItemStatusCache = & get_Cache( 'ItemStatusCache' );
	$Form->select_options( 'item_st_ID', $ItemStatusCache->get_option_list( $edited_Item->pst_ID, true ), T_('Task status') );
	echo ' '; // allow wrapping!
	$Form->date( 'item_deadline', $edited_Item->get( 'datedeadline' ), T_('Deadline') );
	echo '</div>';
	$Form->end_fieldset();
}

// ====== ADDITIONAL ACTIONS ======
if( isset( $Blog ) && $Blog->get( 'allowtrackbacks' ) )
{
	$Form->begin_fieldset( T_('Additional actions'), array( 'id' => 'itemform_additional_actions' ) );
	// ====== TRACKBACK ======
	?>
	<div id="itemform_trackbacks">
	<label for="trackback_url"><strong><?php echo T_('Trackback URLs') ?>:</strong>
	<span class="notes"><?php echo T_('(Separate by space)') ?></span></label><br />
	<input type="text" name="trackback_url" class="large form_text_input" id="trackback_url" value="<?php echo format_to_output( $trackback_url, 'formvalue' ); ?>" />
	</div>
	<?php
	$Form->end_fieldset();
}
?>
</div>

<div class="right_col sidebar_panel">
<?php
$Form->switch_layout( 'chicago' );
// spark the plugin manager
$Plugins->trigger_event( 'AdminDisplayFieldsetSidebar', array(
	'Form' => & $Form,
	'Item' => & $edited_Item,
) );
?>

<div class="edit_toolbars">
<?php
// spark the plugin manager
$Plugins->trigger_event( 'AdminDisplayToolbarSidebar', array(
	'target_type' => 'Item',
	'template_type' => $Blog->template_type,
) );
?>
</div>

<?php
// ====== CATEGORIES ======
cat_select( $Form );

$Form->switch_layout( 'linespan' );
// ====== TAGS ======
$Form->begin_fieldset( T_('Tags'), array( 'id' => 'itemform_tags' ) );
$Form->textarea_input( 'item_tags', $item_tags, 4, '', array( 'note' => T_('separated by' ).' <strong>,</strong>', 'cols' => 10, 'style' => 'width: 98%;margin:0 auto;display:block;') );
$Form->end_fieldset();

// ====== VISIBILITY / SHARING ======
$Form->begin_fieldset( T_('Visibility / Sharing'), array( 'id' => 'itemform_visibility' ) );
visibility_select( $Form, $edited_Item->status );
$Form->end_fieldset();

// ====== ISSUE DATE ======
$Form->switch_layout( 'linespan' );
$Form->begin_fieldset( T_('Item issue date'), array( 'id' => 'itemform_iss_date' ) );
if( $current_User->check_perm( 'edit_timestamp' ) )
{
	// ====== TIME STAMP ======
	echo '<div id="itemform_edit_timestamp" class="edit_fieldgroup">';
	issue_date_control( $Form, true );
	echo '</div>';
}

/**
 * commented out because I don't like this "order" thing
 * echo '<table>';
 * echo '<tr><td><strong>'.T_('Order').':</strong></td><td>';
 * $Form->text( 'item_order', $edited_Item->order, 10, '', T_('can be decimal') );
 * echo '</td></tr>';
 * echo '</table>';
 */

$Form->end_fieldset();

// ====== TEXT RENDERERS ======
$Form->begin_fieldset( T_('Text Renderers'), array( 'id' => 'itemform_renderers' ) );
// fp> TODO: there should be no param call here (shld be in controller)
$edited_Item->renderer_checkboxes( param('renderers', 'array', NULL) );
$Form->end_fieldset();

// ====== COMMENT STATUS ======
if( $Blog->allowcomments == 'post_by_post' )
{
	$Form->begin_fieldset( T_('Comments'), array( 'id' => 'itemform_comments' ) );
	?>
	<label title="<?php echo T_('Visitors can leave comments on this post.') ?>"><input type="radio" name="post_comment_status" value="open" class="checkbox" <?php if( $post_comment_status == 'open' ) echo 'checked="checked"'; ?> />
	<?php echo T_('Open') ?></label><br />
	<label title="<?php echo T_('Visitors can NOT leave comments on this post.') ?>"><input type="radio" name="post_comment_status" value="closed" class="checkbox" <?php if( $post_comment_status == 'closed' ) echo 'checked="checked"'; ?> />
	<?php echo T_('Closed') ?></label><br />
	<label title="<?php echo T_('Visitors cannot see nor leave comments on this post.') ?>"><input type="radio" name="post_comment_status" value="disabled" class="checkbox" <?php if( $post_comment_status == 'disabled' ) echo 'checked="checked"'; ?> />
	<?php echo T_('Disabled') ?></label><br />
	<?php
	$Form->end_fieldset();
}
?>
</div>
<div class="clear"></div>

<?php
// ====== END OF EDIT FORM ======
$Form->end_form();

if( $publishnow_displayed )
{
	// @todo (0000) fp> ideally this should not be hacked in *here*
	echo_publishnowbutton_js( $next_action );
}
?>
<script type="text/javascript">
/* <![CDATA[ */
	jQuery( '.fieldset_wrapper').each( function(){
		var title_parent = jQuery( this ).attr( 'id' );
		if( title_parent && jQuery( this ).find( '.fieldset_title' ) )
		{
			var _icons = jQuery( '<span class="panel_icons"><?php echo get_icon( 'move_up', 'imgtag', array( 'class' => 'panel_collapse' ) ).get_icon( 'move_down', 'imgtag', array( 'class' => 'panel_expand' ) ); ?><\/span>' ).data( 'my_parent', '#'+title_parent );
			_icons.click( function(){
				jQuery( jQuery( this ).data( 'my_parent' ) ).toggleClass( 'collapse_panel' );
				jQuery( '#panel_settings').attr('value', '' );
				jQuery( '.collapse_panel').each( function(){
					jQuery( '#panel_settings').attr('value', jQuery( this ).attr('id') + ' ' + jQuery( '#panel_settings').attr('value') );
				});
			}).prependTo( jQuery( this ).find( '.fieldset_title' ) );
		}
	});
	jQuery( '.main_panel #itemform_post_content' ).data( 'original_height', jQuery( '.main_panel #itemform_post_content' ).height() );

	var _icons = jQuery( '<span class="sidebar_icons"><?php echo get_icon( 'move_right', 'imgtag', array( 'class' => 'sidebar_collapse' ) ).get_icon( 'move_left', 'imgtag', array( 'class' => 'sidebar_expand' ) ); ?><\/span>' );
	_icons.click( function(){
		jQuery( 'body' ).toggleClass( 'collapse_sidebar' );
		jQuery( '#sidebar_setting' ).attr('value', ( jQuery( 'body' ).hasClass('collapse_sidebar') ? 'closed' : 'open' ) );
		if( jQuery( '#itemform_post_content_tbl').is('table') )
		{
			jQuery( '#itemform_post_content_tbl').css({width:'98%'});
		}
		if( jQuery( 'body' ).hasClass('collapse_sidebar') )
		{
			jQuery( '.main_panel #itemform_post_content' ).height( jQuery( window ).height() - ( jQuery( '.main_panel .fieldset_content:first' ).height() - jQuery( '.main_panel #itemform_post_content' ).data( 'original_height' ) ) - 80 );
			jQuery( window ).scrollTop( jQuery( '.main_panel .fieldset_content:first' ).offset().top - 60 );
		}
		else
		{
			jQuery( '.main_panel #itemform_post_content' ).height( jQuery( '.main_panel #itemform_post_content' ).data( 'original_height' ) );
		}
	}).prependTo( '.main_panel .fieldset_title:first' );

	jQuery( '<input type="hidden" name="panel_settings" id="panel_settings" value="" />').appendTo('#item_checkchanges');
	jQuery( '<input type="hidden" name="sidebar_setting" id="sidebar_setting" value="open" />').appendTo('#item_checkchanges');
	jQuery( '<input type="hidden" name="store_panel_settings" value="1" />').appendTo('#item_checkchanges');
<?php
global $UserSettings;
if( !( $closed_panels = $UserSettings->get( 'write_panels' ) ) )
{
	// default to simple
	$closed_panels = array(
		'itemform_createlinks',
		'itemform_adv_props',
		'itemform_iss_date',
		'itemform_renderers',
		'itemform_comments',
	);
}
foreach( $closed_panels as $closed_panel )
{
	echo '	jQuery("#'.$closed_panel.' .panel_icons").click();'."\n";
}
if( $UserSettings->get( 'write_sidebar' ) == 'closed' )
{
	echo '	jQuery(".main_panel .sidebar_icons").click();'."\n";
}
?>
/* ]]> */
</script>
