<?php
/**
 * This file implements the post browsing in tracker mode
 *
 * @copyright (c) 2009 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://www.gnu.org/licenses/gpl.txt GNU General Public License v3
 * @package items
 */
if(!defined('QP_MAIN_INIT')) die('fail');

global $Blog;
global $delete_item_url;
global $edit_item_url;
global $ItemList;
global $postIDarray;
global $postIDlist;
global $tab;

if( $highlight = param( 'highlight', 'integer', NULL ) )
{
	// There are lines we want to highlight
	$result_fadeout = array( 'post_ID' => array( $highlight ) );
}
else
{
	// Nothing to highlight
	$result_fadeout = NULL;
}

// Display title depending on selection params
echo $ItemList->get_filter_title( '<h2>', '</h2>', '<br />', NULL, 'htmlbody' );

$ItemList->title = T_('Post list');

// Issue date
$ItemList->cols[] = array(
	'th' => T_('Date'),
	'order' => 'datestart',
	'default_dir' => 'D',
	'th_class' => 'nowrap',
	'td_class' => 'nowrap',
	'td' => '@get_permanent_link( get_icon(\'permalink\') )@ <span class="date">@get_issue_date()@</span>',
);

// Blog name
if( $Blog->get_setting( 'aggregate_blog_IDs' ) )
{
	// Aggregated blog - display name of blog
	$ItemList->cols[] = array(
		'th' => T_('Blog'),
		'th_class' => 'nowrap',
		'td_class' => 'nowrap',
		'td' => '@load_Blog()@<a href="regenerate_url( \'blog,results_order\', \'blog=@blog_ID@\' )">@Blog->dget(\'shortname\')@</a>',
	);
}

if( $tab == 'intros' )
{
	// Type
	$ItemList->cols[] = array(
		'th' => T_('Type'),
		'th_class' => 'nowrap',
		'td_class' => 'nowrap',
		'order' => 'ptyp_ID',
		'td' => '@type()@',
	);
}
else
{
	// Author
	$ItemList->cols[] = array(
		'th' => T_('Author'),
		'th_class' => 'nowrap',
		'td_class' => 'nowrap',
		'order' => 'creator_user_ID',
		'td' => '@get(\'t_author\')@',
	);
}

$ItemList->cols[] = array(
	'th' => T_('Title'),
	'order' => 'title',
	'td_class' => 'tskst_$post_pst_ID$',
	'td' => '<strong lang="@get(\'locale\')@">%task_title_link( {Obj} )%</strong>',
);

$ItemList->cols[] = array(
	'th' => T_('Visibility'),
	'order' => 'status',
	'td_class' => 'shrinkwrap',
	'td' => '%item_visibility( {Obj} )%',
);

$ItemList->cols[] = array(
	'th' => T_('Visibility'),
	'order' => 'status',
	'td_class' => 'tskst_$post_pst_ID$ nowrap',
	'td' => '@get( \'t_status\' )@',
);

$ItemList->cols[] = array(
	'th' => T_('Ord'),
	'order' => 'order',
	'td_class' => 'right',
	'td' => '$post_order$',
);

$ItemList->cols[] = array(
	'th' => /* TRANS: abbrev for info */ T_('i'),
	'order' => 'datemodified',
	'default_dir' => 'D',
	'th_class' => 'shrinkwrap',
	'td_class' => 'shrinkwrap',
	'td' => '<a href="?ctrl=items&amp;p=$post_ID$&amp;action=history">@history_info_icon()@</a>',
);

$ItemList->cols[] = array(
	'th' => T_('Act.'),
	'td_class' => 'shrinkwrap',
	'td' => '%item_edit_actions( {Obj} )%',
);

if( $ItemList->is_filtered() )
{
	// List is filtered, offer option to reset filters
	$ItemList->global_icon( T_('Reset all filters!'), 'reset_filters', '?ctrl=items&amp;blog='.$Blog->ID.'&amp;filter=reset', T_('Reset filters') );
}

if( $current_User->check_perm( 'blog_post_statuses', 'edit', false, $Blog->ID ) )
{
	// We have permission to add a post with at least one status
	switch( $tab )
	{
		case 'pages':
		$label = T_('New page');
		$title = T_('Create a new page...');
		$new_ptyp_ID = 1000;
		break;

		case 'intros':
		$label = T_('New intro');
		$title = T_('Write a new intro text...');
		$new_ptyp_ID = 1570;
		break;

		case 'links':
		$label = T_('New link');
		$title = T_('Add a sidebar link...');
		$new_ptyp_ID = 2000;
		break;

		default:
		$label = T_('New post');
		$title = T_('Write a new post...');
		$new_ptyp_ID = 1;
		break;
	}
	$ItemList->global_icon( $title, 'new', '?ctrl=items&amp;action=new&amp;blog='.$Blog->ID.'&amp;item_typ_ID='.$new_ptyp_ID, $label.' &raquo;' );
}


// EXECUTE the query now
$ItemList->restart();

// Initialize funky display vars now
$postIDarray = $ItemList->get_page_ID_array();
$postIDlist = $ItemList->get_page_ID_list();

// DISPLAY table now
$ItemList->display( NULL, $result_fadeout );

/**
 * Callback to add filters on top of the result set
 *
function filter_on_post_title( & $Form )
{
	global $pagenow;
	global $post_filter;

	$Form->hidden( 'filter_on_post_title', 1 );
	$Form->text( 'post_filter', $post_filter, 20, T_('Task title'), '', 60 );
}
$ItemList->filters_callback = 'filter_on_post_title';
*/


/**
 * Edit Actions
 *
 * @param Item
 */
function item_edit_actions( $Item )
{
	global $Blog;

	$r = action_icon( T_('Edit linked files...'), 'folder',
		url_add_param( $Blog->get_filemanager_link(), 'fm_mode=link_item&amp;item_ID='.$Item->ID ), T_('Files') );
	// provide a link to edit an item if user has edit rights
	$r .= $Item->get_edit_link( array( 'text' => get_icon( 'edit' ) ) );
	// provide a link to delete an item if user has edit rights
	$r .= $Item->get_delete_link( array( 'text' => get_icon( 'delete' ) ) );
	return $r;
}


/**
 * Visibility
 */
function item_visibility( $Item )
{
	// display a link to 'publish NOW' an item if user has edit rights
	$r = $Item->get_publish_link( array( 'text' => get_icon( 'publish' ) ) );
	// display a link to deprecate an item if user has edit rights
	$r .= $Item->get_deprecate_link( array( 'text' => get_icon( 'deprecate' ) ) );
	if( empty( $r ) )
	{
		// for IE
		$r = '&nbsp;';
	}
	return $r;
}


/**
 * Task title
 */
function task_title_link( $Item )
{
	global $current_User;

	$col = locale_flag( $Item->locale, 'w16px', 'flag', '', false ).' ';
	$Item->get_Blog();
	if( $Item->Blog->allowcomments != 'never' )
	{
		// The current blog can have comments
		$nb_comments = generic_ctp_number( $Item->ID, 'feedback' );
		$col .= '<a href="?ctrl=items&amp;blog='.$Item->get_blog_ID().'&amp;p='.$Item->ID.'"
			title="'.sprintf( T_('%d feedbacks'), $nb_comments ).'" class="">';
		if( $nb_comments )
		{
			$col .= get_icon( 'comments' );
		}
		else
		{
			$col .= get_icon( 'nocomment' );
		}
		$col .= '</a> ';
	}
	$col .= '<a href="?ctrl=items&amp;blog='.$Item->get_blog_ID().'&amp;p='.$Item->ID.'" class="" title="'.
		T_('View this post...').'">'.$Item->dget( 'title' ).'</a></strong>';
	return $col;
}

?>
