<?php
/**
 * This file displays the links attached to an Item
 *
 * @copyright (c) 2009 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://www.gnu.org/licenses/gpl.txt GNU General Public License v3
 * @package items
 */
if(!defined('QP_MAIN_INIT')) die('fail');

global $Blog;
global $edited_Item;

$SQL = new SQL();

$SQL->SELECT( 'link_ID, link_ltype_ID, file_ID, file_title, file_root_type, file_root_ID, file_path, file_alt, file_desc' );
$SQL->FROM( 'T_links LEFT JOIN T_files ON link_file_ID = file_ID' );
$SQL->WHERE( 'link_itm_ID = '.$edited_Item->ID );
$SQL->ORDER_BY( 'link_ID' );

$Results = new Results( $SQL->get(), 'link_' );
$Results->title = T_('Attachments');

$Results->cols[] = array(
	'th' => T_('Type'),
	'th_class' => 'shrinkwrap',
	'td_class' => 'shrinkwrap',
	'td' => '%display_type( {row} )%',
);

$Results->cols[] = array(
	'th' => T_('Icon/Type'),
	'td_class' => 'shrinkwrap',
	'td' => '%display_subtype( {row} )%',
);

$Results->cols[] = array(
	'th' => T_('Destination'),
	'td' => '%display_link( {row} )%',
);

if( $current_User->check_perm( 'files', 'view' ) )
{
	$Results->cols[] = array(
		'th' => T_('Actions'),
		'td_class' => 'shrinkwrap',
		'td' => '%file_actions( #link_ID# )%',
	);
}

if( $current_User->check_perm( 'files', 'view' )
	&& $current_User->check_perm( 'item_post!CURSTATUS', 'edit', false, $edited_Item ) )
{
	// Check that we have permission to edit item
	$Results->global_icon( T_('Link a file...'), 'link', url_add_param( $Blog->get_filemanager_link(),
		'fm_mode=link_item&amp;item_ID='.$edited_Item->ID ), T_('Link files') );
}

$Results->display();

/**
 * LINK column
 */
function display_link( & $row )
{
	if( ! empty( $row->file_ID ) )
	{
		global $current_File;
		global $edited_Item;

		$r = '';
		// File relative path & name
		// return $current_File->get_linkedit_link( '&amp;fm_mode=link_item&amp;itm_ID='.$edited_Item->ID );
		if( $current_File->is_dir() )
		{
			// Directory
			$r .= $current_File->dget( '_name' );
		}
		else
		{
			// File
			if( $view_link = $current_File->get_view_link() )
			{
				$r .= $view_link;
			}
			else
			{
				// File extension unrecognized
				$r .= $current_File->dget( '_name' );
			}
		}

		$r .= '<span class="filemeta"> - '.$current_File->dget( 'title' ).'</span>';
		return $r;
	}
	return '?';
}


/**
 * Sub Type column
 */
function display_subtype( & $row )
{
	global $current_File;

	if( empty( $row->file_ID ) )
	{
		return '';
	}

	// Instantiate a File object for this line
	$current_File = new File( $row->file_root_type, $row->file_root_ID, $row->file_path ); // COPY!
	// Flow meta data into File object
	$current_File->load_meta( false, $row );

	return $current_File->get_preview_thumb( 'fulltype' );
}


/**
 * TYPE
 */
function display_type( & $row )
{
	if( ! empty( $row->file_ID ) )
	{
		return T_('File');
	}
	return '?';
}


/**
 * dummy docblock
 */
function file_actions( $link_ID )
{
	global $current_File;
	global $current_User;
	global $edited_Item;

	$r = '';
	if( isset( $current_File ) )
	{
		$title = T_('Locate this file!');
		$r = $current_File->get_linkedit_link( $edited_Item->ID, get_icon( 'locate', 'imgtag', array( 'title' => $title ) ), $title ).' ';
	}

	if( $current_User->check_perm( 'item_post!CURSTATUS', 'edit', false, $edited_Item ) )
	{
		// Check that we have permission to edit item
		$r .= action_icon( T_('Delete this link!'), 'unlink',
			regenerate_url( 'p,itm_ID,action', "link_ID=$link_ID&amp;action=unlink" ) );
	}

	return $r;
}

?>
