<?php
/**
 * This file implements functions for handling charsets
 *
 * @copyright (c) 2009 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://www.gnu.org/licenses/gpl.txt GNU General Public License v3
 * @package locales
 */
if(!defined('QP_MAIN_INIT')) die('fail');

/**
 * Convert special chars (like german umlauts) to ASCII characters
 *
 * @param string
 * @return string
 */
function replace_special_chars( $str )
{
	global $app_charset;

	if( can_convert_charsets( 'UTF-8', $app_charset ) && can_convert_charsets( 'UTF-8', 'ISO-8859-1' ) /* source */ )
	{
		$str = convert_charset( $str, 'UTF-8', $app_charset );

		// @todo (0000) add more...?!
		$search = array( '', '', '', '', '', '', '', '', '', '', '', '', '', '', '' ); // iso-8859-1
		$replace = array( 'Ae', 'ae', 'Oe', 'oe', 'Ue', 'ue', 'ss', 'a', 'c', 'e', 'e', 'i', 'o', 'o', 'u' );

		foreach( $search as $k => $v )
		{
			// convert $search to UTF-8
			$search[$k] = convert_charset( $v, 'UTF-8', 'ISO-8859-1' );
		}
		$str = str_replace( $search, $replace, $str );

		// Replace HTML entities
		$str = htmlentities( $str, ENT_NOQUOTES, 'UTF-8' );
	}
	else
	{
		// Replace HTML entities only
		$str = htmlentities( $str, ENT_NOQUOTES, $app_charset );
	}

	// Keep only one char in entities!
	$str = preg_replace( '/&(.).+?;/', '$1', $str );
	// Replace non acceptable chars
	$str = preg_replace( '/[^A-Za-z0-9_]+/', '-', $str );
	// Remove '-' at start and end:
	$str = preg_replace( '/^-+/', '', $str );
	$str = preg_replace( '/-+$/', '', $str );

	return $str;
}

?>
