<?php
/**
 * This file implements the Plugins_admin_no_DB class
 *
 * This gets used for administrative handling of the {@link Plugin Plugins}, but
 * without database. A sub-class of {@link Plugins_admin} which will not load
 * any DB info (i-e: Plugins and Events).
 *
 * This is useful for displaying a list of available plugins which can be installed.
 * This is also useful during installation in order to have a global $Plugins object
 * that does not interfere with the installation process. This is probably quicker
 * and cleaner than using a member boolean in {@link Plugins_admin} itself.
 *
 * @copyright (c) 2009 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://www.gnu.org/licenses/gpl.txt GNU General Public License v3
 * @package plugins
 */
if(!defined('QP_MAIN_INIT')) die('fail');

/**
 * Plugins_admin_no_DB class
 *
 * @package plugins
 */
class Plugins_admin_no_DB extends Plugins_admin
{

	/**
	 * No-operation
	 */
	function load_plugins_table()
	{
	}


	/**
	 * No-operation
	 */
	function load_events()
	{
	}

}

?>
