<?php
/**
 * This file implements the UI view for the referering searches stats.
 *
 * @copyright (c) 2009 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://www.gnu.org/licenses/gpl.txt GNU General Public License v3
 * @package sessions
 */
if(!defined('QP_MAIN_INIT')) die('fail');

/**
 * View funcs
 */
require_once dirname(__FILE__).'/_stats_view.funcs.php';

global $admin_url;
global $blog;
global $rsc_url;

// Create result set
$Results = new Results( "SELECT hit_ID, hit_datetime, hit_referer, dom_name, hit_blog_ID,
	hit_uri, hit_remote_addr, blog_shortname, keyp_phrase, hit_serprank
	FROM T_hitlog INNER JOIN T_basedomains ON dom_ID = hit_referer_dom_ID
	LEFT JOIN T_keyphrases ON hit_keyphrase_keyp_ID = keyp_ID
	LEFT JOIN T_blogs ON hit_blog_ID = blog_ID
	WHERE hit_referer_type = 'search'
	AND hit_agnt_type = 'browser'"
	.( empty( $blog ) ? '' : "AND hit_blog_ID = $blog " ), 'lstsrch', 'D' );

$Results->title = T_('Search browser hits');

// datetime
$Results->cols[0] = array(
	'th' => T_('Date Time'),
	'order' => 'hit_ID', // This field is index, much faster than actually sorting on the datetime!
	'td_class' => 'timestamp',
	'td' => '%mysql2localedatetime_spans( \'$hit_datetime$\' )%',
);

// Referer:
$Results->cols[1] = array(
	'th' => T_('Referer'),
	'order' => 'dom_name',
	'td_class' => 'nowrap',
);

if( $current_User->check_perm( 'stats', 'edit' ) )
{
	$Results->cols[1]['td'] = '<a href="%regenerate_url( \'action\', \'action=delete&amp;hit_ID=$hit_ID$\')%" title="'
		.T_('Delete this hit!').'">'.get_icon('delete').'</a> '
		.'<a href="$hit_referer$" target="_blank">$dom_name$</a>';
}
else
{
	$Results->cols[1]['td'] = '<a href="$hit_referer$">$dom_name$</a>';
}

// Keywords
$Results->cols[] = array(
	'th' => T_('Search keywords'),
	'order' => 'keyp_phrase',
	'td' => '%stats_search_keywords( #keyp_phrase#, 45 )%',
);

// Serp Rank
$Results->cols[] = array(
	'th' => T_('SR'),
	'order' => 'hit_serprank',
	'td_class' => 'center',
	'td' => '$hit_serprank$',
);

// Target Blog
if( empty( $blog ) )
{
	$Results->cols[] = array(
		'th' => T_('Target Blog'),
		'order' => 'hit_blog_ID',
		'td' => '$blog_shortname$',
	);
}

// Requested URI (linked to blog's baseurlroot+URI)
$Results->cols[] = array(
	'th' => T_('Requested URI'),
	'order' => 'hit_uri',
	'td' => '%stats_format_req_URI( #hit_blog_ID#, #hit_uri# )%',
);

// Remote address (IP)
$Results->cols[] = array(
	'th' => T_('Remote IP'),
	'order' => 'hit_remote_addr',
	'td' => '% $GLOBALS[\'Plugins\']->get_trigger_event( \'FilterIpAddress\', $tmp_params = array(\'format\' => \'htmlbody\', \'data\' => \'$hit_remote_addr$\') ) %',
);

// Display results
$Results->display();

echo '<p class="notes">'.T_('These are hits from people who came to this blog system through a search engine. (Search engines must be listed in /qp_config/_stats.php)').'</p>';

?>
