<?php
/**
 * This file implements the UI view for the Session stats.
 *
 * @copyright (c) 2009 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://www.gnu.org/licenses/gpl.txt GNU General Public License v3
 * @package sessions
 */
if(!defined('QP_MAIN_INIT')) die('fail');

global $admin_url;
global $blog;
global $rsc_url;

/**
 * View funcs
 */
require_once dirname(__FILE__).'/_stats_view.funcs.php';

// Create result set:
$sql = 'SELECT user_login, COUNT( sess_ID ) AS nb_sessions, MAX( sess_lastseen ) AS sess_lastseen
	FROM T_sessions LEFT JOIN T_users ON sess_user_ID = user_ID GROUP BY sess_user_ID';
$count_sql = 'SELECT COUNT( DISTINCT(sess_user_ID) ) FROM T_sessions';

$Results = new Results( $sql, 'usess_', '-D', 20, $count_sql );
$Results->title = T_('Recent User sessions');
$Results->cols[] = array(
	'th' => T_('User login'),
	'order' => 'user_login',
	'td' => '%stat_session_login( #user_login#, true )%',
);

$Results->cols[] = array(
	'th' => T_('Last seen'),
	'order' => 'sess_lastseen',
	'default_dir' => 'D',
	'td_class' => 'timestamp',
	'td' => '%mysql2localedatetime_spans( #sess_lastseen# )%',
 );

$Results->cols[] = array(
	'th' => T_('Session count'),
	'order' => 'nb_sessions',
	'td_class' => 'right',
	'total_class' => 'right',
	'td' => '$nb_sessions$',
);

// Display results
$Results->display();

?>
