<?php
/**
 * This file implements the UI view for the Session list.
 *
 * @copyright (c) 2009 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://www.gnu.org/licenses/gpl.txt GNU General Public License v3
 * @package sessions
 */
if(!defined('QP_MAIN_INIT')) die('fail');

global $admin_url;
global $blog;
global $rsc_url;

/**
 * View funcs
 */
require_once dirname(__FILE__).'/_stats_view.funcs.php';

$user = param( 'user', 'string', '', true );

// Create result set:
$sql = 'SELECT sess_ID, user_login, sess_hitcount, sess_lastseen, sess_ipaddress
	FROM T_sessions LEFT JOIN T_users ON sess_user_ID = user_ID';
$count_sql = 'SELECT COUNT(sess_ID) FROM T_sessions';
if( ! empty( $user ) )
{
	$sql .= ' WHERE user_login LIKE "%'.$DB->escape( $user ).'%"';
	$count_sql .= ' LEFT JOIN T_users ON sess_user_ID = user_ID WHERE user_login LIKE "%'.$DB->escape( $user ).'%"';
}

$Results = new Results( $sql, 'sess_', 'D', 20, $count_sql );
$Results->title = T_('Recent sessions');

$Results->filter_area = array(
	'callback' => 'filter_sessions',
	'url_ignore' => 'results_sess_page,user',
	'presets' => array(
		'all' => array( T_('All'), '?ctrl=stats&amp;tab=sessions&amp;tab3=sessid&amp;blog=0' ),
	)
);

$Results->cols[] = array(
	'th' => T_('ID'),
	'order' => 'sess_ID',
	'default_dir' => 'D',
	'td_class' => 'right',
	'td' => '<a href="?ctrl=stats&amp;tab=sessions&amp;tab3=hits&amp;blog=0&amp;sess_ID=$sess_ID$">$sess_ID$</a>',
);

$Results->cols[] = array(
	'th' => T_('Last seen'),
	'order' => 'sess_lastseen',
	'default_dir' => 'D',
	'td_class' => 'timestamp',
	'td' => '%mysql2localedatetime_spans( #sess_lastseen# )%',
 );

$Results->cols[] = array(
	'th' => T_('User login'),
	'order' => 'user_login',
	'td' => '%stat_session_login( #user_login# )%',
);

$Results->cols[] = array(
	'th' => T_('Remote IP'),
	'order' => 'sess_ipaddress',
	'td' => '$sess_ipaddress$',
);

$Results->cols[] = array(
	'th' => T_('Hit count'),
	'order' => 'sess_hitcount',
	'td_class' => 'right',
	'total_class' => 'right',
	'td' => '$sess_hitcount$',
);

// Display results
$Results->display();

/**
 * Callback to add filters on top of the result set
 * @param Form
 */
function filter_sessions( & $Form )
{
	$Form->text( 'user', get_param('user'), 20, T_('User login') );
}

?>
