<?php
/**
 * This file implements the UI view for the browser hits summary
 *
 * @copyright (c) 2009 by {@link http://quamplures.net/ the Quam Plures project}
 * @copyright (c) 2003 by Francois PLANQUE - {@link http://fplanque.net/}
 * @license http://www.gnu.org/licenses/gpl.txt GNU General Public License v3
 * @package sessions
 */
if(!defined('QP_MAIN_INIT')) die('fail');

/**
 * Helper function for "Requested URI" column
 *
 * @param integer Blog ID
 * @param string Requested URI
 * @return string
 */
function stats_format_req_URI( $hit_blog_ID, $hit_uri, $max_len = 40 )
{
	if( ! empty( $hit_blog_ID ) )
	{
		$BlogCache = & get_Cache( 'BlogCache' );
		$tmp_Blog = & $BlogCache->get_by_ID( $hit_blog_ID );
		$full_url = $tmp_Blog->get( 'baseurlroot' ).$hit_uri;
	}
	else
	{
		$full_url = $hit_uri;
	}

	if( strlen( $hit_uri ) > $max_len )
	{
		$hit_uri = '...'.substr( $hit_uri, -$max_len );
	}

	return '<a href="'.$full_url.'">'.$hit_uri.'</a>';
}


/**
 * dummy docblock
 */
function stat_session_login( $login, $link = false )
{
	if( empty( $login ) )
	{
		return '<span class="note">'.T_('Anon.').'</span>';
	}
	elseif( $link )
	{
		return '<strong><a href="?ctrl=stats&amp;tab=sessions&amp;tab3=sessid&amp;user='.$login.'">'.$login.'</a></strong>';
	}
	else
	{
		return '<strong>'.$login.'</strong>';
	}
}

?>
