<?php
/**
 * This file implements the Template properties form
 *
 * @copyright (c) 2009 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://www.gnu.org/licenses/gpl.txt GNU General Public License v3
 * @package templates
 */
if(!defined('QP_MAIN_INIT')) die('fail');

global $edited_Template;

$Form = new Form( NULL, 'template_checkchanges' );
$Form->global_icon( T_('Uninstall this template!'), 'delete', regenerate_url( 'action', 'action=delete' ), T_('delete') );
$Form->global_icon( T_('Cancel editing!'), 'close', regenerate_url( 'action' ), T_('cancel') );
$Form->begin_form( 'fform', T_('Template properties') );
$Form->hidden_ctrl();
$Form->hidden( 'action', 'update' );
$Form->hidden( 'template_ID', $edited_Template->ID );

$Form->begin_fieldset( T_('Template properties') );
Template::disp_screenshot( $edited_Template->folder, $edited_Template->name, $edited_Template->type );
$Form->text_input( 'template_name', $edited_Template->name, 32, T_('Template name'), T_('As seen by blog owners'), array( 'required' => true ) );

switch( $edited_Template->type )
{
	case 'xhtml':
	$info = T_('XHTML, for general browsing');
	break;

	case 'html5':
	$info = T_('HTML5, for general browsing (Warning: experimental!)');
	break;

	case 'feed':
	$info = T_('Special, for XML feeds like RSS and Atom');
	break;

	case 'other':
	$info = T_('Anything other than general browsing or syndication feeds');
	break;

	default:
	$info = T_('This template does not have a "type" value, which should never happen, but it obviously did, which sucks, but hey that\'s life.');
	break;
}
$Form->info( T_('Template type'), $info );

if( $template_containers = $edited_Template->get_containers() )
{
	$container_ul = '<ul><li>'.implode( '</li><li>', $template_containers ).'</li></ul>';
}
else
{
	$container_ul = '-';
}
$Form->info( T_('Containers'), $container_ul );
$Form->end_fieldset();

$Form->end_form( array(
	array( 'submit', 'submit', T_('Update'), 'SaveButton' ),
	array( 'reset', '', T_('Reset'), 'ResetButton' )
) );

?>
