<?php
/**
 * This file implements the UI view for Available templates
 *
 * @copyright (c) 2009 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://www.gnu.org/licenses/gpl.txt GNU General Public License v3
 * @package templates
 */
if(!defined('QP_MAIN_INIT')) die('fail');

global $redirect_to;
global $templates_path;

$TemplateCache = & get_Cache( 'TemplateCache' );
$TemplateCache->load_all();

$block_item_Widget = new Widget( 'block_item' );
$block_item_Widget->title = T_('Templates available for installation');
if( $current_User->check_perm( 'options', 'edit', false ) )
{
	// We have permission to modify
  $block_item_Widget->global_icon( T_('Cancel install!'), 'close', $redirect_to, T_('cancel') );
}
$block_item_Widget->disp_template_replaced( 'block_start' );

// Get all template folder names
$template_folders = get_filenames( $templates_path, false, true, true, false, true );

// Go through all template folders
foreach( $template_folders as $a_folder )
{
	if( ! strlen( $a_folder ) || $a_folder[0] == '.' || $a_folder == 'CVS' )
	{
		// don't try to install...
		continue;
	}
	if( $TemplateCache->get_by_folder( $a_folder, false ) )
	{
		// already installed...
		continue;
	}
	if( ! template_file_exists( $a_folder, '_template.class.php' ) )
	{
		// don't install without a class file...
		continue;
	}


	/**
	 * require class file
	 */
	require( $templates_path.$a_folder.'/_template.class.php' );
	$objtype = $a_folder.'_Template';
	if( ! class_exists( $objtype ) )
	{
		debug_die( 'There seems to be a _template.class.php file in the template directory ['.$template_folder.'], but it does not contain a properly named class. Expected class name is: '.$objtype );
	}
	else
	{
		$foo = new $objtype;
	}



	// Display screenshot:
	$function_url = '?ctrl=templates&amp;action=create&amp;template_folder='.rawurlencode( $a_folder ).'&amp;redirect_to='.rawurlencode( $redirect_to );
	Template::disp_screenshot( $a_folder, $a_folder, $foo->type, 'install', false, NULL, $function_url );
}
echo '<div class="clear"></div>';
$block_item_Widget->disp_template_replaced( 'block_end' );

?>
