<?php
/**
 * This file implements the UI view for the installed templates
 *
 * @copyright (c) 2009 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://www.gnu.org/licenses/gpl.txt GNU General Public License v3
 * @package templates
 */
if(!defined('QP_MAIN_INIT')) die('fail');

// Create result set:
$Results = new Results( 'SELECT T_templates.*, COUNT(blog_ID) AS nb_blogs
	FROM T_templates LEFT JOIN T_blogs ON template_ID = blog_template_ID
	GROUP BY template_ID',
	'', '', NULL, 'SELECT COUNT( * ) FROM T_templates' );
$Results->Cache = & get_Cache( 'TemplateCache' );
$Results->title = T_('Installed templates');

if( $current_User->check_perm( 'options', 'edit', false ) )
{
	// We have permission to modify
	$Results->cols[] = array(
		'th' => T_('Template Name'),
		'order' => 'template_name',
		'td' => '<strong><a href="'.regenerate_url( '', 'template_ID=$template_ID$&amp;action=edit' ).'" title="'.TS_('Edit template properties...').'">$template_name$</a></strong>',
		);
}
else
{
	// We have NO permission to modify
	$Results->cols[] = array(
		'th' => T_('Name'),
		'order' => 'template_name',
		'td' => '<strong>$template_name$</strong>',
	);
}

$Results->cols[] = array(
	'th' => T_('Type'),
	'order' => 'template_type',
	'td_class' => 'center',
	'td' => '$template_type$',
);

$Results->cols[] = array(
	'th' => T_('Blogs'),
	'order' => 'nb_blogs',
	'th_class' => 'shrinkwrap',
	'td_class' => 'center',
	'td' => 'conditional( (#nb_blogs# > 0), #nb_blogs#, \'&nbsp;\' )',
);

$Results->cols[] = array(
	'th' => T_('Folder'),
	'order' => 'template_folder',
	'td' => '$template_folder$',
);

if( $current_User->check_perm( 'options', 'edit', false ) )
{
	// We have permission to modify
	$Results->cols[] = array(
		'th' => T_('Actions'),
		'th_class' => 'shrinkwrap',
		'td_class' => 'shrinkwrap',
		'td' => action_icon( TS_('Edit template properties...'), 'properties',
			'%regenerate_url( \'\', \'template_ID=$template_ID$&amp;action=edit\')%' )
			.action_icon( TS_('Reload containers!'), 'reload',
			'%regenerate_url( \'\', \'template_ID=$template_ID$&amp;action=reload\')%' )
			.'conditional( #nb_blogs# < 1, \''
			.action_icon( TS_('Uninstall this template!'), 'delete',
			'%regenerate_url( \'\', \'template_ID=$template_ID$&amp;action=delete\')%' ).'\', \''
			.get_icon( 'delete', 'noimg' ).'\' )',
	);
  $Results->global_icon( T_('Install new template...'), 'new', regenerate_url( 'action,blog', 'action=new'), T_('Install new') );
}

// $fadeout_array = array( 'template_ID' => array(6) );
$fadeout_array = NULL;

$Results->display( NULL, 'session' );

?>
