<?php
/**
 * This file implements the UI view for Advanced blog properties
 *
 * @copyright (c) 2009 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://www.gnu.org/licenses/gpl.txt GNU General Public License v3
 * @package templates
 */
if(!defined('QP_MAIN_INIT')) die('fail');

global $admin_url;
global $dispatcher;
global $edited_Blog;

$block_item_Widget = new Widget( 'block_item' );
$block_item_Widget->title = T_('Choose a template');
if( $current_User->check_perm( 'options', 'edit', false ) )
{
	// We have permission to modify:
  $block_item_Widget->global_icon( T_('Manage installed templates...'), 'properties', $dispatcher.'?ctrl=templates', T_('Manage templates') );
  $block_item_Widget->global_icon( T_('Install new template...'), 'new', $dispatcher.'?ctrl=templates&amp;action=new&amp;redirect_to='.rawurlencode( url_rel_to_same_host( regenerate_url( '','','','&' ), $admin_url ) ), T_('Install new') );
}
$block_item_Widget->disp_template_replaced( 'block_start' );

$TemplateCache = & get_Cache( 'TemplateCache' );
$TemplateCache->load_all();
foreach( $TemplateCache->cache as $Template )
{
	if( $Template->type == 'feed' || $Template->type == 'other' )
	{
		// This template cannot be used here...
		continue;
	}
	$selected = ( $edited_Blog->template_ID == $Template->ID );
	$select_url = '?ctrl=blog_settings&tab=template&blog='.$edited_Blog->ID.
		'&amp;action=update&amp;blog_template_ID='.$Template->ID.'&amp;blog_template_type='.$Template->type;
	$preview_url = url_add_param( $edited_Blog->gen_blogurl(), 'viewmode='.rawurlencode( $Template->folder ) );
	// Display screenshot:
	Template::disp_screenshot( $Template->folder, $Template->name, $Template->type, 'select', $selected, $select_url, $preview_url );
}
echo '<div class="clear"></div>';
$block_item_Widget->disp_template_replaced( 'block_end' );

?>
