<?php
/**
 * This file implements the UI view for template selection when creating a blog
 *
 * @copyright (c) 2009 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://www.gnu.org/licenses/gpl.txt GNU General Public License v3
 * @package templates
 */
if(!defined('QP_MAIN_INIT')) die('fail');

global $kind;

echo '<h2>'.sprintf( T_('New %s'), Blog::kind_name( $kind ) ).':</h2>';

echo '<h3>'.T_('Pick a template:').'</h3>';

$TemplateCache = & get_Cache( 'TemplateCache' );
$TemplateCache->load_all();

foreach( $TemplateCache->cache as $Template )
{
	if( $Template->type == 'feed' || $Template->type == 'other' )
	{
		// This template cannot be used here...
		continue;
	}

	// Display screenshot:
	Template::disp_screenshot( $Template->folder, $Template->name, $Template->type, 'pick', false,
		'?ctrl=blogs&amp;action=new-name&amp;kind='.$kind.'&amp;template_ID='.$Template->ID );
}

echo '<div class="clear"></div>';

?>
