<?php
/**
 * This file implements the Template properties form
 *
 * @copyright (c) 2009 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://www.gnu.org/licenses/gpl.txt GNU General Public License v3
 * @package templates
 */
if(!defined('QP_MAIN_INIT')) die('fail');

global $Blog;
global $edited_Template;

$Form = new Form( NULL, 'template_settings_checkchanges' );
$Form->begin_form( 'fform' );
$Form->hidden_ctrl();
$Form->hidden( 'tab', 'template_settings' );
$Form->hidden( 'action', 'update' );
$Form->hidden( 'blog', $Blog->ID );

$Form->begin_fieldset( T_('Current template') );
Template::disp_screenshot( $edited_Template->folder, $edited_Template->name, $edited_Template->type );
$Form->info( T_('Template name'), $edited_Template->name );
$Form->info( T_('version'), $edited_Template->version );
$Form->info( T_('type'), $edited_Template->type );

if( $template_containers = $edited_Template->get_containers() )
{
	$container_ul = implode( ', ', $template_containers );
}
else
{
	$container_ul = '-';
}
$Form->info( T_('Containers'), $container_ul );
$Form->end_fieldset();

$Form->begin_fieldset( T_('Template params') );
$template_params = $edited_Template->get_param_definitions( $tmp_params = array('for_editing' => true) );
if( empty( $template_params ) )
{
	// Advertise this feature!!
	echo '<p>'.T_('This template does not provide any configurable settings.').'</p>';
}
else
{
	load_funcs( 'plugins/_plugin.funcs.php' );
	foreach( $template_params as $l_name => $l_meta )
	{
		// Loop through all widget params:
		autoform_display_field( $l_name, $l_meta, $Form, 'Template', $edited_Template );
	}
}
$Form->end_fieldset();

if( empty( $template_params ) )
{
	// end without buttons
	$Form->end_form();
}
else
{
	$Form->end_form( array(
			array( 'submit', 'submit', T_('Update'), 'SaveButton' ),
			array( 'reset', '', T_('Reset'), 'ResetButton' )
	) );
}

?>
