<?php
/**
 * $ctrl_mappings: 'tools' || Tools -> Misc
 *
 * @todo (1111) this page needs to be the default under tools - no "Misc" subtab.
 * @todo (1111) the "misc" subtab needs an easy way to list a descriptive note
 * about all plugin-generated subtabs.
 *
 * @copyright (c) 2009 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://www.gnu.org/licenses/gpl.txt GNU General Public License v3
 * @package tools
 */
if(!defined('QP_MAIN_INIT')) die('fail');

load_funcs( 'plugins/_plugin.funcs.php' );

param( 'tab', 'string', '', true );

$tab_Plugin = NULL;
$tab_plugin_ID = false;

if( ! empty( $tab ) && $tab != 'misc' )
{
	// We have requested a tab which is handled by a plugin
	if( preg_match( '~^plug_ID_(\d+)$~', $tab, $match ) )
	{
		// Instanciate the invoked plugin
		$tab_plugin_ID = $match[1];
		$tab_Plugin = & $Plugins->get_by_ID( $match[1] );
		if( ! $tab_Plugin )
		{
			// Plugin does not exist
			$Messages->add( sprintf( T_( 'The plugin with ID %d could not get instantiated.' ), $tab_plugin_ID ), 'error' );
			$tab_plugin_ID = false;
			$tab_Plugin = false;
			$tab = '';
		}
		else
		{
			$Plugins->call_method_if_active( $tab_plugin_ID, 'AdminTabAction', $params = array() );
		}
	}
	else
	{
		$tab = '';
		$Messages->add( 'Invalid sub-menu!' ); // Should need no translation, prevented by GUI
	}
}
else
{
	$tab = 'misc';
}
// Highlight the requested tab (if valid)
$AdminUI->set_path( 'tools', $tab );

if( $tab == 'misc' )
{
	// "Main tab" actions
	param( 'action', 'string', '' );

	switch( $action )
	{
		case 'del_itemprecache':
		$current_User->check_perm( 'options', 'edit', true );
		$DB->query( 'DELETE FROM T_item_prerendering WHERE 1=1' );
		$Messages->add( sprintf( T_('Removed %d cached entries.'), $DB->rows_affected ), 'success' );
		break;
	}
}

// Display <html><head>...</head> section (should be done early if actions do not redirect)
$AdminUI->disp_html_head();
// Display title, menu, messages, etc... (messages MUST be displayed AFTER the actions)
$AdminUI->disp_body_top();

// Begin payload block
$AdminUI->disp_payload_begin();

if( $tab == 'misc' )
{
	// "bookmarklet" section
	$block_item_Widget = new Widget( 'block_item' );
	global $app_shortname;
	global $admin_url;
	global $Hit;

	$block_item_Widget->title = T_('Bookmarklet');
	$block_item_Widget->disp_template_replaced( 'block_start' );
	$bm_title = sprintf( /* TRANS: %s will be replaced by the app shortname. */ T_('%s bookmarklet'), $app_shortname );
	echo T_('Add this').' ';
	if( $Hit->is_NS4() || $Hit->is_gecko() || $Hit->is_firefox() )
	{
		?>
		<a href="javascript:Q=document.selection?'document.selection.createRange().text:document.getSelection();void(window.open('<?php echo $admin_url ?>?ctrl=items&amp;action=new&amp;mode=bookmarklet&amp;content='+escape(Q)+'&amp;post_url='+escape(location.href)+'&amp;post_title='+escape(document.title),'qp_bookmarklet','scrollbars=yes,resizable=yes,width=750,height=550,left=25,top=15,status=yes'));"><?php echo $bm_title; ?></a>
		<?php
	}
	elseif( $Hit->is_winIE() )
	{
		?>
		<a href="javascript:Q='';if(top.frames.length==0)Q=document.selection.createRange().text;void(btw=window.open('<?php echo $admin_url ?>?ctrl=items&amp;action=new&amp;mode=bookmarklet&amp;content='+escape(Q)+'&amp;post_url='+escape(location.href)+'&amp;post_title='+escape(document.title),'qp_bookmarklet','scrollbars=yes,resizable=yes,width=750,height=550,left=25,top=15,status=yes'));btw.focus();"><?php echo $bm_title; ?></a>
		<?php
	}
	elseif( $Hit->is_opera() )
	{
		?>
		<a href="javascript:void(window.open('<?php echo $admin_url ?>?ctrl=items&amp;action=new&amp;mode=bookmarklet&amp;post_url='+escape(location.href)+'&amp;post_title='+escape(document.title),'qp_bookmarklet','scrollbars=yes,resizable=yes,width=750,height=550,left=25,top=15,status=yes'));"><?php echo $bm_title; ?></a>
		<?php
	}
	elseif( $Hit->is_macIE() )
	{
		?>
		<a href="javascript:Q='';if(top.frames.length==0);void(btw=window.open('<?php echo $admin_url ?>?ctrl=items&amp;action=new&amp;mode=bookmarklet&amp;content='+escape(document.getSelection())+'&amp;post_url='+escape(location.href)+'&amp;post_title='+escape(document.title),'qp_bookmarklet','scrollbars=yes,resizable=yes,width=750,height=550,left=25,top=15,status=yes'));btw.focus();"><?php echo $bm_title; ?></a>
		<?php
	}
	else
	{
		// This works in Safari, at least
		?>
		<a href="javascript:Q=window.getSelection();void(window.open('<?php echo $admin_url ?>?ctrl=items&amp;action=new&amp;mode=bookmarklet&amp;content='+escape(Q)+'&amp;post_url='+escape(window.location.href)+'&amp;post_title='+escape(document.title),'qp_bookmarklet','scrollbars=yes,resizable=yes,width=750,height=550,status=yes'));"><?php echo $bm_title; ?></a>
		<?php
	}
	echo ' '.T_('link to your Favorites/Bookmarks for easy blogging as you surf the web. Then from any web page, click this link to get your blog engine in a pop-up window. ');
	$block_item_Widget->disp_template_raw( 'block_end' );

	// "delete pre-rendered cache" section
	if( $current_User->check_perm( 'options', 'edit' ) )
	{
		// default admin actions
		$block_item_Widget->title = T_('Contents cached in the database');
		$block_item_Widget->disp_template_replaced( 'block_start' );
		echo '<a href="'.regenerate_url( 'action', 'action=del_itemprecache' ).'">'.T_('Delete pre-renderered item cache.').'</a> '.T_('You might want to do this after upgrading a rendering plugin, for example.');
		$block_item_Widget->disp_template_raw( 'block_end' );
	}

	// Event AdminToolPayload for each Plugin
	$tool_plugins = $Plugins->get_list_by_event( 'AdminToolPayload' );
	foreach( $tool_plugins as $loop_Plugin )
	{
		$block_item_Widget->title = format_to_output( $loop_Plugin->name );
		$block_item_Widget->disp_template_replaced( 'block_start' );
		$Plugins->call_method_if_active( $loop_Plugin->ID, 'AdminToolPayload', $params = array() );
		$block_item_Widget->disp_template_raw( 'block_end' );
	}

}
elseif( $tab_Plugin )
{
	// Plugin tab
	// Icons
	echo '<div class="right_icons">';
	echo $tab_Plugin->get_edit_settings_link().' '.$tab_Plugin->get_help_link( '$help_url' ).' '.$tab_Plugin->get_help_link( '$readme' );
	echo '</div>';
	$Plugins->call_method_if_active( $tab_plugin_ID, 'AdminTabPayload', $params = array() );
}

// End payload block
$AdminUI->disp_payload_end();
// Display body bottom, debug info, close </html>
$AdminUI->disp_global_footer();

?>
