<?php
/**
 * This file implements the "Blog Long Description" widget
 *
 * To call this widget directly in your template (bypassing containers), use
 * the following code modified with any params you need to customize:
 * <code>
 * // display a widget without a container
 * template_widget( array(
 * 	'widget' => 'longdesc',
 * 	'widget_title' => '', // default shown, customize as desired
 * ) );
 * </code>
 *
 * This widget has no params that you can set when with a direct widget call
 *
 * @see ComponentWidget::init_display()
 * @copyright (c) 2009 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://www.gnu.org/licenses/gpl.txt GNU General Public License v3
 * @package widgets
 */
if(!defined('QP_MAIN_INIT')) die('fail');

/**
 * longdesc_Widget class
 *
 * @package widgets
 */
class longdesc_Widget extends ComponentWidget
{
	/**
	 * Constructor
	 */
	function longdesc_Widget( $db_row = NULL )
	{
		// Call parent constructor
		parent::ComponentWidget( $db_row, 'widget', 'longdesc' );
		$this->widget_name = T_('Blog Long Description');
		$this->widget_title = '';
	}


	/**
	 * Display the widget!
	 *
	 * @param array MUST contain at least the basic display params
	 */
	function display( $params )
	{
		global $Blog;

		$this->init_display( $params ); // just in case it hasn't been done before

		echo $this->disp_params['block_start'];
		$this->disp_title();
		$Blog->disp( 'longdesc', 'htmlbody' );
		echo $this->disp_params['block_end'];
		return true;
	}


	/**
	 * Get widget's description
	 */
	function get_desc()
	{
		global $Blog;

		return sprintf( T_('Long description from the blog\'s <a %s>general settings</a>.'),
			'href="?ctrl=blog_settings&tab=general&blog='.$Blog->ID.'"' );
	}


	/**
	 * Get widget's title
	 *
	 * @todo (3069) EdB: rename this to get_title()
	 */
	function get_short_desc()
	{
		return format_to_output( $this->disp_params['widget_title'] );
	}

}

?>
