<?php
/**
 * This file implements the UI view for the widgets params form.
 *
 * @copyright (c) 2009 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://www.gnu.org/licenses/gpl.txt GNU General Public License v3
 * @package widgets
 */
if(!defined('QP_MAIN_INIT')) die('fail');

load_funcs( 'plugins/_plugin.funcs.php' );

global $edited_ComponentWidget;

// Determine if we are creating or updating...
$creating = is_create_action( $action );

$Form = new Form( NULL, 'form' );
$Form->global_icon( T_('Cancel editing!'), 'close', regenerate_url( 'action' ), T_('cancel') );
$Form->begin_form( 'fform', sprintf( $creating ?  T_('New widget %s in %s') : T_('Edit widget %s in %s'), $edited_ComponentWidget->get_name(), $edited_ComponentWidget->get( 'sco_name' ) ) );
$Form->hidden( 'action', $creating ? 'create' : 'update' );
$Form->hidden( 'wi_ID', $edited_ComponentWidget->ID );
$Form->hiddens_by_key( get_memorized( 'action' ) );

// Display properties
$Form->begin_fieldset( T_('Properties') );
$Form->info( T_('Widget type'), $edited_ComponentWidget->get_name() );
$Form->info( T_('Description'), $edited_ComponentWidget->get_desc() );
$Form->end_fieldset();

// Display (editable) parameters
$Form->begin_fieldset( T_('Params') );
// $params = $edited_ComponentWidget->get_params();

// Loop through all widget params
foreach( $edited_ComponentWidget->get_param_definitions( $tmp_params = array( 'for_editing' => true ) ) as $l_name => $l_meta )
{
	// Display field
	autoform_display_field( $l_name, $l_meta, $Form, 'Widget', $edited_ComponentWidget );
}
$Form->end_fieldset();

// @todo (0000) dh> allow the widget to display information, e.g. the category_list widget could say
// which blogs it affects. (Maybe this would be useful for all even, so a default info field(set)).
// Does a callback make sense? Then we should have a action hook too, to catch any params/settings
// maybe? Although this could be done in the same hook in most cases probably. (dh)

if( $creating )
{
	$Form->end_form( array(
		array( 'submit', 'submit', T_('Record'), 'SaveButton' ),
		array( 'reset', '', T_('Reset'), 'ResetButton' )
	) );
}
else
{
	$Form->end_form( array(
		array( 'submit', 'submit', T_('Update'), 'SaveButton' ),
		array( 'reset', '', T_('Reset'), 'ResetButton' )
	) );
}

?>
