<?php
/**
 * This file installs sample blogs
 *
 * @copyright (c) 2009 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://www.gnu.org/licenses/gpl.txt GNU General Public License v3
 * @package installer
 */
if(!defined('QP_MAIN_INIT')) die('fail');

$default_longdesc = T_("This is the long description for '%s'. You can change it (and many other things) on your Blog Settings -> General tab.");

$blogs_array = array();

// begin blog #1
$shortname = T_('Blog A');
$blogs_array[] = array(
	'blogs' => array(
		'name' => sprintf( T_('%s Title'), $shortname ),
		'shortname' => $shortname,
		'urlname' => 'a',
		'tagline' => sprintf( T_('Tagline for %s'), $shortname ),
		'longdesc' => sprintf( T_('This is the long description for "%s". You can change it (and many other things) on your Blog Settings -> General tab.'), $shortname ),
		'template' => 'darkdragon',
		'template_type' => 'html5',
	),
	'settings' => array(
		'posts_per_page' => 5,
	),
	'categories' => array(
		'Welcome' => 'NULL',
		'News' => 'NULL',
		'Post features' => 'NULL',
	),
);

// begin blog #2
global $app_name;
$tips = sprintf( '%s Tips', $app_name );
$shortname = T_('Blog B');
$blogs_array[] = array(
	'blogs' => array(
		'name' => sprintf( T_('%s Title'), $shortname ),
		'shortname' => $shortname,
		'urlname' => 'b',
		'tagline' => sprintf( T_('Tagline for %s'), $shortname ),
		'longdesc' => sprintf( $default_longdesc, $shortname ),
		'template' => 'coolblue',
	),
	'settings' => array(
		'posts_per_page' => 5,
	),
	'categories' => array(
		'Announcements' => 'NULL',
		$tips => 'NULL',
		'Write page' => 'NULL',
		'Main body' => 'Write page',
		'Sidebar' => 'Write page',
		'Toolbars' => 'Write page',
	),
);

// begin blog #3
$shortname = T_('Linkblog');
$more_longdesc = '<br /><br />'.T_('The main purpose for this blog is to be included as a side item for other blogs where it will display your favorite/related links.');
$blogs_array[] = array(
	'blogs' => array(
		'name' => sprintf( T_('%s Title'), $shortname ),
		'shortname' => $shortname,
		'urlname' => 'links',
		'tagline' => T_('Some interesting links...'),
		'longdesc' => sprintf( T_('%s would like to thank the following contributors for making version %s possible.'), $app_name, $app_version ).$more_longdesc,
		'template' => 'nifty_colors',
	),
	'settings' => array(
		'posts_per_page' => 10,
	),
	'categories' => array(
		$app_name => 'NULL',
		'Contributors' => 'NULL',
		'Sources' => 'NULL',
		'Tools' => 'NULL',
	),
);

// begin blog #4
$shortname = T_('Photoblog');
$more_longdesc = '<br /><br /><strong>'.T_('This is a photoblog, optimized for displaying photos.').'</strong>';
$blogs_array[] = array(
	'blogs' => array(
		'name' => sprintf( T_('%s Title'), $shortname ),
		'shortname' => $shortname,
		'urlname' => 'photos',
		'tagline' => T_('This blog shows photos...'),
		'longdesc' => sprintf( $default_longdesc, $shortname ).$more_longdesc,
		'template' => 'pictogram',
	),
	'settings' => array(
		'posts_per_page' => 1,
	),
	'categories' => array(
		'Yellowstone' => 'NULL',
	),
);

$install_sample_posts = 1;

?>
