<?php
/**
 * This file installs sample items
 *
 * @copyright (c) 2009 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://www.gnu.org/licenses/gpl.txt GNU General Public License v3
 * @package installer
 */
if(!defined('QP_MAIN_INIT')) die('fail');

global $timestamp; // unused?

echo T_('Creating sample items').' ... ';

// this is sloppy but it works ...
foreach( $cats_all_array as $cat_array )
{
	if( array_search( 'Welcome', $cat_array ) )
	{
		$cat_welcome = key( $cat_array );
	}
	if( array_search( 'News', $cat_array ) )
	{
		$cat_news = key( $cat_array );
	}
	if( array_search( 'Post features', $cat_array ) )
	{
		$cat_post_features = key( $cat_array );
	}
	if( array_search( 'Announcements', $cat_array ) )
	{
		$cat_ann_b = key( $cat_array );
	}
	if( array_search( sprintf( '%s Tips', $app_name ), $cat_array ) )
	{
		$cat_appname = key( $cat_array );
	}
	if( array_search( 'Write page', $cat_array ) )
	{
		$cat_writepage = key( $cat_array );
	}
	if( array_search( 'Main body', $cat_array ) )
	{
		$cat_mainbody = key( $cat_array );
	}
	if( array_search( 'Sidebar', $cat_array ) )
	{
		$cat_sidebar = key( $cat_array );
	}
	if( array_search( 'Toolbars', $cat_array ) )
	{
		$cat_toolbars = key( $cat_array );
	}
	if( array_search( $app_name, $cat_array ) )
	{
		$cat_linkblog_b2evo = key( $cat_array );
	}
	if( array_search( 'Contributors', $cat_array ) )
	{
		$cat_contributors = key( $cat_array );
	}
	if( array_search( 'Sources', $cat_array ) )
	{
		$cat_sources = key( $cat_array );
	}
	if( array_search( 'Tools', $cat_array ) )
	{
		$cat_tools = key( $cat_array );
	}
	if( array_search( 'Yellowstone', $cat_array ) )
	{
		$cat_yellowstone = key( $cat_array );
	}
}

// set up for tags without knowing post IDs
$tag_id_counter = 0;

// used in 2 of the sample posts
$info_page = /* TRANS: 1st %s: App name; 2nd %s: Blog name. */ T_('This blog is powered by %s.

You are currently looking at an info page about %s. The post type is "Page".

Info pages are very much like regular posts, except that they do not appear in the regular flow of posts.

If needed, a template can format info pages differently from regular posts.');

// Insert a post into blog #1
$now = date( 'Y-m-d H:i:s', installer_timestamp() );
$edited_Item = new Item();
$edited_Item->insert( 1, T_('First Post'), sprintf( T_('This is the first post, which makes it show up last in the posts list. It appears in multiple categories and has 2 comments.

Each post (or "item") must be in a primary category, and can also have additional "sub-categories". There is no limit to how many categories a post can be attached to. It is also possible to configure %s to allow posts to be attached to categories in different blogs.

The first comment has been published (approved), and the second is in draft (moderation). Log in to see and approve or delete the second comment. By the way both of these comments are impossible given the default configuration: anonymous comments are not enabled. They are here only to show you about comments in %s.

Technically each post is attached to a category which is attached to a blog, instead of the post being directly tied to a blog. That may be a small internal detail, but it causes confusion so there you go!'), $app_name, $app_name ), $now, $cat_welcome, array() );

// Insert a COMMENT into post #1
$now = date( 'Y-m-d H:i:s', installer_timestamp() );
$query = "INSERT INTO T_comments( comment_post_ID, comment_type, comment_author,
	comment_author_email, comment_author_url, comment_author_IP,
	comment_date, comment_content, comment_karma)
	VALUES( 1, 'comment', 'Yabs', 'yabs@quamplures.net', 'http://quamplures.net', '127.0.0.1', '$now', '".
		$DB->escape( T_('Hi, this is a comment that has been approved.<br />To delete a comment, just log in, and view the posts\' comments, there you will have the option to edit or delete them.') ). "', 0 )";
$DB->query( $query );

// Insert a COMMENT into post #1
$now = date( 'Y-m-d H:i:s', installer_timestamp() );
$query = "INSERT INTO T_comments( comment_post_ID, comment_type, comment_status,
	comment_author, comment_author_email, comment_author_url, comment_author_IP,
	comment_date, comment_content, comment_karma)
	VALUES( 1, 'comment', 'draft', 'Tblue', 'tblue@quamplures.net', 'http://quamplures.net', '127.0.0.1', '$now', '".
		$DB->escape( T_('Hi, this is a comment that is still in moderation, or "draft".<br />You are already logged in because you can see this, so all you have to do is change the visibility to "Published" to let visitors read this comment.') ). "', 0 )";
$DB->query( $query );

// Insert a post PAGE into blog #2
$now = date( 'Y-m-d H:i:s', installer_timestamp() );
$edited_Item = new Item();
$edited_Item->insert( 1, T_('About Blog B'), sprintf( $info_page, $app_name, T_('Blog B') ), $now, $cat_ann_b, array(), 'published', '#', '', '', 'open', array('default'), 1000 );

// Insert a post into blog #3
$now = date( 'Y-m-d H:i:s', installer_timestamp() );
$edited_Item = new Item();
$edited_Item->insert( 1, 'jQuery v1.6.2', '', $now, $cat_tools, array(), 'published', 'en-US', 'jquery', 'http://jquery.com/', 'disabled', array('default') );
$edited_Item->set( 'renderers', array( '' ) );
$edited_Item->dbsave();

// Insert a post into blog #4
$now = date('Y-m-d H:i:s',installer_timestamp());
$edited_Item = new Item();
$edited_Item->insert( 1, T_('artists-paint-pots-2'), 'This shows the simplest attachment possible: the file name became the file\'s title, alt text, description, and post title.', $now, $cat_yellowstone, array(), 'published','en-US' );
// attach an image to the item
$edit_File = new File( 'blog', 4, 'artists-paint-pots-2.jpg' );
$edit_File->link_to_Item( $edited_Item );
// add meta data for this image (only once per image!)
$query = "UPDATE T_files SET file_title = 'artists-paint-pots-2', file_alt = 'artists-paint-pots-2', file_desc = 'artists-paint-pots-2' WHERE file_ID = {$edit_File->ID}";
$DB->query( $query );

// Insert a post PAGE into blog #1
$now = date( 'Y-m-d H:i:s', installer_timestamp() );
$edited_Item = new Item();
$edited_Item->insert( 1, T_('About Blog A'), sprintf( $info_page, $app_name, T_('Blog A') ), $now, $cat_welcome, array(), 'published', '#', '', '', 'open', array('default'), 1000 );

// Insert a post into blog #2
$now = date( 'Y-m-d H:i:s', installer_timestamp() );
$edited_Item = new Item();
$edited_Item->insert( 1, T_('Sample Intro-Cat post'), T_('This uses post type "Intro-Cat". To use this effectively it needs to be in the category/categories you are writing about.

Click the "About widgets..." post, then the "widgets" tag to see the last intro type in action :)'), $now, $cat_appname, array(), 'published', '#', '', '', 'open', array('default'), 1520 );

// Insert a post into blog #3
$now = date( 'Y-m-d H:i:s', installer_timestamp() );
$edited_Item = new Item();
$edited_Item->insert( 1, 'jQuery UI v1.8.16', '', $now, $cat_tools, array(), 'published', 'en-US', 'jquery-ui', 'http://jqueryui.com/', 'disabled', array('default') );
$edited_Item->set( 'renderers', array( '' ) );
$edited_Item->dbsave();

// Insert a post into blog #4
$now = date('Y-m-d H:i:s',installer_timestamp());
$edited_Item = new Item();
$edited_Item->insert( 1, T_('Photo of Biscuit Basin'), 'This shows a customized "file title" field, which became the alt text and description and item title.', $now, $cat_yellowstone, array(), 'published','en-US' );
// attach an image to the item
$edit_File = new File( 'blog', 4, 'biscuit-basin.jpg' );
$edit_File->link_to_Item( $edited_Item );
// add meta data for this image (only once per image!)
$query = "UPDATE T_files SET file_title = 'Photo of Biscuit Basin', file_alt = 'Photo of Biscuit Basin', file_desc = 'Photo of Biscuit Basin' WHERE file_ID = {$edit_File->ID}";
$DB->query( $query );

// Insert a post PAGE into blog #1 (cross-posted):
$now = date( 'Y-m-d H:i:s', installer_timestamp() );
$edited_Item = new Item();
$edited_Item->insert( 1, T_('About this system'), sprintf( T_('This blog platform is powered by %s.

You are currently looking at an info page about this system. It is cross-posted among the demo blogs. Thus, this page will be linked on each of these blogs.

Cross-posting across multiple blogs is an advanced feature that is not on by default. The primary category is attached to blog #1, so clicking this link from any blog will display this item in blog #1.

Info pages use post type "Page" and are very much like regular posts, except that they do not appear in the regular flow of posts. You place them in a container using the "Simple Page list" widget.

If needed, a template can format info pages differently from regular posts. For example in a default installation, this template does not have a sidebar on "pages", or offer any feedback options.'), $app_name ),
	$now, $cat_welcome, array( $cat_ann_b, $cat_linkblog_b2evo ), 'published', '#', '', '', 'open', array('default'), 1000 );


// Insert a post into blog #2
$now = date( 'Y-m-d H:i:s', installer_timestamp() );
$edited_Item = new Item();
$edited_Item->insert( 1, T_('Sample Intro-Tag post'), T_('This uses post type "Intro-Tag". When you use this make sure you add the tag/tags you are writing about.'), $now, $cat_appname, array(), 'published', '#', '', '', 'open', array('default'), 1530 );
// Insert a post TAG for this post:
$item_ID = $edited_Item->ID;
$this_tag_id = $DB->get_var( "SELECT `tag_ID` FROM T_tags WHERE `tag_name` = 'widgets'" );
if( ! $this_tag_id )
{
	$tag_id_counter++;
	$this_tag_id = $tag_id_counter;
	$query = "INSERT INTO T_tags( tag_ID, tag_name ) VALUES( $this_tag_id, 'widgets' )";
	$DB->query( $query );
}
$query = "INSERT INTO T_item_tags( itag_itm_ID, itag_tag_ID ) VALUES( $item_ID, $this_tag_id )";
$DB->query( $query );

// Insert a post into blog #3
$now = date( 'Y-m-d H:i:s', installer_timestamp() );
$edited_Item = new Item();
$edited_Item->insert( 1, 'PHP/SWF Charts v1.6', '', $now, $cat_tools, array(), 'published', 'en-US', 'php-swf-charts', 'http://www.maani.us/charts/index.php', 'disabled', array('default') );
$edited_Item->set( 'renderers', array( '' ) );
$edited_Item->dbsave();

// Insert a post into blog #4
$now = date('Y-m-d H:i:s',installer_timestamp());
$edited_Item = new Item();
$edited_Item->insert( 1, T_('Emerald Pool, Yellowstone NP'), 'This image has all three attributes set to unique values, then this post was created with a unique title and content, then the image was attached to the post.', $now, $cat_yellowstone, array(), 'published','en-US' );
// attach an image to the item
$edit_File = new File( 'blog', 4, 'emerald-pool-in-yellowstone.jpg' );
$edit_File->link_to_Item( $edited_Item );
// add meta data for this image (only once per image!)
$query = "UPDATE T_files SET file_title = 'Emerald Pool, Yellowstone', file_alt = 'Photo of Emerald Pool in Yellowstone', file_desc = 'This is the \"description/caption\" field for the file name \"emerald-pool-in-yellowstone.jpg\"' WHERE file_ID = {$edit_File->ID}";
$DB->query( $query );

// Insert a post into blog #1
$now = date( 'Y-m-d H:i:s', installer_timestamp() );
$edited_Item = new Item();
$edited_Item->insert( 1, T_('About widgets...'), sprintf( T_('Widgets are little bits of code that you put into "containers" to add something to your web pages. You can add, remove and reorder widgets from the <a href="'.$app_baseurl.'admin.php?ctrl=blog_settings&blog=2&tab=template" target="_blank">Blog settings->Widgets</a> tab in the admin interface.

Each container appears in a specific place in a template, typically the header area, sidebar, and footer area are containers.  If you change your blog template, the new template may not use the same containers as the previous one. Make sure you place your widgets in containers that exist in the specific template you are using.

Your template may or may not have widgets pre-selected by the template author. If it does not, then $s will provide widgets ... if the template has containers with names it expects. Widgets can also be "hard-coded" into your template, meaning no container is used. Blog A header is an example of this: the title and long description are coded widgets.'), $app_name ), $now, $cat_post_features );
// Insert a post TAG for this post:
$item_ID = $edited_Item->ID;
$this_tag_id = $DB->get_var( "SELECT `tag_ID` FROM T_tags WHERE `tag_name` = 'widgets'" );
if( ! $this_tag_id )
{
	$tag_id_counter++;
	$this_tag_id = $tag_id_counter;
	$query = "INSERT INTO T_tags( tag_ID, tag_name ) VALUES( $this_tag_id, 'widgets' )";
	$DB->query( $query );
}
$query = "INSERT INTO T_item_tags( itag_itm_ID, itag_tag_ID ) VALUES( $item_ID, $this_tag_id )";
$DB->query( $query );

// Insert a post into blog #2
$now = date( 'Y-m-d H:i:s', installer_timestamp() );
$edited_Item = new Item();
$edited_Item->insert( 1, T_('Sample Intro-Sub post'), T_('This uses post type "Intro-Sub". These show up on any page except the main page that has more than one post and no other "intro" post to display.

Click the "'.$app_name.' Tips" category for another type of intro post :)'), $now, $cat_appname, array(), 'published', '#', '', '', 'open', array('default'), 1570 );

// Insert a post into blog #3
$now = date( 'Y-m-d H:i:s', installer_timestamp() );
$edited_Item = new Item();
$edited_Item->insert( 1, 'TAR/GZIP/BZIP2/ZIP Archives', '', $now, $cat_tools, array(), 'published', 'en-US', 'tar-gzip-bzip2-zip-archives', 'http://www.phpclasses.org/browse/package/945.html', 'disabled', array('default') );
$edited_Item->set( 'renderers', array( '' ) );
$edited_Item->dbsave();

// Insert a post into blog #4
$now = date( 'Y-m-d H:i:s', installer_timestamp() );
$edited_Item = new Item();
$edited_Item->insert( 1, T_('Mammoth Hot Springs'), '', $now, $cat_yellowstone, array(), 'published','en-US' );
// attach an image to the item
$edit_File = new File( 'blog', 4, 'mammoth-hot-springs.jpg' );
$edit_File->link_to_Item( $edited_Item );
// add meta data for this image (only once per image!)
$query = "UPDATE T_files SET file_title = 'Mammoth Hot Springs', file_alt = 'Mammoth Hot Springs', file_desc = 'Free Stock Photo of Mammoth Hot Springs - Yellowstone - Travel, from public-domain-photos.com' WHERE file_ID = {$edit_File->ID}";
$DB->query( $query );

// Insert a post into blog #1
$now = date( 'Y-m-d H:i:s', installer_timestamp() );
$edited_Item = new Item();
$edited_Item->insert( 1, T_('About plugins...'), sprintf( T_('A plugin is a piece of software written to extend the capabilities of %s beyond the basic web engine requirements.

For example you may or may not have a need to embed a video in your content. If you do, then you use the "video" plugin and get your videos scaled to match your template. If not then you don\'t!

There are many plugins written for Quam Plures, and a small handful that are included in this package. To see the installed plugins visit your <a href="'.$app_baseurl.'admin.php?ctrl=plugins" target="_blank">Global settings -> Plugins</a> tab. To find more plugins visit <a href="http://1912webworks.com/plugins.php">1912WebWorks plugins page</a>.'), $app_name ), $now, $cat_post_features );

// Insert a post into blog #1
$now = date( 'Y-m-d H:i:s', installer_timestamp() );
$edited_Item = new Item();
$edited_Item->insert( 1, T_('About templates...'), sprintf( T_('%s uses templates to create your website pages. A template is a set of files that define what shows up on your blog and how it looks. You can change the template used by any blog by editing the <a href="'.$app_baseurl.'admin.php?ctrl=blog_settings&blog=2&tab=template" target="_blank">Blog settings->Templates</a> tab in the admin interface.

You can download additional template from the <a href="http://1912webworks.com/templates.php" target="_blank">templates site</a>. To install them, unzip them in the /blogs/qp_templates directory, then go to General Settings &gt; Templates in the admin interface and click on "Install new".

You can also create your own templates by duplicating, renaming and customizing any existing template folder from the /qp_templates/ directory. The "Basic" template is a really good starting point because it shows all the default $params values each function and method has available to you.

To start customizing a template, open the template\'s "<code>index.main.php</code>" file in an editor and read the comments in there. Note: you can also edit templates in the "Files" tab of the admin interface if you enable template directories (Global settings, Files sub-section).'), $app_name ), $now, $cat_post_features );
// Insert a post TAG for this post:
$item_ID = $edited_Item->ID;
$this_tag_id = $DB->get_var( "SELECT `tag_ID` FROM T_tags WHERE `tag_name` = 'templates'" );
if( ! $this_tag_id )
{
	$tag_id_counter++;
	$this_tag_id = $tag_id_counter;
	$query = "INSERT INTO T_tags( tag_ID, tag_name ) VALUES( $this_tag_id, 'templates' )";
	$DB->query( $query );
}
$query = "INSERT INTO T_item_tags( itag_itm_ID, itag_tag_ID ) VALUES( $item_ID, $this_tag_id )";
$DB->query( $query );

// Insert a post into blog #2
$now = date( 'Y-m-d H:i:s', installer_timestamp() );
$edited_Item = new Item();
$edited_Item->insert( 1, T_('Comments'), T_('The comments section is really easy: for each post you get to decide if people can comment (open), if comments are no longer accepted (closed), or if comments simply aren\'t part of the post (disabled). If you edit a post and select "disable" any comments that post already got will no longer be shown on the blog.

On your <a href="'.$app_baseurl.'admin.php?ctrl=blog_settings&blog=2&tab=features" target="_blank">Blog settings->Features</a> page you can set the default value for this field.

On your <a href="'.$app_baseurl.'admin.php?ctrl=plugins" target="_blank">Global settings->Plugins</a> page if you click on "Basic Antispam" you will be able to enable or disable anonymous comments.'), $now, $cat_sidebar, array( $cat_writepage, $cat_sidebar ) );

// Insert a post into blog #3
$now = date( 'Y-m-d H:i:s', installer_timestamp() );
$edited_Item = new Item();
$edited_Item->insert( 1, 'IDNA Convert', '', $now, $cat_tools, array(), 'published', 'en-US', 'idna-convert', 'http://www.phpclasses.org/package/1509-PHP-Convert-from-and-to-IDNA-Punycode-domain-names.html', 'disabled', array('default') );
$edited_Item->set( 'renderers', array( '' ) );
$edited_Item->dbsave();

// Insert a post into blog #4
$now = date( 'Y-m-d H:i:s', installer_timestamp() );
$edited_Item = new Item();
$edited_Item->insert( 1, T_('Morning Glory Pool'), 'This photo has some text like a normal blog post might.', $now, $cat_yellowstone, array(), 'published','en-US' );
// attach an image to the item
$edit_File = new File( 'blog', 4, 'morning-glory-pool.jpg' );
$edit_File->link_to_Item( $edited_Item );
// add meta data for this image (only once per image!)
$query = "UPDATE T_files SET file_title = 'Morning Glory Pool', file_alt = 'Morning Glory Pool', file_desc = 'Free Stock Photo of Morning Glory Pool - Yellowstone - Travel, from public-domain-photos.com' WHERE file_ID = {$edit_File->ID}";
$DB->query( $query );

// Insert a post into blog #1
$now = date( 'Y-m-d H:i:s', installer_timestamp() );
$edited_Item = new Item();
$edited_Item->insert( 1, T_('About blogs...'), sprintf( T_('In %s, a blog is the highest level of content separation. A "blog" doesn\'t have to be a blog-blog ... but it could be. Each blog can have it\'s own RSS feed, and can be completely separate from (or fully integrated with) all other blogs in your installation. You can have as many blogs as you want.

Each blog must have at least one category, and can have as many as you want, and each category can also have "sub-categories". Categories are how your content (items, posts, pages) are organized, meaning an item is in a category which in turn is in a blog. It is possible to move a category from one blog to another, which would move all the items in that category to the new blog.

Each blog also has a template. Your template determines what goes where and how it looks. For example one template might show the author\'s name for each item, another one might not.'), $app_name ), $now, $cat_post_features );

// Insert a post into blog #2
$localdoc = '<img src="'.$app_baseurl.'qp_rsc/icons/question.png" alt="Help" height="16" width="16">';
$homepage = '<img src="'.$app_baseurl.'qp_rsc/icons/url.png" alt="WWW" height="16" width="32">';
$now = date( 'Y-m-d H:i:s', installer_timestamp() );
$edited_Item = new Item();
$edited_Item->insert( 1, T_('Text Renderers'), sprintf( T_('Text renderers are really easy! They come from plugins and do stuff to your post content. The checkbox for each renderer is checked or not depending on the plugin\'s settings. On your <code>Global settings->Plugins</code> page if you click the name of the plugin you will be able to change the default condition.

<strong>An example of how a renderer works:</strong> The "Smilies" plugin is off by default (which seems wrong to me but it is what it is). Therefore typing :) will NOT turn into a happy face. If I turn on that renderer then it will. Simple?

The post is stored exactly as you type it: rendering happens when the post is called for displaying in a browser, but not in the "write" screen when writing or editing.

Another example would be the code generated by the "Videos" plugin. You have a toolbar, you get code, the renderer makes it be a video. Edit this post to see the code :)
<!--more-->
[video:vimeo:1124192 w:400 h:225]
Each renderer might have 2 linked icons. The %s links to a readme file about the plugin/renderer and provides information about the plugin. The %s links to the plugin\'s home page where you might be able to learn more, or just thank the author for their work.'), $localdoc, $homepage ), $now, $cat_sidebar, array( $cat_writepage, $cat_sidebar ) );
$edited_Item->set( 'renderers', array('video') );
$edited_Item->dbsave();

// Insert a post into blog #3
$now = date( 'Y-m-d H:i:s', installer_timestamp() );
$edited_Item = new Item();
$edited_Item->insert( 1, 'MIME Parser', '', $now, $cat_tools, array(), 'published', 'en-US', 'mime-parser', 'http://www.phpclasses.org/browse/file/14670.html', 'disabled', array('default') );
$edited_Item->set( 'renderers', array( 'smilies','autolinks','auto_p' ) );
$edited_Item->dbsave();

// Insert a post into blog #4
$now = date('Y-m-d H:i:s',installer_timestamp());
$edited_Item = new Item();
$edited_Item->insert( 1, T_('2 pics in one post'), 'This post shows how you can attach more than one image to a post. All of the Yellowstone photos came from <a href="http://www.public-domain-photos.com/travel/yellowstone">Public-Domain-Photos</a>.', $now, $cat_yellowstone, array(), 'published','en-US' );
// attach an image to the item
$edit_File = new File( 'blog', 4, 'mammoth-hot-springs.jpg' );
$edit_File->link_to_Item( $edited_Item );
// add meta data for this image (only once per image!)
$query = "UPDATE T_files SET file_title = 'Mammoth Hot Springs', file_alt = 'Mammoth Hot Springs', file_desc = 'Mammoth Hot Springs.' WHERE file_ID = {$edit_File->ID}";
$DB->query( $query );
// attach another image to the item
$edit_File = new File( 'blog', 4, 'morning-glory-pool.jpg' );
$edit_File->link_to_Item( $edited_Item );
// add meta data for this image (only once per image!)
$query = "UPDATE T_files SET file_title = 'Morning Glory Pool', file_alt = 'Morning Glory Pool', file_desc = 'Morning Glory Pool.' WHERE file_ID = {$edit_File->ID}";
$DB->query( $query );

// Insert a post into blog #1
$now = date( 'Y-m-d H:i:s', installer_timestamp() );
$edited_Item = new Item();
$edited_Item->insert( 1, T_('Blogs, Stubs &amp; website integration...'), sprintf( T_('By default, blogs are displayed using a template (more on both in another post). In most cases, blogs are accessed through a stub file with "clean URLs" enabled. If your server does not support clean URLs you will need to change your <a href="'.$app_baseurl.'admin.php?ctrl=blog_settings&blog=2&tab=urls" target="_blank">Blog settings->URLs</a> selections to "Use params" ... or change hosts.

A stub file defines which blog will be called, and can optionally force other parameters (template, category/categories, date range, display order, others). In the URL of this page "blog2.php" is a a stub file in the installation\'s root directory.

You should use a stub file even if clean URLs do not work on your server. For example the following URLs all point to the same page: blog #2 displaying posts in the "announcements" category.
<!--more-->
<ul><li><code>http://yourdomain.com/blog2.php/announcements/</code></li><li><code>http://yourdomain.com/blog2.php?cat=4</code></li><li><code>http://yourdomain.com/index.php?blog=2&amp;cat=4</code></li></ul>

When you create a new blog, %s will create a new stub file for you named "blogNN.php" where NN is the blog\'s number. You can then rename the file and change the "Relative to baseurl" setting on your <a href="'.$app_baseurl.'admin.php?ctrl=blog_settings&blog=2&tab=urls" target="_blank">Blog settings->URLs</a> tab in the admin interface.

Finally, if you need to do some very specific customizations to your blog, you may want to call your blog through the \'<code>no_template.php</code>\' file. On your <a href="'.$app_baseurl.'admin.php?ctrl=settings" target="_blank">Global settings->General</a> page select which blog to display, then on that blog\'s <a href="'.$app_baseurl.'admin.php?ctrl=blog_settings&blog=2&tab=urls" target="_blank">Blog settings->URLs</a> page put the file name in the box for "Relative to baseurl". Or delete the existing index.php file and rename no_template.php to index.php and select "Default blog in index.php".

If you want to integrate a %s blog into a complex website, you might want to do it by copy/pasting code from <code>no_template.php</code> into a page of your website.

You will find more information in the stub and template files themselves. Open them in a text editor and read the comments in there. Either way, make sure you go to the blogs admin and set the correct access method/URL for your blog. Otherwise, the permalinks will not function properly.'), $app_name, $app_name, $app_name ), $now, $cat_post_features, array(), 'published', '#', '', '', 'open', array( 'auto_p' ) );
// Insert a post TAG for this post:
$item_ID = $edited_Item->ID;
$this_tag_id = $DB->get_var( "SELECT `tag_ID` FROM T_tags WHERE `tag_name` = 'templates'" );
if( ! $this_tag_id )
{
	$tag_id_counter++;
	$this_tag_id = $tag_id_counter;
	$query = "INSERT INTO T_tags( tag_ID, tag_name ) VALUES( $this_tag_id, 'templates' )";
	$DB->query( $query );
}
$query = "INSERT INTO T_item_tags( itag_itm_ID, itag_tag_ID ) VALUES( $item_ID, $this_tag_id )";
$DB->query( $query );

// Insert a post into blog #2
$now = date( 'Y-m-d H:i:s', installer_timestamp() );
$edited_Item = new Item();
$edited_Item->insert( 1, T_('Visibility / Sharing'), sprintf( T_('This section is all about who can see your post, and when, and where.

<h3>Published</h3>
A published post is visible to everyone who visits your blog. Publishing a post will trigger any pinging you may have enabled, and sets the displayed date and time of the post.

<h3>Protected</h3>
A protected post is only visible to people who are members of the blog the post is in and are logged in. You can use this to share information with a limited audience (blog members) in the usual post flow model. For example you might post about traffic data so your bloggers can react, but do not want that "out there" for all the world to see.
<!--more-->
<h3>Private</h3>
A private post is only visible to the author of the post, which seems silly to me. Why post something for you and only you to see? The only case I can think of for this is when you share a login with your significant other and want to "talk dirty" or post naughty pictures.

<h3>Draft</h3>
This is the default status for a new entry. Saving a draft in %s is just like saving a draft in many other applications: you start something, save it as a draft, and continue working on it later. <strong>When you are ready to publish your draft you should always use the "Publish NOW" button!</strong> If you edit the post and change the status it won\'t store the current date and time, or send out pings.

<h3>Deprecated</h3>
A deprecated post is deleted from the public side of the blog but not removed from the database. This is useful if you want to keep the information in the post, but it really doesn\'t need to be out there anymore.

<h3>Redirected</h3>
A redirected post is a strange case. Let\'s say after a while a certain post got so much attention that you decided to create a blog for that topic. You would put the new blog\'s URL in the "Link to URL" field and change the visibility to \'redirected\'. Visitors to the original permalink will now go straight to the content\'s new home.'), $app_name ), $now, $cat_sidebar, array( $cat_writepage, $cat_sidebar ) );

// Insert a post into blog #3
$now = date( 'Y-m-d H:i:s', installer_timestamp() );
$edited_Item = new Item();
$edited_Item->insert( 1, 'RFC822 addresses', '', $now, $cat_tools, array(), 'published', 'en-US', 'rfc822-addresses', 'http://www.phpclasses.org/browse/file/21704.html', 'disabled', array('default') );
$edited_Item->set( 'renderers', array( 'smilies','autolinks','auto_p' ) );
$edited_Item->dbsave();

// Insert a post into blog #2
$now = date( 'Y-m-d H:i:s', installer_timestamp() );
$edited_Item = new Item();
$edited_Item->insert( 1, T_('Properties'), T_('The Properties section is kinda silly for the #2 spot in the sidebar. It contains 3 sections, one of which doesn\'t work, one of which you\'ll rarely ever use, and the last that I don\'t even know what it does.

<strong>Featured post:</strong> this checkbox lets you make a post be "featured", which means it will show up on the top of the main blog page. It isn\'t supposed to show up in the post flow but it does. It should just go away.

<strong>Update / Set issue date:</strong> This lets you edit the apparent date of an item. You can set it to "now", or any date and time you choose.

<strong>Order:</strong> When you figure it out let us know okay?'), $now, $cat_sidebar, array( $cat_writepage, $cat_sidebar ) );

// Insert a post into blog #3
$now = date( 'Y-m-d H:i:s', installer_timestamp() );
$edited_Item = new Item();
$edited_Item->insert( 1, 'XML-RPC for PHP', '', $now, $cat_tools, array(), 'published', 'en-US', 'xml-rpc-for-php', 'http://phpxmlrpc.sourceforge.net/', 'disabled', array('default') );
$edited_Item->set( 'renderers', array( '' ) );
$edited_Item->dbsave();

// Insert a post into blog #2
$now = date( 'Y-m-d H:i:s', installer_timestamp() );
$edited_Item = new Item();
$edited_Item->insert( 1, T_('Categories'), T_('Categories are fairly simple. You create categories for each blog on your <a href="'.$app_baseurl.'admin.php?ctrl=blog_settings&blog=2&ctrl=cats" target="_blank">Blog settings->Categories</a> page, then select which category/categories each post will be in.

Each post needs to have a "Main" category selected by clicking the radio button. Additionally you can assign "Extra" categories to a post by clicking the checkbox for each one.

Visitors can use categories to help find content they\'re into reading.'), $now, $cat_sidebar, array( $cat_writepage, $cat_sidebar ) );

// Insert a post into blog #3
$now = date( 'Y-m-d H:i:s', installer_timestamp() );
$edited_Item = new Item();
$edited_Item->insert( 1, T_('b2evolution'), T_('A great improvement on b2evolution, slowed by lack of developers and lack of consensus on what to do next.'), $now, $cat_sources, array(), 'published', '#', '', 'http://b2evolution.net/', 'disabled', array() );

// Insert a post into blog #2
$now = date( 'Y-m-d H:i:s', installer_timestamp() );
$edited_Item = new Item();
$edited_Item->insert( 1, T_('Advanced Properties'), sprintf( T_('<h3>URL title "slug":</h3>
The URL title slug is used as part of each item\'s permalink, and will be automatically created from your post Title. You can over-ride creation by supplying your own. You may want to do this if your post title is very long, or contains special characters. You can change your configuration to not use this feature but the "slug" will always be created anyway.

<h3>Tags:</h3>
Tags allow a different way to let visitors find content on your site. Think of them as "categories on the fly" because you can write as many or few tags as you want based on what your blog post is about.

<h3>&lt;title> tag:</h3>
This field lets you create your own title displayed at the top of the browser. If you leave this field blank then %s will use the item title as the browser page title.
<!--more-->
<h3>&lt;meta> desc:</h3>
This field lets you create your own "description meta tag" for the permalink\'s &lt;head> section. Some think this will help search engine placement, others doubt it. If you leave this field blank then %s will use the blog\'s description field.

<h3>&lt;meta> keywds:</h3>
This field lets you create your own "keywords meta tag" for the permalink\'s &lt;head> section. Some think this will help search engine placement, others doubt it. If you leave this field blank then %s will use the blog\'s keywords field.

<h3>Excerpt:</h3>
Excerpt is like a box of chocolates: if you leave it in the car everything will get all melty unless it is the middle of winter. Then they\'ll all freeze.'), $app_name, $app_name, $app_name ), $now, $cat_mainbody, array( $cat_writepage, $cat_mainbody ) );

// Insert a post into blog #3
$now = date( 'Y-m-d H:i:s', installer_timestamp() );
$edited_Item = new Item();
$edited_Item->insert( 1, T_('Quam Plures'), T_('The original "multi-blog multi-author multi-lingual" blog engine, unfortunately littered with linkback spam in an effort to drive profitability :('), $now, $cat_sources, array(), 'published', '#', '', 'http://quamplures.net/', 'disabled', array() );

// Insert a post into blog #2
$now = date( 'Y-m-d H:i:s', installer_timestamp() );
$edited_Item = new Item();
$edited_Item->insert( 1, T_('Images &amp; Attachments'), sprintf( T_('This post is about the "Images & Attachments" section of the write page. Images can also be \'inserted\' into a post. This entry does not cover that.

Attaching a file to an item (your post) is similar to attaching a file to an email. In %s if you attach an image it will also be resized if required to fit your template and displayed at the top of your post. You can attach as many images to a post as you like, but all will be displayed at the top of the post.

Attaching an image takes advantage of the fields available when you enable \'advanced upload properties\' on the upload page. Each attached image will use the long title and alternative text in the IMG tag, and display the description/caption under the image. That means you can, effectively, write your blog post entries straight from the file manager by uploading and providing a good title, alt text and caption, then selecting your images and choosing the "make multiple posts" option.
<!--more-->
Templates can resize images from 80 to 800 pixels wide, in 40 pixel increments. Width x Height proportionality is maintained. Your template can use one size in the sidebar, another in the main body, and a third for the item\'s permalink page. Attached images can be linked to the original, another resized version of the image (in a popup window), the item\'s permalink, or nothing.

If you attach a non-image file (.doc, .xls, .ppt, .zip, etcetera) the file will be made available to your visitors as a link. What happens with that link depends on the visitors browser and computer.'), $app_name ), $now, $cat_mainbody, array( $cat_writepage, $cat_mainbody ) );

// Insert a post into blog #3
$now = date( 'Y-m-d H:i:s', installer_timestamp() );
$edited_Item = new Item();
$edited_Item->insert( 1, T_('Free Stock Photos'), T_('All photos in blog #4 are from this site\'s "Travel - Yellowstone" collection.'), $now, $cat_sources, array(), 'published', '#', '', 'http://www.public-domain-photos.com/', 'disabled', array() );

// Insert a post into blog #2
$now = date( 'Y-m-d H:i:s', installer_timestamp() );
$edited_Item = new Item();
$edited_Item->insert( 1, T_('Post contents'), sprintf( T_('The Post contents section is the easiest to figure out. Sort of...

<strong>Title:</strong> This is the title of your post. Pretty easy eh? On your <a href="'.$app_baseurl.'admin.php?ctrl=blog_settings&blog=2&tab=features" target="_blank">Blog settings->Features</a> page you can make titles optional or not allowed (hide the field). The default for that setting is "required".

<strong>Link to url:</strong> This one is a little confusing. IF you want to associate a web page with your post you would paste in the URL here. On your <a href="'.$app_baseurl.'admin.php?ctrl=blog_settings&blog=2&tab=urls" target="_blank">Blog settings->URLs</a> page you can tell %s to link the title to this URL if you provide one. Your template can display it as "Link: what_you_put_in_link-to-url", like in this post for example.

<strong>Type:</strong> This one is a lot confusing. Most of your posts will use the post type "Post" which is the default, but there are quite a few options. Some of which are probably dumb.
<!--more-->
<ul>
<li>Page: this is for informational items that are not part of the normal blog post flow but you do want listed on your web. For example the traditional "About Me" page would be a post using type=page. These items can be placed with a widget, such as the "About this system" link above.</li>
<li>Intro-Main, Intro-Cat, Intro-Tag, Intro-Sub, Intro-All: each of these is covered by it\'s own sample so no sense in re-writing it all here.</li>
<li>Podcast: this is a special case that will call up an audio player if you have a link to an audio file in your "link to url" field. Your template can display the player anywhere but will typically put it above the post text.</li>
<li>Sidebar link: heck I dunno what this one does. I\'m thinking it probably puts links in the sidebar, but really that means it puts links in a widget that you might put in the sidebar container.</li>
</ul>'), $app_name ), $now, $cat_mainbody, array( $cat_writepage, $cat_mainbody ), 'published','en-US', '', 'http://forums.quamplures.net/' );

// Insert a post into blog #3 for each contributor:
require( $templates_path.'/_contributors.php' );
// reverse alpha order so date order is alpha order ;)
krsort( $_hic_sunt_dracones );
foreach( $_hic_sunt_dracones as $_dracone )
{
	$now = date( 'Y-m-d H:i:s', installer_timestamp() );
	$edited_Item = new Item();
	$edited_Item->insert( 1, $_dracone['name'], $_dracone['spiel'], $now, $cat_contributors, array(), 'published', $_dracone['locale'], '', $_dracone['homepage'], 'disabled', array() );
}

// Insert a post into blog #2
$now = date( 'Y-m-d H:i:s', installer_timestamp() );
$edited_Item = new Item();
$edited_Item->insert( 1, T_('Inserted Image post'), T_('<span class="floatright center" style="width:172px;"><span class="image_title">waterfall</span><br /><img src="'.$app_baseurl.'media/blogs/id_2/waterfall.jpg" alt="waterfall" width="160" height="240" class="center" /><br /><span class="image_legend">waterfall</span></span> This waterfall image was re-sized before uploading, then uploaded using the <strong>quick upload</strong> feature. Therefore the file name is also the title, alt text, and image caption. You can customize those details and even rename the file when you upload it if you use <strong>advanced upload properties</strong>, which is discussed in a different post.

This image is floated to the right which is why the text flows alongside and under the image. When you insert an image you can float it right, or left, or have it centered in a &lt;div&gt; if you like. Whatever positioning you choose, you can also choose to have the image\'s title and caption/description displayed with the image.

This paragraph is dummy text so there is enough text to wrap around the image. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Suspendisse ac tellus nisl; ut bibendum ante. Suspendisse ac odio sit amet nibh ultricies semper at id lorem. Suspendisse faucibus pretium ullamcorper. Nam congue est ut nunc malesuada pellentesque.

Image used compliments of <a href="http://www.flickr.com/photos/leeturner/sets/72157622986782395/with/4278672768/" title="inserted image sample" target="_blank">Lee Turner</a>'), $now, $cat_appname );
// attach an image to the item
$edit_File = new File( 'blog', 2, 'waterfall.jpg' );
$edit_File->link_to_Item( $edited_Item );
// add meta data for this image (only once per image!)
$query = "UPDATE T_files SET file_title = 'waterfall', file_alt = 'waterfall', file_desc = 'waterfall' WHERE file_ID = {$edit_File->ID}";
$DB->query( $query );
// now break the attachment
$query = "DELETE FROM T_links WHERE link_itm_ID = {$edited_Item->ID}";
$DB->query( $query );

// Insert a post into blog #2
$now = date( 'Y-m-d H:i:s', installer_timestamp() );
$edited_Item = new Item();
$edited_Item->insert( 1, T_('Attached Image post'), T_('This post has an image attached (or linked) to it. Attaching an image will automatically resize it to fit the current template. Automatic resizing is based on width, with sizes from 80 to 800 pixels wide.
<!--more-->
You can create a template that will resize an image to 240 pixels wide in the sidebar, 400 wide in the main body on multipost pages, and 600 wide on the item\'s permalink page. You can link the resized image to a larger resized version, the item\'s permalink, the original image, or nothing (as seen in this template).

Check out the photoblog (accessible through the links at the top) to see a completely different template focused more on the photos than on the blog text.

This file was uploaded using the <strong>advanced upload properties</strong> which allows for customizing the title and alt text and caption/description.

Image used compliments of <a href="http://innervisions.org.uk/bimble/2008/08/sunshine-and-showers" title="attached image sample" target="_blank">Yabs</a>'), $now, $cat_appname );
// attach an image to the item
$edit_File = new File( 'blog', 2, 'sunshine_and_flowers.jpeg' );
$edit_File->link_to_Item( $edited_Item );
// add meta data for this image (do once per default image!)
$query = "UPDATE T_files SET file_title = 'Coral Jupiter', file_alt = 'home grown flowers', file_desc = 'Coral Jupiter - home grown flowers (caption/description field)' WHERE file_ID = {$edit_File->ID}";
$DB->query( $query );

// Insert a post into blog #2
$now = date( 'Y-m-d H:i:s', installer_timestamp() );
$edited_Item = new Item();
$edited_Item->insert( 1, T_('This is a multipage post'), T_('This is page 1 of a multipage post. You can see the other pages by clicking on the links below the text.
<!--nextpage-->
This is page 2. This feature uses the <strong><span class="black">!NP</span></strong> button on the Quick Tags toolbar. You can add as many pages as you want. In single item mode, each page will have comments (if enabled) visible.
<!--nextpage-->
This is third and final page. This page demonstrates some other features of the Quick Tags toolbar.

<ins>This sentence is wrapped with the "ins" (insert) button.</ins> <del>This sentence is wrapped with the "del" (delete) button.</del> <strong>This sentence is wrapped with the "str" (strong/bold) button.</strong> <em>This sentence is wrapped with the "em" (emphasize/italic) button.</em> <code>This sentence is wrapped with the "code" button.</code> <blockquote>This uses the "block" button, for quoting text.</blockquote>

Create an unordered list with the "ul" and "li" buttons:
<ul>
<li>Make <span class="red">Red text</span> with the R button</li>
<li>Make <span class="orange">Orange text</span> with the O button</li>
<li>Make <span class="yellow">Yellow text</span> with the Y button</li>
<li>Make <span class="green">Green text</span> with the G button</li>
<li>Make <span class="blue">Blue text</span> with the B button</li>
</ul>

Create an ordered list with the "ol" and "li" buttons:
<ol>
<li><span class="indigo">Indigo text</span> with the I button</li>
<li><span class="violet">Violet text</span> with the V button</li>
<li><span class="black">Black text</span> with the BLK button</li>
<li><span class="gray">Gray text</span> with the GR button</li>
<li><span class="white">White text</span> with the WHT button</li>
</ol>

You can make text <span class="larger">larger with "t+"</span>, <span class="smaller">smaller with "t-"</span>, or <span class="underline">underline you text with "_"</span>.

<h1>This is the h1 button</h1>
<h2>This is the h2 button</h2>
<h3>This is the h3 button</h3>
<h4>This is the h4 button</h4>
<h5>This is the h5 button</h5>
<h6>This is the h6 button</h6>

The styles for these buttons can be changed in your template\'s style sheet.'), $now, $cat_appname );

// Insert a post into blog #2
$now = date( 'Y-m-d H:i:s', installer_timestamp() );
$edited_Item = new Item();
$edited_Item->insert( 1, T_('Extended post with no teaser'), T_('This is an extended post with no teaser. This means that you won\'t see this teaser any more when you click the "Read more &raquo;" link (or the item\'s permalink).
<!--noteaser-->
This is the extended text. You only see it when you have clicked the "Read more &raquo;" link (or the permalink), and you no longer see the "teaser" portion of this post.

This feature uses the <strong><span class="black">!NT</span></strong> button on the Quick Tags toolbar. By editing your template you will be able to change "Read  more &raquo;" to suit your tastes, but the changes will apply to all features that create a "more" link.

Note that the "Read more &raquo;" text will be the same for both !M and !NT features - you can set it in your template, but not different for each feature.'), $now, $cat_appname );

// Insert a post into blog #2
$now = date( 'Y-m-d H:i:s', installer_timestamp() );
$edited_Item = new Item();
$edited_Item->insert( 1, T_('Extended post'), T_('This is an extended post. This means you only see this small teaser on a multi-post page, and must click on the "Read more &raquo;" link (or the item\'s permalink) to see the rest of the item.
<!--more-->
This is the extended text. You only see it when you have clicked the "Read more &raquo;" link, (or the permalink). This feature uses the <strong><span class="black">!M</span></strong> button on the Quick Tags toolbar. You decide where you want the link, if at all, by clicking <strong><span class="black">!M</span></strong> when writing your article. You can edit your template to customize both "Read more &raquo;" and "Follow up:" to suit your tastes.

By the way, this post uses "strong" and "BLK" buttons to make the !M stand out as it does. If you change templates the black text might not show up.'), $now, $cat_appname );

// Insert a post into blog #2
$now = date( 'Y-m-d H:i:s', installer_timestamp() );
$edited_Item = new Item();
$edited_Item->insert( 1, T_('Sample Intro-Main post'), T_('This is the main intro post. It uses post type "Intro-Main" and appears on the homepage only. Your template can make these "intro" posts have a different look, and different features. For example this template does not show the date, the time, tags, or allow any feedback. A different template might have comments possible, or the item itself can have comments disabled.
<!--more-->
There are 4 types of "intro" posts:
<ul><li><strong>Intro-Main</strong>: This shows up on a completely unfiltered page, meaning the first page of multiple posts.</li>
<li><strong>Intro-Cat</strong>: This shows up when a visitor clicks on a category name, useful to describe the category for your visitor.</li>
<li><strong>Intro-Tag</strong>: Similar to "intro-cat", this shows up when a visitor clicks on a tag name.</li>
<li><strong>Intro-Sub</strong>: This shows up if there is no other intro type of post to show.</li></ul>

Again, each template can handle intro items differently, including not showing them at all (usually an older template, or one not designed well).'), $now, $cat_appname, array(), 'published', '#', '', '', 'open', array('default'), 1500 );

// Insert a post into blog #1
$now = date( 'Y-m-d H:i:s', installer_timestamp() );
$edited_Item = new Item();
$edited_Item->insert( 1, sprintf( T_('Welcome to %s!'), $app_name ), sprintf( T_('The best web engine on earth! Four blogs have been created with sample contents:

<ul><li><strong>Blog A</strong>: You are currently looking at it. It contains posts that explain %s in a "big picture" sort of way.</li>
<li><strong>Blog B</strong>: You can access it from a link at the top of the page. It contains information about more advanced features of %s.</li>
<li><strong>Linkblog</strong>: The linkblog shows how to use a blog as a "blogroll", displayed in the sidebar of both Blog A &amp; Blog B.</li>
<li><strong>Photoblog</strong>: This blog is an example of how you can use %s to showcase photos, with one photo per page as well as a thumbnail index.</li></ul>

You can add new blogs, delete unwanted blogs and customize existing blogs (title, sidebar, blog template, widgets, etc.) from your <a href="'.$app_baseurl.'admin.php?ctrl=blogs" target="_blank">Blog Settings</a> tab in the admin interface.

We strongly suggest you read through these sample posts to get an idea of how this whole thing works. Also, after reading you might want to change the "Visibility / Sharing" from \'Published\' to \'Deprecated\' instead of deleting them.'), $app_name, $app_name, $app_name ), $now, $cat_welcome );

task_end();

?>
