<?php
/**
 * This file installs sample groups and users
 *
 * @copyright (c) 2009 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://www.gnu.org/licenses/gpl.txt GNU General Public License v3
 * @package installer
 */
if(!defined('QP_MAIN_INIT')) die('fail');

global $create_sample_contents;
$group_names_ids = array();

echo T_('Creating default groups').' ... ';
// highest order of permissions for group #1
$Group_Admins = new Group();
$Group_Admins->set( 'name', 'Administrators' );
$Group_Admins->set( 'perm_admin', 'visible' );
$Group_Admins->set( 'perm_blogs', 'editall' );
$Group_Admins->set( 'perm_xhtml_css_tweaks', 1 );
$Group_Admins->set( 'perm_stats', 'edit' );
$Group_Admins->set( 'perm_spamblacklist', 'edit' );
$Group_Admins->set( 'perm_options', 'edit' );
$Group_Admins->set( 'perm_users', 'edit' );
$Group_Admins->set( 'perm_templates', 1 );
$Group_Admins->set( 'perm_files', 'all' );
$Group_Admins->dbinsert();
$group_names_ids['Admins'] = 1;
// designate as group for new registrants
$GLOBALS['default_group_ID'] = $Group_Admins->ID;
if( $create_sample_contents )
{
	// permissions generally one step down from group #1
	$Group_Special = new Group();
	$Group_Special->set( 'name', 'Special Bloggers' );
	$Group_Special->set( 'perm_admin', 'visible' );
	$Group_Special->set( 'perm_blogs', 'viewall' );
	$Group_Special->set( 'perm_xhtml_css_tweaks', 1 );
	$Group_Special->set( 'perm_stats', 'view' );
	$Group_Special->set( 'perm_spamblacklist', 'view' );
	$Group_Special->set( 'perm_options', 'view' );
	$Group_Special->set( 'perm_users', 'view' );
	$Group_Special->set( 'perm_templates', 0 );
	$Group_Special->set( 'perm_files', 'edit' );
	$Group_Special->dbinsert();
	$group_names_ids['Special'] = 2;
	// permissions generally one step down from group #2
	$Group_Bloggers = new Group();
	$Group_Bloggers->set( 'name', 'Bloggers' );
	$Group_Bloggers->set( 'perm_admin', 'hidden' );
	$Group_Bloggers->set( 'perm_blogs', 'user' );
	$Group_Bloggers->set( 'perm_stats', 'user' );
	$Group_Bloggers->set( 'perm_spamblacklist', 'none' );
	$Group_Bloggers->set( 'perm_options', 'none' );
	$Group_Bloggers->set( 'perm_users', 'none' );
	$Group_Bloggers->set( 'perm_templates', 0 );
	$Group_Bloggers->set( 'perm_files', 'add' );
	$Group_Bloggers->dbinsert();
	$group_names_ids['Bloggers'] = 3;
	// permissions generally one step down from group #3
	$Group_Users = new Group();
	$Group_Users->set( 'name', 'Basic Users' );
	$Group_Users->set( 'perm_admin', 'hidden' );
	$Group_Users->set( 'perm_blogs', 'user' );
	$Group_Users->set( 'perm_stats', 'none' );
	$Group_Users->set( 'perm_spamblacklist', 'none' );
	$Group_Users->set( 'perm_options', 'none' );
	$Group_Users->set( 'perm_users', 'none' );
	$Group_Users->set( 'perm_templates', 0 );
	$Group_Users->set( 'perm_files', 'view' );
	$Group_Users->dbinsert();
	$group_names_ids['Users'] = 4;
	// designate this group for new registrants
	$GLOBALS['default_group_ID'] = $Group_Users->ID;
}
task_end();


echo T_('Creating default users').' ... ';
// user in group #1
$User_Admin = new User();
$User_Admin->set( 'login', param('conf_admin_login', 'string' ) );
$User_Admin->set( 'pass', md5( param( 'conf_admin_pass', 'string' ) ) );
$User_Admin->set( 'nickname', 'admin' );
$User_Admin->set_email( param('conf_admin_email', 'string' ) );
$User_Admin->set( 'validated', 1 ); // assume it's validated
$User_Admin->set( 'ip', '127.0.0.1' );
$User_Admin->set( 'domain', 'localhost' );
$User_Admin->set( 'level', 10 );
$User_Admin->set( 'locale', $default_locale );
$User_Admin->set_datecreated( installer_timestamp() );
$User_Admin->set_Group( $Group_Admins );
$User_Admin->dbinsert();
if( $create_sample_contents )
{
	// user in group #2
	$User_Special = new User();
	$User_Special->set( 'login', 'demospecial' );
	$User_Special->set( 'pass', md5( param( 'conf_admin_pass', 'string' ) ) );
	$User_Special->set( 'nickname', 'demospecial' );
	$User_Special->set_email( param('conf_admin_email', 'string') );
	$User_Special->set( 'validated', 1 ); // assume it's validated
	$User_Special->set( 'ip', '127.0.0.1' );
	$User_Special->set( 'domain', 'localhost' );
	$User_Special->set( 'level', 1 );
	$User_Special->set( 'locale', $default_locale );
	$User_Special->set_datecreated( installer_timestamp() );
	$User_Special->set_Group( $Group_Special );
	$User_Special->dbinsert();
	// user in group #3
	$User_Bloggers = new User();
	$User_Bloggers->set( 'login', 'demoblogger' );
	$User_Bloggers->set( 'pass', md5( param( 'conf_admin_pass', 'string' ) ) );
	$User_Bloggers->set( 'nickname', 'demoblogger' );
	$User_Bloggers->set_email( param('conf_admin_email', 'string') );
	$User_Bloggers->set( 'validated', 1 );
	$User_Bloggers->set( 'ip', '127.0.0.1' );
	$User_Bloggers->set( 'domain', 'localhost' );
	$User_Bloggers->set( 'level', 1 );
	$User_Bloggers->set( 'locale', 	$default_locale );
	$User_Bloggers->set_datecreated( installer_timestamp() );
	$User_Bloggers->set_Group( 	$Group_Bloggers );
	$User_Bloggers->dbinsert();
	// user in group #4
	$User_Demo = new User();
	$User_Demo->set( 'login', 'demouser' );
	$User_Demo->set( 'pass', md5( param( 'conf_admin_pass', 'string' ) ) );
	$User_Demo->set( 'nickname', 'demouser' );
	$User_Demo->set_email( param('conf_admin_email', 'string') );
	$User_Demo->set( 'validated', 1 );
	$User_Demo->set( 'ip', '127.0.0.1' );
	$User_Demo->set( 'domain', 'localhost' );
	$User_Demo->set( 'level', 0 );
	$User_Demo->set( 'locale', 	$default_locale );
	$User_Demo->set_datecreated( installer_timestamp() );
	$User_Demo->set_Group( 	$Group_Users );
	$User_Demo->dbinsert();
}
task_end();

echo T_('Creating default group/blog permissions').' ... ';
$query = "INSERT INTO T_blog_groups(
	bloggroup_blog_ID,
	bloggroup_group_ID,
	bloggroup_ismember,
	bloggroup_perm_poststatuses,
	bloggroup_perm_delpost,
	bloggroup_perm_comments,
	bloggroup_perm_cats,
	bloggroup_perm_properties,
	bloggroup_perm_media_upload,
	bloggroup_perm_media_browse,
	bloggroup_perm_media_change )
VALUES
	( 1, ".$Group_Admins->ID.", 1, 'published,deprecated,protected,private,draft', 1, 1, 1, 1, 1, 1, 1 ),
	( 2, ".$Group_Admins->ID.", 1, 'published,deprecated,protected,private,draft', 1, 1, 1, 1, 1, 1, 1 ),
	( 3, ".$Group_Admins->ID.", 1, 'published,deprecated,protected,private,draft', 1, 1, 1, 1, 1, 1, 1 ),
	( 4, ".$Group_Admins->ID.", 1, 'published,deprecated,protected,private,draft', 1, 1, 1, 1, 1, 1, 1 )";
$DB->query( $query );
if( $create_sample_contents )
{
	$query = "INSERT INTO T_blog_groups(
		bloggroup_blog_ID,
		bloggroup_group_ID,
		bloggroup_ismember,
		bloggroup_perm_poststatuses,
		bloggroup_perm_delpost,
		bloggroup_perm_comments,
		bloggroup_perm_cats,
		bloggroup_perm_properties,
		bloggroup_perm_media_upload,
		bloggroup_perm_media_browse,
		bloggroup_perm_media_change )
	VALUES
		( 1, ".$Group_Special->ID.", 1, 'published,deprecated,protected,private,draft', 1, 1, 0, 0, 1, 1, 1 ),
		( 2, ".$Group_Special->ID.", 1, 'published,deprecated,protected,private,draft', 1, 1, 0, 0, 1, 1, 1 ),
		( 3, ".$Group_Special->ID.", 1, 'published,deprecated,protected,private,draft', 1, 1, 0, 0, 1, 1, 1 ),
		( 4, ".$Group_Special->ID.", 1, 'published,deprecated,protected,private,draft', 1, 1, 0, 0, 1, 1, 1 ),
		( 1, ".$Group_Bloggers->ID.", 1, 'published,deprecated,protected,private,draft', 0, 0, 0, 0, 1, 1, 0 ),
		( 2, ".$Group_Bloggers->ID.", 1, 'published,deprecated,protected,private,draft', 0, 0, 0, 0, 1, 1, 0 ),
		( 3, ".$Group_Bloggers->ID.", 1, 'published,deprecated,protected,private,draft', 0, 0, 0, 0, 1, 1, 0 ),
		( 4, ".$Group_Bloggers->ID.", 1, 'published,deprecated,protected,private,draft', 0, 0, 0, 0, 1, 1, 0 ),
		( 1, ".$Group_Users->ID.", 1, '', 0, 0, 0, 0, 0, 0, 0 ),
		( 2, ".$Group_Users->ID.", 1, '', 0, 0, 0, 0, 0, 0, 0 ),
		( 3, ".$Group_Users->ID.", 1, '', 0, 0, 0, 0, 0, 0, 0 ),
		( 4, ".$Group_Users->ID.", 1, '', 0, 0, 0, 0, 0, 0, 0 )";
	$DB->query( $query );
}
task_end();

/*
// Note: we don't really need this any longer, but we might use it for a better default setup later...
echo T_('Creating default user/blog permissions').' ... ';
// Admin for blog A:
$query = "INSERT INTO T_blog_users( bloguser_blog_ID, bloguser_user_ID, bloguser_ismember,
	bloguser_perm_poststatuses, bloguser_perm_delpost, bloguser_perm_comments,
	bloguser_perm_cats, bloguser_perm_properties,
	bloguser_perm_media_upload, bloguser_perm_media_browse, bloguser_perm_media_change )
VALUES
	( 1, ".$User_Demo->ID.", 1,
	'published,deprecated,protected,private,draft', 1, 1, 0, 0, 1, 1, 1 )";
$DB->query( $query );
task_end();
*/

// we need this for _create_perms.php - an array of group names to IDs
$GLOBALS['Groups'] = $group_names_ids;

?>
