<?php
/**
 * This is the main install menu
 *
 * IF YOU ARE READING THIS IN YOUR WEB BROWSER, IT MEANS THAT PHP IS NOT PROPERLY
 * INSTALLED ON YOUR WEB SERVER. IF YOU DON'T KNOW WHAT THIS MEANS, CONTACT YOUR
 * SERVER ADMINISTRATOR OR YOUR HOSTING COMPANY.
 *
 * @copyright (c) 2009 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://www.gnu.org/licenses/gpl.txt GNU General Public License v3
 * @package installer
 */

/**
 * include config and default functions
 */
require_once dirname(__FILE__).'/../qp_config/_config.php';

/**
 * Make the includes believe they are being called in the right place...
 */
define( 'QP_MAIN_INIT', true );

/**
 * Define that we're in the install process
 */
define( 'QP_IS_INSTALLING', true );

$script_start_time = time();
$localtimenow = $script_start_time; // used e.g. for post_datemodified (sample posts)

if( ! $app_config_is_done )
{
	// Base config is not done yet, try to guess some values needed for correct display
	$rsc_url = '../qp_rsc/';
}

/**
 * dummy docblock
 */
require_once $inc_path.'_core/_class.funcs.php';

/**
 * dummy docblock
 */
require_once $inc_path.'_core/_misc.funcs.php';

$Debuglog = new Log( 'note' );
$Messages = new Log( 'error' );

/**
 * dummy docblock
 */
require_once $inc_path.'_vars.inc.php';

load_funcs( 'blogs/model/_blog.funcs.php' );
load_funcs( 'categories/model/_category.funcs.php' );
load_funcs( 'items/model/_item.funcs.php' );
load_funcs( 'users/model/_user.funcs.php' );
load_funcs( '_core/ui/forms/_form.funcs.php' );

/**
 * dummy docblock
 */
require_once dirname(__FILE__).'/_functions_install.php';

$Timer = new Timer( 'main' );

load_funcs( '_core/_param.funcs.php' );
param( 'action', 'string', 'default' );
param( 'new_conf', 'integer', 0 );

// Load all available locale defintions
locales_load_available_defs();
param( 'locale', 'string' );
if( preg_match('/[a-z]{2}-[A-Z]{2}(-.{1,14})?/', $locale) )
{
	$default_locale = $locale;
}
else
{
	// detect language
	$default_locale = locale_from_httpaccept();
}

// Activate default locale
if( ! locale_activate( $default_locale ) )
{
	// Could not activate locale (non-existent?), fallback to en-US
	$default_locale = 'en-US';
	locale_activate( 'en-US' );
}

init_charsets( $current_charset );

/**
 * count contributors
 */
require( $templates_path.'/_contributors.php' );
$count_contribs = count( $_hic_sunt_dracones );

// count sample posts from the appropriate sample posts file
if( file_exists( $conf_path.'_create_items.php' ) )
{
	$count_samples = substr_count( php_strip_whitespace( $conf_path.'_create_items.php' ), 'installer_timestamp()' );
}
else
{
	$count_samples = substr_count( php_strip_whitespace( dirname( __FILE__ ).'/_create_items.php' ), 'installer_timestamp()' );
}

// count users from the appropriate sample users file
if( file_exists( $conf_path.'_create_users.php' ) )
{
	$count_users = substr_count( php_strip_whitespace( $conf_path.'_create_users.php' ), 'installer_timestamp()' );
}
else
{
	$count_users = substr_count( php_strip_whitespace( dirname( __FILE__ ).'/_create_users.php' ), 'installer_timestamp()' );
}

// add 'em up for _functions_create
$count_timestamped_items = $count_contribs + $count_samples + $count_users;

// calculate how far back to start the installation
$timestamp = ( time() - ( $count_timestamped_items * 86400 ) );

// what are we doing?
switch( $action )
{
	case 'dbupgrade':
	$title = T_('Upgrade from a previous version');
	break;

	case 'newdb':
	$msg = array();
	if( file_exists( dirname(__FILE__).'/_automated.php' ) )
	{
		// automated install
		require_once dirname(__FILE__).'/_automated.php';
	}

	// check that we have login, password, and email ...
	if( ! param( 'conf_admin_login', 'string' ) )
	{
		$msg[] = T_('Please enter a login to use for your admin account' );
	}
	if( ! param( 'conf_admin_pass', 'string' ) )
	{
		$msg[] = T_('We strongly advise you choose a password' );
	}
	if( ! param( 'conf_admin_email', 'string' ) )
	{
		$msg[] = T_('Your email is needed in case you forget your password ;)' );
	}

	// ... and go back if we don't
	if( ! empty( $msg ) )
	{
		$title = T_('Try again!');
		$action = 'menu';
		break;
	}
	$title = T_('New Install');
	break;

	case 'deletedb':
	$title = sprintf( /* TRANS: %s: Application name */ T_('Delete %s tables'), $app_name );
	break;

	case 'start':
	$title = T_('Base configuration');
	break;

	default:
	$title = '';
}

header('Content-Type: text/html; charset='.$io_charset);
header('Cache-Control: no-cache'); // no request to this page should get cached!
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="<?php locale_lang() ?>" lang="<?php locale_lang() ?>">
<head>
<title><?php
printf( /* TRANS: %s: Application name */ T_('%s installer'), $app_name );
if( $title )
{
	echo ': ', $title;
}
?></title>
<link rel="icon" href="../favicon.ico" type="image/x-icon"/>
<link rel="shortcut icon" href="../favicon.ico" type="image/x-icon"/>
<meta name="viewport" content="width = 750" />
<link href="../qp_rsc/css/support_install.css" rel="stylesheet" type="text/css" />
<link href="../qp_rsc/css/password_strength_plugin.css" rel="stylesheet" type="text/css" />
<script type="text/javascript" src="../qp_rsc/js/jquery.min.js"></script>
<script type="text/javascript" src="../qp_rsc/js/password_strength_plugin.js"></script>

<script>
$(document).ready( function() {
	//BASIC
	$("#conf_admin_pass").passStrength({
		shortPass: "top_shortPass",
		badPass: "top_badPass",
		goodPass: "top_goodPass",
		strongPass: "top_strongPass",
		baseStyle: "top_testresult",
		userid: "#conf_admin_login",
		messageloc: 0
		});
	});
</script>
</head>
<body>
<div class="wrapper">
<?php display_locale_selector(); ?>
<?php block_open(); ?>
<?php
if( $app_config_is_done || ( ( $action != 'start' ) && ( $action != 'default' ) && ( $action != 'conf' ) ) )
{
	// Connect to DB
	$tmp_db_config = $app_db_config;

	// We want a friendly message if we can't connect
	$tmp_db_config['halt_on_error'] = false;
	$tmp_db_config['show_errors'] = false;

	// Make sure we use the proper charset
	$tmp_db_config['connection_charset'] = $app_charset;

	// CONNECT TO DB
	$DB = new DB( $tmp_db_config );
	unset( $tmp_db_config );

	if( $DB->error )
	{
		// restart conf
		echo '<div class="error"><p class="error">'.T_('Check your database config settings below and update them if necessary...').'</p></div>';
		display_base_config_recap();
		$action = 'start';
	}
	else
	{
		$DB->halt_on_error = true; // From now on, halt on errors.
		$DB->show_errors = true; // From now on, show errors (they're helpful in case of errors!).

		// Check MySQL version
		$mysql_version = $DB->get_var( 'SELECT VERSION()' );
		list( $mysl_version_main, $mysl_version_minor ) = explode( '.', $mysql_version );
		if( ( $mysl_version_main * 100 + $mysl_version_minor ) < 500 )
		{
			die( '<div class="error"><p class="error"><strong>'
				.sprintf( T_('The minimum requirement for this version of %s is %s version %s but you are trying to use version %s!'),
				$app_name, 'MySQL', '5.0', $mysql_version ).'</strong></p></div>' );
		}
	}
}

// Check PHP version
list( $version_main, $version_minor ) = explode( '.', phpversion() );
if( ( $version_main * 100 + $version_minor * 10 ) < 510 )
{
	die( '<div class="error"><p class="error"><strong>'
		.sprintf( T_( 'The minimum requirement for this version of %s is %s version %s but you are trying to use version %s!'),
		$app_name, 'PHP', '5.1', phpversion() ).'</strong></p></div>' );
}

// Check other dependencies
if( $req_errors = install_validate_requirements() )
{
	echo '<div class="error">';
	echo '<p class="error"><strong>';
	printf( T_('%s cannot be installed because of the following errors:'), $app_name );
	echo '</strong></p>';
	echo '<ul class="error"><li>'.implode( '</li><li>', $req_errors ).'</li></ul>';
	echo '</div>';
	die;
}

$success_message = '';

switch( $action )
{
	case 'conf':
	// Write conf file
	display_locale_selector();
	block_open();
	param( 'conf_db_user', 'string', true );
	param( 'conf_db_password', '', true );
	param( 'conf_db_name', 'string', true );
	param( 'conf_db_host', 'string', true );
	param( 'conf_db_tableprefix', 'string', $app_db_tableprefix );
	param( 'conf_baseurl', 'string', true );
	$conf_baseurl = preg_replace( '#(/)?$#', '', $conf_baseurl ).'/'; // force trailing slash
	// Connect to DB
	$DB = new DB( array(
			'user' => $conf_db_user,
			'password' => $conf_db_password,
			'name' => $conf_db_name,
			'host' => $conf_db_host,
			'aliases' => $app_db_config['aliases'],
			'use_transactions' => $app_db_config['use_transactions'],
			'table_options' => $app_db_config['table_options'],
			'connection_charset' => $app_db_config['connection_charset'],
			'halt_on_error' => false
		)
	);
	if( $DB->error )
	{
		// restart conf
		echo '<p class="error">'.T_('It seems that the database config settings you entered don\'t work. Please check them carefully and try again...').'</p>';
		$action = 'start';
	}
	else
	{
		$conf_template_filepath = $conf_path.'_main_config.template.php';
		$conf_filepath = $conf_path.'_main_config.php';

		// Read original
		$file_loaded = @file( $conf_template_filepath );
		if( empty( $file_loaded ) )
		{
			// This should actually never happen, just in case...
			echo '<div class="error"><p class="error">'.sprintf( T_('Could not load original conf file [%s]. Is it missing?'), $conf_filepath ).'</p></div>';
			break;
		}
		// File loaded...
		$conf = implode( '', $file_loaded );
		// Update conf
		$conf = preg_replace(
			array(
				'#\$app_db_config\s*=\s*array\(
					\s*[\'"]host[\'"]\s*=>\s*[\'"].*?[\'"], ([^\n\r]*\r?\n)
					\s*[\'"]name[\'"]\s*=>\s*[\'"].*?[\'"], ([^\n\r]*\r?\n)
					\s*[\'"]user[\'"]\s*=>\s*[\'"].*?[\'"], ([^\n\r]*\r?\n)
					\s*[\'"]password[\'"]\s*=>\s*[\'"].*?[\'"], ([^\n\r]*\r?\n)
					#ixs',
				"#app_db_tableprefix\s*=\s*'.*?';#",
				"#app_baseurl\s*=\s*'.*?';#",
				"#app_config_is_done\s*=.*?;#",
			),
			array(
				"\$app_db_config = array(\n"
					."\t'host' => '".str_replace( "'", "\'", $conf_db_host )."',\$1"
					."\t'name' => '".str_replace( "'", "\'", $conf_db_name )."',\$2"
					."\t'user' => '".str_replace( "'", "\'", $conf_db_user )."',\$3"
					."\t'password' => '".str_replace( "'", "\'", $conf_db_password )."',\$4",
				"app_db_tableprefix = '".str_replace( "'", "\'", $conf_db_tableprefix )."';",
				"app_baseurl = '".str_replace( "'", "\'", $conf_baseurl )."';",
				'app_config_is_done = 1;',
			), $conf );

		$f = @fopen( $conf_filepath, 'w' );
		if( $f == false )
		{
			?>
			<h1><?php echo T_('Config file update') ?></h1>
			<p><strong><?php printf( T_('We cannot automatically create or update your config file [%s]!'), $conf_filepath ); ?></strong></p>
			<p><strong><?php echo T_('You need to update the config file manually:') ?></strong></p>
			<ol>
			<li><?php echo T_('Create a new text file with a text editor.') ?></li>
			<li><?php echo T_('Copy the contents from the box below.') ?></li>
			<li><?php echo T_('Paste them into your local text editor. <strong>ATTENTION: make sure there is ABSOLUTELY NO WHITESPACE after the final <code>?&gt;</code> in the file.</strong> Any space, tab, newline or blank line at the end of the conf file may prevent cookies from being set when you try to log in later.') ?></li>
			<li><?php echo T_('Save the file locally under the name <code>_main_config.php</code>') ?></li>
			<li><?php echo T_('Upload the file to your server, into the <code>/qp_config</code> folder.') ?></li>
			<li><?php printf( T_('When done <a %s>call the installer</a> again. The installer will rerun tests to connect to your database.'), 'href="index.php?locale='.$default_locale.'"') ?></li>
			</ol>
			<p><?php echo T_('This is how your _main_config.php should look like:') ?></p>
			<blockquote>
			<pre><?php echo htmlspecialchars( $conf ); ?></pre>
			</blockquote>
			<?php
			break;
		}
		else
		{
			// Write new contents
			fwrite( $f, $conf );
			fclose( $f );
			$success_message = sprintf( '<div class="success"><p>'.T_('Your configuration file [%s] has been successfully created.').'</p></div>', $conf_filepath );
			$app_db_tableprefix = $conf_db_tableprefix;
			$app_baseurl = $conf_baseurl;
			$app_config_is_done = 1;
			$action = 'menu';
		}
	}
	// ATTENTION: we continue here...

	case 'start':
	case 'default':
	// Start of install procedure
	if( $action == 'start' || ! $app_config_is_done )
	{
		display_locale_selector();
		block_open();
		?>
		<div class="infos">
		<h4><a href="index.php?locale=<?php echo $default_locale ?>" class="floatright" title="<?php echo T_('Install menu'); ?>"><?php echo T_('Install menu'); ?></a></h4>
		<div class="image_block">
		<?php
		printf( '<img src="../qp_rsc/logo.jpg" width="337" height="76" alt="'.T_('%s Logo').'" title="'.T_('%s Logo').'" />', $app_name, $app_name );
		?>
		<h1><?php echo sprintf( T_('%s Base configuration'), $app_name ); ?></h1>&nbsp;
		</div>
		<?php
		echo '<span style="text-align:justify;">';
		if( $app_config_is_done && $app_allow_dbase_reset != 1 )
		{
			echo '<p><strong>'.T_('Resetting the base configuration is currently disabled for security reasons.').'</strong></p>';
			echo '<p>'.sprintf( T_('To enable it, please go to the %s file and change: %s to %s'), '/qp_config/_main_config.php', '<pre>$app_allow_dbase_reset = 0;</pre>', '<pre>$app_allow_dbase_reset = 1;</pre>' ).'</p>';
			echo '<p>'.T_('Then <strong>reload this page</strong> and a reset option will appear.').'</p>';
			echo '</span></div><div class="clear"></div>';
			block_close();
			break;
		}
		else
		{
			// Set default params if not provided otherwise
			param( 'conf_db_user', 'string', $app_db_config['user'] );
			param( 'conf_db_password', '', $app_db_config['password'] );
			param( 'conf_db_name', 'string', $app_db_config['name'] );
			param( 'conf_db_host', 'string', $app_db_config['host'] );
			param( 'conf_db_tableprefix', 'string', $app_db_tableprefix );
			// Guess baseurl
			$app_baseurl = 'http://'.( isset( $_SERVER['HTTP_HOST'] ) ? $_SERVER['HTTP_HOST'] : 'yourserver.com' );
			if( isset( $_SERVER['SERVER_PORT'] ) && ( $_SERVER['SERVER_PORT'] != '80' ) && ( strpos( $app_baseurl,':' ) === false ) )
			{
				$app_baseurl .= ':'.$_SERVER['SERVER_PORT'];
			}
			$app_baseurl .= preg_replace( '#/qp_install(/(index.php)?)?$#', '', $ReqPath ).'/';
			param( 'conf_baseurl', 'string', $app_baseurl );

			echo '<p>'.T_('If your server supports it, you can automatically generate your config file by provide the connection details for your database in the form below.').' ';
			echo T_('If you are not familiar with this then you should ask your hosting provider to create the database and give you the connection details.').'</p>';
			?>
			</span></div><div class="clear"></div>

			<form class="fform" name="form" action="index.php" method="post">
			<input type="hidden" name="action" value="conf" />
			<input type="hidden" name="new_conf" value="1" />
			<input type="hidden" name="locale" value="<?php echo $default_locale; ?>" />

			<fieldset>
			<legend><?php echo T_('Blog settings') ?></legend>
			<?php
			form_text( 'conf_baseurl', $conf_baseurl, 50, T_('Website address'),
				sprintf( /* TRANS: %1$s: App name */
					T_('This is where %1$s and your blogs reside by default. '), $app_name ), 120 );
			?>
			</fieldset>

			<fieldset>
			<legend><?php echo T_('Database you want to install into') ?></legend>
			<?php
			form_text( 'conf_db_host', $conf_db_host, 20, T_('MySQL Host/Server'), T_( 'Typically this is "localhost", contact your host if not' ), 120 );
			form_text( 'conf_db_name', $conf_db_name, 20, T_('MySQL Database'), T_( 'Name of the MySQL database you have created' ), 100);
			form_text( 'conf_db_user', $conf_db_user, 20, T_('MySQL Username'), sprintf( T_('Used by %s to access the MySQL database' ), $app_name ), 100 );
			form_text( 'conf_db_password', $conf_db_password, 20, T_('MySQL Password'), sprintf( T_('Used by %s to access the MySQL database' ), $app_name ), 100 ); // no need to hide this. nobody installs an application from a public place
			?>
			</fieldset>

			<fieldset>
			<legend><?php echo T_('Database configuration') ?></legend>
			<?php
			form_text( 'conf_db_tableprefix', $conf_db_tableprefix, 20, T_('Tables prefix'), sprintf( T_('All DB tables will be prefixed with this. You need to change this only if you want to have multiple %s installations in the same DB.' ), $app_name ), 30 );
			?>
			</fieldset>
			<div class="buttons">
			<input type="submit" name="submit" value="<?php echo T_('Update config file') ?>" class="search" />
			<input type="reset" value="<?php echo T_('Reset') ?>" class="search" />
			</div>

			</form>

			<?php
			break;
		}
	}

	// if config was already done, move on to main menu

	case 'menu':
	// Menu
	param( 'conf_admin_login', 'string' );
	param( 'conf_admin_pass', 'string' );
	param( 'conf_admin_email', 'string' );
	display_locale_selector();
	block_open();
	?>
	<div class="infos">
	<h4><a href="index.php?locale=<?php echo $default_locale ?>" class="floatright" title="<?php echo T_('Install menu'); ?>"><?php echo T_('Install menu'); ?></a></h4>
	<div class="image_block">
	<?php
	printf( '<img src="../qp_rsc/logo.jpg" width="337" height="76" alt="'.T_('%s Logo').'" title="'.T_('%s Logo').'" />', $app_name, $app_name );
	?>
	<h1><?php printf( T_('Install %s version %s'), $app_name, $app_version ); ?></h1>&nbsp;
	</div>
	<?php
	echo '<span style="text-align:justify;">';
	if( $success_message )
	{
		echo $success_message;
	}
	echo '</span></div><div class="clear"></div>';

	$old_db_version = get_db_version( 'version' );
	?>
	<form action="index.php" method="post">
	<input type="hidden" name="locale" value="<?php echo $default_locale ?>" />
	<input type="hidden" name="confirmed" value="0" />
	<input type="hidden" name="installer_version" value="10" />

	<div id="op-newdb" class="op-group">
	<input type="radio" name="action" id="newdb" value="newdb"
	<?php
	if( is_null( $old_db_version ) )
	{
		echo ' checked="checked" />';
	}
	else
	{
		echo ' />';
	}
	?>
	<label for="newdb" class="option"><?php
	printf( T_('<strong>New Install</strong>: Install %s database tables.'), $app_name );
	?></label>

	<div class="options">
	<h3><?php echo T_('Admin account details'); ?></h3>
	<?php
	if( ! empty( $msg ) )
	{
		echo '<p class="error">'.implode( '<br />', $msg ).'</p>';
	}
	form_text( 'conf_admin_login', $conf_admin_login, 50, T_('Login'), T_('This will be used to create your admin account.' ), 80 );
	form_text( 'conf_admin_pass', $conf_admin_pass, 50, T_('Password'), T_('We advise you use a strong password' ), 80 );
	form_text( 'conf_admin_email', $conf_admin_email, 50, T_('Your email'), T_('This will be used to receive notifications for comments on your blog, etc.' ), 80 );
	?></div>

	<div class="options">
	<input type="checkbox" name="create_sample_contents" id="create_sample_contents" value="1" checked="checked" />
	<label for="create_sample_contents"><?php echo '<strong>'.T_('Install sample blogs &amp; sample contents').'</strong> '.T_('(highly recommended for new users).'); ?></label>
	<br />
	<input type="checkbox" name="create_htaccess" id="create_htaccess" value="1" checked="checked" />
	<label for="create_htaccess"><?php echo '<strong>'.T_('Create .htaccess file').'</strong> '.T_('(will not over-write if .htaccess already exists).'); ?></label>
	</div>

	</div>

	<?php
	if( ! $new_conf )
	{
		?>
		<div id="op-dbupgrade" class="op-group">
		<input type="radio" name="action" id="dbupgrade" value="dbupgrade"
		<?php
		if( ! is_null( $old_db_version ) && $old_db_version < $app_db_version )
		{
			echo ' checked="checked" />';
		}
		else
		{
			echo ' />';
		}
		?>
		<label for="dbupgrade"><?php
		printf( /* TRANS: %1$s: App name. */ T_('<strong>Upgrade from a previous version of %1$s</strong>'), $app_name );
		?></label>
		<p class="options"><?php
		echo sprintf( T_('Upgrade your '
			.'%1$s database tables in order to make them compatible with the current '
			.'version.'), $app_name ).'</p><p class="options">'
			.T_('<strong>WARNING:</strong> If you have modified your database, '
			.'this operation may fail. Make sure you have a backup.');
		?></p>
		</div>
		<?php
	}

	if( $app_allow_dbase_reset == 1 )
	{
		?>
		<div class="op-deletedb"><input type="radio" name="action" id="deletedb" value="deletedb" />
		<label for="deletedb"><strong><?php printf( T_('Delete %s tables'), $app_name ); ?></strong></label>
		<p class="options"><?php
		printf( /* TRANS: %1$s: App name. */
			T_('If you have installed %1$s tables before and wish to start anew, '
			.'you must delete the %1$s tables before you can start a new installation. <br />'
			.'<strong>WARNING: All your %1$s tables and data will be lost!!!</strong> '
			.'Any non-%1$s tables will remain untouched though.'), $app_name );
		?></p>
		<input type="radio" name="action" id="start" value="start" />
		<label for="start"><strong><?php echo T_('Change your base configuration'); ?></strong></label>
		<p class="options"><?php
		printf( T_('(see recap below): '
			.'You only want to do this in rare occasions where you may have moved '
			.'your %s files or database to a different location...'), $app_name );
		?></p></div>
		<?php
	}

	if( $app_allow_dbase_reset != 1 )
	{
		echo '<div class="floatright"><a href="index.php?action=deletedb&amp;locale='.$default_locale.'">'.T_('Need to start anew?').' &raquo;</a></div>';
	}
	?>

	<p>
	<input type="submit" value="&nbsp; <?php echo T_('GO!')?> &nbsp;"
		onclick="var dc = document.getElementById( 'deletedb' ); if( dc && dc.checked ) { if( confirm( '<?php
		printf( /* TRANS: %s gets replaced by app name, usually "quamplures" */ TS_( 'Are you sure you want to delete your existing %s tables?\nDo you have a backup?' ), $app_name );
		?>' ) ) { this.form.confirmed.value = 1; return true; } else return false; }" />
	</p>

	</form>
	<?php
	block_close();
	display_base_config_recap();
	break;

	case 'newdbsettings':
	// nothing here?

	case 'newdb':
	// Note: auto installers should kick in directly at this step and provide all required params
	// fp> TODO: this test should probably be made more generic and applied to upgrade too
	$expected_connection_charset = $DB->php_to_mysql_charmap( $app_charset );
	if( $DB->connection_charset != $expected_connection_charset )
	{
		echo '<div class="error"><p class="error">';
		printf( T_('In order to install %s with the %s locale, your MySQL needs to support '
			.'the %s connection charset (SET NAMES %s).' ), $app_name, $current_locale,
			$app_charset, $expected_connection_charset );
		echo '</p></div>';
		// sam2kb> TODO: If something is not supported we can display a message saying "do this and that, enable extension X etc. etc... or switch to a better hosting".
		break;
	}

	install_newdb();
	break;

	case 'dbupgrade':
	/**
	 * DATABASE UPGRADE: Upgrade data from existing Quam Plures database
	 */
	require_once( dirname(__FILE__). '/_functions_dbupgrade.php' );

	echo '<h2>';
	printf( T_('Upgrading data in existing %s database...'), $app_name );
	echo '</h2>';
	flush();
	if( upgrade_dbase_tables() )
	{
		?>
		<p><?php echo T_('Upgrade completed successfully!')?></p>
		<p><?php printf( T_('Now you can <a %s>log in</a> with your usual %s username and password.'), 'href="'.$admin_url.'"', $app_name ); ?></p>
		<?php
	}
	break;

	case 'deletedb':
	/**
	 * DELETE DB: Delete the db structure!!! (Everything will be lost)
	 */
	require_once( dirname(__FILE__). '/_functions_delete.php' );
	?>
	<div class="menu_top"><a href="index.php?locale=<?php echo $default_locale ?>"><?php echo T_('Install menu') ?></a></div>
	<?php
	printf( '<img src="../qp_rsc/logo.jpg" width="337" height="76" alt="'.T_('%s Logo').'" />', $app_name, $app_name );
	echo '<h2>';
	printf( T_('Deleting %s tables from the datatase...'), $app_name );
	echo '</h2>';
	flush();

	if( $app_allow_dbase_reset != 1 )
	{
		printf( /* TRANS: %1$s: App name. */
			T_('If you have installed %1$s tables before and wish to start anew, you must delete '
			.'the %1$s tables before you can start a new installation. %1$s can delete its '
			.'own tables for you, but for obvious security reasons, this feature is disabled '
			.'by default.'), $app_name );
		echo '<p>'.sprintf( T_('To enable it, please go to the %s file and change: %s to %s'), '/qp_config/_main_config.php', '<pre>$app_allow_dbase_reset = 0;</pre>', '<pre>$app_allow_dbase_reset = 1;</pre>' ).'</p>';
		echo '<p>'.T_('Then reload this page and a reset option will appear.').'</p>';
		echo '<p><a href="index.php?locale='.$default_locale.'">&laquo; '.T_('Back to install menu').'</a></p>';
		break;
	}

	if( ! param('confirmed', 'integer', 1) )
	{
		echo '<p>';
		echo nl2br( htmlspecialchars( sprintf( /* TRANS: %s gets replaced by app name, usually "quamplures" */ T_( "Are you sure you want to delete your existing %s tables?\nDo you have a backup?" ), $app_name ) ) );
		?>
		</p>
		<p>
		<form class="inline" name="form" action="index.php" method="post">
		<input type="hidden" name="action" value="deletedb" />
		<input type="hidden" name="confirmed" value="1" />
		<input type="hidden" name="locale" value="<?php echo $default_locale; ?>" />
		<input type="submit" value="&nbsp; <?php echo T_('I am sure!')?> &nbsp;" />
		</form>

		<form class="inline" name="form" action="index.php" method="get">
		<input type="hidden" name="locale" value="<?php echo $default_locale; ?>" />
		<input type="submit" value="&nbsp; <?php echo T_('CANCEL')?> &nbsp;" />
		</form>
		</p>
		<?php
		break;
	}

	db_delete();
	?>
	<p><?php echo T_('Reset done!')?></p>
	<p><a href="index.php?locale=<?php echo $default_locale ?>">&laquo; <?php echo T_('Back to install menu') ?></a></p>
	<?php
	break;
}

block_close();
?>

</div>
</body>
</html>
