<?php
/**
 * This file implements the AutoLinks plugin
 *
 * @todo (1111) if make_clickable() isn't used outside this plugin it needs to
 * move from core to this plugin
 * @author {@link http://wonderwinds.com/ Ed Bennett}
 * @author {@link http://fplanque.net/ Francois PLANQUE}
 * @copyright (c) 2009 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://www.gnu.org/licenses/gpl.txt GNU General Public License v3
 * @package plugins
 * @subpackage AutoLinks
 */
if(!defined('QP_MAIN_INIT')) die('fail');

/**
 * @package plugins
 *
 * @subpackage AutoLinks
 */
class autolinks_plugin extends Plugin
{
	var $apply_rendering = 'opt-out';
	var $code = 'autolinks';
	var $group = 'renderers';
	var $number_of_installs = 1;
	var $priority = 60;
	var $version = '1.0';

	/**
	 * @see Plugin::PluginInit()
	 */
	function PluginInit( & $params )
	{
		$this->name = $this->T_('Auto Links');
		$this->short_desc = T_('Automatically turn URLs in your post into links.');
		$this->long_desc = T_('This renderer automatically creates links for you when you paste a URL into your blog post.');
	}


	/**
	 * @see Plugin::RenderItemAsHtml()
	 */
	function RenderItemAsHtml( & $params )
	{
		$content = & $params['data'];
		$content = make_clickable( $content );
		return true;
	}

}

?>
