<?php
/**
 * Class to provide IPv4 calculations
 *
 * Module written/ported by Eric Kilfoil <eric@ypass.net>
 *
 * The majority of this is _NOT_ my code. I simply ported it from the PERL Net::DNS module.
 * The author of the Net::DNS module is {@link http://www.fuhr.org/~mfuhr/perldns/ Michael Fuhr}.
 * Michael Fuhr has nothing to with the porting of this code to PHP. Any questions
 * directly related to this class library should be directed to the maintainer.
 *
 * @link http://pear.php.net/package/Net_DNS
 * @author {@link http://wonderwinds.com/ Ed Bennett}
 * @author Eric Kilfoil <eric@ypass.net>
 * @author Marco Kaiser <bate@php.net>
 * @author Florian Anderiasch <fa@php.net>
 * @copyright (c) 2009 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://www.php.net/license/3_01.txt The PHP License
 * @package external
 * @subpackage Net_DNS
 */

/**
 * dummy docblock
 */
require_once("Net/DNS/Header.php");
/**
 * dummy docblock
 */
require_once("Net/DNS/Question.php");
/**
 * dummy docblock
 */
require_once("Net/DNS/Packet.php");
/**
 * dummy docblock
 */
require_once("Net/DNS/Resolver.php");
/**
 * dummy docblock
 */
require_once("Net/DNS/RR.php");

$GLOBALS['_Net_DNS_packet_id'] = mt_rand(0, 65535);

/**
 * @package external
 * @subpackage Net_DNS
 */
class Net_DNS
{
	var $resolver;
	var $VERSION = '1.00b2'; // This should probably be a define :(
	var $PACKETSZ = 512;
	var $HFIXEDSZ = 12;
	var $QFIXEDSZ = 4;
	var $RRFIXEDSZ = 10;
	var $INT32SZ = 4;
	var $INT16SZ = 2;

	/**
	 * dummy docblock
	 */
	function Net_DNS($defaults = array())
	{
		$this->resolver = new Net_DNS_Resolver($defaults);
	}


	/**
	 * dummy docblock
	 */
	function opcodesbyname($opcode)
	{
		$op = array(
			'QUERY' => 0, // RFC 1035
			'IQUERY' => 1, // RFC 1035
			'STATUS' => 2, // RFC 1035
			'NS_NOTIFY_OP' => 4, // RFC 1996
			'UPDATE' => 5, // RFC 2136
		);
		if (! strlen($op[$opcode])) {
			$op[$opcode] = null;
		}
		return $op[$opcode];
	}


	/**
	 * dummy docblock
	 */
	function opcodesbyval($opcodeval)
	{
		$opval = array(
			0 => 'QUERY',
			1 => 'IQUERY',
			2 => 'STATUS',
			4 => 'NS_NOTIFY_OP',
			5 => 'UPDATE',
		);
		if (! strlen($opval[$opcodeval])) {
			$opval[$opcodeval] = null;
		}
		return $opval[$opcodeval];
	}


	/**
	 * dummy docblock
	 */
	function rcodesbyname($rcode)
	{
		$rc = array(
			'NOERROR' => 0, // RFC 1035
			'FORMERR' => 1, // RFC 1035
			'SERVFAIL' => 2, // RFC 1035
			'NXDOMAIN' => 3, // RFC 1035
			'NOTIMP' => 4, // RFC 1035
			'REFUSED' => 5, // RFC 1035
			'YXDOMAIN' => 6, // RFC 2136
			'YXRRSET' => 7, // RFC 2136
			'NXRRSET' => 8, // RFC 2136
			'NOTAUTH' => 9, // RFC 2136
			'NOTZONE' => 10, // RFC 2136
		);
		if (! strlen($rc[$rcode])) {
			$rc[$rcode] = null;
		}
		return $rc[$rcode];
	}


	/**
	 * dummy docblock
	 */
	function rcodesbyval($rcodeval)
	{
		$rc = array(
			0 => 'NOERROR',
			1 => 'FORMERR',
			2 => 'SERVFAIL',
			3 => 'NXDOMAIN',
			4 => 'NOTIMP',
			5 => 'REFUSED',
			6 => 'YXDOMAIN',
			7 => 'YXRRSET',
			8 => 'NXRRSET',
			9 => 'NOTAUTH',
			10 => 'NOTZONE',
		);
		if (! strlen($rc[$rcodeval])) {
			$rc[$rcodeval] = null;
		}
		return $rc[$rcodeval];
	}


	/**
	 * dummy docblock
	 */
	function typesbyname($rrtype)
	{
		$rc = array(
			'A' => 1,
			'NS' => 2,
			'MD' => 3,
			'MF' => 4,
			'CNAME' => 5,
			'SOA' => 6,
			'MB' => 7,
			'MG' => 8,
			'MR' => 9,
			'NULL' => 10,
			'WKS' => 11,
			'PTR' => 12,
			'HINFO' => 13,
			'MINFO' => 14,
			'MX' => 15,
			'TXT' => 16,
			'RP' => 17,
			'AFSDB' => 18,
			'X25' => 19,
			'ISDN' => 20,
			'RT' => 21,
			'NSAP' => 22,
			'NSAP_PTR' => 23,
			'SIG' => 24,
			'KEY' => 25,
			'PX' => 26,
			'GPOS' => 27,
			'AAAA' => 28,
			'LOC' => 29,
			'NXT' => 30,
			'EID' => 31,
			'NIMLOC' => 32,
			'SRV' => 33,
			'ATMA' => 34,
			'NAPTR' => 35,
			'SPF' => 99,
			'UINFO' => 100,
			'UID' => 101,
			'GID' => 102,
			'UNSPEC' => 103,
			'TSIG' => 250,
			'IXFR' => 251,
			'AXFR'=> 252,
			'MAILB' => 253,
			'MAILA' => 254,
			'ANY' => 255,
		);
		if (empty($rc[$rrtype])) {
			$rc[$rrtype] = null;
		}
		return $rc[$rrtype];
	}


	/**
	 * dummy docblock
	 */
	function typesbyval($rrtypeval)
	{
		$rc = array(
			1 => 'A',
			2 => 'NS',
			3 => 'MD',
			4 => 'MF',
			5 => 'CNAME',
			6 => 'SOA',
			7 => 'MB',
			8 => 'MG',
			9 => 'MR',
			10 => 'NULL',
			11 => 'WKS',
			12 => 'PTR',
			13 => 'HINFO',
			14 => 'MINFO',
			15 => 'MX',
			16 => 'TXT',
			17 => 'RP',
			18 => 'AFSDB',
			19 => 'X25',
			20 => 'ISDN',
			21 => 'RT',
			22 => 'NSAP',
			23 => 'NSAP_PTR',
			24 => 'SIG',
			25 => 'KEY',
			26 => 'PX',
			27 => 'GPOS',
			28 => 'AAAA',
			29 => 'LOC',
			30 => 'NXT',
			31 => 'EID',
			32 => 'NIMLOC',
			33 => 'SRV',
			34 => 'ATMA',
			35 => 'NAPTR',
			99 => 'SPF',
			100 => 'UINFO',
			101 => 'UID',
			102 => 'GID',
			103 => 'UNSPEC',
			250 => 'TSIG',
			251 => 'IXFR',
			252 => 'AXFR',
			253 => 'MAILB',
			254 => 'MAILA',
			255 => 'ANY',
		);
		$rrtypeval = preg_replace(array('/\s*/',' /^0*/'), '', $rrtypeval);
		if (empty($rc[$rrtypeval])) {
			$rc[$rrtypeval] = null;
		}
		return $rc[$rrtypeval];
	}


	/**
	 * dummy docblock
	 */
	function classesbyname($class)
	{
		$rc = array(
			'IN' => 1, // RFC 1035
			'CH' => 3, // RFC 1035
			'HS' => 4, // RFC 1035
			'NONE' => 254, // RFC 2136
			'ANY' => 255 // RFC 1035
		);
		if (! isset($rc[$class])) {
			$rc[$class] = null;
		}
		return $rc[$class];
	}


	/**
	 * dummy docblock
	 */
	function classesbyval($classval)
	{
		$rc = array(
			1 => 'IN',
			3 => 'CH',
			4 => 'HS',
			254 => 'NONE',
			255 => 'ANY'
		);
		$classval = preg_replace(array('/\s*/',' /^0*/'), '', $classval);
		if (empty($rc[$classval])) {
			$rc[$classval] = null;
		}
		return $rc[$classval];
	}

}

?>
