<?php
/**
 * Net_DNS: A resolver library for PHP
 *
 * @author {@link http://wonderwinds.com/ Ed Bennett}
 * @author Eric Kilfoil <eric@ypass.net>
 * @copyright (c) 2009 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://www.php.net/license/3_01.txt The PHP License
 * @package external
 * @subpackage Net_DNS
 */

/**
 * @package external
 * @subpackage Net_DNS
 */
class Net_DNS_Question
{
	var $qname = null;
	var $qtype = null;
	var $qclass = null;

	/**
	 * dummy docblock
	 */
	function Net_DNS_Question($qname, $qtype, $qclass)
	{
		$qtype = !is_null($qtype) ? strtoupper($qtype) : 'ANY';
		$qclass = !is_null($qclass) ? strtoupper($qclass) : 'ANY';

		// Check if the caller has the type and class reversed.
		// We are not that kind for unknown types.... :-)
		if ( ( is_null(Net_DNS::typesbyname($qtype)) ||
			is_null(Net_DNS::classesbyname($qtype)) )
			&& !is_null(Net_DNS::classesbyname($qclass))
			&& !is_null(Net_DNS::typesbyname($qclass)))
		{
			list($qtype, $qclass) = array($qclass, $qtype);
		}
		$qname = preg_replace(array('/^\.+/', '/\.+$/'), '', $qname);
		$this->qname = $qname;
		$this->qtype = $qtype;
		$this->qclass = $qclass;
	}


	/**
	 * dummy docblock
	 */
	function display()
	{
		echo $this->string() . "\n";
	}


	/**
	 * dummy docblock
	 */
	function string()
	{
		return $this->qname . ".\t" . $this->qclass . "\t" . $this->qtype;
	}


	/**
	 * dummy docblock
	 */
	function data($packet, $offset)
	{
		$data = $packet->dn_comp($this->qname, $offset);
		$data .= pack('n', Net_DNS::typesbyname(strtoupper($this->qtype)));
		$data .= pack('n', Net_DNS::classesbyname(strtoupper($this->qclass)));
		return $data;
	}

}

?>
