<?php
/**
 * Net_DNS: A resolver library for PHP
 *
 * @author {@link http://wonderwinds.com/ Ed Bennett}
 * @author Eric Kilfoil <eric@ypass.net>
 * @copyright (c) 2009 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://www.php.net/license/3_01.txt The PHP License
 * @package external
 * @subpackage Net_DNS
 */

/**
 * @package external
 * @subpackage Net_DNS
 */
class Net_DNS_RR_A extends Net_DNS_RR
{
	var $name;
	var $type;
	var $class;
	var $ttl;
	var $rdlength;
	var $rdata;
	var $address;

	/**
	 * dummy docblock
	 */
	function Net_DNS_RR_A(&$rro, $data, $offset = '')
	{
		$this->name = $rro->name;
		$this->type = $rro->type;
		$this->class = $rro->class;
		$this->ttl = $rro->ttl;
		$this->rdlength = $rro->rdlength;
		$this->rdata = $rro->rdata;

		if ($offset) {
			if ($this->rdlength > 0) {
				/*
				 * We don't have inet_ntoa in PHP?
				 */
				$aparts = unpack('C4b', $this->rdata);
				$addr = $aparts['b1'] . '.' .
					$aparts['b2'] . '.' .
					$aparts['b3'] . '.' .
					$aparts['b4'];
				$this->address = $addr;
			}
		} elseif (is_array($data)) {
			$this->address = $data['address'];
		} else {
			if (strlen($data) && preg_match("/([0-9]+)\.([0-9]+)\.([0-9]+)\.([0-9]+)[ \t]*$/", $data, $regs)) {
				if (($regs[1] >= 0 && $regs[1] <= 255) &&
						($regs[2] >= 0 && $regs[2] <= 255) &&
						($regs[3] >= 0 && $regs[3] <= 255) &&
						($regs[4] >= 0 && $regs[4] <= 255)) {
					$this->address = $regs[1] . '.' . $regs[2] . '.' . $regs[3] . '.' .$regs[4];
				}
			}
		}
	}


	/**
	 * dummy docblock
	 */
	function rdatastr()
	{
		if (strlen($this->address)) {
			return $this->address;
		}
		return '; no data';
	}


	/**
	 * dummy docblock
	 */
	function rr_rdata($packet, $offset)
	{
		$aparts = explode('.', $this->address);
		if (count($aparts) == 4) {
			return pack('c4', $aparts[0], $aparts[1], $aparts[2], $aparts[3]);
		}
		return null;
	}

}

?>
