<?php
/**
 * Net_DNS: A resolver library for PHP
 *
 * @author {@link http://wonderwinds.com/ Ed Bennett}
 * @author Eric Kilfoil <eric@ypass.net>
 * @copyright (c) 2009 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://www.php.net/license/3_01.txt The PHP License
 * @package external
 * @subpackage Net_DNS
 */

/**
 * @package external
 * @subpackage Net_DNS
 */
class Net_DNS_RR_HINFO extends Net_DNS_RR
{
	var $name;
	var $type;
	var $class;
	var $ttl;
	var $rdlength;
	var $rdata;
	var $cpu;
	var $os;

	/**
	 * dummy docblock
	 */
	function Net_DNS_RR_HINFO(&$rro, $data, $offset = '')
	{
		$this->name = $rro->name;
		$this->type = $rro->type;
		$this->class = $rro->class;
		$this->ttl = $rro->ttl;
		$this->rdlength = $rro->rdlength;
		$this->rdata = $rro->rdata;

		if ($offset) {
			if ($this->rdlength > 0) {
				list($cpu, $offset) = Net_DNS_Packet::label_extract($data, $offset);
				list($os, $offset) = Net_DNS_Packet::label_extract($data, $offset);

				$this->cpu = $cpu;
				$this->os = $os;
			}
		} elseif (is_array($data)) {
			$this->cpu = $data['cpu'];
			$this->os = $data['os'];
		} else {
			$data = str_replace('\\\\', chr(1) . chr(1), $data); /* disguise escaped backslash */
			$data = str_replace('\\"', chr(2) . chr(2), $data); /* disguise \" */

			preg_match('/("[^"]*"|[^ \t]*)[ \t]+("[^"]*"|[^ \t]*)[ \t]*$/', $data, $regs);
			foreach($regs as $idx => $value) {
				$value = str_replace(chr(2) . chr(2), '\\"', $value);
				$value = str_replace(chr(1) . chr(1), '\\\\', $value);
				$regs[$idx] = stripslashes($value);
			}

			$this->cpu = $regs[1];
			$this->os = $regs[2];
		}
	}


	/**
	 * dummy docblock
	 */
	function rdatastr()
	{
		if ($this->text) {
			return '"' . addslashes($this->cpu) . '" "' . addslashes($this->os) . '"';
		} else return '; no data';
	}


	/**
	 * dummy docblock
	 */
	function rr_rdata($packet, $offset)
	{
		if ($this->text) {
			$rdata = pack('C', strlen($this->cpu)) . $this->cpu;
			$rdata .= pack('C', strlen($this->os)) . $this->os;
			return $rdata;
		}
		return null;
	}

}

?>
