<?php
/**
 * Net_DNS: A resolver library for PHP
 *
 * @author {@link http://wonderwinds.com/ Ed Bennett}
 * @author Eric Kilfoil <eric@ypass.net>
 * @copyright (c) 2009 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://www.php.net/license/3_01.txt The PHP License
 * @package external
 * @subpackage Net_DNS
 */

/**
 * @package external
 * @subpackage Net_DNS
 */
class Net_DNS_RR_MX extends Net_DNS_RR
{
	var $name;
	var $type;
	var $class;
	var $ttl;
	var $rdlength;
	var $rdata;
	var $preference;
	var $exchange;

	/**
	 * dummy docblock
	 */
	function Net_DNS_RR_MX(&$rro, $data, $offset = '')
	{
		$this->name = $rro->name;
		$this->type = $rro->type;
		$this->class = $rro->class;
		$this->ttl = $rro->ttl;
		$this->rdlength = $rro->rdlength;
		$this->rdata = $rro->rdata;

		if ($offset) {
			if ($this->rdlength > 0) {
				$a = unpack("@$offset/npreference", $data);
				$offset += 2;
				$packet = new Net_DNS_Packet();
				list($exchange, $offset) = $packet->dn_expand($data, $offset);
				$this->preference = $a['preference'];
				$this->exchange = $exchange;
			}
		} elseif (is_array($data)) {
			$this->preference = $data['preference'];
			$this->exchange = $data['exchange'];
		} else {
			preg_match("/([0-9]+)[ \t]+(.+)[ \t]*$/", $data, $regs);
			$this->preference = $regs[1];
			$this->exchange = preg_replace('/(.*)\.$/', '\\1', $regs[2]);
		}
	}


	/**
	 * dummy docblock
	 */
	function rdatastr()
	{
		if (preg_match('/^[0-9]+$/', $this->preference)) {
			return $this->preference . ' ' . $this->exchange . '.';
		}
		return '; no data';
	}


	/**
	 * dummy docblock
	 */
	function rr_rdata($packet, $offset)
	{
		if (preg_match('/^[0-9]+$/', $this->preference)) {
			$rdata = pack('n', $this->preference);
			$rdata .= $packet->dn_comp($this->exchange, $offset + strlen($rdata));
			return $rdata;
		}
		return null;
	}

}

?>
