<?php
/**
 * Net_DNS: A resolver library for PHP
 *
 * @author {@link http://wonderwinds.com/ Ed Bennett}
 * @author Eric Kilfoil <eric@ypass.net>
 * @copyright (c) 2009 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://www.php.net/license/3_01.txt The PHP License
 * @package external
 * @subpackage Net_DNS
 */

/**
 * @package external
 * @subpackage Net_DNS
 */
class Net_DNS_RR_PTR extends Net_DNS_RR
{
	var $name;
	var $type;
	var $class;
	var $ttl;
	var $rdlength;
	var $rdata;
	var $ptrdname;

	/**
	 * dummy docblock
	 */
	function Net_DNS_RR_PTR(&$rro, $data, $offset = '')
	{
		$this->name = $rro->name;
		$this->type = $rro->type;
		$this->class = $rro->class;
		$this->ttl = $rro->ttl;
		$this->rdlength = $rro->rdlength;
		$this->rdata = $rro->rdata;


		if ($offset) {
			if ($this->rdlength > 0) {
				$packet = new Net_DNS_Packet();

				list($ptrdname, $offset) = $packet->dn_expand($data, $offset);
				$this->ptrdname = $ptrdname;
			}
		} elseif (is_array($data)) {
			$this->ptrdname = $data['ptrdname'];
		} else {
			$this->ptrdname = preg_replace("/[ \t]+(.+)[ \t]*$/", '\\1', $data);
		}
	}


	/**
	 * dummy docblock
	 */
	function rdatastr()
	{
		if (strlen($this->ptrdname)) {
			return $this->ptrdname . '.';
		}
		return '; no data';
	}


	/**
	 * dummy docblock
	 */
	function rr_rdata($packet, $offset)
	{
		if (strlen($this->ptrdname)) {
			return $packet->dn_comp($this->ptrdname, $offset);
		}
		return null;
	}

}

?>
