<?php
/**
 * Net_DNS: A resolver library for PHP
 *
 * @author {@link http://wonderwinds.com/ Ed Bennett}
 * @author Eric Kilfoil <eric@ypass.net>
 * @copyright (c) 2009 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://www.php.net/license/3_01.txt The PHP License
 * @package external
 * @subpackage Net_DNS
 */

/**
 * @package external
 * @subpackage Net_DNS
 */
class Net_DNS_RR_SRV extends Net_DNS_RR
{
	var $name;
	var $type;
	var $class;
	var $ttl;
	var $rdlength;
	var $rdata;
	var $preference;
	var $weight;
	var $port;
	var $target;

	/**
	 * dummy docblock
	 */
	function Net_DNS_RR_SRV(&$rro, $data, $offset = '')
	{
		$this->name = $rro->name;
		$this->type = $rro->type;
		$this->class = $rro->class;
		$this->ttl = $rro->ttl;
		$this->rdlength = $rro->rdlength;
		$this->rdata = $rro->rdata;

		if ($offset) {
			if ($this->rdlength > 0) {
				$a = unpack("@$offset/npreference/nweight/nport", $data);
				$offset += 6;
				$packet = new Net_DNS_Packet();

				list($target, $offset) = $packet->dn_expand($data, $offset);
				$this->preference = $a['preference'];
				$this->weight = $a['weight'];
				$this->port = $a['port'];
				$this->target = $target;
			}
		} elseif (is_array($data)) {
			$this->preference = $data['preference'];
			$this->weight = $data['weight'];
			$this->port = $data['port'];
			$this->target = $data['target'];
		} else {
			preg_match("/([0-9]+)[ \t]+([0-9]+)[ \t]+([0-9]+)[ \t]+(.+)[ \t]*$/", $data, $regs);
			$this->preference = $regs[1];
			$this->weight = $regs[2];
			$this->port = $regs[3];
			$this->target = preg_replace('/(.*)\.$/', '\\1', $regs[4]);
		}
	}


	/**
	 * dummy docblock
	 */
	function rdatastr()
	{
		if ($this->port) {
			return intval($this->preference) . ' ' . intval($this->weight) . ' ' . intval($this->port) . ' ' . $this->target . '.';
		}
		return '; no data';
	}


	/**
	 * dummy docblock
	 */
	function rr_rdata($packet, $offset)
	{
		if (isset($this->preference)) {
			$rdata = pack('nnn', $this->preference, $this->weight, $this->port);
			$rdata .= $packet->dn_comp($this->target, $offset + strlen($rdata));
			return $rdata;
		}
		return null;
	}

}

?>
