<?php
/**
 * Net_DNS: A resolver library for PHP
 *
 * @author {@link http://wonderwinds.com/ Ed Bennett}
 * @author Eric Kilfoil <eric@ypass.net>
 * @copyright (c) 2009 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://www.php.net/license/3_01.txt The PHP License
 * @package external
 * @subpackage Net_DNS
 */

/**
 * @package external
 * @subpackage Net_DNS
 */
class Net_DNS_RR_TXT extends Net_DNS_RR
{
	var $name;
	var $type;
	var $class;
	var $ttl;
	var $rdlength;
	var $rdata;
	var $text;

	/**
	 * dummy docblock
	 */
	function Net_DNS_RR_TXT(&$rro, $data, $offset = '')
	{
		$this->name = $rro->name;
		$this->type = $rro->type;
		$this->class = $rro->class;
		$this->ttl = $rro->ttl;
		$this->rdlength = $rro->rdlength;
		$this->rdata = $rro->rdata;

		if ($offset) {
			if ($this->rdlength > 0) {
				$maxoffset = $this->rdlength + $offset;
				while ($maxoffset > $offset) {
					list($text, $offset) = Net_DNS_Packet::label_extract($data, $offset);
					$this->text[] = $text;
				}
			}
		} elseif (is_array($data)) {
			$this->text = $data['text'];
		} else {
			$data = str_replace('\\\\', chr(1) . chr(1), $data); /* disguise escaped backslash */
			$data = str_replace('\\"', chr(2) . chr(2), $data); /* disguise \" */

			preg_match('/("[^"]*"|[^ \t]*)[ \t]*$/', $data, $regs);
			$regs[1] = str_replace(chr(2) . chr(2), '\\"', $regs[1]);
			$regs[1] = str_replace(chr(1) . chr(1), '\\\\', $regs[1]);
			$regs[1] = stripslashes($regs[1]);

			$this->text = $regs[1];
		}
	}


	/**
	 * dummy docblock
	 */
	function rdatastr()
	{
		if ($this->text) {
			if (is_array($this->text)) {
				$tmp = array();
				foreach ($this->text as $t) {
					$tmp[] = '"'.addslashes($t).'"';
				}
				return implode(' ',$tmp);
			} else {
				return '"' . addslashes($this->text) . '"';
			}
		} else return '; no data';
	}


	/**
	 * dummy docblock
	 */
	function rr_rdata($packet, $offset)
	{
		if ($this->text) {
			$rdata = pack('C', strlen($this->text)) . $this->text;
			return $rdata;
		}
		return null;
	}

}

?>
