<?php
/**
 * This file implements the PingOMatic plugin
 *
 * @author {@link http://wonderwinds.com/ Ed Bennett}
 * @author {@link http://daniel.hahler.de/ Daniel HAHLER}
 * @author {@link http://fplanque.net/ Francois PLANQUE}
 * @copyright (c) 2009 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://www.gnu.org/licenses/gpl.txt GNU General Public License v3
 * @package plugins
 * @subpackage PingOMatic
 */
if(!defined('QP_MAIN_INIT')) die('fail');

/**
 * @package plugins
 *
 * @subpackage PingOMatic
 */
class ping_pingomatic_plugin extends Plugin
{
	var $author = 'blueyed';
	var $author_url = 'http://daniel.hahler.de/';
	var $code = 'ping_pingomatic';
	var $group = 'pingers';
	var $number_of_installs = 1;
	var $priority = 50;
	var $version = '1.0';

	/**
	 * @see Plugin::PluginInit()
	 */
	function PluginInit( & $params )
	{
		$this->name = $this->T_('Ping-O-Matic');
		$this->short_desc = $this->T_('Pings the Ping-O-Matic service.');
		$this->long_desc = $this->T_('Pings the <a href="http://pingomatic.com/">Ping-O-Matic</a> service, which relays your ping to the most common services.');

		$this->ping_service_name = 'Ping-O-Matic';
		$this->ping_service_note = $this->T_('Pings a service that relays the ping to the most common services.');
	}


	/**
	 * @see Plugin::ItemSendPing()
	 */
	function ItemSendPing( & $params )
	{
		global $debug;

		$item_Blog = $params['Item']->get_Blog();

		$client = new xmlrpc_client( '/', 'rpc.pingomatic.com', 80 );
		$client->debug = ( $debug && $params['display'] );

		$message = new xmlrpcmsg("weblogUpdates.ping", array(
				new xmlrpcval( $item_Blog->get( 'name' ) ),
				new xmlrpcval( $item_Blog->get( 'url' ) )
		) );
		$result = $client->send( $message );

		$params['xmlrpcresp'] = $result;

		return true;
	}

}

?>
