<?php
/**
 * This file implements the twitter plugin callback
 *
 * @author {@link http://wonderwinds.com/ Ed Bennett}
 * @copyright (c) 2009 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://www.gnu.org/licenses/gpl.txt GNU General Public License v3
 * @package plugins
 * @subpackage Twitter
 */

/**
 * dummy docblock
 */
require_once dirname(__FILE__).'/../../qp_config/_config.php';
/**
 * dummy docblock
 */
require_once dirname(__FILE__).'/twitteroauth/twitteroauth.php';

/**
 * Main initialization, without a specific blog identified
 */
require_once $inc_path.'_main.inc.php';

load_funcs( '_core/_param.funcs.php' );

global $Session;
global $Messages;
global $admin_url;

$req_token = param( 'oauth_token', 'string', '' );
$oauth_verifier = param( 'oauth_verifier', 'string', '' );
$oauth_token = $Session->get( 'oauth_token' );
$redir = $Session->get( 'redir' );
$user_id = $Session->get( 'user_id' );
$plugin_id = $Session->get( 'plugin_id' );
$consumer_key = $Session->get( 'consumer_key' );
$consumer_secret = $Session->get( 'consumer_secret' );

// to where shall we twitter redirect us?
if( $redir == 'foo' )
{
	$redirect_to = url_add_param( $admin_url, 'ctrl=users&user_ID='.$user_id );
}
else
{
	$redirect_to = url_add_param( $admin_url, $redir );
}

// check tokens
if( ( ! empty( $req_token ) && ( $oauth_token !== $req_token ) ) || empty( $user_id ) )
{
	$Messages->add( T_( 'Error occured during twitter plugin initialization. Please try again.' ), 'error' );
	/* Remove stuff we don't need anymore */
	$Session->delete( 'redir' );
	$Session->delete( 'user_id' );
	$Session->delete( 'plugin_id' );
	$Session->delete( 'oauth_token' );
	$Session->delete( 'oauth_token_secret' );
	$Session->dbsave();
	header_redirect( $redirect_to );
}

if( empty( $oauth_verifier ) )
{
	// twitter refused the connection
	$denied = param( 'denied', 'string', '' );
	if( empty( $denied ) )
	{
		$Messages->add( T_( 'Error occured during verifying twitter plugin initialization. Pleas try again.' ), 'error' );
	}
	else
	{
		// user didn't allow the connection
		$Messages->add( T_( 'Twitter plugin connection denied.' ), 'error' );
	}
	header_redirect( $redirect_to ); // !!!! Where to redirect
}

$connection = new TwitterOAuth( $consumer_key, $consumer_secret, $oauth_token, $Session->get( 'oauth_token_secret' ) );

//get access token
$access_token = $connection->getAccessToken( $oauth_verifier );

// save plugin settings for this user
global $Plugins;
$Plugin = & $Plugins->get_by_ID( $plugin_id );
if( empty( $Plugin ) )
{
	$Messages->add( T_( 'Can not find twitter plugin!' ), 'error' );
}
else
{
	// user preferences
	$Plugin->UserSettings->set( 'twitter_token', $access_token['oauth_token'], $user_id );
	$Plugin->UserSettings->set( 'twitter_secret', $access_token['oauth_token_secret'], $user_id );
	$Plugin->UserSettings->dbupdate();
}

/* Remove no longer needed request tokens */
$Session->delete( 'consumer_key' );
$Session->delete( 'consumer_secret' );
$Session->delete( 'oauth_token' );
$Session->delete( 'oauth_token_secret' );
$Session->dbsave();

$Messages->add( T_( 'Twitter plugin was initialized successful!' ), 'success' );
header_redirect( $redirect_to );

?>
