<?php
/**
 * This file implements the Ask A Ninja Video class of the video plugin
 *
 * @author {@link http://wonderwinds.com/ Ed Bennett}
 * @author {@link http://astonishme.co.uk/ Yabba (Paul Jones, rest in peace)}
 * @copyright (c) 2009 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://www.gnu.org/licenses/gpl.txt GNU General Public License v3
 * @package plugins
 * @subpackage video
 */
if(!defined('QP_MAIN_INIT')) die('fail');

/**
 * Ask A Ninja Video Class
 *
 * @package plugins
 * @subpackage video
 */
class vp_askaninja extends vp_video {

	var $nice_name = 'Ask A Ninja';
	var $homepage = 'http://askaninja.com';
	var $def_value = 0;


	/**
	 * source-specific javascript
	 */
	function GetJavascript()
	{
		$r = <<<JAVASCRIPT
var p = '{$this->T_('Enter the EMBED code for your askaninja video:')}';
var ninja_ID = _me.prompt( p, '' );
if( ! ninja_ID ) {
	return;
}
if( ninja_ID.search("embed") == 1 ) {
	var splitA = ninja_ID.split("\"");
	var stringA = splitA[3];
	var clip_ID = stringA.split("/");
	tag = '[video:ninja:'+clip_ID[5]+'/'+clip_ID[6]+']';
	_me.addTag(tag);
} else {
	return;
}
JAVASCRIPT;
return $r;
	}


	/**
	 * supports RenderItemAsHtml() in _video.plugin.php
	 */
	function RenderContent( $content, $width )
	{
		if( strpos( $content, '[video:ninja' ) !== false )
		{
			$content = preg_replace( '#\[video:ninja:(.+?)]#', '<div class="videoblock"><object type="application/x-shockwave-flash" data="http://p.castfire.com/1P48R/video/\\1" [ninj:345] ><param name="movie" value="http://p.castfire.com/1P48R/video/\\1" /><param name="allowfullscreen" value="true" /><param name="wmode" value="transparent" /></object></div>', $content );
			$content = preg_replace( '#\[ninj:(.+?)]#', 'width="'.$width.'" height="'.round( ( $width * substr( $content, strpos( $content, '[ninj')+6, 3 ) ) / 425 ).'"', $content );
		}
		return $content;
	}
}
?>
