<?php
/**
 * This file implements the SWF Video class of the video plugin
 *
 * @author {@link http://wonderwinds.com/ Ed Bennett}
 * @author {@link http://astonishme.co.uk/ Yabba (Paul Jones, rest in peace)}
 * @copyright (c) 2009 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://www.gnu.org/licenses/gpl.txt GNU General Public License v3
 * @package plugins
 * @subpackage video
 */
if(!defined('QP_MAIN_INIT')) die('fail');

/**
 * SWF Video Class
 *
 * @package plugins
 * @subpackage video
 */
class vp_swf extends vp_video {

	var $nice_name = 'SWF';
	var $homepage = 'http://wow-factor.com/index.php/flash-test';
	var $def_value = 0;


	/**
	 * source-specific javascript
	 */
	function GetJavascript()
	{
		/**
		 * todo : this will probably match to many sources
		 * might be better being it's own button?
		 */
		$r = <<<JAVASCRIPT
var regex = new RegExp( '^(http.+?\.swf)$', 'i' );
if( vid_code.match( regex ) ) {
	var object_width = window.prompt('{$this->T_('Enter the width, using px or %, of your')} SWF:', '' );
	var object_height = window.prompt('{$this->T_('Enter the height, using px or %, of your')} SWF:', '' );
	return '[object:SWF:'+vid_code.replace( regex, '$3' )+' w:'+object_width+' h:'+object_height+']';
} else {
	return false;
}
JAVASCRIPT;

		return $r;
	}


	/**
	 * supports RenderItemAsHtml() in _video.plugin.php
	 */
	function RenderContent( $content, $width )
	{
		$content = preg_replace( '#\[object:swf:(.+?) w:(.+?) h:(.+?)]#i', '<div class="videoblock"><object type="application/x-shockwave-flash" style="width:\\2; height:\\3;" data="\\1"><param name="movie" value="\\1" /></object></div>', $content );
		return $content;
	}
}
?>
