<?php
/**
 * This is the handler for asynchronous 'AJAX' calls
 *
 * @copyright (c) 2009 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://www.gnu.org/licenses/gpl.txt GNU General Public License v3
 * @package core
 */

/**
 * Load the configuration minimum
 */
require_once dirname(__FILE__).'/../qp_config/_config.php';

/**
 * Main initialization, without a specific blog identified
 */
require_once $inc_path.'_main.inc.php';

param( 'action', 'string', '' );

// Check global permission
if( empty( $current_User ) || ! $current_User->check_perm( 'admin', 'any' ) )
{
	/**
	 * No permission to access admin...
	 */
	require $admintemplates_path.'_access_denied.main.php';
}

// fp> Does the following have an HTTP fallback when Javascript/AJ is not available?
// dh> yes, but not through this file. dh> IMHO it does not make sense to let the
// "normal controller" handle the AJAX call if there's something lightweight like
// calling "$UserSettings->param_Request()"! Hmm... bad example (but valid). Better
// example: something like the actions below, which output only a small part of
// what the "real controller" does..
switch( $action )
{
	case 'add_plugin_sett_set':
		// Add a Plugin(User)Settings set (for "array" type settings)
		header_content_type( 'text/html' ); // sets charset

		param( 'plugin_ID', 'integer', true );

		// use Plugins_admin, because a plugin might be disabled
		$admin_Plugins = & get_Cache('Plugins_admin');
		$Plugin = & $admin_Plugins->get_by_ID($plugin_ID);
		if( ! $Plugin )
		{
			bad_request_die('Invalid Plugin.');
		}
		param( 'set_type', 'string', '' ); // "Settings" or "UserSettings"
		if( $set_type != 'Settings' /* && $set_type != 'UserSettings' */ )
		{
			bad_request_die('Invalid set_type param!');
		}
		param( 'set_path', '/^\w+(?:\[\w+\])+$/', '' );

		load_funcs( 'plugins/_plugin.funcs.php' );

		// Init the new setting set
		_set_setting_by_path( $Plugin, $set_type, $set_path, array() );
		$r = get_plugin_settings_node_by_path( $Plugin, $set_type, $set_path, /* create: */ false );

		$Form = new Form(); // fake Form
		autoform_display_field( $set_path, $r['set_meta'], $Form, $set_type, $Plugin, NULL, $r['set_node'] );
		exit();

	case 'del_plugin_sett_set':
	echo 'OK';
	exit();

	case 'admin_blogperms_set_layout':
	// Save blog permission tab layout into user settings. This gets called on JS-toggling.
	$UserSettings->param_Request( 'layout', 'blogperms_layout', 'string', $debug ? 'all' : 'default' );  // table layout mode
	exit();

}

/**
 * Call the handler/dispatcher
 *
 * It is a common handler for asynchronous calls -- both AJax calls and HTTP GET fallbacks
 */
require_once $inc_path.'_async.inc.php';

// Debug info
echo '-expand='.$expand;
echo '-collapse='.$collapse;

?>
