<?php
/**
 * This file gets used to access {@link Plugin} methods that are marked to be accessible this way
 *
 * See {@link Plugin::GetSrvcMethods()}.
 *
 * @copyright (c) 2009 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://www.gnu.org/licenses/gpl.txt GNU General Public License v3
 * @package plugins
 */

/**
 * Load the configuration minimum
 */
require_once dirname(__FILE__).'/../qp_config/_config.php';

/**
 * Main initialization, without a specific blog identified
 */
require_once $inc_path.'_main.inc.php';

param( 'plugin_ID', 'integer', true );
param( 'method', 'string', '' );
param( 'params', 'string', null ); // serialized

if( is_null($params) )
{
	// Default
	$params = array();
}
else
{
	// params given. This may result in "false", but this means that unserializing failed
	$params = @unserialize($params);
}

if( $plugin_ID )
{
	$Plugin = & $Plugins->get_by_ID( $plugin_ID );

	if( ! $Plugin )
	{
		debug_die( 'Invalid Plugin!' );
	}

	if( ! in_array( $method, $Plugin->GetSrvcMethods() ) )
	{
		debug_die( 'Call to non-srvc Plugin method!' );
	}
	elseif( ! method_exists( $Plugin, 'srvc_'.$method ) )
	{
		debug_die( 'srvc method does not exist!' );
	}

	// Call the method:
	$Plugins->call_method( $Plugin->ID, 'srvc_'.$method, $params );
}

?>
