<?php
/**
 * This file updates the current user's profile
 *
 * @copyright (c) 2009 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://www.gnu.org/licenses/gpl.txt GNU General Public License v3
 * @package users
 */

/**
 * Load the configuration minimum
 */
require_once dirname(__FILE__).'/../qp_config/_config.php';

/**
 * Main initialization, without a specific blog identified
 */
require_once $inc_path.'_main.inc.php';

// Getting GET or POST parameters
param( 'checkuser_id', 'integer', '' );
param( 'newuser_firstname', 'string', '' );
param( 'newuser_lastname', 'string', '' );
param( 'newuser_nickname', 'string', '' );
param( 'newuser_idmode', 'string', '' );
param( 'newuser_locale', 'string', $default_locale );
param( 'newuser_url', 'string', '' );
param( 'newuser_email', 'string', '' );
param( 'newuser_allow_msgform', 'integer', 0 ); // checkbox
param( 'newuser_notify', 'integer', 0 );        // checkbox
param( 'newuser_showonline', 'integer', 0 );    // checkbox
param( 'pass1', 'string', '' );
param( 'pass2', 'string', '' );

/**
 * Basic security checks
 */
if( ! is_logged_in() )
{
	// must be logged in!
	bad_request_die( T_('You are not logged in.') );
}

if( $checkuser_id != $current_User->ID )
{
	// Can only edit your own profile
	bad_request_die( 'You are not logged in under the same account you are trying to modify.' );
}

if( $demo_mode && ( $current_User->ID == 1
	|| $current_User->login == 'demouser'
	|| $current_User->login == 'demoblogger'
	|| $current_User->login == 'demospecial' ) )
{
	bad_request_die( 'Demo mode: you can\'t edit the admin/demouser profile!<br />[<a href="javascript:history.go(-1)">'
		. T_('Back to profile').'</a>]' );
}

// Additional checks
profile_check_params( array(
	'nickname' => $newuser_nickname,
	'email' => $newuser_email,
	'url' => $newuser_url,
	'pass1' => $pass1,
	'pass2' => $pass2,
	'pass_required' => false ), $current_User );

if( $Messages->count('error') )
{
	header_content_type( 'text/html' ); // sets charset
	// @todo (0000) dh> these error should get displayed with the profile form itself,
	// or at least there should be a "real HTML page" here (without JS-backlink)
	$Messages->display( T_('Cannot update profile. Please correct the following errors:'),
		'[<a href="javascript:history.go(-1)">'.T_('Back to profile').'</a>]' );
	exit(0);
}

// Do the update
$updatepassword = '';
if( ! empty( $pass1 ) )
{
	$newuser_pass = md5( $pass1 );
	$current_User->set( 'pass', $newuser_pass );
}

$current_User->set( 'firstname', $newuser_firstname );
$current_User->set( 'lastname', $newuser_lastname );
if( ! $lock_id_and_nick )
{
	$current_User->set( 'nickname', $newuser_nickname );
}
$current_User->set_email( $newuser_email );
$current_User->set( 'url', $newuser_url );
$current_User->set( 'idmode', $newuser_idmode );
$current_User->set( 'locale', $newuser_locale );
$current_User->set( 'allow_msgform', $newuser_allow_msgform );
$current_User->set( 'notify', $newuser_notify );
$current_User->set( 'showonline', $newuser_showonline );

// Set Messages into user's session, so they get restored on the next page (after redirect):
if( $current_User->dbupdate() )
{
	$Messages->add( T_('Your profile has been updated.'), 'success' );
}
else
{
	$Messages->add( T_('Your profile has not been changed.'), 'note' );
}

header_nocache();
// redirect Will save $Messages into Session:
header_redirect();

?>
