<?php
/**
 * RSD (Really Simple Discoverability)
 *
 * Curious? Check out the following links:
 * - {@link http://archipelago.phrasewise.com/rsd}
 * - {@link http://cyber.law.harvard.edu/blogs/gems/tech/rsd.html}
 * - {@link http://en.wikipedia.org/wiki/Really_Simple_Discovery}
 *
 * @copyright (c) 2009 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://www.gnu.org/licenses/gpl.txt GNU General Public License v3
 * @package xml
 */
header('Content-type: text/xml; charset=UTF-8', true);

/**
 * Load the configuration minimum
 */
require_once dirname(__FILE__).'/../qp_config/_config.php';

/**
 * Main initialization, without a specific blog identified
 */
require_once $inc_path.'_main.inc.php';

param( 'blog', 'integer', NULL );

echo '<?xml version="1.0" encoding="UTF-8"?'.'>';
?>
<rsd version="1.0" xmlns="http://archipelago.phrasewise.com/rsd">
	<service>
		<engineName><?php echo $app_name; ?></engineName>
		<engineLink><?php echo $app_homepage; ?></engineLink>
		<homePageLink><?php echo $app_baseurl; ?></homePageLink>
		<apis>
	  	<?php if( $Settings->get( 'general_xmlrpc_metaweblog' ) )
	  	{?>
		<api name="MetaWeblog" preferred="true" apiLink="<?php echo $srvc_url; ?>xmlrpc.php"<?php
	    	if( ! empty( $blog ) ) { echo ' blogID="'.$blog.'"'; }
	    	?>>
				<settings>
					<docs>http://manual.b2evolution.net/MetaWeblog_API</docs>
				</settings>
			</api>
		<?}?>
	  	<?php if( $Settings->get( 'general_xmlrpc_mt' ) )
	  	{?>
		<api name="MovableType" preferred="false" apiLink="<?php echo $srvc_url; ?>xmlrpc.php"<?php
	    	if( ! empty( $blog ) ) { echo ' blogID="'.$blog.'"'; }
	    	?>>
				<settings>
					<docs>http://manual.b2evolution.net/MovableType_API</docs>
				</settings>
			</api>
		<?}?>
	  	<?php if( $Settings->get( 'general_xmlrpc_blogger' ) )
	  	{?>
	    <api name="Blogger" preferred="false" apiLink="<?php echo $srvc_url; ?>xmlrpc.php"<?php
	    	if( ! empty( $blog ) ) { echo ' blogID="'.$blog.'"'; }
	    	?>>
				<settings>
					<docs>http://manual.b2evolution.net/Blogger_API</docs>
				</settings>
			</api>
		<?}?>
	  	<?php if( $Settings->get( 'general_xmlrpc_b2' ) )
	  	{?>
	    <api name="b2" preferred="false" apiLink="<?php echo $srvc_url; ?>xmlrpc.php"<?php
	    	if( ! empty( $blog ) ) { echo ' blogID="'.$blog.'"'; }
	    	?>>
				<settings>
					<docs>http://manual.b2evolution.net/B2_API</docs>
				</settings>
			</api>
		<?}?>
		</apis>
	</service>
</rsd>
