<?php
/**
 * template when $disp == 'comments'
 *
 * @copyright (c) 2009 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://www.gnu.org/licenses/gpl.txt GNU General Public License v3
 * @package templates
 */
if(!defined('QP_MAIN_INIT')) die('fail');

$CommentList = new CommentList( $Blog, "'comment','trackback'", array('published'), '', '', 'DESC', '', 20 );

// display a message if list is empty
$CommentList->display_if_empty( array() );

// Loop through comments
while( $Comment = & $CommentList->get_next() )
{
	// Load comment's Item object
	$Comment->get_Item();
	$Comment->anchor(); // display an anchor for this comment
	?>

	<div class="bComment">
	<h3 class="bTitle">
	<?php
	echo T_('In response to').':';

	$Comment->Item->title( array(
		'link_type' => 'permalink',
	) );
	?>
	</h3>

	<div class="bCommentTitle">
	<?php
	// display comment author's name
	$Comment->author( array() );

	// display a link to comment author's URL
	$Comment->author_url( array(
		'before' => ' &middot; '
	) );
	?>
	</div>

	<div class="bCommentText">
	<?php $Comment->content(); // display the comment's contents ?>
	</div>

	<div class="bCommentSmallPrint">
	<?php
	// display a permalink link to the comment
	$Comment->permanent_link( array(
		'class' => 'permalink_right',
		'nofollow' => true,
	) );

	// display the comment's date
	$Comment->date( array(
		'after' => ' @ ',
	) );

	// display the comment's time
	$Comment->time( array(
		'format' => 'H:i',
	) );

	// display a link to edit a comment
	$Comment->edit_link( array(
		'before' => ' &middot; ',
	) );

	// display a link to delete a comment
	$Comment->delete_link( array(
		'before' => ' &middot; ',
	) );
	?>
	</div>

	</div>
	<?php
}
?>
