<?php
/**
 * item comment template (sub-template)
 *
 * @copyright (c) 2009 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://www.gnu.org/licenses/gpl.txt GNU General Public License v3
 * @package templates
 */
if(!defined('QP_MAIN_INIT')) die('fail');

// set some default params...
$params = array_merge( array(
	'comment_start' => '<div class="bComment">',
	'comment_end' => '</div>',
	'Comment' => NULL, // this object MUST be passed as a param!
), $params );

$Comment = & $params['Comment'];
$Comment->anchor(); // display an anchor for this comment
echo $params['comment_start'];
?>

<div class="bCommentTitle">
<?php
switch( $Comment->get( 'type' ) )
{
	case 'comment':
	if( empty( $Comment->ID ) )
	{
		// PREVIEW comment
		echo T_('PREVIEW Comment from:').' ';
	}
	else
	{
		// display a permalink link to the comment
		$Comment->permanent_link( array(
			'after' => ' '.T_('from:').' ',
			'text' => T_('Comment'),
			'nofollow' => true,
		) );
	}

	// display comment author's name
	$Comment->author( array() );

	// display a link to message form for this comment's author
	$Comment->msgform_link( $Blog->get( 'msgformurl' ), array() );

	// display a link to comment author's URL
	$Comment->author_url( array(
		'before' => ' &middot; '
	) );
	break;

	case 'trackback':
	// display a permalink link to the trackback
	$Comment->permanent_link( array(
		'after' => ' '.T_('from:').' ',
		'text' => T_('Trackback'),
		'nofollow' => true,
	) );

	// display trackback author's name
	$Comment->author( array(
		'make_link' => true
	) );
	break;

}
?>
</div>

<?php
// display a comment's rating
$Comment->rating( array() );
?>

<div class="bCommentText">
<?php $Comment->content(); // display the comment's contents ?>
</div>

<div class="bCommentSmallPrint">
<?php
// display a link to edit a comment
$Comment->edit_link( array(
	'class' => 'permalink_right',
) );

// display a link to delete a comment
$Comment->delete_link( array(
	'class' => 'permalink_right',
) );

// display the comment's date
$Comment->date( array(
	'after' => ' @ ',
) );

// display the comment's time
$Comment->time( array(
	'format' => 'H:i',
) );
?>
</div>

<?php
echo $params['comment_end'];
?>
