<?php
/**
 * template when $disp == 'msgform'
 *
 * @todo (0000) dh> A user/blog might want to accept only mails from logged in
 * users (fp>yes!)
 * @todo (0000) dh> For logged in users the From name and address should be not
 * editable/displayed (the same as when commenting). (fp>yes!!!)
 * @todo (0000) dh> params should get remembered, e.g. if somebody clicks on the
 * login/logout link from the msgform page. BUT, for the logout link remembering
 * it here is too late normally.. :/
 *
 * @copyright (c) 2009 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://www.gnu.org/licenses/gpl.txt GNU General Public License v3
 * @package templates
 */
if(!defined('QP_MAIN_INIT')) die('fail');

global $cookie_email;
global $cookie_name;
global $DB;

// Parameters
$redirect_to = param( 'redirect_to', 'string', '' ); // pass-through (hidden field)
$recipient_id = param( 'recipient_id', 'integer', '' );
$post_id = param( 'post_id', 'integer', '' );
$comment_id = param( 'comment_id', 'integer', '' );
$subject = param( 'subject', 'string', '' );

// are we returning to this page?
$sent = param( 'sent', 'integer', 0 );

// if we are sending a message (not returning after sending) ...
// (a) get user's preferred name or the stored value in cookie (from commenting)
// (b) get user's email address or the stored value in cookie (from commenting)
if( ! $sent )
{
	$email_author = '';
	$email_author_address = '';

	if( is_logged_in() )
	{
		$email_author = $current_User->get_preferred_name();
		$email_author_address = $current_User->email;
	}
	// name from cookie?
	if( ! strlen( $email_author ) && isset( $_COOKIE[$cookie_name] ) )
	{
		$email_author = trim( $_COOKIE[$cookie_name] );
	}
	// email from cookie?
	if( ! strlen( $email_author_address ) && isset( $_COOKIE[$cookie_email] ) )
	{
		$email_author_address = trim( $_COOKIE[$cookie_email] );
	}
}

$recipient_User = NULL;
$Comment = NULL;

$UserCache = & get_Cache( 'UserCache' );
// check if the recipient wants to receive mails through the message form
if( ! empty( $recipient_id ) )
{
	$recipient_User = & $UserCache->get_by_ID( $recipient_id );
	if( $recipient_User )
	{
		if( empty( $recipient_User->allow_msgform ) )
		{
			echo '<p class="error">The user does not want to receive emails through the message form.</p>';
			return;
		}
		$recipient_name = $recipient_User->get( 'preferredname' );
		$recipient_address = $recipient_User->get( 'email' );
	}
}
// check if the commenter wants to receive mails through the message form
elseif( ! empty( $comment_id ) )
{
	// Load comment from DB
	$row = $DB->get_row( 'SELECT * FROM T_comments WHERE comment_ID = '.$comment_id, ARRAY_A );
	if( $row )
	{
		$Comment = new Comment( $row );
		if( $comment_author_User = & $Comment->get_author_User() )
		{
			// Source comment is from a registered user
			if( ! $comment_author_User->allow_msgform )
			{
				echo '<p class="error">The user does not want to get contacted through the message form.</p>'; // should be prevented by UI
				return;
			}
		}
		elseif( ! $Comment->allow_msgform )
		{
			// Source comment is from an anonymous user
			echo '<p class="error">This commentator does not want to get contacted through the message form.</p>'; // should be prevented by UI
			return;
		}
		$recipient_name = $Comment->get_author_name();
		$recipient_address = $Comment->get_author_email();
	}
}
// if we are sending a message (not returning after sending) get info from settings
if( ! $sent && $recipient_id == '' )
{
	$recipient_id = $Blog->get_setting( 'contact_id' );
	$redirect_to = $Blog->get_setting( 'contact_redirect' );
	// duplicated from a few lines above. not the best but oh well ...
	$recipient_User = & $UserCache->get_by_ID( $recipient_id );
	if( $recipient_User )
	{
		if( empty( $recipient_User->allow_msgform ) )
		{
			echo '<p class="error">The user does not want to receive emails through the message form.</p>';
			return;
		}
		$recipient_name = $recipient_User->get( 'preferredname' );
		$recipient_address = $recipient_User->get( 'email' );
	}
}

// if we are sending and do not have a recipient addy, die :(
if( ! $sent && empty( $recipient_address ) )
{
	echo 'No recipient specified!';
	return;
}

// Get the suggested subject for the email:
if( empty( $subject ) )
{
	if( ! empty( $comment_id ) )
	{
		$row = $DB->get_row( 'SELECT post_title FROM T_items, T_comments WHERE comment_ID = '.$DB->quote( $comment_id ).' AND post_ID = comment_post_ID' );
		if( $row )
		{
			$subject = T_('Re:').' '.sprintf( /* TRANS: Used as mail subject; %s gets replaced by an item's title */ T_('Comment on %s'), $row->post_title );
		}
	}
	if( empty( $subject ) && ! empty( $post_id ) )
	{
		$row = $DB->get_row( 'SELECT post_title FROM T_items WHERE post_ID = '.$post_id );
		if( $row )
		{
			$subject = T_('Re:').' '.$row->post_title;
		}
	}
	if( empty( $subject ) )
	{
		$subject = $Blog->get_setting( 'contact_subject' );
	}
}

// Begin displaying the page...
if( ! $sent )
{
	echo '<div class="bTitle"><h3 class="bTitle">'.$Blog->get_setting( 'contact_title_before' ).'</h3></div>';
	echo '<div class="bPost" lang="'.$Blog->locale.'"><div class="bText">';
	echo '<p>'.$Blog->get_setting( 'contact_msg_before' ).'</p></div>'; // closes "bText" div
}
else
{
	echo '<div class="bTitle"><h3 class="bTitle">'.$Blog->get_setting( 'contact_title_after' ).'</h3></div>';
	echo '<div class="bPost" lang="'.$Blog->locale.'"><div class="bText">';
	echo '<p>'.$Blog->get_setting( 'contact_msg_after' ).'</p>'; // closes "bText" div
}

// the form if we are not returning from a send...
if( ! $sent )
{
	$Form = new Form( $srvc_url.'message_send.php' );
	$Form->begin_form( 'bComment' );
	if( ! empty( $Blog ) )
	{
		$Form->hidden( 'blog', $Blog->ID );
	}
	$Form->hidden( 'recipient_id', $recipient_id );
	$Form->hidden( 'post_id', $post_id );
	$Form->hidden( 'comment_id', $comment_id );
	$Form->hidden( 'redirect_to', url_rel_to_same_host( $redirect_to, $srvc_url ) );
	$Form->hidden( 'return', 1 );
	?>
	<fieldset>
	<div class="label"><label><?php echo T_('To')?>:</label></div>
	<div class="info"><strong><?php echo $recipient_name;?></strong></div>
	</fieldset>
	<?php
	// Note: we use funky field names in order to defeat the most basic guestbook spam bots
	$Form->text( 'd', $email_author, 40, T_('From'),  T_('Your name.'), 50, 'bComment' );
	$Form->text( 'f', $email_author_address, 40, T_('Email'), T_('Your email address will <strong>not</strong> be revealed on this site.'), 100, 'bComment' );
	$Form->text( 'g', $subject, 40, T_('Subject'), T_('Subject of email message.'), 255, 'bComment' );
	$Form->textarea( 'h', '', 15, T_('Message'), T_('Plain text only.'), 40, 'bComment' );

	$Plugins->trigger_event( 'DisplayMessageFormFieldset', array(
			'Form' => & $Form,
			'recipient_ID' => & $recipient_id,
			'item_ID' => $post_id,
			'comment_ID' => $comment_id,
	) );
	$Form->begin_fieldset();
	?>
	<div class="input">
	<?php
	$Form->button_input( array(
			'name' => 'submit_message_'.$recipient_id,
			'class' => 'submit',
			'value' => T_('Send message'),
	) );

	$Plugins->trigger_event( 'DisplayMessageFormButton', array(
			'Form' => & $Form,
			'recipient_ID' => & $recipient_id,
			'item_ID' => $post_id,
			'comment_ID' => $comment_id,
	) );
	?>
	</div>
	<?php
	$Form->end_fieldset();
}

echo '</div>'; // closes "bPost" div
echo '<div class="clear"></div>';

$Form->end_form();
?>
