<?php
/**
 * template when $disp == 'profile'
 *
 * @todo (1111) core avatars removed from "$ProfileForm->begin_fieldset( T_('Identity') )",
 * might need to be a plugin hook?
 *
 * @copyright (c) 2009 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://www.gnu.org/licenses/gpl.txt GNU General Public License v3
 * @package templates
 */
if(!defined('QP_MAIN_INIT')) die('fail');

// must be logged in!
if( ! is_logged_in() )
{
	echo '<p class="error">'.T_('You are not logged in.').'</p>';
	return;
}

$redirect_to = param( 'redirect_to', 'string', '' );

// form to update the profile
$ProfileForm = new Form( $srvc_url_sensitive.'profile_update.php', 'ProfileForm' );
$ProfileForm->begin_form( 'bComment' );
$ProfileForm->hidden( 'checkuser_id', $current_User->ID );
$ProfileForm->hidden( 'redirect_to', url_rel_to_same_host( $redirect_to, $srvc_url_sensitive ) );

$ProfileForm->begin_fieldset( T_('Email communications') );
$ProfileForm->text_input( 'newuser_email', $current_User->get( 'email' ), 40, T_('Email'), '', array( 'maxlength' => 100, 'class' => 'bComment' ) );
$ProfileForm->checkbox( 'newuser_allow_msgform', $current_User->get( 'allow_msgform' ), T_('Message form'), T_('Check this to allow receiving emails through a message form.') );
$ProfileForm->checkbox( 'newuser_notify', $current_User->get( 'notify' ), T_('Notifications'), T_('Check this to receive a notification whenever someone else comments on one of <strong>your</strong> posts.') );
$ProfileForm->end_fieldset();

$ProfileForm->begin_fieldset( T_('Identity') );
$ProfileForm->info( T_('Login'), $current_User->get( 'login' ) );
$ProfileForm->text_input( 'newuser_firstname', $current_User->get( 'firstname' ), 40, T_('First name'), '', array( 'maxlength' => 50, 'class' => 'bComment' ) );
$ProfileForm->text_input( 'newuser_lastname', $current_User->get( 'lastname' ), 40, T_('Last name'), '', array( 'maxlength' => 50, 'class' => 'bComment' ) );
$ProfileForm->text_input( 'newuser_nickname', $current_User->get( 'nickname' ), 40, T_('Nickname'), '', array( 'maxlength' => 50, 'class' => 'bComment' ) );
$ProfileForm->select( 'newuser_idmode', $current_User->get( 'idmode' ), array( &$current_User, 'callback_optionsForIdMode' ), T_('Identity shown'), '', 'bComment' );
$ProfileForm->checkbox( 'newuser_showonline', $current_User->get( 'showonline' ), T_('Show online'), T_('Check this to be displayed as online when visiting the site.') );
$ProfileForm->end_fieldset();

$ProfileForm->begin_fieldset( T_('Password') );

$ProfileForm->password_input( 'pass1', '', 16, T_('New pass'), array( 'note' => T_('Leave blank to leave the password unchanged.'), 'maxlength' => 50, 'class' => 'bComment', 'autocomplete' => 'off' ) );
$ProfileForm->password_input( 'pass2', '', 16, T_('Confirm'), array( 'note' => T_('Confirm new password by typing it again.')
	.' '.sprintf( T_('Minimum length: %d characters.'), $Settings->get( 'user_minpwdlen' ) ), 'maxlength' => 50, 'class' => 'bComment', 'autocomplete' => 'off' ) );
$ProfileForm->end_fieldset();

$ProfileForm->begin_fieldset( T_('Preferences') );
$ProfileForm->select( 'newuser_locale', $current_User->get( 'locale' ), 'locale_options_return', T_('Preferred locale'), '', 'bComment' );
$ProfileForm->end_fieldset();

$ProfileForm->begin_fieldset( T_('Additional info') );
$ProfileForm->info( T_('Level'), $current_User->get( 'level' ) );
$ProfileForm->info( T_('Posts'), $current_User->get( 'num_posts' ) );
$ProfileForm->text_input( 'newuser_url', $current_User->get( 'url' ), 40, T_('URL'), '', array( 'maxlength' => 100, 'class' => 'bComment' ) );
$ProfileForm->end_fieldset();

$ProfileForm->buttons( array(
		array( '', '', T_('Update'), 'SaveButton' ),
		array( 'reset', '', T_('Reset'), 'ResetButton' )
) );

$ProfileForm->end_form();

?>
