<?php
/**
 * Blog Comments feed, RSS 0.92 format
 *
 * @copyright (c) 2009 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://www.gnu.org/licenses/gpl.txt GNU General Public License v3
 * @package xml
 * @subpackage rss
 */
if(!defined('QP_MAIN_INIT')) die('fail');

if( isset( $Item ) )
{
	// Comments for a specific Item
	$CommentList = new CommentList( $Blog, "'comment'", array('published'), $Item->ID, '', 'DESC', '', $Blog->get_setting('posts_per_feed') );
}
else
{
	// Comments for the blog
	$CommentList = new CommentList( $Blog, "'comment'", array('published'), '', '', 'DESC', '', $Blog->get_setting('posts_per_feed') );
}

header_content_type( 'application/xml' ); // sets charset

echo '<?xml version="1.0" encoding="'.$io_charset.'"?'.'>';
?>
<rss version="0.92">
	<channel>
		<title><?php
			$Blog->disp( 'name', 'xml' );
			// title for the current request
			request_title( array(
				'title_before' => ' - ',
				'format' => 'xml',
			) ); ?></title>
		<link><?php $Blog->disp( 'lastcommentsurl', 'xml' ) ?></link>
		<description></description>
		<language><?php $Blog->disp( 'locale', 'xml' ) ?></language>
		<docs>http://backend.userland.com/rss092</docs>
		<?php while( $Comment = & $CommentList->get_next() )
		{
			// Loop through comments
			// Load comment's Item
			$Comment->get_Item();
			?>
		<item>
			<title><?php echo format_to_output( $Template->T_('In response to').':', 'xml' ) ?> <?php $Comment->Item->title( array( 'format' => 'xml', 'link_type' => 'none' ) ); ?></title>
			<description><?php echo make_rel_links_abs( $Comment->get_content('entityencoded') ); ?></description>
			<link><?php $Comment->permanent_url(); ?></link>
		</item>
		<?php 
	}
	?>
  </channel>
</rss>
<?php $Hit->log(); // log the hit on this page ?>
