<?php
/**
 * This file displays the navbar
 *
 * @copyright (c) 2009 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://www.gnu.org/licenses/gpl.txt GNU General Public License v3
 * @package admin
 */
if(!defined('QP_MAIN_INIT')) die('fail');

global $Blog;
global $Settings;
global $is_admin_page, $localtimenow, $disp_detail;
global $current_User;
global $home_url, $admin_url, $debug, $seo_page_type, $robots_index;
global $Hit;
global $Plugins;
global $topleft_Menu;
global $topright_Menu;

if( ! is_logged_in() )
{
	return;
}

$topleft_Menu = new Menu();
$topright_Menu = new Menu();

// Let the modules construct the menu
modules_call_method( 'build_navbar_menu' );

// Call AdminAfterNavbarInit to notify Plugins that the toolbar menus are initialized. Plugins can add entries
$Plugins->trigger_event( 'AdminAfterNavbarInit' );
?>

<div id="toolbar" class="toolbar_<?php echo $Hit->get_agent_name(); ?>">

<div class="actions_right">
<?php
// Display navbar menu
echo $topright_Menu->get_html_menu( NULL, 'sf-menu-right' );
?>
</div>

<div class="actions_left">
<?php
if( $is_admin_page || $current_User->check_perm( 'admin', 'visible' ) )
{
	// We are already in admin or we have permission to view admin options, display navbar menu
	echo $topleft_Menu->get_html_menu( NULL, 'sf-menu-left' );
	if( $debug )
	{
		echo '<div style="position:relative;left:5px;top:-8px;color:#999;z-index:-1;">'.$disp_detail.'</div>';
	}
}
?>
</div>

</div>
