<?php
/**
 * template when $disp == 'user'
 *
 * @todo (1111) core avatars removed from "$ProfileForm->begin_fieldset( T_('Identity') )",
 * might need to be a plugin hook?
 * @todo (0000) needs hooks for plugin profile bits
 *
 * @copyright (c) 2009 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://www.gnu.org/licenses/gpl.txt GNU General Public License v3
 * @package templates
 */
if(!defined('QP_MAIN_INIT')) die('fail');

$user_ID = param( 'user_ID', 'integer', '' );
if( empty( $user_ID ) )
{
	echo '<p class="error">'.T_('No user specified.').'</p>';
	return;
}

$UserCache = & get_Cache( 'UserCache' );
$User = & $UserCache->get_by_ID( $user_ID );

// form to update the profile
$ProfileForm = new Form( '', 'ProfileForm' );
$ProfileForm->begin_form( 'bComment' );
$ProfileForm->begin_fieldset( T_('Identity') );
$ProfileForm->info( T_('Name'), $User->get( 'preferredname' ) );
$ProfileForm->info( T_('Login'), $User->get( 'login' ) );
$msgform_url = $User->get_msgform_url( $Blog->get( 'msgformurl' ) );
if( ! empty( $msgform_url ) )
{
	$ProfileForm->info( T_('Contact'), '<a href="'.$msgform_url.'">'.T_('Send a message').'</a>' );
}
else
{
	$ProfileForm->info( T_('Contact'), T_('This user does not wish to be contacted directly.') );
}
if( ! empty( $User->url ) )
{
	$ProfileForm->info( T_('Website'), '<a href="'.$User->url.'" rel="nofollow" target="_blank">'.$User->url.'</a>' );
}
$ProfileForm->end_fieldset();

$ProfileForm->begin_fieldset( T_('Miscellaneous') );
$ProfileForm->info( T_('Locale'), $User->get( 'locale' ) );
$ProfileForm->info( T_('Level'), $User->get( 'level' ) );
$ProfileForm->info( T_('Posts'), $User->get( 'num_posts' ) );
$ProfileForm->end_fieldset();

$ProfileForm->end_form();
?>
