<?php
/**
 * html5 head template (sub-template)
 *
 * @copyright (c) 2009 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://creativecommons.org/licenses/by/3.0/us/ Creative Commons (Attribution)
 * @package templates
 * @subpackage CoolBlue
 */
if(!defined('QP_MAIN_INIT')) die('fail');

global $rsc_url;
global $srvc_url;

add_js_for_toolbar(); // registers javascripts for the navbar
if( $disp == '404' )
{
	header('HTTP/1.0 404 Not Found');
}
header_content_type(); // sets charset
?>
<!DOCTYPE html>
<html lang="<?php locale_lang(); ?>">
<head>
<?php
template_content_meta( 'html5' ); // Content-Type meta tag
template_base_tag(); // for css and img includes
// spark the plugin manager
$Plugins->trigger_event( 'TemplateBeginHtmlHead' );
?>
<title><?php // title for the current request
request_title( array(
	'auto_pilot' => 'seo_title'
) ); ?></title>
<?php
template_description_tag(); // description meta tag
template_keywords_tag(); // keywords meta tag
robots_tag(); // robots meta tag
if( $Blog->get_setting( 'feed_content' ) != 'none' )
{
	template_feed_tags();
}
?>
<link rel="EditURI" type="application/rsd+xml" title="RSD" href="<?php echo $srvc_url; ?>rsd.php?blog=<?php echo $Blog->ID; ?>" />
<meta name="viewport" content="width = 750" />
<?php
if( is_logged_in() )
{
	?>
	<link rel="stylesheet" type="text/css" href="<?php echo $rsc_url; ?>css/toolbar_debug.css" media="screen" />
	<?php
}
?>
<link rel="stylesheet" href="<?php echo $rsc_url; ?>css/basic.css" media="screen" />
<link rel="stylesheet" href="<?php echo $rsc_url; ?>css/blog_base.css" media="screen" />
<link rel="stylesheet" href="<?php echo $rsc_url; ?>css/item_base.css" media="screen" />
<link rel="stylesheet" href="style.css" media="screen" />
<link rel="stylesheet" href="print.css" media="print" />
<?php
include_headlines( 'html5' ); // output collected <head> lines
$Blog->disp( 'blog_css', 'raw'); // blog-specific css tweaks, if allowed
$Blog->disp( 'user_css', 'raw'); // user-specific css tweaks, if allowed
?>
<!--[if lt IE 9]><script src="<?php echo $rsc_url; ?>js/html5shiv.js"></script><![endif]-->
</head>

<body>
<?php
// spark the plugin manager
$Plugins->trigger_event( 'TemplateBeginHtmlBody' );

// --- --- --- --- --- --- --- --- --- --- ---
// --- TOOLBAR INCLUDED HERE ---
template_include( '_toolbar.inc.php' );

if( is_logged_in() )
{
	echo "\n".'<div id="template_wrapper" class="template_wrapper_loggedin">'."\n";
}
else
{
	echo "\n".'<div id="template_wrapper" class="template_wrapper_anonymous">'."\n";
}
?>
