<?php
/**
 * item block template (sub-template)
 *
 * @copyright (c) 2009 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://creativecommons.org/licenses/by/3.0/us/ Creative Commons (Attribution)
 * @package templates
 * @subpackage CoolBlue
 */
if(!defined('QP_MAIN_INIT')) die('fail');

global $Item;

// set some default params...
$params = array_merge( array(
	'content_mode' => 'auto',
	'item_class' => 'post',
	'image_size' => 'fit-520',
), $params );

$Item->locale_temp_switch(); // temporarily switch to item's locale
?>

<article class="<?php echo $params['item_class'] ?>" lang="<?php $Item->lang(); ?>">
<div class="primary">
<?php
// display and link item title
$Item->title( array(
	'before' => '<h2>',
	'after' => '</h2>',
) );

// display and link categories by name
$Item->categories( array(
	'before' => '<p class="categories"><span>'.$Template->T_('filed under').'</span> ',
	'after' => '</p>',
	'before_main' => '<strong>',
	'after_main' => '</strong>',
) );

// --- --- --- --- --- --- --- --- --- --- ---
// --- POST CONTENT INCLUDED HERE ---
template_include( '_item_content.inc.php', $params );
?>
</div>

<footer>
<?php
if( ! $Item->is_intro() )
{
	// display issue date/time of item
	$Item->issue_date( array(
		'before' => '<p class="dateinfo">',
		'after' => '</p>',
		'date_format' => 'M<\sp\a\n>d</\sp\a\n>',
	) );
}
?>
<div class="info">
<h4><?php echo $Template->T_('Post Info'); ?></h4>
<ul>
<?php
// display author/creator of item
$Item->author( array(
	'before' => '<li class="user">',
	'after' => '</li>',
	'link_to' => 'userurl',
) );

// displays message form link to item's author
$Item->msgform_link( array(
	'before' => '<li class="contact">',
	'after' => '</li>',
	'text' => $Template->T_('Contact'),
) );

if( ! $Item->is_intro() )
{
	// display issue date/time of item
	$Item->issue_time( array(
		'before' => '<li class="time">',
		'after' => '</li>',
		'time_format' => 'g:i A',
	) );
}

// display the item's permalink
$Item->permanent_link( array(
	'before' => '<li class="permalink">',
	'after' => '</li>',
	'text' =>'#text#',
) );

if( ! $Item->is_intro() )
{
	// display link to (and count of) comments and trackbacks
	$Item->feedback_link( array(
		'link_before' => '<li class="comment">',
		'link_after' => '</li>',
	) );
}

// display link to edit this item
$Item->edit_link( array(
	'before' => '<li class="edit">',
	'after' => '</li>',
	'text' => $Template->T_('Edit...'),
) );

// display the item's tags
$Item->tags( array(
	'before' => '<li class="tags">'.$Template->T_('Tags').':<br /> ',
	'after' => '</li>',
) );
?>
</ul>
</div>
</footer>

</article>

<?php
locale_restore_previous(); // restores previous locale
?>
