<?php
/**
 * this template's class file
 *
 * @copyright (c) 2009 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://creativecommons.org/licenses/by/3.0/us/ Creative Commons (Attribution)
 * @package templates
 * @subpackage CoolBlue
 */
if(!defined('QP_MAIN_INIT')) die('fail');

/**
 * darkdragon_Template class
 *
 * @package templates
 * @subpackage CoolBlue
 */
class coolblue_Template extends Template
{
	var $container_order = array( 'Sidebar','Long Footer','Footer A','Footer B','Footer C','Footer D' );
	var $folder = 'coolblue';
	var $name = 'Cool Blue';
	var $type = 'html5';
	var $version = '1.0';

	/**
	 * Get the widgets for this template
	 *
	 * @see Template::get_default_widgets()
	 */
	function get_default_widgets( $params = array() )
	{
		// Containers (each container needs to be an array to hold arrays)
		$template_widgets = array(
			'Sidebar' => array(),
			'Long Footer' => array(),
		);

		// Sidebar widgets
		$template_widgets['Sidebar'][] = array(
			'longdesc' => array(
				'type' => 'widget',
			),
			'category_list' => array(
				'type' => 'widget',
			),
		);

		// Footer widgets
		$template_widgets['Long Footer'][] = array(
			'user_tools' => array(
				'type' => 'widget',
			),
		);

		return $template_widgets;
	}


	/**
	 * Get credits for linkbacks
	 *
	 * @see Template::get_template_credits()
	 */
	function get_template_credits()
	{
		$template_linkbacks = array(
			'designer' => array(
				'pre' => $this->T_('Design by'),
				'text' => 'styleshout.com',
				'url' => 'http://www.styleshout.com/templates/preview/CoolBlue11/index.html',
				'title' => 'Free CSS Website Templates & Resources',
				'post' => $this->T_('CoolBlue is a free website template by <a href="http://www.styleshout.com/">styleshout.com</a>. This work is released and licensed under the <a rel="license" href="http://creativecommons.org/licenses/by/3.0/">Creative Commons Attribution 3.0 License</a>, which means that you are free to use and modify it for any personal or commercial purpose. All I ask is that you give me credit by including a link back to <a href="http://www.styleshout.com/">my website</a>.<br />If you don\'t want to link back to styleshout.com, you can always pay a link removal fee of $10 USD. This will allow you to use the template link free on ONE DOMAIN name. Also, kindly send me the site\'s url so I can include it on my list of verified users.<br />You can send your payments through Paypal to this address: ealigam@gmail.com'),
			),
			'ported' => array(
				'pre' => $this->T_('Ported by'),
				'text' => 'EdB',
				'url' => 'http://1912webworks.com/',
				'title' => 'web engine tune-up specialist',
				'post' => $this->T_('Lorem ipsum dolor sit amet, consectetuer adipiscing elit.'),
			),
			'license' => array(
				'pre' => $this->T_('License'),
				'text' => 'CC By-SA 3.0',
				'url' => 'http://creativecommons.org/licenses/by-sa/3.0/',
				'title' => 'CC By-SA 3.0',
				'post' => $this->T_('Attribution-ShareAlike 3.0 Unported (CC BY-SA 3.0)'),
			),


		);
		return $template_linkbacks;
	}

}

?>
