<?php
/**
 * Primary / default template file
 *
 * @copyright (c) 2009 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://creativecommons.org/licenses/by/3.0/us/ Creative Commons (Attribution)
 * @package templates
 * @subpackage CoolBlue
 */
if(!defined('QP_MAIN_INIT')) die('fail');

template_init( $disp ); // do $disp-based initializations...

// --- --- --- --- --- --- --- --- --- --- ---
// --- HTML HEADER INCLUDED HERE ---
template_include( '_html5_header.inc.php' );
?>

<header>
<div id="MastHead">
<?php
// display the Public Blog List widget
template_widget( array(
	'widget' => 'bloglist',
	'block_start' => '<nav>',
	'block_end' => '</nav>',
	'block_display_title' => false,
	'item_selected_start' => '<li id="current">',
	'item_selected_end' => '<span></span></li>',
) );

// display a link to contact the current blog owner
$Blog->contact_link( array(
		'before' => '<div class="tools">',
		'after' => ' || ',
		'text' => T_('Contact'),
		'title' => T_('Send a message to the owner of this website...'),
	) );
// display a link to the admin side of town
user_admin_link( '', '</div>' );

// display the Title widget
template_widget( array(
	'widget' => 'title',
	'block_start' => '<hgroup>',
	'block_end' => '',
	'block_title_start' => '<h1>',
	'block_title_end' => '</h1>',
) );
// display the Tagline widget
template_widget( array(
	'widget' => 'tagline',
	'block_start' => '<h4>',
	'block_end' => '</h4></hgroup>',
) );
?>
</div>
</header>

<div id="PageBody">
<div id="Content" class="clearfix">
<div id="main">
<?php
// messages generated from actions
messages( array() );

// title for the current request
request_title( array(
	'title_before' => '<h2>',
	'title_after' => '</h2>',
	'title_single_disp' => false,
) );

// display a message if list is empty
display_if_empty( array() );

// prev/next links in single post mode
item_prevnext_links( array(
	'block_start' => '<table class="prevnext_post"><tr>',
	'prev_start' => '<td>',
	'prev_end' => '</td>',
	'next_start' => '<td class="right">',
	'next_end' => '</td>',
	'block_end' => '</tr></table>',
) );

// do we have a featured/intro item to display?
if( $Item = & get_featured_Item() )
{
	// --- --- --- --- --- --- --- --- --- --- ---
	// --- ITEM BLOCK INCLUDED HERE ---
	template_include( '_item_block.inc.php', array(
		'content_mode' => 'auto',
		'intro_mode' => 'normal',
		'item_class' => 'post featured',
	) );
}

// loop through as long as we have an Item...
while( $Item = & mainlist_get_item() )
{
	// --- --- --- --- --- --- --- --- --- --- ---
	// --- ITEM BLOCK INCLUDED HERE ---
	template_include( '_item_block.inc.php', array(
		'content_mode' => 'auto',
	) );

	// --- --- --- --- --- --- --- --- --- --- ---
	// --- ITEM FEEDBACK INCLUDED HERE ---
	template_include( '_item_feedback.inc.php', array(
		'before_section_title' => '<h3>',
		'after_section_title' => '</h3>',
	) );
}

// prev/next links on multi-post pages
mainlist_page_links( array(
	'block_start' => '<div class="navigation">',
	'block_end' => '</div>',
) );

// --- --- --- --- --- --- --- --- --- --- ---
// --- MAIN CONTENT INCLUDED HERE ---
template_include( '$disp$', array(
	// these cases already handled by this file
	'disp_posts' => '',
	'disp_single' => '',
	'disp_intro' => '',
	'disp_page' => '',
) );
?>
</div><?php // closes <div id="main"> ?>

<?php
// --- --- --- --- --- --- --- --- --- --- ---
// display "Sidebar" container's contents
template_container( NT_('Sidebar'), array(
	'container_start' => '<aside>',
	'container_end' => '</aside>',
	'block_start' => '<div class="sideitem">',
	'block_end' => '</div>',
) );
?>
</div><?php // closes <div id="content" class="clearfix"> ?>
</div><?php // closes <div id="PageBody"> ?>

<?php
// --- --- --- --- --- --- --- --- --- --- ---
// --- HTML HEADER INCLUDED HERE ---
template_include( '_footer.inc.php' );

// spark the plugin manager
$Plugins->trigger_event( 'TemplateEndHtmlBody' );
debug_info(); // output debug info if requested
?>
</div><?php // closes <div id="template_wrapper"> ?>
</body>
</html>
<?php $Hit->log(); // log the hit on this page ?>
