<?php
/**
 * this template's class file
 *
 * @copyright (c) 2009 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://creativecommons.org/licenses/by/3.0/us/ Creative Commons (Attribution)
 * @package templates
 * @subpackage darkdragon
 */
if(!defined('QP_MAIN_INIT')) die('fail');

/**
 * darkdragon_Template class
 *
 * @package templates
 * @subpackage darkdragon
 */
class darkdragon_Template extends Template
{
	var $container_order = array( 'Header','Menu','Sidebar','Footer' );
	var $folder = 'darkdragon';
	var $name = 'Dark Dragon';
	var $type = 'html5';
	var $version = '1.0';

	/**
	 * Get the widgets for this template
	 *
	 * @see Template::get_default_widgets()
	 */
	function get_default_widgets( $params = array() )
	{
		global $app_baseurl;

		// Containers (each container needs to be an array to hold arrays)
		$template_widgets = array(
			'Header' => array(),
			'Menu' => array(),
			'Sidebar' => array(),
			'Footer' => array(),
		);
		// Header widgets
		$template_widgets['Header'][] = array(
			'bloglist' => array(
				'type' => 'widget',
				'params' => array( 'blog_list_type' => ( $params['Blog']->get( 'in_bloglist' ) ? 'public' : 'owner' ) ),
			),
		);
		// Menu widgets
		$template_widgets['Menu'][] = array(
			'page_list' => array(
				'type' => 'widget',
			),
		);
		// Sidebar widgets
		$template_widgets['Sidebar'][] = array(
			'logo' => array(
				'type' => 'widget',
			),
			'linkblog' => array(
				'type' => 'widget',
				'params' => array( 'blog_ID' => 3 ),
			),
			'category_list' => array(
				'type' => 'widget',
			),
			'free_html' => array(
				'type' => 'widget',
				'params' => array( 'content' => '<p>Everything in this sidebar is a widget in the sidebar container. On your <a href="'.$app_baseurl.'admin.php?ctrl=widgets&blog=1">Blog settings -> Widgets</a> tab you can add or remove widgets, and shuffle them around as you see fit.</p>' ),
			),
		);
		// Footer widgets
		$template_widgets['Footer'][] = array(
			'user_tools' => array(
				'type' => 'widget',
			),
		);

		return $template_widgets;
	}


	/**
	 * Get credits for linkbacks
	 *
	 * @see Template::get_template_credits()
	 */
	function get_template_credits()
	{
		$template_linkbacks = array(
			'designer' => array(
				'pre' => $this->T_('Design by'),
				'text' => 'Free HTML5 Templates',
				'url' => 'http://freehtml5templates.com/darkdragon-html5-and-css3-template/',
				'title' => 'Free HTML5 Templates | Bringing modern web standards to everyone',
				'post' => $this->T_('DarkDragon is a dark 2-column HTML5 and CSS3 template with a gothic medieval style. Makes use of slight gradient backgrounds, @font-face for the heading title and text shadows.'),
			),
			'ported' => array(
				'pre' => $this->T_('Ported by'),
				'text' => 'EdB',
				'url' => 'http://1912webworks.com/',
				'title' => 'web engine tune-up specialist',
				'post' => $this->T_('Lorem ipsum dolor sit amet, consectetuer adipiscing elit.'),
			),
			'license' => array(
				'pre' => $this->T_('License'),
				'text' => 'CC By-SA 3.0',
				'url' => 'http://creativecommons.org/licenses/by-sa/3.0/',
				'title' => 'CC By-SA 3.0',
				'post' => $this->T_('Attribution-ShareAlike 3.0 Unported (CC BY-SA 3.0)'),
			),


		);
		return $template_linkbacks;
	}

}

?>
