<?php
/**
 * Primary / default template file
 *
 * @copyright (c) 2009 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://creativecommons.org/licenses/by/3.0/us/ Creative Commons (Attribution)
 * @package templates
 * @subpackage darkdragon
 */
if(!defined('QP_MAIN_INIT')) die('fail');

template_init( $disp ); // do $disp-based initializations...

// --- --- --- --- --- --- --- --- --- --- ---
// --- HTML HEADER INCLUDED HERE ---
template_include( '_html5_header.inc.php' );

// --- --- --- --- --- --- --- --- --- --- ---
// display "Menu" container's widgets
template_container( NT_('Header'), array(
	'container_start' => '<nav id="bloglist"><ul>',
	'container_end' => '</ul></nav>',
	'block_start' => '',
	'block_end' => '',
	'block_display_title' => false,
	'list_start' => '',
	'list_end' => '',
) );
?>

<div id="wrapper">
<header>
<div id="headerlogo"><img src="images/dragon.png" title="<?php $Blog->disp( 'tagline', 'htmlbody' ); ?>" alt="<?php $Blog->disp( 'tagline', 'htmlbody' ); ?>" width="237" height="271" /></div>
<h1><a href="<?php $Blog->disp( 'url' ); ?>" title="<?php $Blog->disp( 'tagline' ); ?>"><?php $Blog->disp( 'name' ); ?></a></h1>
<p><?php $Blog->disp( 'longdesc', 'htmlbody' ); ?></p>
</header>

<?php
// --- --- --- --- --- --- --- --- --- --- ---
// display "Menu" container's widgets
template_container( NT_('Menu'), array(
	'container_start' => '<nav id="pages"><ul>',
	'container_end' => '</ul></nav>',
	'block_start' => '',
	'block_end' => '',
	'block_display_title' => false,
	'list_start' => '',
	'list_end' => '',
) );
?>

<section id="main">
<?php
// do we have a featured/intro item to display?
if( $Item = & get_featured_Item() )
{
	// --- --- --- --- --- --- --- --- --- --- ---
	// --- ITEM BLOCK INCLUDED HERE ---
	template_include( '_item_block_featured.inc.php', array(
		'content_mode' => 'auto',
		'intro_mode' => 'normal',
		'item_class' => 'featured_post',
		'image_size' => 'fit-560',
	) );
}
?>

<section id="content">
<?php
// messages generated from actions
messages( array() );
// prev/next links in single post mode
item_prevnext_links( array(
	'block_start' => '<table class="prevnext_post"><tr>',
	'prev_start' => '<td>',
	'prev_end' => '</td>',
	'next_start' => '<td class="right">',
	'next_end' => '</td>',
	'block_end' => '</tr></table>',
) );
// title for the current request
request_title( array(
	'title_before' => '<h2>',
	'title_after' => '</h2>',
	'title_single_disp' => false,
	'title_page_disp' => false,
) );

// display a message if list is empty
display_if_empty( array() );

// loop through as long as we have an Item...
while( $Item = & mainlist_get_item() )
{
	// --- --- --- --- --- --- --- --- --- --- ---
	// --- ITEM BLOCK INCLUDED HERE ---
	template_include( '_item_block.inc.php', array(
		'content_mode' => 'auto',
		'image_size' => 'fit-560',
	) );
}

// --- --- --- --- --- --- --- --- --- --- ---
// --- MAIN CONTENT INCLUDED HERE ---
template_include( '$disp$', array(
	// these cases already handled by this file
	'disp_posts' => '',
	'disp_single' => '',
	'disp_page' => '',
) );
// prev/next links on multi-post pages
mainlist_page_links( array(
	'block_start' => '<nav>'.$Template->T_('Pages:').' <strong>',
	'block_end' => '</strong></nav>',
) );
?>
</section>

<?php
// prev/next links on multi-post pages
mainlist_page_links( array(
	'block_start' => '<nav class="center">',
	'block_end' => '</nav>',
) );

// --- --- --- --- --- --- --- --- --- --- ---
// display "Sidebar" container's contents
template_container( NT_('Sidebar'), array(
	'container_start' => '<aside id="sidebar">',
	'container_end' => '</aside>',
	'block_start' => '<div class="sideitem">',
	'block_end' => '</div>',
) );
?>
</section>

<footer id="footer">
<?php
// --- --- --- --- --- --- --- --- --- --- ---
// display "Footer" container's widgets
template_container( NT_('Footer'), array(
	'container_start' => '',
	'container_end' => '',
	'block_start' => '<aside class="footer-segment">',
	'block_end' => '</aside>',
	'list_start' => '',
	'list_end' => '',
	'item_start' => ' &bull; ',
	'item_end' => '',
) );
?>
<p>
<?php
// display the current blog's footer text
$Blog->footer_text( array(
	'after' => ' &bull; ',
) );

// display a link to contact the current blog owner
$Blog->contact_link( array(
	'after' => ' &bull; ',
) );

// display a link to this blog's credits page
$Blog->credits_link( array() );
?>
</p>
</footer>

</div>

<?php
// spark the plugin manager
$Plugins->trigger_event( 'TemplateEndHtmlBody' );
debug_info(); // output debug info if requested
?>
</div></body></html><?php // opened by _html5_header.inc.php ?>
<?php $Hit->log(); // log the hit on this page ?>
