<?php
/**
 * template when $disp == 'page'
 *
 * @copyright (c) 2009 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://www.gnu.org/licenses/gpl.txt GNU General Public License v3
 * @package templates
 * @subpackage evocamp
 */
if(!defined('QP_MAIN_INIT')) die('fail');

template_init( $disp ); // do $disp-based initializations...

// --- --- --- --- --- --- --- --- --- --- ---
// --- HTML HEADER INCLUDED HERE ---
template_include( '_xhtml_header.inc.php' );

// --- --- --- --- --- --- --- --- --- --- ---
// --- BODY HEADER INCLUDED HERE ---
template_include( '_body_header.inc.php' );
?>

<div id="page">

<div id="contentleft">
<?php
// --- --- --- --- --- --- --- --- --- --- ---
// --- LEFT SIDEBAR INCLUDED HERE ---
template_include( '_sidebar.inc.php', array() );
?>

<div id="content">
<?php
// messages generated from actions
messages( array() );

// display a message if list is empty
display_if_empty( array() );

// loop through as long as we have an Item...
while( $Item = & mainlist_get_item() )
{
	$Item->locale_temp_switch(); // temporarily switch to item's locale
	?>

	<div id="<?php $Item->anchor_id(); ?>" lang="<?php $Item->lang(); ?>">
	<h2 class="sectionhead">
	<?php
	// display link to edit this item
	$Item->edit_link( array(
		'after' => '',
		'class' => 'floatright',
	) );

	// display and link item title
	$Item->title( array() );
	?>
	</h2>

	<div class="post post<?php $Item->status_raw(); ?>">
	<?php
	// --- --- --- --- --- --- --- --- --- --- ---
	// --- POST CONTENT INCLUDED HERE ---
	template_include( '_item_content.inc.php', array() );
	?>
	</div>

	<?php
	// --- --- --- --- --- --- --- --- --- --- ---
	// --- ITEM FEEDBACK INCLUDED HERE ---
	template_include( '_item_feedback.inc.php', array(
		'before_section_title' => '<h3 class="feedback_section">',
		'after_section_title' => '</h3>',
		'form_title_start' => '<h3 class="comment_form_title">',
		'form_title_end' => '</h3>',
	) );
	?>
	</div>

	<?php
	locale_restore_previous(); // restores previous locale

}
?>
</div>

</div>

<?php
// --- --- --- --- --- --- --- --- --- --- ---
// --- RIGHT SIDEBAR INCLUDED HERE ---
template_include( '_sidebar_2.inc.php' );
?>
</div>

<?php
// --- --- --- --- --- --- --- --- --- --- ---
// --- BODY FOOTER INCLUDED HERE ---
template_include( '_body_footer.inc.php' );
?>
