<?php
/**
 * template for multipost pages
 *
 * @copyright (c) 2009 by {@link http://quamplures.net/ the Quam Plures project}
 * @copyright (c) 2007 by {@link http://fplanque.net/ Francois PLANQUE}
 * @package templates
 * @subpackage evocamp
 */
if(!defined('QP_MAIN_INIT')) die('fail');

template_init( $disp ); // do $disp-based initializations...

// --- --- --- --- --- --- --- --- --- --- ---
// --- HTML HEADER INCLUDED HERE ---
template_include( '_xhtml_header.inc.php' );

// --- --- --- --- --- --- --- --- --- --- ---
// --- BODY HEADER INCLUDED HERE ---
template_include( '_body_header.inc.php' );
?>

<div id="page">

<div id="contentleft">
<?php
// do we have a featured/intro item to display?
if( $Item = & get_featured_Item() )
{
	// --- --- --- --- --- --- --- --- --- --- ---
	// --- ITEM BLOCK INCLUDED HERE ---
	template_include( '_item_block.inc.php', array(
		'content_mode' => 'auto',
		'intro_mode' => 'normal',
		'item_class' => 'featurepost',
	) );
}

// --- --- --- --- --- --- --- --- --- --- ---
// --- LEFT SIDEBAR INCLUDED HERE ---
template_include( '_sidebar.inc.php', array() );
?>

<div id="content">
<?php
// title for the current request
request_title( array(
	'title_before' => '<h2 class="sectionhead">',
	'title_after' => '</h2>',
) );

// messages generated from actions
messages( array() );

// display a message if list is empty
display_if_empty( array() );

// loop through as long as we have an Item...
while( $Item = & mainlist_get_item() )
{
	// --- --- --- --- --- --- --- --- --- --- ---
	// --- ITEM BLOCK INCLUDED HERE ---
	template_include( '_item_block.inc.php', array(
		'content_mode' => 'auto',
	) );
}

// prev/next links on multi-post pages
mainlist_page_links( array(
	'block_start' => '<div class="navigation">',
	'block_end' => '</div>',
) );
?>
</div>

</div>

<?php
// --- --- --- --- --- --- --- --- --- --- ---
// --- RIGHT SIDEBAR INCLUDED HERE ---
template_include( '_sidebar_2.inc.php' );
?>
</div>

<?php
// --- --- --- --- --- --- --- --- --- --- ---
// --- BODY FOOTER INCLUDED HERE ---
template_include( '_body_footer.inc.php' );
?>
