<?php
/**
 * template when $disp == 'single'
 *
 * @copyright (c) 2009 by {@link http://quamplures.net/ the Quam Plures project}
 * @package templates
 * @subpackage evocamp
 */
if(!defined('QP_MAIN_INIT')) die('fail');

template_init( $disp ); // do $disp-based initializations...

// --- --- --- --- --- --- --- --- --- --- ---
// --- HTML HEADER INCLUDED HERE ---
template_include( '_xhtml_header.inc.php' );

// --- --- --- --- --- --- --- --- --- --- ---
// --- BODY HEADER INCLUDED HERE ---
template_include( '_body_header.inc.php' );
?>

<div id="page">

<div id="contentleft">
<?php
// --- --- --- --- --- --- --- --- --- --- ---
// --- LEFT SIDEBAR INCLUDED HERE ---
template_include( '_sidebar.inc.php', array() );
?>

<div id="content">
<?php
// messages generated from actions
messages( array() );

// display a message if list is empty
display_if_empty( array() );

// loop through as long as we have an Item...
while( $Item = & mainlist_get_item() )
{
	$Item->locale_temp_switch(); // temporarily switch to item's locale
	?>

	<div id="<?php $Item->anchor_id(); ?>" class="post post<?php $Item->status_raw(); ?>" lang="<?php $Item->lang(); ?>">
	<?php
	// display and link item title
	$Item->title( array(
		'before' => '<h2>',
		'after' => '</h2>',
	) );
	?>
	<p class="postinfo">
	<?php
	// display author/creator of item
	$Item->author( array(
		'before' => $Template->T_('By').' ',
	) );

	// display issue date/time of item
	$Item->issue_date( array(
		'before' => /* TRANS: date */ $Template->T_('on').' ',
		'date_format' => 'M j, Y',
		'after' => '',
	) );

	// display and link categories by name
	$Item->categories( array(
		'before' => ' | '.$Template->T_('In').' ',
	) );

	// display link to (and count of) comments and trackbacks
	$Item->feedback_link( array(
		'link_before' => ' | ',
	) );

	// display link to edit this item
	$Item->edit_link( array(
		'before' => ' | ',
		'after' => '',
	) );
	?></p>
	<?php
	// --- --- --- --- --- --- --- --- --- --- ---
	// --- POST CONTENT INCLUDED HERE ---
	template_include( '_item_content.inc.php', array() );

	// display the item's tags
	$Item->tags( array(
		'before' => '<div class="posttags">'.$Template->T_('Tags').': ',
	) );
	?>
	</div>

	<?php
	// --- --- --- --- --- --- --- --- --- --- ---
	// --- ITEM FEEDBACK INCLUDED HERE ---
	template_include( '_item_feedback.inc.php', array(
		'before_section_title' => '<h3 class="feedback_section">',
		'after_section_title' => '</h3>',
		'form_title_start' => '<h3 class="comment_form_title">',
		'form_title_end' => '</h3>',
	) );

	locale_restore_previous(); // restores previous locale

}

// prev/next links in single post mode
item_prevnext_links( array(
	'block_start' => '<table class="prevnext_post"><tr>',
	'prev_start' => '<td>',
	'prev_end' => '</td>',
	'next_start' => '<td class="right">',
	'next_end' => '</td>',
	'block_end' => '</tr></table>',
) );
?>
</div>

</div>

<?php
// --- --- --- --- --- --- --- --- --- --- ---
// --- RIGHT SIDEBAR INCLUDED HERE ---
template_include( '_sidebar_2.inc.php' );
?>
</div>

<?php
// --- --- --- --- --- --- --- --- --- --- ---
// --- BODY FOOTER INCLUDED HERE ---
template_include( '_body_footer.inc.php' );
?>
