<?php
/**
 * item block template (sub-template)
 *
 * @author {@link http://wonderwinds.com/ Ed Bennett}
 * @author {@link http://www.tenderfeelings.be/ Tender Feelings}
 * @author {@link http://www.ndesign-studio.com/ Nick La}
 * @copyright (c) 2009 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://www.gnu.org/licenses/gpl.txt GNU General Public License v3
 * @package templates
 * @subpackage glossyblue
 */
if(!defined('QP_MAIN_INIT')) die('fail');

global $Item;

// set some default params...
$params = array_merge( array(
	'content_mode' => 'auto',
	'item_class' => 'post',
	'content_start_excerpt' => '<div class="content_excerpt entry">',
	'content_end_excerpt' => '</div>',
	'content_start_full' => '<div class="content_full">',
	'content_end_full' => '</div>',
	'image_size' => 'fit-440',
	'image_link_to' => '',
), $params );

$Item->locale_temp_switch(); // temporarily switch to item's locale
?>

<div id="<?php $Item->anchor_id(); ?>" class="<?php $Item->div_classes( $params ); ?>" lang="<?php $Item->lang(); ?>">
<?php
if( ! $Item->is_intro() )
{
	?>
	<div class="post-date">
	<?php
	// display issue date/time of item
	$Item->issue_date( array(
		'before' => '<span class="post-month">',
		'after' => '</span>',
		'date_format' => 'M',
	) );

	// display issue date/time of item
	$Item->issue_date( array(
		'before' => '<span class="post-day">',
		'after' => '</span>',
		'date_format' => 'd',
	) );
	?>
	</div>
	<?php
}
?>

<div class="post-title">
<?php
// display and link item title
$Item->title( array(
	'before' => '<h2>',
	'after' => '</h2>',
) );

// display and link categories by name
$Item->categories( array(
	'before' => '<span class="post-cat">',
	'after' => '</span> ',
) );

// display link to (and count of) comments and trackbacks
$Item->feedback_link( array(
	'link_before' => '<span class="post-comments">',
	'link_after' => '</span>',
) );
?>
</div>

<?php
// --- --- --- --- --- --- --- --- --- --- ---
// --- POST CONTENT INCLUDED HERE ---
template_include( '_item_content.inc.php', $params );
?>

<p class="postmetadata alt small">
<?php
// display the item's tags
$Item->tags( array(
	'before' => $Template->T_('Tags').': ',
	'after' => ' ',
) );

// display link to edit this item
$Item->edit_link( array(
	'after' => '',
) );
?>
</p>

<?php
locale_restore_previous(); // restores previous locale
?>
</div>
