<?php
/**
 * template for multipost pages
 *
 * @author {@link http://wonderwinds.com/ Ed Bennett}
 * @author {@link http://www.tenderfeelings.be/ Tender Feelings}
 * @author {@link http://www.ndesign-studio.com/ Nick La}
 * @copyright (c) 2009 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://www.gnu.org/licenses/gpl.txt GNU General Public License v3
 * @package templates
 * @subpackage glossyblue
 */
if(!defined('QP_MAIN_INIT')) die('fail');

template_init( $disp ); // do $disp-based initializations...

// --- --- --- --- --- --- --- --- --- --- ---
// --- HTML HEADER INCLUDED HERE ---
template_include( '_xhtml_header.inc.php' );

// --- --- --- --- --- --- --- --- --- --- ---
// --- BODY HEADER INCLUDED HERE ---
template_include( '_body_header.inc.php' );
?>

<div id="content">
<?php
// messages generated from actions
messages( array() );

// title for the current request
request_title( array(
	'title_before' => '<h2>',
	'title_after' => '</h2>',
) );

// do we have a featured/intro item to display?
if( $Item = & get_featured_Item() )
{
	// --- --- --- --- --- --- --- --- --- --- ---
	// --- ITEM BLOCK INCLUDED HERE ---
	template_include( '_item_block.inc.php', array(
		'content_mode' => 'auto',
		'intro_mode' => 'normal',
		'item_class' => 'featured_post',
	) );
}

// display a message if list is empty
display_if_empty( array() );

// loop through as long as we have an Item...
while( $Item = & mainlist_get_item() )
{
	// --- --- --- --- --- --- --- --- --- --- ---
	// --- ITEM BLOCK INCLUDED HERE ---
	template_include( '_item_block.inc.php', array(
		'content_mode' => 'auto',
	) );
}

// prev/next links on multi-post pages
mainlist_page_links( array(
	'block_start' => '<div class="navigation">',
	'block_end' => '</div>',
) );
?>
</div>

<?php
// --- --- --- --- --- --- --- --- --- --- ---
// --- SIDEBAR INCLUDED HERE ---
template_include( '_sidebar.inc.php', array() );

// --- --- --- --- --- --- --- --- --- --- ---
// --- BODY FOOTER INCLUDED HERE ---
template_include( '_body_footer.inc.php' );
?>
