<?php
/**
 * item block template (sub-template)
 *
 * @author {@link http://wonderwinds.com/ Ed Bennett}
 * @author {@link http://freehtml5templates.com/ Gekko}
 * @copyright (c) 2013 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://creativecommons.org/licenses/by/3.0/us/ Creative Commons (Attribution)
 * @package templates
 * @subpackage grungefx
 */
if(!defined('QP_MAIN_INIT')) die('fail');

global $Item;

// set some default params...
$params = array_merge( array(
	'content_mode' => 'auto',
	'item_class' => 'bPost',
), $params );

$Item->locale_temp_switch(); // temporarily switch to item's locale
?>

<article id="<?php $Item->anchor_id(); ?>" lang="<?php $Item->lang(); ?>">
<header class="article">
<?php
// display the item's locale flag
$Item->locale_flag( array(
	'after' => ' ',
) );

// display issue date/time of item
$Item->issue_date( array(
	'after' => ' @ ',
) );

$Item->issue_time( array(
	'after' => ', ',
) );

// display word count
$Item->wordcount( array(
	'after' => ' '.$Template->T_('words'),
) );

// display and link item title
$Item->title( array(
	'before' => '<h3>',
	'after' => '</h3>',
) );
?>
</header>

<?php
// --- --- --- --- --- --- --- --- --- --- ---
// --- POST CONTENT INCLUDED HERE ---
template_include( '_item_content.inc.php', $params );
?>

<footer>
<?php
// display the item's permalink
$Item->permanent_link( array(
	'class' => 'permalink_right',
) );

// display author/creator of item
$Item->author( array(
	'before' => $Template->T_('By').' ',
) );

// display message form link to item's author
$Item->msgform_link( array(
	'after' => ' &middot; ',
) );

// display and link categories by name
$Item->categories( array(
	'before' => $Template->T_('Categories').': ',
) );

// display the item's tags
$Item->tags( array(
	'before' => ' &middot; '.$Template->T_('Tags').': ',
	'after' => '',
) );

// display link to (and count of) comments only
$Item->feedback_link( array(
	'type' => 'comments',
	'link_before' => ' &middot; ',
) );

// display link to (and count of) trackbacks only
$Item->feedback_link( array(
	'type' => 'trackbacks',
	'link_before' => ' &middot; ',
) );

// display link to edit this item
$Item->edit_link( array(
	'before' => ' &middot; ',
	'after' => '',
) );
?>
</footer>

<?php
// --- --- --- --- --- --- --- --- --- --- ---
// --- ITEM FEEDBACK INCLUDED HERE ---
template_include( '_item_feedback.inc.php', array(
	'before_section_title' => '<h4>',
	'after_section_title' => '</h4>',
) );

locale_restore_previous(); // restores previous locale
?>
</article>
