<?php
/**
 * item content template (sub-template)
 *
 * @author {@link http://wonderwinds.com/ Ed Bennett}
 * @author {@link http://freehtml5templates.com/ Gekko}
 * @copyright (c) 2013 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://creativecommons.org/licenses/by/3.0/us/ Creative Commons (Attribution)
 * @package templates
 * @subpackage grungefx
 */
if(!defined('QP_MAIN_INIT')) die('fail');

global $disp_detail;

// set some default params...
$params = array_merge( array(
	'content_mode' => 'auto',
	'intro_mode' => 'auto',
	'force_more' => false,
	'content_start_excerpt' => '',
	'content_end_excerpt' => '',
	'content_start_full' => '',
	'content_end_full' => '',
	'excerpt_before_text' => '<div class="excerpt">',
	'excerpt_after_text' => '</div>',
	'excerpt_before_more' => ' <span class="excerpt_more">',
	'excerpt_after_more' => '</span>',
	'excerpt_more_text' => T_('more').' &raquo;',
	'limit_files' => 1000,
	'file_list_start' => '<div class="attachments"><h3>'.T_('Attachments').':</h3><ul>',
	'file_list_end' => '</ul></div>',
	'file_start' => '<li>',
	'file_end' => '</li>',
	'before_file_size' => ' <span class="file_size">',
	'after_file_size' => '</span>',
	), $params );

if( $Item->is_intro() )
{
	$content_mode = $params['intro_mode'];
}
else
{
	$content_mode = $params['content_mode'];
}
if( $content_mode == 'auto' )
{
	switch( $disp_detail )
	{
		case 'posts-cat':
		$content_mode = $Blog->get_setting( 'category_content' );
		break;

		case 'posts-tag':
		$content_mode = $Blog->get_setting( 'tag_content' );
		break;

		case 'posts-date':
		$content_mode = $Blog->get_setting( 'archive_content' );
		break;

		case 'posts-filtered':
		$content_mode = $Blog->get_setting( 'filtered_content' );
		break;

		case 'posts-default': // home page 1
		case 'posts-next': // next page 2, 3, etc
		default:
		$content_mode = $Blog->get_setting( 'main_content' );
	}
}

switch( $content_mode )
{
	case 'excerpt':
	// Reduced display:
	echo $params['content_start_excerpt'];

	// Display images that are linked to this post:
	$Item->images( array_merge( array(
		'before' => '<div class="bImages">',
		'image_link_to' => 'single',
	), $params ) );

	$Item->excerpt( array(
		'before' => $params['excerpt_before_text'],
		'after' => $params['excerpt_after_text'],
		'excerpt_before_more' => $params['excerpt_before_more'],
		'excerpt_after_more' => $params['excerpt_after_more'],
		'excerpt_more_text' => $params['excerpt_more_text'],
	) );

	echo $params['content_end_excerpt'];
	break;

	case 'full':
	$params['force_more'] = true;
	/* continue down */

	case 'normal':
	default:
	// Full dislpay:
	echo $params['content_start_full'];

	// increment view counter
	$Item->count_view( array() );

	// display images linked to this item
	$Item->images( array_merge( array(
		'before' => '<div class="bImages">',
	), $params ) );
	?>

	<?php
	// URL link, if the post has one
	$Item->url_link( array(
		'before' => '<p class="post_link">'.T_('Link:').' ',
		'after' => '</p>',
	) );

	// display item's teaser
	$Item->content_teaser( array() );

	// display "more" (read more/follow up) link
	$Item->more_link( array(
		'force_more' => $params['force_more'],
	) );

	// display content teaser of item
	$Item->content_extension( array(
		'force_more' => $params['force_more'],
	) );

	// display links to pages for multi-page items
	$Item->page_links( array(
		'separator' => ' &middot; ',
	) );

	// display item's footer
	$Item->footer( array() );
	?>

	<?php
	if( ! empty( $params['limit_files'] ) )
	{
		// display block of attachments/files linked to this item
		$Item->files( array(
			'before' => $params['file_list_start'],
			'before_file' => $params['file_start'],
			'before_file_size' => $params['before_file_size'],
			'after_file_size' => $params['after_file_size'],
			'after_file' => $params['file_end'],
			'after' => $params['file_list_end'],
			'limit_files' => $params['limit_files'],
		) );
	}

	echo $params['content_end_full'];
}

?>
