<?php
/**
 * this template's class file
 *
 * @author {@link http://wonderwinds.com/ Ed Bennett}
 * @copyright (c) 2009 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://www.gnu.org/licenses/gpl.txt GNU General Public License v3
 * @package templates
 * @subpackage intense
 */
if(!defined('QP_MAIN_INIT')) die('fail');

/**
 * intense_Template class
 *
 * @package templates
 * @subpackage intense
 */
class intense_Template extends Template
{
	var $container_order = array( 'Page Top','Menu','Sidebar' );
	var $folder = 'intense';
	var $name = 'Intense';
	var $type = 'xhtml';
	var $version = '1.0';

	/**
	 * Get ready for displaying the template
	 */
	function display_init()
	{
		// call parent
		parent::display_init();
	}


	/**
	 * Get definitions for editable params
	 *
	 * @see Plugin::GetDefaultSettings()
	 */
	function get_param_definitions( $params )
	{
		$template_params = array_merge( array(
				'head_image' => array(
					'label' => $this->T_('Header Image'),
					'note' => $this->T_('0 for random header image; 1,2,3,4 for custom header image.'),
					'defaultvalue' => 0,
					'valid_pattern' => array(
						'pattern' =>'^([0-4]{1})?$', 'error' =>T_('Invalid Header Image.'),
					),
				)
			), parent::get_param_definitions( $params )	);
		return $template_params;
	}


	/**
	 * Get credits for linkbacks
	 *
	 * @see Template::get_template_credits()
	 */
	function get_template_credits()
	{
		$template_linkbacks = array(
			'designer' => array(
				'pre' => $this->T_('Design by'),
				'text' => 'Salted Sugar',
				'url' => 'http://saltedsugar.com/',
				'title' => 'http://saltedsugar.com/',
				'post' => '', /* Replace with $this->T_('...') when there is something to translate */
			),
			'ported' => array(
				'pre' => $this->T_('Ported by'),
				'text' => 'EdB',
				'url' => 'http://1912webworks.com/',
				'title' => 'web engine tune-up specialist',
				'post' => $this->T_('Lorem ipsum dolor sit amet, consectetuer adipiscing elit.'),
			),
		);
		return $template_linkbacks;
	}

}

?>
