<?php
/**
 * item block template (sub-template)
 *
 * @author {@link http://wonderwinds.com/ Ed Bennett}
 * @author {@link http://severinelandrieu.com/ Sverine Landrieu}
 * @copyright (c) 2009 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://www.gnu.org/licenses/gpl.txt GNU General Public License v3
 * @package templates
 * @subpackage natural_pink
 */
if(!defined('QP_MAIN_INIT')) die('fail');

global $Item;

// set some default params...
$params = array_merge( array(
	'content_mode' => 'auto',
	'item_class' => 'bPost',
	'item_status_class' => 'bPost',
), $params );

$Item->locale_temp_switch(); // temporarily switch to item's locale
?>

<div id="<?php $Item->anchor_id(); ?>" class="<?php $Item->div_classes( $params ); ?>" lang="<?php $Item->lang(); ?>">

<div class="bSmallHead">
<?php
// display the item's permalink
$Item->permanent_link( array(
	'text' => '#icon#',
) );

// display issue date/time of item
$Item->issue_time( array(
	'before' => ' ',
) );

// display author/creator of item
$Item->author( array(
	'before' => $Template->T_('by').' ',
	'after' => ', ',
) );

// display and link categories by name
$Item->categories( array(
	'before' => $Template->T_('Categories').': ',
) );

// display the item's tags
$Item->tags( array(
	'before' => ', '.$Template->T_('Tags').': ',
	'after' => ' ',
) );
?>
</div>

<?php
// display and link item title
$Item->title( array(
	'before' => '<h3 class="bTitle">',
	'after' => '</h3>',
) );

// --- --- --- --- --- --- --- --- --- --- ---
// --- POST CONTENT INCLUDED HERE ---
template_include( '_item_content.inc.php', $params );
?>

<div class="bSmallPrint">
<?php
// display the item's permalink
$Item->permanent_link( array() );

// display link to (and count of) comments only
$Item->feedback_link( array(
	'type' => 'comments',
	'link_before' => ' &bull; ',
) );

// display link to (and count of) trackbacks only
$Item->feedback_link( array(
	'type' => 'trackbacks',
	'link_before' => ' &bull; ',
) );

// display link to edit this item
$Item->edit_link( array(
	'before' => ' &bull; ',
	'after' => '',
) );
?>
</div>

<?php
// --- --- --- --- --- --- --- --- --- --- ---
// --- ITEM FEEDBACK INCLUDED HERE ---
template_include( '_item_feedback.inc.php', array(
	'before_section_title' => '<h4>',
	'after_section_title' => '</h4>',
) );

locale_restore_previous(); // restores previous locale
?>
</div>
