<?php
/**
 * featured item template (sub-template)
 *
 * @author {@link http://wonderwinds.com/ Ed Bennett}
 * @author {@link http://www.blog.hemminga.net/ Afwas}
 * @copyright (c) 2010 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://www.gnu.org/licenses/gpl.txt GNU General Public License v3
 * @package templates
 * @subpackage nifty_colors
 */
if(!defined('QP_MAIN_INIT')) die('fail');

global $Item;

// set some default params...
$params = array_merge( array(
	'content_mode' => 'auto',
	'intro_mode' => 'normal',
	'item_class' => 'bPost featured_post',
	'image_size' => 'fit-560',
	'image_link_to' => 'fit-720',
), $params );

$Item->locale_temp_switch(); // temporarily switch to item's locale

// display and link item title
$Item->title( array(
	'before' => '<div class="featuredTitle"><h3 class="bTitle">',
	'after' => '</h3></div>',
) );
?>

<div id="<?php $Item->anchor_id(); ?>" class="bPost featured">

<div class="bSmallHead">
<?php
// display link to edit this item
$Item->edit_link( array(
	'before' => '',
	'after' => '',
	'class' => 'permalink_right',
) );

// display the item's locale flag
$Item->locale_flag( array(
	'before' => '',
	'after' => ' &nbsp;',
) );

// display author/creator of item
$Item->author( array(
	'before' => $Template->T_('by').' ',
) );

// display message form link to item's author.
$Item->msgform_link( array(
	'after' => ' ',
) );

?>
</div>

<?php
// --- --- --- --- --- --- --- --- --- --- ---
// --- POST CONTENT INCLUDED HERE ---
template_include( '_item_content.inc.php', $params );
?>

<div class="bSmallPrint">
<?php
// display link to (and count of) comments only
$Item->feedback_link( array(
	'link_before' => '<span class="floatright">',
	'link_after' => '</span>',
	'type' => 'feedbacks',
) );

// display and link categories by name
$Item->categories( array(
	'before' => $Template->T_('Categories').': ',
	'after' => ' &middot; ',
) );

// display the item's tags
$Item->tags( array(
	'before' => $Template->T_('Tags').': ',
	'after' => '<br />',
) );

?>
</div>

<?php
// --- --- --- --- --- --- --- --- --- --- ---
// --- ITEM FEEDBACK INCLUDED HERE ---
template_include( '_item_feedback.inc.php', array(
	'before_section_title' => '<h4>',
	'after_section_title' => '</h4>',
) );

locale_restore_previous(); // restores previous locale
?>
</div>
