<?php
/**
 * this template's class file
 *
 * @author {@link http://wonderwinds.com/ Ed Bennett}
 * @author {@link http://www.blog.hemminga.net/ Afwas}
 * @copyright (c) 2010 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://www.gnu.org/licenses/gpl.txt GNU General Public License v3
 * @package templates
 * @subpackage nifty_colors
 */
if(!defined('QP_MAIN_INIT')) die('fail');

/**
 * nifty_colors_Template class
 *
 * @package templates
 * @subpackage nifty_colors
 */
class nifty_colors_Template extends Template
{
	var $container_order = array( 'Page Top','Header','Menu','Sidebar','Footer' );
	var $folder = 'nifty_colors';
	var $name = 'Nifty Colors';
	var $type = 'xhtml';
	var $version = '1.1';

	/**
	 * Get ready for displaying the template
	 */
	function display_init()
	{
		// call parent
		parent::display_init();

		$sidebar_css = '<link rel="stylesheet" type="text/css" href="rsc/'.$this->get_setting( 'sidebar' ).'.css" media="screen" />'."\n";
		$color_css = '<link rel="stylesheet" type="text/css" href="rsc/'.$this->get_setting( 'color' ).'.css" media="screen" />'."\n";
		add_headline( $sidebar_css );
		add_headline( $color_css );
	}


	/**
	 * Get definitions for editable params
	 *
	 * @see Plugin::GetDefaultSettings()
	 */
	function get_param_definitions( $params )
	{
		$template_params = array_merge( array(
				'color' => array(
					'label' => $this->T_('Color Scheme'),
					'type' => 'select',
					'options' => array(
						'A0C22E' => $this->T_('Green'),
						'A477A4' => $this->T_('Purple'),
						'BD4D55' => $this->T_('Red'),
						'FF9933' => $this->T_('Yellow'),
					),
					'defaultvalue' => 'A0C22E',
				),
				'sidebar' => array(
					'label' => $this->T_('Sidebar'),
					'type' => 'select',
					'options' => array(
						'left' => $this->T_('Left'),
						'right' => $this->T_('Right'),
					),
					'defaultvalue' => 'right',
				),
			), parent::get_param_definitions( $params )	);
		return $template_params;
	}


	/**
	 * Get credits for linkbacks
	 * @see Template::get_template_credits()
	 */
	function get_template_credits()
	{
		$template_linkbacks = array(
			'designer' => array(
				'pre' => $this->T_('Design by'),
				'text' => 'Afwas',
				'url' => 'http://www.blog.hemminga.net/',
				'title' => 'http://www.blog.hemminga.net/',
				'post' => '', /* Replace with $this->T_('...') when there is something to translate */
			),
			'ported' => array(
				'pre' => $this->T_('Ported by'),
				'text' => 'EdB',
				'url' => 'http://1912webworks.com/',
				'title' => 'web engine tune-up specialist',
				'post' => $this->T_('Lorem ipsum dolor sit amet, consectetuer adipiscing elit.'),
			),
		);
		return $template_linkbacks;
	}

}

?>
