<?php
/**
 * Primary / default template file
 *
 * @author {@link http://wonderwinds.com/ Ed Bennett}
 * @author {@link http://www.blog.hemminga.net/ Afwas}
 * @copyright (c) 2010 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://www.gnu.org/licenses/gpl.txt GNU General Public License v3
 * @package templates
 * @subpackage nifty_colors
 */
if(!defined('QP_MAIN_INIT')) die('fail');

template_init( $disp ); // do $disp-based initializations...

require_css( 'rsc/nifty_corners.css', true );
require_js( 'rsc/nifty_corners.js', true );
$color = $Template->get_setting( 'color' );
add_headline( '<script type="text/javascript">
window.onload=function()
{
	if(!NiftyCheck())
		return;
	Rounded("div.outerwrap","all","transparent","#fff","");
	Rounded("div.bPosts","all","transparent","#fff","");
	Rounded("div.bSideBar","all","transparent","#fff","");
	Rounded("div.bTitle","top","#fff","#'.$color.'","smooth");
	Rounded("div.featuredTitle","top","#fff","#'.$color.'","smooth");
}
</script>' );

// --- --- --- --- --- --- --- --- --- --- ---
// --- HTML HEADER INCLUDED HERE ---
template_include( '_xhtml_header.inc.php' );
?>

<div id="wrapper">

<div class="outerwrap">

<div class="innerwrap">
<?php
// --- --- --- --- --- --- --- --- --- --- ---
// display "Page Top" container's widgets
template_container( NT_('Page Top'), array(
	'container_start' => '<div class="PageTop">',
	'container_end' => '</div>',
	'block_display_title' => false,
) );

// --- --- --- --- --- --- --- --- --- --- ---
// display "Header" container's widgets
template_container( NT_('Header'), array(
	'container_start' => '<div class="pageHeader">',
	'container_end' => '</div>',
	'block_title_start' => '<h1>',
	'block_title_end' => '</h1>',
) );

// --- --- --- --- --- --- --- --- --- --- ---
// display "Menu" container's widgets
template_container( NT_('Menu'), array(
	'container_start' => '<div class="top_menu"><ul>',
	'container_end' => '</ul>&nbsp;</div>',
	'block_start' => '',
	'block_end' => '',
	'block_display_title' => false,
	'list_start' => '',
	'list_end' => '',
) );
?>
</div>

</div>

<div class="bPosts">

<div class="innerwrap">
<?php
// messages generated from actions
messages( array() );

// prev/next links in single post mode
item_prevnext_links( array(
	'block_start' => '<table class="prevnext_post"><tr>',
	'prev_start' => '<td>',
	'prev_end' => '</td>',
	'next_start' => '<td class="right">',
	'next_end' => '</td>',
	'block_end' => '</tr></table>',
) );

// title for the current request
request_title( array(
	'title_before' => '<h2>',
	'title_after' => '</h2>',
) );

// prev/next links on multi-post pages
mainlist_page_links( array(
	'block_start' => '<p class="center">'.$Template->T_('Pages:').' <strong>',
	'block_end' => '</strong></p>',
) );

// do we have a featured/intro item to display?
if( $Item = & get_featured_Item() )
{
	// --- --- --- --- --- --- --- --- --- --- ---
	// --- ITEM BLOCK INCLUDED HERE ---
	template_include( '_featured_item.inc.php', array(
		'content_mode' => 'auto',
		'intro_mode' => 'normal',
		'item_class' => 'featured_post',
	) );
}

// display a message if list is empty
display_if_empty( array() );

// loop through as long as we have an Item...
while( $Item = & mainlist_get_item() )
{
	$Item->locale_temp_switch(); // temporarily switch to item's locale

	// display and link item title
	$Item->title( array(
		'before' => '<div class="bTitle"><h3 class="bTitle">',
		'after' => '</h3></div>',
	) );
	?>

	<div id="<?php $Item->anchor_id(); ?>" class="bPost">

	<div class="bSmallHead">
	<?php
	// display link to edit this item
	$Item->edit_link( array(
		'before' => '',
		'after' => '',
		'class' => 'permalink_right',
	) );

	// display the item's locale flag
	$Item->locale_flag( array(
		'before' => '',
		'after' => ' &nbsp;',
	) );

	// display issue date/time of item
	$Item->issue_date( array(
		'after' => ', ',
	) );

	// display author/creator of item
	$Item->author( array(
		'before' => $Template->T_('by').' ',
	) );

	// display message form link to item's author.
	$Item->msgform_link( array(
		'after' => ' ',
	) );

	// display word count
	$Item->wordcount( array(
		'after' => ' '.$Template->T_('words'),
	) );
	?>
	</div>

	<div class="bText">
	<?php
	// --- --- --- --- --- --- --- --- --- --- ---
	// --- POST CONTENT INCLUDED HERE ---
	template_include( '_item_content.inc.php', array(
		'image_size' => 'fit-560',
	) );
	?>
	</div>

	<div class="bSmallPrint">
	<?php
	// display link to (and count of) comments only
	$Item->feedback_link( array(
		'link_before' => '<span class="floatright">',
		'link_after' => '</span>',
		'type' => 'feedbacks',
	) );

	// display and link categories by name
	$Item->categories( array(
		'before' => $Template->T_('Categories').': ',
		'after' => ' &middot; ',
	) );


	// display the item's tags
	$Item->tags( array(
		'before' => $Template->T_('Tags').': ',
		'after' => '<br />',
	) );

	?>
	</div>

	<?php
	// --- --- --- --- --- --- --- --- --- --- ---
	// --- ITEM FEEDBACK INCLUDED HERE ---
	template_include( '_item_feedback.inc.php', array(
		'before_section_title' => '<h4>',
		'after_section_title' => '</h4>',
	) );

	locale_restore_previous(); // restores previous locale
	?>
	</div>

	<?php
}

// prev/next links on multi-post pages
mainlist_page_links( array(
	'block_start' => '<p class="center"><strong>',
	'block_end' => '</strong></p>',
) );

// --- --- --- --- --- --- --- --- --- --- ---
// --- MAIN CONTENT INCLUDED HERE ---
template_include( '$disp$', array(
	// these cases already handled by this file
	'disp_posts' => '', 
	'disp_single' => '',
	'disp_intro' => '',
	'disp_page' => '', 
) );
?>
</div>

</div>

<?php
// --- --- --- --- --- --- --- --- --- --- ---
// display "Sidebar" container's contents
template_container( NT_('Sidebar'), array(
	'container_start' => '<div class="bSideBar"><div class="innerwrap">',
	'container_end' => '</div></div>',
	'block_start' => '<div class="bSideItem $wi_class$">',
	'block_end' => '</div>',
) );
?>

<div class="clear"><img src="<?php echo $rsc_url; ?>img/blank.gif" width="1" height="1" alt="" /></div>

<div id="pageFooter">
<?php
// --- --- --- --- --- --- --- --- --- --- ---
// display "Footer" container's widgets
template_container( NT_('Footer'), array(
	'block_title_start' => '<strong>',
	'block_title_end' => '</strong>',
	'list_start' => '',
	'list_end' => '',
	'item_start' => ' &bull; ',
	'item_end' => '',
) );
?>
<p class="baseline">
<?php
// display the current blog's footer text
$Blog->footer_text( array(
	'after' => ' &bull; ',
) );

// display a link to contact the current blog owner
$Blog->contact_link( array(
	'after' => ' &bull; ',
) );

// display a link to this blog's credits page
$Blog->credits_link( array() );
?>
</p>
</div>

</div>

<?php
// spark the plugin manager
$Plugins->trigger_event( 'TemplateEndHtmlBody' );
debug_info(); // output debug info if requested
?>
</div>
</body>
</html>
<?php $Hit->log(); // log the hit on this page ?>
