<?php
/**
 * this template's class file
 *
 * @author {@link http://wonderwinds.com/ Ed Bennett}
 * @author {@link http://fplanque.net/ Francois PLANQUE}
 * @copyright (c) 2009 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://www.gnu.org/licenses/gpl.txt GNU General Public License v3
 * @package templates
 * @subpackage photoblog
 */
if(!defined('QP_MAIN_INIT')) die('fail');

/**
 * photoblog_Template class
 *
 * @package templates
 * @subpackage photoblog
 */
class photoblog_Template extends Template
{
	var $container_order = array( 'Page Top','Menu' );
	var $folder = 'photoblog';
	var $name = 'PhotoBlog';
	var $type = 'xhtml';
	var $version = '1.0';

	/**
	 * Get the widgets for this template
	 *
	 * @see Template::get_default_widgets()
	 */
	function get_default_widgets( $params = array() )
	{
		// Containers (each container needs to be an array to hold arrays)
		$template_widgets = array(
			'Page Top' => array(),
			'Menu' => array(),
		);
		// Page Top widgets
		$template_widgets['Page Top'][] = array(
			'bloglist' => array(
				'type' => 'widget',
				'params' => array(
					'blog_list_type' => ( $params['Blog']->get( 'in_bloglist' ) ? 'public' : 'owner' ),
				),
			),
		);
		// Menu widgets
		$template_widgets['Menu'][] = array(
			'menu_link' => array(
				'type' => 'widget',
				'params' => array(
					'link_type' => 'main',
					'widget_name' => 'Menu link',
				),
			),
		);
		$template_widgets['Menu'][] = array(
			'menu_link' => array(
				'type' => 'widget',
				'params' => array(
					'link_type' => 'ownercontact',
					'widget_name' => 'Menu link',
				),
			),
		);
		$template_widgets['Menu'][] = array(
			'user_tools' => array(
				'type' => 'widget',
			),
		);

		return $template_widgets;
	}


	/**
	 * Get credits for linkbacks
	 * @see Template::get_template_credits()
	 */
	function get_template_credits()
	{
		$template_linkbacks = array(
			'designer' => array(
				'pre' => $this->T_('Design by'),
				'text' => 'Fran&ccedil;ois PLANQUE',
				'url' => 'http://fplanque.net/',
				'title' => 'http://fplanque.net/',
				'post' => '', /* Replace with $this->T_('...') when there is something to translate */
			),
			'ported' => array(
				'pre' => $this->T_('Ported by'),
				'text' => 'EdB',
				'url' => 'http://1912webworks.com/',
				'title' => 'web engine tune-up specialist',
				'post' => $this->T_('Lorem ipsum dolor sit amet, consectetuer adipiscing elit.'),
			),
		);
		return $template_linkbacks;
	}

}

?>
