<?php
/**
 * template when $disp == 'credits'
 *
 * @author {@link http://wonderwinds.com/ Ed Bennett}
 * @author {@link http://astonishme.co.uk/ Yabba (Paul Jones, rest in peace)}
 * @copyright (c) 2013 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://www.gnu.org/licenses/gpl.txt GNU General Public License v3
 * @package templates
 * @subpackage pictogram
 */
if(!defined('QP_MAIN_INIT')) die('fail');

if( $Blog->get_setting( 'credits_page' ) != 'credits' )
{
	return; // credits page not wanted
}
?>

<div id="credits">
<ul>

<?php
$credits_array = explode( ',', $Blog->get_setting( 'credit_sections' ) );


// Finally: QP's only linkback
if( isset( $Template ) )
{
	echo '<li class="blockwrap"><h3 id="software" class="blocknice">'
	.$Template->poweredby_linkback['pre']
	.': <a href="'.$Template->poweredby_linkback['url'].'" title=" '
	.format_to_output( $Template->poweredby_linkback['title'], 'htmlattr' ), ' ">'
	.format_to_output( $Template->poweredby_linkback['text'], 'text' ), '</a></h3>'."\n";
	echo '<p>'.format_to_output( $Template->poweredby_linkback['post'], 'htmlbody'), "</p>\n";
	echo '</li>'."\n";
}

// Third: core contributor credits
if( in_array( 'contribs', $credits_array ) )
{
	global $templates_path;
	/**
	 * contributors links
	 */
	require_once $templates_path.'/_contributors.php';

	echo '<li id="dracones"><h3 class="blocknice">'.T_('Core Contributors').'</h3><ul>'."\n";

	usort( $_hic_sunt_dracones, 'alpha_dracones' );

	foreach( $_hic_sunt_dracones as $dracone )
	{
		echo '<li class="blockwrap dracone-'.( ( $odd = empty( $odd ) ) ? 'odd' : 'even' ).'"><h3 class="blocknice">';
		locale_flag( $dracone['locale'], 'h10px', 'myclass' );
		echo ' <a href="'.$dracone['homepage'].'" title=" '
		.format_to_output( $dracone['homepage'], 'htmlattr' ).' ">'
		.format_to_output( $dracone['name'], 'text' ).'</a></h3>'."\n"
		.format_to_output( $dracone['spiel'], 'htmlbody').'</li>'."\n";
	}
	echo '</ul></li>'."\n";
}

// Second: plugin credits excluding 'core' plugins
global $Plugins;
$credits = array();

$Plugins->restart();
while( ( $a_plugin = & $Plugins->get_next() ) && ( in_array( 'plugins', $credits_array ) ) )
{
	// Skip our own plugins
	if( empty( $a_plugin->name ) || $a_plugin->author == 'Dracones Incompertus' || $a_plugin->author == 'The b2evo Group' )
	{
		continue;
	}

	// plugin $name linked to $help_url (if set)
	$p_name = format_to_output( $a_plugin->name, 'htmlbody' );
	if( $a_plugin->help_url != '' )
	{
		$p_name = '<a href="'.format_to_output( $a_plugin->help_url, 'htmlattr' ).'" title="'.T_('visit this plugins web page').'">'.$p_name.'</a>';
	}

	// plugin $author linked to $author_url (if set)
	$a_name = format_to_output( $a_plugin->author, 'htmlbody' );
	if( $a_plugin->author_url != '' )
	{
		$a_name = '<a href="'.format_to_output( $a_plugin->author_url, 'htmlattr' ).'" title="'.T_('visit the authors website').'">'.$a_name.'</a>';
	}

	// plugin $long_desc used as description
	$credits[ strtolower( $a_plugin->name ) ] = array(
		'p_name' => $p_name,
		'a_name' => $a_name,
		'desc' => $a_plugin->short_desc,
		'extras' => $a_plugin->get_plugin_credits(),
		'licence' => ( empty( $a_plugin->licence ) ? '' : $a_plugin->licence ),
	);
}

if( ! empty( $credits ) )
{
	ksort( $credits );
	$odd = false;
	echo '<li id="plugins"><h3 class="blocknice">'.T_('Plugin Credits').':</h3><ul>'."\n";

	foreach( $credits as $credit )
	{
		echo '<li class="dracone-'.( ( $odd = empty( $odd ) ) ? 'odd' : 'even' ).'"><div class="blockwrap"><h3 class="blocknice">'.$credit['p_name'].' '.T_('by').' '.$credit['a_name']
		.'</h3><div>'.$credit['desc'].'</div></div>'
		.( $credit['licence'] ? '<div class="block-footer blocknice">'.str_replace( '$branch$', '<em>Steal Me</em> : cd your-blog-root/qp_plugins && <br />bzr branch lp:~quam-plures-core/', $credit['licence'] ).'</div>' : '' ).'</li>'."\n";
	}

	echo '</ul></li>'."\n";
}

// First: template credits from the template.class file
if( isset( $Template ) && ( $credits = $Template->get_template_credits() ) && ( in_array( 'template', $credits_array ) ) )
{
	echo '<li id="vanity" class="blockwrap"><h3 class="blocknice">'.T_('Template Credits').' :</h3><dl>'."\n";

	foreach( $credits as $linkback )
	{
		echo '<dt>'.format_to_output( $linkback['pre'], 'htmlbody').' <a href="', $linkback['url'].'" title=" ';
		echo format_to_output( $linkback['title'], 'htmlattr' ).' ">';
		echo format_to_output( $linkback['text'], 'text' ).'</a></dt>';
		echo '<dd>'.format_to_output( $linkback['post'], 'htmlbody')."</dd>\n";
	}

	echo '</dl></li>'."\n";
}
?>
</ul>
</div>
<?php
/**
 * Callback function for sorting dracones into alphabetical order by "name"
 * as opposed to forum names, which are the (unique) array keys we use
 *
 * @param string $drac_1 array entry
 * @param string $drac_2 next array entry
 * @return is $drac_1's name further down the alphabet than $drac_2's name
 */
function alpha_dracones( $drac_1, $drac_2 )
{
	$sorted = array( $drac_1['name'], $drac_2['name'] );
	natcasesort( $sorted );
	$sorted = array_values( $sorted );

	return ( $sorted[0] == $drac_2['name'] );
}
?>
