<?php
/**
 * item block template (sub-template)
 *
 * @author {@link http://wonderwinds.com/ Ed Bennett}
 * @author {@link http://astonishme.co.uk/ Yabba (Paul Jones, rest in peace)}
 * @copyright (c) 2013 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://www.gnu.org/licenses/gpl.txt GNU General Public License v3
 * @package templates
 * @subpackage pictogram
 */
if(!defined('QP_MAIN_INIT')) die('fail');

global $Item;

// set some default params...
$params = array_merge( array(
	'content_mode' => 'auto',
	'item_class' => 'post',
	'more_link_text' => $Template->T_('Read more'),
	'image_size' => 'fit-720',
	'image_link_to' => 'nothing',
), $params );

$Item->locale_temp_switch(); // temporarily switch to item's locale
?>

<div id="<?php $Item->anchor_id(); ?>" class="<?php echo $params['item_class']; ?>" lang="<?php $Item->lang(); ?>">
<div class="blockwrap">
<?php
if( $Item->is_intro() )
{
	// display link to edit this item
	$Item->edit_link( array(
		'before' => '<div class="floatright">',
		'after' => '</div>',
	) );
}

// display and link item title
$Item->title( array(
	'before' => '<h2 class="blocktitle">',
	'after' => '</h2>',
) );
?>
<p class="postinfo">
<?php
if( ! $Item->is_intro() )
{
	// display author/creator of item
	$Item->author( array(
		'before' => $Template->T_('By').' ',
	) );

	// display issue date/time of item
	$Item->issue_date( array(
		'before' => /* TRANS: date */ $Template->T_('on').' ',
		'after' => '',
		'date_format' => 'M j, Y',
	) );

	// display link to edit this item
	$Item->edit_link( array(
		'before' => ' ',
		'after' => '',
		'text' => get_icon('edit', 'imgtag'),
	) );
}
?>
</p>
<?php
// --- --- --- --- --- --- --- --- --- --- ---
// --- POST CONTENT INCLUDED HERE ---
template_include( '_item_content.inc.php', $params );
?>
<div class="clear"></div>

</div>

<div class="block-footer blocknice posttags">
<?php
// display and link categories by name
$Item->categories( array(
	'before' => $Template->T_('In').' : ',
) );

// display link to (and count of) comments and trackbacks
$Item->feedback_link( array(
	'link_before' => ' '.$Template->T_('Feedback').' : ',
	'link_text_zero' => $Template->T_('None'),
	'link_text_one' => '1',
	'link_text_more' => '%d',
) );

// display link to edit this item
$Item->edit_link( array(
	'before' => ' '.$Template->T_('Edit').'  : ',
	'after' => '',
	'text' => get_icon('edit', 'imgtag'),
) );

// display the item's tags
$Item->tags( array(
	'before' => ' <br /><span class="posttags">'.$Template->T_('Tags').': ',
	'after' => '</span>',
) );
?>
</div>

<?php
locale_restore_previous(); // restores previous locale
?>
</div>