<?php
/**
 * item comment template (sub-template)
 *
 * @author {@link http://wonderwinds.com/ Ed Bennett}
 * @author {@link http://astonishme.co.uk/ Yabba (Paul Jones, rest in peace)}
 * @copyright (c) 2013 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://www.gnu.org/licenses/gpl.txt GNU General Public License v3
 * @package templates
 * @subpackage pictogram
 */
if(!defined('QP_MAIN_INIT')) die('fail');

global $odd;

// set some default params...
$params = array_merge( array(
	'comment_start' => '<div class="bComment">',
	'comment_end' => '</div>',
	'Comment' => NULL, // this object MUST be passed as a param!
), $params );

$Comment = & $params['Comment'];
$comment_class = ( $Comment->author_user_ID == $params['creator_user_ID'] ? 'author' : 'other' );
echo str_replace( '$class$', 'cmt_'.$comment_class.' cmt_'.( ( $odd = empty( $odd ) ) ? 'odd' : 'even' ), $params['comment_start'] );
$Comment->anchor(); // display an anchor for this comment
?>
<div class="blockwrap">
<div class="blocktitle cmt_title">
<?php
switch( $Comment->get( 'type' ) )
{
	case 'comment':
	if( empty( $Comment->ID ) )
	{
		// PREVIEW comment
		echo T_('PREVIEW Comment :').' ';
	}
	else
	{
		// display a permalink link to the comment
		$Comment->permanent_link( array(
			'after' => '',
			'text' => $Comment->author( array(
				'before_visitor' => '',
				'after_visitor' => '',
				'before_user' => '',
				'after_user' => '',
				'format' => 'htmlbody',
				'make_link' => false,
			) ),
			'nofollow' => true,
		) );
	}
	// display a link to comment author's URL
	if( $url = $Comment->get_author_url() )
	{
		echo ' @'.T_('link').': '.$url;
	}
	break;

	case 'trackback':
	break;
	// display a permalink link to the trackback
	$Comment->permanent_link( array(
		'after' => ' '.T_('from:').' ',
		'text' => T_('Trackback'),
		'nofollow' => true,
	) );
	// display trackback author's name
	$Comment->author( array(
		'make_link' => true
	) );
	break;
}

$Comment->rating( array() );
?>
<div class="cmt_footer">
<?php
// display the comment's date
$Comment->date( array(
	'after' => ' @ ',
) );

// display the comment's time
$Comment->time( array(
	'format' => 'H:i',
) );

$Comment->edit_link( array(
	'class' => 'permalink_right',
	'text' => get_icon( 'edit', 'imgtag', array( 'title' => T_('Edit this comment') ) ),
) );

// display a link to delete a comment
$Comment->delete_link( array(
	'class' => 'permalink_right',
	'text' => get_icon( 'delete', 'imgtag', array( 'title' => T_('Delete this comment') ) ),
) );
?>
</div>

</div>

<div class="cmt_text">
<?php
$Comment->content(); // display the comment's contents

echo '<div>'."\n";
// display a link to edit a comment
$Comment->edit_link( array(
	'class' => 'permalink_right',
	'text' => get_icon( 'edit', 'imgtag', array( 'title' => T_('Edit this comment') ) ),
) );

// display a link to delete a comment
$Comment->delete_link( array(
	'class' => 'permalink_right',
	'text' => get_icon( 'delete', 'imgtag', array( 'title' => T_('Delete this comment') ) ),
) );

echo '</div>'."\n";
?>
</div>

</div>

<?php
echo $params['comment_end'];
?>
