<?php
/**
 * this template's class file
 *
 * @author {@link http://wonderwinds.com/ Ed Bennett}
 * @author {@link http://astonishme.co.uk/ Yabba (Paul Jones, rest in peace)}
 * @copyright (c) 2013 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://www.gnu.org/licenses/gpl.txt GNU General Public License v3
 * @package templates
 * @subpackage pictogram
 */
if(!defined('QP_MAIN_INIT')) die('fail');

/**
 * pictogram_Template class
 *
 * @package templates
 * @subpackage pictogram
 */
class pictogram_Template extends Template
{
	var $container_order = array( 'Header Top','Header Middle','Header Bottom','Pages Bar','Footer Left','Footer Middle','Footer Right' );
	var $folder = 'pictogram';
	var $name = 'Pictogram';
	var $type = 'xhtml';
	var $version = '1.0';

	/**
	 * Get the widgets for this template
	 *
	 * @see Template::get_default_widgets()
	 */
	function get_default_widgets( $params = array() )
	{
		// Containers (each container needs to be an array to hold arrays)
		$template_widgets = array(
			'Header Top' => array(),
			'Header Middle' => array(),
			'Header Bottom' => array(),
			'Pages Bar' => array(),
			'Footer Left' => array(),
			'Footer Middle' => array(),
			'Footer Right' => array(),
		);
		// Header Top widgets
		$template_widgets['Header Top'][] = array(
			'user_tools' => array(
				'type' => 'widget',
			),
		);
		// Header Middle widgets
		$template_widgets['Header Middle'][] = array(
			'title' => array(
				'type' => 'widget',
			),
			'tagline' => array(
				'type' => 'widget',
			),
		);
		// Header Bottom widgets
		$template_widgets['Header Bottom'][] = array(
			'bloglist' => array(
				'type' => 'widget',
				'params' => array( 'blog_list_type' => ( $params['Blog']->get( 'in_bloglist' ) ? 'public' : 'owner' ) ),
			),
		);
		// Pages Bar widgets
		$template_widgets['Pages Bar'][] = array(
			'page_list' => array(
				'type' => 'widget',
			),
		);
		// Footer Left widgets
		$template_widgets['Footer Left'][] = array(
			'category_list' => array(
				'type' => 'widget',
			),
		);
		// Footer Middle widgets
		$template_widgets['Footer Middle'][] = array(
			'comment_list' => array(
				'type' => 'widget',
			),
		);
		// Footer Right widgets
		$template_widgets['Footer Right'][] = array(
			'search_form' => array(
				'type' => 'widget',
				'params' => array( 'search_options' => false, 'title' => '' ),
			),
			'longdesc' => array(
				'type' => 'widget',
			),
		);

		return $template_widgets;
	}


	/**
	 * Get credits for linkbacks
	 *
	 * @see Template::get_template_credits()
	 */
	function get_template_credits()
	{
		$template_linkbacks = array(
			'designer' => array(
				'pre' => $this->T_('Design by'),
				'text' => 'Yabs',
				'url' => 'http://onewish.co.uk/',
				'title' => 'Don\'t be greedy',
				'post' => $this->T_('de fumo in flammam ;)'),
			),
		);
		return $template_linkbacks;
	}


	/**
	 * dummy docblock
	 */
	function get_cat_thumbs( $Blog, $what )
	{
		global $DB;

		if( $what == 'links' && isset( $this->thumb_links ) )
		{
			return $this->thumb_links;
		}

		// get the category info we will need
		$catnames = $DB->get_results("SELECT cat_ID, cat_name, cat_description FROM T_categories WHERE cat_blog_ID = {$Blog->ID} ORDER BY cat_name ASC");
		// 2 bits for thumb_links
		$cats = array();
		$this->thumb_links = '<a href="'.$Blog->get( 'mediaidxurl' ).'">'.$this->T_('All').'</a>';
		// an array for titles
		$this->thumb_titles = array();
		// run through the cat names...
		foreach( $catnames as $k => $v )
		{
			$cats[$v->cat_name] = array( $v->cat_ID, $v->cat_description );
			$this->thumb_links .= ', ';
			$this->thumb_links .= '<a href="'.$Blog->get( 'mediaidxurl' ).'&amp;cat='.$v->cat_ID.'"';
			// cat description is null if not set
			if( ! is_null( $v->cat_description ) )
			{
				$this->thumb_links .= ' title="'.$v->cat_description.'"';
			}
			$this->thumb_titles[$v->cat_ID] = $v->cat_name.' ('.$this->T_('Photo index').')';
			$this->thumb_links .= '>'.$v->cat_name.'</a>';
		}

		if( $what == 'titles' )
		{
			return $this->thumb_titles;
		}
		return $this->thumb_links;
	}

}

?>
