<?php
/**
 * html head template (sub-template)
 *
 * @author {@link http://wonderwinds.com/ Ed Bennett}
 * @author {@link http://astonishme.co.uk/ Yabba (Paul Jones, rest in peace)}
 * @copyright (c) 2013 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://www.gnu.org/licenses/gpl.txt GNU General Public License v3
 * @package templates
 * @subpackage pictogram
 */
if(!defined('QP_MAIN_INIT')) die('fail');

global $rsc_url;
global $srvc_url;

add_js_for_toolbar(); // registers javascripts for the navbar
if( $disp == '404' )
{
	header('HTTP/1.0 404 Not Found');
}
header_content_type(); // sets charset
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="<?php locale_lang(); ?>" lang="<?php locale_lang(); ?>">
<head>
<?php
template_content_meta(); // Content-Type meta tag
template_base_tag(); // for css and img includes
// spark the plugin manager
$Plugins->trigger_event( 'TemplateBeginHtmlHead' );
?>
<title><?php // title for the current request
request_title( array(
	'auto_pilot' => 'seo_title'
) ); ?></title>
<?php
template_description_tag(); // description meta tag
template_keywords_tag(); // keywords meta tag
robots_tag(); // robots meta tag
if( $Blog->get_setting( 'feed_content' ) != 'none' )
{
	template_feed_tags();
}
?>
<link rel="EditURI" type="application/rsd+xml" title="RSD" href="<?php echo $srvc_url; ?>rsd.php?blog=<?php echo $Blog->ID; ?>" />
<meta name="viewport" content="width = 750" />
<?php
if( is_logged_in() )
{
	?>
	<link rel="stylesheet" type="text/css" href="<?php echo $rsc_url; ?>css/toolbar_debug.css" media="screen" />
	<?php
}
?>
<link rel="stylesheet" type="text/css" href="style-reset.css" media="screen" />
<link rel="stylesheet" type="text/css" href="<?php echo $rsc_url; ?>css/basic.css" media="screen" />
<link rel="stylesheet" type="text/css" href="<?php echo $rsc_url; ?>css/blog_base.css" media="screen" />
<link rel="stylesheet" type="text/css" href="<?php echo $rsc_url; ?>css/item_base.css" media="screen" />
<link rel="stylesheet" type="text/css" href="style.css" media="screen" />
<link rel="stylesheet" type="text/css" href="print.css" media="print" />
<!--[if IE]>
<style type="text/css">
body{
font-size:70%;
}</style>
<![endif]-->
<?php
include_headlines(); // output collected <head> lines
$Blog->disp( 'blog_css', 'raw'); // blog-specific css tweaks, if allowed
$Blog->disp( 'user_css', 'raw'); // user-specific css tweaks, if allowed
?>
</head>

<body>
<?php
// spark the plugin manager
$Plugins->trigger_event( 'TemplateBeginHtmlBody' );

// --- --- --- --- --- --- --- --- --- --- ---
// --- TOOLBAR INCLUDED HERE ---
template_include( '_toolbar.inc.php' );

if( is_logged_in() )
{
	echo "\n".'<div id="template_wrapper" class="template_wrapper_loggedin">'."\n";
}
else
{
	echo "\n".'<div id="template_wrapper" class="template_wrapper_anonymous">'."\n";
}

?>
