<?php
/**
 * template for multipost pages
 *
 * @author {@link http://wonderwinds.com/ Ed Bennett}
 * @author {@link http://astonishme.co.uk/ Yabba (Paul Jones, rest in peace)}
 * @copyright (c) 2013 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://www.gnu.org/licenses/gpl.txt GNU General Public License v3
 * @package templates
 * @subpackage pictogram
 */
if(!defined('QP_MAIN_INIT')) die('fail');

template_init( $disp ); // do $disp-based initializations...

// --- --- --- --- --- --- --- --- --- --- ---
// --- HTML HEADER INCLUDED HERE ---
template_include( '_xhtml_header.inc.php' );

// --- --- --- --- --- --- --- --- --- --- ---
// --- BODY HEADER INCLUDED HERE ---
template_include( '_body_header.inc.php' );
?>

<div id="content" class="inner-wrap">
<?php
// messages generated from actions
messages( array() );

// display a message if list is empty
display_if_empty( array() );

// the first post is always large...
if( $Item = & mainlist_get_item() )
{
	// --- --- --- --- --- --- --- --- --- --- ---
	// --- ITEM BLOCK INCLUDED HERE ---
	template_include( '_item_block.inc.php', array(
		'content_mode' => 'normal',
		'intro_mode' => 'normal',
		'item_class' => 'featurepost',
		'image_block_start' => '<div class="excerpt-image excerpt-$mode$"><div class="excerpt-large">',
		'image_block_end' => '</div></div>',
		'image_size' => 'fit-640',
		'image_link_to' => 'single',
	) );
}

$postCount = 0;
// loop through as long as we have an Item...
while( $Item = & mainlist_get_item() )
{
	if( ++$postCount < 3 )
	{
		// --- --- --- --- --- --- --- --- --- --- ---
		// --- ITEM BLOCK INCLUDED HERE ---
		template_include( '_item_block.inc.php', array(
			'content_mode' => 'auto',
			'item_class' => 'large-post large-'.( $postCount == 1 ? 'left' : 'right' ) ,
			'image_block_start' => '<div class="excerpt-image excerpt-$mode$"><div class="excerpt-small">',
			'image_block_end' => '</div></div>',
			'image_size' => 'fit-440',
			'image_link_to' => 'fit-640',
		) );
	}
	else
	{
		$pos = $postCount%3;
		$pos = ( $pos == 0 ? 'left' : ( $pos == 1 ? 'middle' : 'right' ) );
		// --- --- --- --- --- --- --- --- --- --- ---
		// --- ITEM BLOCK INCLUDED HERE ---
		template_include( '_item_block.inc.php', array(
			'content_mode' => 'auto',
			'item_class' => 'small-post small-'.$pos,
			'image_block_start' => '<div class="excerpt-image excerpt-$mode$"><div class="excerpt-small">',
			'image_block_end' => '</div></div>',
			'image_size' => 'fit-240',
			'image_link_to' => 'fit-640',
		) );
	}
}

// prev/next links on multi-post pages
mainlist_page_links( array(
	'block_start' => '<div class="navigation pages-navigation">',
	'block_end' => '</div>',
	'prev_text' => $Template->T_('Newer posts'),
	'next_text' => $Template->T_('Older posts'),
	'list_span' => 5,
	'scroll_list_range' => 10,
) );
?>
</div>

<?php
// --- --- --- --- --- --- --- --- --- --- ---
// --- BODY FOOTER INCLUDED HERE ---
template_include( '_body_footer.inc.php' );
?>
