<?php
/**
 * template when $disp == 'single'
 *
 * @author {@link http://wonderwinds.com/ Ed Bennett}
 * @author {@link http://astonishme.co.uk/ Yabba (Paul Jones, rest in peace)}
 * @copyright (c) 2013 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://www.gnu.org/licenses/gpl.txt GNU General Public License v3
 * @package templates
 * @subpackage pictogram
 */
if(!defined('QP_MAIN_INIT')) die('fail');

template_init( $disp ); // do $disp-based initializations...

// --- --- --- --- --- --- --- --- --- --- ---
// --- HTML HEADER INCLUDED HERE ---
template_include( '_xhtml_header.inc.php' );

// --- --- --- --- --- --- --- --- --- --- ---
// --- BODY HEADER INCLUDED HERE ---
template_include( '_body_header.inc.php' );
?>

<div id="content" class="inner-wrap">
<?php
// messages generated from actions
messages( array() );

// display a message if list is empty
display_if_empty( array() );

// loop through as long as we have an Item...
while( $Item = & mainlist_get_item() )
{
	$Item->locale_temp_switch(); // temporarily switch to item's locale
	?>
	<div id="<?php $Item->anchor_id(); ?>" class="<?php $Item->status_raw(); ?>" lang="<?php $Item->lang(); ?>">
	<div class="blockwrap">
	<?php
	// display and link item title
	$Item->title( array(
		'before' => '<h2 class="blocktitle">',
		'after' => '</h2>',
	) );
	?>
	<p class="postinfo">
	<?php
	// display author/creator of item
	$Item->author( array(
		'before' => $Template->T_('By').' ',
	) );

	// display issue date/time of item
	$Item->issue_date( array(
		'before' => /* TRANS: date */ $Template->T_('on').' ',
		'date_format' => 'M j, Y',
		'after' => '',
	) );

	// display link to edit this item
	$Item->edit_link( array(
		'before' => ' | ',
		'after' => '',
		'text' => get_icon('edit', 'imgtag'),
	) );
	?>
	</p>
	<?php
	// --- --- --- --- --- --- --- --- --- --- ---
	// --- POST CONTENT INCLUDED HERE ---
	template_include( '_item_content.inc.php', array(
		'content_mode' => 'auto',
		'intro_mode' => 'normal',
		'item_class' => 'featurepost',
		'image_block_start' => '<div class="excerpt-image excerpt-$mode$"><div class="excerpt-large">',
		'image_block_end' => '</div></div>',
		'image_size' => 'fit-720',
		'image_link_to' => '',
	) );
	?>
	<div class="clear"></div>
	</div>

	<div class="block-footer blocknice posttags">
	<?php
	// display and link categories by name
	$Item->categories( array(
		'before' => $Template->T_('In').' : ',
	) );

	// display link to (and count of) comments and trackbacks
	$Item->feedback_link( array(
		'link_before' => ' '.$Template->T_('Feedback').' : ',
		'link_text_zero'   => $Template->T_('None'),
		'link_text_one'    => '1',
		'link_text_more'   => '%d',
	) );

	// display link to edit this item
	$Item->edit_link( array(
		'before' => ' '.$Template->T_('Edit').'  : ',
		'after' => '',
		'text' => get_icon('edit', 'imgtag'),
	) );

	$Item->tags( array(
		'before' => ' <br /><span class="posttags">'.$Template->T_('Tags').': ',
		'after' => '</span>',
	) );
	?>
	</div>

	<div class="clear"></div>

	<?php
	// --- --- --- --- --- --- --- --- --- --- ---
	// --- ITEM FEEDBACK INCLUDED HERE ---
	template_include( '_item_feedback.inc.php', array(
		'before_section_title' => "\n".'<div class="blockwrap comments"><h3 class="blocknice main-title">',
		'after_section_title' => '</h3>'."\n",
		'comment_list_start' => '<ul class="cmt_list">'."\n",
		'comment_list_end' => '</ul></div>'."\n",
		'comment_start' => '<li class="comment $class$">',
		'comment_end' => '</li>'."\n",
		'preview_start' => '<li class="comment" id="comment_preview">',
		'preview_end' => '</li>'."\n",
		'form_title_start' => '<h3>',
		'form_title_end' => '</h3>',
		'creator_user_ID' => $Item->creator_user_ID,
	) );

	locale_restore_previous(); // restores previous locale

}
?>
</div>

<?php
// prev/next links in single post mode
item_prevnext_links( array(
	'block_start' => '<table class="prevnext_post"><tr>',
	'prev_start' => '<td>',
	'prev_end' => '</td>',
	'next_start' => '<td class="right">',
	'next_end' => '</td>',
	'block_end' => '</tr></table>',
) );
?>
</div>

<?php
// --- --- --- --- --- --- --- --- --- --- ---
// --- BODY FOOTER INCLUDED HERE ---
template_include( '_body_footer.inc.php' );
?>
