<?php
/**
 * item block template (sub-template)
 *
 * @author {@link http://wonderwinds.com/ Ed Bennett}
 * @author {@link http://www.brendoman.com/dbc Danny Ferguson}
 * @author {@link http://www.styleshout.com/ Erwin Aligam}
 * @copyright (c) 2009 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://www.gnu.org/licenses/gpl.txt GNU General Public License v3
 * @package templates
 * @subpackage pixelgreen
 */
if(!defined('QP_MAIN_INIT')) die('fail');

global $Item;

// set some default params...
$params = array_merge( array(
	'content_mode' => 'auto',
	'item_class' => 'post',
	'item_status_class' => 'bPost',
	'image_size' => 'fit-440',
), $params );

$Item->locale_temp_switch(); // temporarily switch to item's locale
?>

<div id="<?php $Item->anchor_id(); ?>" class="<?php $Item->div_classes( $params ); ?>" lang="<?php $Item->lang(); ?>">
<?php
// display and link item title
$Item->title( array(
	'before' => '<h3 class="bTitle">',
	'after' => '</h3>',
) );
?>
<p>
<?php
// display author/creator of item
$Item->author( array(
	'before' => $Template->T_('by').' <strong>',
	'after' => '</strong>',
) );

// display message form link to item's author
$Item->msgform_link( array(
	'before' => ' ',
	'after' => '',
) );
?>
</p>
<?php
// --- --- --- --- --- --- --- --- --- --- ---
// --- POST CONTENT INCLUDED HERE ---
template_include( '_item_content.inc.php', $params );
?>

<div class="post-footer">

<div class="bSmallHead">
<?php
// display and link categories by name
$Item->categories( array(
	'before' => $Template->T_('Categories').': ',
) );

// display the item's tags
$Item->tags( array(
	'before' => $Template->T_('Tags').': ',
	'after' => '<br />',
) );

// display the item's permalink
$Item->permanent_link( array(
	'class' => 'permalink_right',
	'text' => '#icon#'
) );

// display issue date/time of item
$Item->issue_date( array(
	'before' => '<img src="img/clock.gif" alt="" class="middle" />',
) );

// display issue date/time of item
$Item->issue_time( array(
	'after' => '',
) );

echo ', ';

// display link to (and count of) comments only
$Item->feedback_link( array(
	'type' => 'comments',
	'link_before' => '<img src="img/comment.gif" alt="" class="middle" />',
) );

// display link to (and count of) trackbacks only
$Item->feedback_link( array(
	'type' => 'trackbacks',
	'link_before' => ' &bull; ',
) );

// display link to edit this item
$Item->edit_link( array(
	'before' => ' &bull; ',
	'after' => '',
) );
?>
</div>

</div>

<?php
// --- --- --- --- --- --- --- --- --- --- ---
// --- ITEM FEEDBACK INCLUDED HERE ---
template_include( '_item_feedback.inc.php', array(
	'before_section_title' => '<h4>',
	'after_section_title' => '</h4>',
) );

locale_restore_previous(); // restores previous locale
?>
</div>
