<?php
/**
 * Primary / default template file
 *
 * @author {@link http://wonderwinds.com/ Ed Bennett}
 * @author {@link http://www.brendoman.com/dbc Danny Ferguson}
 * @author {@link http://www.styleshout.com/ Erwin Aligam}
 * @copyright (c) 2009 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://www.gnu.org/licenses/gpl.txt GNU General Public License v3
 * @package templates
 * @subpackage pixelgreen
 */
if(!defined('QP_MAIN_INIT')) die('fail');

template_init( $disp ); // do $disp-based initializations...

// --- --- --- --- --- --- --- --- --- --- ---
// --- HTML HEADER INCLUDED HERE ---
template_include( '_xhtml_header.inc.php' );
?>

<div id="wrap">

<div id="header">

<div id="header-content">
<?php
// --- --- --- --- --- --- --- --- --- --- ---
// display "Page Top" container's widgets
template_container( NT_('Page Top'), array(
	'container_start' => '<div class="PageTop">',
	'container_end' => '</div>',
	'block_display_title' => false,
) );

// --- --- --- --- --- --- --- --- --- --- ---
// display "Header" container's widgets
template_container( NT_('Header'), array(
	'container_start' => '',
	'container_end' => '',
	'block_title_start' => '<h1>',
	'block_title_end' => '</h1>',
) );

// --- --- --- --- --- --- --- --- --- --- ---
// display "Menu" container's widgets
template_container( NT_('Menu'), array(
	'container_start' => '<div class="top_menu"><ul>',
	'container_end' => '</ul></div>',
	'block_start' => '',
	'block_end' => '',
	'block_display_title' => false,
	'list_start' => '',
	'list_end' => '',
) );
?>
</div>

</div>

<div class="headerphoto"></div>

<div id="content-wrap">

<div id="content">
<?php
// messages generated from actions
messages( array() );

// title for the current request
request_title( array(
	'title_before' => '<h2>',
	'title_after' => '</h2>',
	'title_single_disp' => false,
) );

// --- --- --- --- --- --- --- --- --- --- ---
// display "Sidebar" container's contents
template_container( NT_('Sidebar'), array(
	'container_start' => '<div id="sidebar">',
	'container_end' => '</div>',
	'block_start' => '<div class="sidebox $wi_class$">',
	'block_end' => '</div>',
	'block_title_start' => '<h1>',
	'block_title_end' => '</h1>',
) );
?>

<div id="main">
<?php
// do we have a featured/intro item to display?
if( $Item = & get_featured_Item() )
{
	// --- --- --- --- --- --- --- --- --- --- ---
	// --- ITEM BLOCK INCLUDED HERE ---
	template_include( '_item_block.inc.php', array(
		'content_mode' => 'auto',
		'intro_mode' => 'normal',
		'item_class' => 'post featured_post',
	) );
}

// display a message if list is empty
display_if_empty( array() );

// loop through as long as we have an Item...
while( $Item = & mainlist_get_item() )
{
	// --- --- --- --- --- --- --- --- --- --- ---
	// --- ITEM BLOCK INCLUDED HERE ---
	template_include( '_item_block.inc.php', array(
		'content_mode' => 'auto',
	) );
}

// prev/next links on multi-post pages
mainlist_page_links( array(
	'block_start' => '<p class="center"><strong>',
	'block_end' => '</strong></p>',
) );

// --- --- --- --- --- --- --- --- --- --- ---
// --- MAIN CONTENT INCLUDED HERE ---
template_include( '$disp$', array(
	// these cases already handled by this file
	'disp_posts' => '',
	'disp_single' => '',
	'disp_intro' => '',
	'disp_page' => '',
) );
?>
</div>

</div>

</div>

<div id="footer">

<div id="footer-content">
<?php
// --- --- --- --- --- --- --- --- --- --- ---
// display "Footer" container's widgets
template_container( NT_('Footer'), array(
	'container_start' => '',
	'container_end' => '',
	'block_start' => '<div class="col float-left $wi_class$">',
	'block_end' => '</div>',
	'block_title_start' => '<h1>',
	'block_title_end' => '</h1>',
) );
?>

<div class="col2 float-right">
<p>&nbsp;</p>
</div>

<p class="baseline">
<?php
// display a link to contact the current blog owner
$Blog->contact_link( array(
	'after' => '',
) );

// display the current blog's footer text
$Blog->footer_text( array(
	'before' => ' &bull; ',
	'after' => '',
) );
?>
<br />
<?php
// display a link to this blog's credits page
$Blog->credits_link( array() );
?>
</p>
</div>

</div>

</div>

<?php
// spark the plugin manager
$Plugins->trigger_event( 'TemplateEndHtmlBody' );
debug_info(); // output debug info if requested
?>
</div>
</body>
</html>
<?php $Hit->log(); // log the hit on this page ?>
