<?php
/**
 * item block template (sub-template)
 *
 * @author {@link http://wonderwinds.com/ Ed Bennett}
 * @author {@link http://wpthemepark.com/ Sadish Bala}
 * @copyright (c) 2009 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://www.gnu.org/licenses/gpl.txt GNU General Public License v3
 * @package templates
 * @subpackage terrafirma
 */
if(!defined('QP_MAIN_INIT')) die('fail');

global $Item;

// set some default params...
$params = array_merge( array(
	'content_mode' => 'auto',
	'item_class' => 'bPost',
), $params );

$Item->locale_temp_switch(); // temporarily switch to item's locale
?>

<div id="<?php $Item->anchor_id(); ?>" class="<?php $Item->div_classes( $params ); ?>" lang="<?php $Item->lang(); ?>">

<div class="bSmallHead">

<div class="date">
<?php
// display author/creator of item
$Item->author( array(
	'before' => '<em class="user">',
	'after' => '</em><br />',
) );

// display issue date/time of item
$Item->issue_date( array(
	'before' => '<em class="bPostdate">',
	'after' => '</em>',
) );
?>
</div>

<?php
// display and link item title
$Item->title( array(
	'before' => '<h2 class="bTitle">',
	'after' => '</h2>',
) );
?>
</div>

<?php
// --- --- --- --- --- --- --- --- --- --- ---
// --- POST CONTENT INCLUDED HERE ---
template_include( '_item_content.inc.php', $params );

// display the item's tags
$Item->tags( array(
	'before' => '<div class="post-tags">'.$Template->T_('Tags').': ',
) );
?>

<div class="bSmallPrint">
<ul>
<?php
// display link to edit this item
$Item->edit_link( array(
	'before' => '<li>',
	'after' => '</li>',
) ); ?>
<li class="readmore">
<?php
// display and link categories by name
$Item->categories( array(
	'after' => '',
) );
?>
</li>
<li class="comments">
<?php
// display link to (and count of) comments only
$Item->feedback_link( array(
	'type' => 'comments',
) );

// display link to (and count of) trackbacks only
$Item->feedback_link( array(
	'type' => 'trackbacks',
	'link_before' => ' &bull; ',
) );
?>
</li>
</ul>
</div>

<?php
// --- --- --- --- --- --- --- --- --- --- ---
// --- ITEM FEEDBACK INCLUDED HERE ---
template_include( '_item_feedback.inc.php', array(
	'before_section_title' => '<h3>',
	'after_section_title' => '</h3>',
) );

locale_restore_previous(); // restores previous locale
?>
</div>
