<?php
/**
 * item comment template (sub-template)
 *
 * @author {@link http://wonderwinds.com/ Ed Bennett}
 * @author {@link http://wpthemepark.com/ Sadish Bala}
 * @copyright (c) 2009 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://www.gnu.org/licenses/gpl.txt GNU General Public License v3
 * @package templates
 * @subpackage terrafirma
 */
if(!defined('QP_MAIN_INIT')) die('fail');

// set some default params...
$params = array_merge( array(
	'comment_start' => '<div class="bComment">',
	'comment_end' => '</div>',
	'Comment' => NULL, // this object MUST be passed as a param!
), $params );

$Comment = & $params['Comment'];
$Comment->anchor(); // display an anchor for this comment
echo $params['comment_start'];
?>

<div class="bCommentTitle">
<?php
if( ! empty( $Comment->author_user_ID ) && $Comment->author_user_ID == $Item->Author->ID )
{
	// This comment was posted by the author
	// do special color?
}

switch( $Comment->get( 'type' ) )
{
	case 'comment':
	if( empty( $Comment->ID ) )
	{
		// PREVIEW comment
		echo $Template->T_('PREVIEW Comment from:').' ';
	}
	else
	{
		// display a permalink link to the comment
		$Comment->permanent_link( array(
			'text' => '&#035;',
			'nofollow' => true,
		) );
	}

	// display comment author's name
	$Comment->author( array(
		'after_visitor' => '',
		'make_link' => true,
	) );

	// display a link to message form for this comment's author
	$Comment->msgform_link( $Blog->get( 'msgformurl' ), array() );
	break;

	case 'trackback':
	// display a permalink link to the trackback
	$Comment->permanent_link( array(
		'text' => $Template->T_('Trackback: '),
		'nofollow' => true,
	) );

	// display trackback author's name
	$Comment->author( array(
		'make_link' => true,
	) );
	break;

}
?>
<em>
<?php
// display the comment's date
$Comment->date( array(
	'before' => /* TRANS: date */ $Template->T_('on').' ',
) );

// display the comment's time
$Comment->time( array(
	'before' => /* TRANS: time */ ' '.$Template->T_('at').' ',
	'format' => 'H:i',
) );

// display a link to edit a comment
$Comment->edit_link( array(
	'before' => ' &nbsp; ',
) );

// display a link to delete a comment
$Comment->delete_link( array(
	'before' => ' &nbsp; ',
) );
?>
</em>
<?php
// display a comment's rating
$Comment->rating( array() );
?>
</div>

<div class="bCommentText">
<?php $Comment->content(); // display the comment's contents ?>
</div>

<?php
echo $params['comment_end'];
?>
