<?php
/**
 * item block template (sub-template)
 *
 * @author {@link http://wonderwinds.com/ Ed Bennett}
 * @author {@link http://www.thedarksighed.com/ Andrew Hreschak}
 * @copyright (c) 2009 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://www.gnu.org/licenses/gpl.txt GNU General Public License v3
 * @package templates
 * @subpackage vastitude
 */
if(!defined('QP_MAIN_INIT')) die('fail');

global $Item;

// set some default params...
$params = array_merge( array(
	'content_mode' => 'auto',
	'item_class' => 'bPost',
	'image_size' => 'fit-520',
	'image_link_to' => '',
), $params );

$Item->locale_temp_switch(); // temporarily switch to item's locale
?>

<div id="<?php $Item->anchor_id(); ?>" class="<?php $Item->div_classes( $params ); ?>" lang="<?php $Item->lang(); ?>">

<div class="post_date">
<?php
// display issue date/time of item
$Item->issue_date( array(
	'date_format' => 'F jS, Y',
) );
?>
</div>

<div class="head">
<?php
// display and link item title
$Item->title( array(
	'before' => '<h2>',
	'after' => '</h2>',
) );
?>

<div class="bSmallHead">

<div class="bSmallHeadMisc">
<?php
// display author/creator of item
$Item->author( array(
	'before' => $Template->T_('Written by:').' <strong>',
	'after' => '</strong>',
) );

echo '<br /> ';

// display issue date/time of item
$Item->issue_date( array(
	'before' => $Template->T_('Published on').' ',
	'date_format' => 'F jS, Y',
) );

// display issue date/time of item
$Item->issue_time( array(
	'before' => '@ ',
) );

// display word count
$Item->wordcount( array(
	'before' => ', '.$Template->T_('using').' ',
	'after' => ' '.$Template->T_('words'),
) );

// display item's view count
$Item->views( array(
	'before' => ', ',
) );
?>
</div>

<div class="bSmallHeadCats">
<?php
// display and link categories by name
$Item->categories( array(
	'before' => $Template->T_('Posted in').' ',
) );
?>
</div>

</div>

</div>

<?php
// --- --- --- --- --- --- --- --- --- --- ---
// --- POST CONTENT INCLUDED HERE ---
template_include( '_item_content.inc.php', $params );
?>

<div class="bSmallPrint">
<?php
// display the item's tags
$Item->tags( array(
	'before' => '<div class="posttags">'.$Template->T_('Tags').': ',
) );

// display the item's permalink
$Item->permanent_link( array(
	'class' => 'permalink_right'
) );

// display link to (and count of) comments only
$Item->feedback_link( array(
	'type' => 'comments',
) );

// display link to (and count of) trackbacks only
$Item->feedback_link( array(
	'type' => 'trackbacks',
	'link_before' => ' &bull; ',
) );

// display link to edit this item
$Item->edit_link( array(
	'before' => ' &nbsp; ',
	'after' => '',
) );
?>
</div>

<?php
// --- --- --- --- --- --- --- --- --- --- ---
// --- ITEM FEEDBACK INCLUDED HERE ---
template_include( '_item_feedback.inc.php', array(
	'before_section_title' => '<h4>',
	'after_section_title' => '</h4>',
) );

locale_restore_previous(); // restores previous locale
?>
</div>
