<?php
/**
 * This page displays an error message if configuration is not done
 *
 * VERY IMPORTANT: this file should assume AS LITTLE AS POSSIBLE on what configuration
 * is already done or not. Before calling this page, you must set: $error_message
 *
 * @author {@link http://wonderwinds.com/ Ed Bennett}
 * @copyright (c) 2009 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://www.gnu.org/licenses/gpl.txt GNU General Public License v3
 * @package admin
 */
if(!defined('QP_MAIN_INIT')) die('fail');

global $app_name;
global $app_version;

header('Content-Type: text/html; charset=iso-8859-1');
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title><?php echo $app_name; ?> is not configured yet</title>
<link href="qp_rsc/css/support_install.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div class="block1">
<?php printf( '<img src="qp_rsc/logo.jpg" width="337" height="76" alt="'.T_('%s Logo').'" title="'.T_('%s Logo').'"/>', $app_name, $app_name ); ?>
<div><strong><?php echo $error_message; ?></strong></div>
<p>You cannot use <?php echo $app_name; ?> version <?php echo $app_version; ?> before you finish configuration and installation. Please use the installer to finish your configuration/installation now.</p>
<p style="font-weight:bold; padding:2ex 4ex; text-align:right;"><a href="qp_install/index.php">Next >></a></p>
</div>
</body>
</html>
<?php exit(0); ?>
