<?php
/**
 * This is the lost password form
 *
 * The user can request a set-password-link to be sent to his/her email address.
 *
 * @author {@link http://wonderwinds.com/ Ed Bennett}
 * @author {@link http://fplanque.net/ Francois PLANQUE}
 * @copyright (c) 2009 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://www.gnu.org/licenses/gpl.txt GNU General Public License v3
 * @package admin
 */
if(!defined('QP_MAIN_INIT')) die('fail');

$page_title = T_('Lost password ?');
$page_icon = 'icon_login.gif';

/**
 * Require html header file
 */
require dirname(__FILE__).'/_html_header.inc.php';

// lost password form
$Form = new Form( $srvc_url_sensitive.'login.php', '', 'post', 'fieldset' );
$Form->begin_form( 'fform' );
$Form->hidden( 'action', 'retrievepassword' );
$Form->hidden( 'redirect_to', url_rel_to_same_host( $redirect_to, $srvc_url_sensitive ) );
$Form->begin_fieldset( T_('Lost password ?') );
echo '<ol>';
echo '<li>'.T_('Please enter your login below. Do <strong>NOT</strong> enter your e-mail address!').'</li>';
echo '<li>'.T_('An email will be sent to your registered email address immediately.').'</li>';
echo '<li>'.T_('As soon as you receive the email, click on the link therein to change your password.').'</li>';
echo '</ol>';
$Form->text( 'login', $login, 16, T_('Login'), '', 20, 'input_text' );
$Form->buttons_input( array( array( /* TRANS: Text for submit button to request an activation link by email */ 'value' => T_('Send me an email now!'), 'class' => 'ActionButton' ) ) );
$Form->end_fieldset();;
$Form->end_form();
?>
<div class="login_actions" style="text-align:right">
<a href="<?php echo get_login_url(); ?>" title="<?php echo T_('Back to login'); ?>"><?php echo T_('Back to login'); ?></a>
</div>
<?php
/**
 * Require html footer file
 */
require dirname(__FILE__).'/_html_footer.inc.php';

?>
