<?php
/**
 * This is the displayed registration complete page
 *
 * @author {@link http://wonderwinds.com/ Ed Bennett}
 * @author {@link http://fplanque.net/ Francois PLANQUE}
 * @copyright (c) 2009 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://www.gnu.org/licenses/gpl.txt GNU General Public License v3
 * @package admin
 */
if(!defined('QP_MAIN_INIT')) die('fail');

$page_title = T_('Registration complete');
$page_icon = 'icon_register.gif';

/**
 * Require html header file
 */
require dirname(__FILE__).'/_html_header.inc.php';

// @todo (0000) dh> this form is not really required and only used for the info fields below.
$Form = new Form( $srvc_url_sensitive.'login.php', 'login', 'post', 'fieldset' );
$Form->begin_form( 'fform' );
$Form->hidden( 'login', $login );
$Form->hidden( 'redirect_to', url_rel_to_same_host( $redirect_to, $srvc_url_sensitive ) );

$Form->begin_fieldset();
$Form->info( T_('Login'), $login );
$Form->info( T_('Email'), $email );
$Form->end_fieldset();

// Now the user has been logged in automatically at the end of the registration progress.
// Allow him to proceed or go to the blogs, though he will see the "validate account"
// screen then, if he has not clicked the validation link yet and validation is required.
if( empty( $redirect_to ) )
{
	$redirect_to = $app_baseurl; // @todo (0000) dh> this was the old behaviour, there could be a better default
}
echo '<p class="center"><a href="'
	.htmlspecialchars( url_rel_to_same_host( $redirect_to, $srvc_url_sensitive ) )
	.'">'.T_('Continue').' &raquo;</a> '; // @todo (0000) dh> this does not seem to be sensible for dir=rtl
echo '</p>';

$Form->end_form();

/**
 * Require html footer file
 */
require dirname(__FILE__).'/_html_footer.inc.php';

?>
