<?php
/**
 * This is the registration form
 *
 * @author {@link http://wonderwinds.com/ Ed Bennett}
 * @author {@link http://fplanque.net/ Francois PLANQUE}
 * @copyright (c) 2009 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://www.gnu.org/licenses/gpl.txt GNU General Public License v3
 * @package admin
 */
if(!defined('QP_MAIN_INIT')) die('fail');

$page_title = T_('Register form');
$page_icon = 'icon_register.gif';

/**
 * Require html header file
 */
require dirname(__FILE__).'/_html_header.inc.php';

$Form = new Form( $srvc_url_sensitive.'register.php', '', 'post', 'fieldset' );
$Form->begin_form( 'fform' );
$Form->hidden( 'action', 'register');
$Form->hidden( 'redirect_to', url_rel_to_same_host( $redirect_to, $srvc_url_sensitive ) );
$Form->begin_fieldset();
$Form->text_input( 'login', $login, 16, T_('Login'), '', array( 'maxlength' => 20, 'class' => 'input_text', 'required' => true ) );
// @todo (0000) dh> display param errors with pass1 and pass2
?>
<fieldset>
<div class="label"><label for="pass1"><?php echo T_('Password') ?><br /><?php echo T_('(twice)').'<br />' ?></label></div>
<div class="input">
<input type="password" name="pass1" id="pass1" size="16" maxlength="50" value="" class="input_text field_required" />
<input type="password" name="pass2" id="pass2" size="16" maxlength="50" value="" class="input_text field_required" />
<span class="notes"><?php printf( T_('Minimum %d characters, please.'), $Settings->get( 'user_minpwdlen' ) ) ?></span>
</div>
</fieldset>
<?php
$Form->text_input( 'email', $email, 16, T_('Email'), '', array( 'maxlength' => 255, 'class' => 'input_text', 'required' => true ) );
$Form->select( 'locale', $locale, 'locale_options_return', T_('Locale'), T_('Preferred language') );
$Plugins->trigger_event( 'DisplayRegisterFormFieldset', array( 'Form' => & $Form ) );
$Form->buttons_input( array( array( 'name' => 'submit', 'value' => T_('Register!'), 'class' => 'ActionInput' ) ) );
$Form->end_fieldset();
$Form->end_form(); // display hidden fields etc
?>
<div style="text-align:right">
<a href="<?php echo $srvc_url_sensitive.'login.php?redirect_to='.rawurlencode( url_rel_to_same_host( $redirect_to, $srvc_url_sensitive ) ) ?>"><?php echo T_('Log into existing account...') ?></a>
</div>
<?php

/**
 * Require html footer file
 */
require dirname(__FILE__).'/_html_footer.inc.php';

?>
