<?php
/**
 * This is the account validation form
 *
 * @author {@link http://wonderwinds.com/ Ed Bennett}
 * @author {@link http://fplanque.net/ Francois PLANQUE}
 * @copyright (c) 2009 by {@link http://quamplures.net/ the Quam Plures project}
 * @license http://www.gnu.org/licenses/gpl.txt GNU General Public License v3
 * @package admin
 */
if(!defined('QP_MAIN_INIT')) die('fail');

$page_title = T_('Email address validation');
$page_icon = 'icon_register.gif';

/**
 * Require html header file
 */
require dirname(__FILE__).'/_html_header.inc.php';

$Form = new Form( $srvc_url_sensitive.'login.php', 'form_validatemail', 'post', 'fieldset' );
$Form->begin_form( 'fform' );
$Form->hidden( 'action', 'req_validatemail');
$Form->hidden( 'redirect_to', url_rel_to_same_host( $redirect_to, $srvc_url_sensitive ) );
$Form->hidden( 'req_validatemail_submit', 1 ); // to know if the form has been submitted

$Form->begin_fieldset( T_('Email address validation') );
echo '<ol>';
echo '<li>'.T_('Please confirm your email address below.').'</li>';
echo '<li>'.T_('An email will be sent to this address immediately.').'</li>';
echo '<li>'.T_('As soon as you receive the email, click on the link therein to activate your account.').'</li>';
echo '</ol>';
$Form->text_input( 'email', $email, 16, T_('Email'), '', array( 'maxlength' => 255, 'class' => 'input_text', 'required' => true ) );
$Plugins->trigger_event( 'DisplayValidateAccountFormFieldset', array( 'Form' => & $Form ) );
$Form->end_form( array(array( 'name' => 'form_validatemail_submit', 'value' => T_('Send me an email now!'), 'class' => 'ActionButton' )) ); // display hidden fields etc

if( $current_User->group_ID == 1 )
{
	// allow admin users to validate themselves by a single click
	$Form = new Form( $srvc_url_sensitive.'login.php', 'form_validatemail', 'post', 'fieldset' );
	$Form->begin_form( 'fform' );
	$Form->hidden( 'action', 'validatemail');
	$Form->hidden( 'redirect_to', url_rel_to_same_host( $redirect_to, $srvc_url_sensitive ) );
	$Form->hidden( 'reqID', 1 );
	$Form->hidden( 'sessID', $Session->ID );
	$Form->begin_fieldset();
	echo '<p>'.sprintf( T_('Since you are an admin user, you can validate your email address (%s) by a single click.' ), $current_User->email ).'</p>';
	$Form->end_form( array(array( 'name' => 'form_validatemail_admin_submit', 'value' => T_('Activate my account!'), 'class' => 'ActionButton' )) ); // display hidden fields etc
}
?>
<div style="text-align:right">
<?php user_logout_link(); ?>
</div>
<?php

/**
 * Require html footer file
 */
require dirname(__FILE__).'/_html_footer.inc.php';

?>
